searchData={"content_type":"text/markdown","items":[{"doc":"Starts the application\n\nThe `--no-halt` flag is automatically added.","ref":"Mix.Tasks.Scenic.Run.html","title":"mix scenic.run","type":"task"},{"doc":"The Scenic module itself is a supervisor that manages all the machinery that\nmakes the [Scenes](overview_scene.html), [ViewPorts](overview_viewport.html),\nand [Drivers](overview_driver.html) run.\n\nIn order to run any Scenic application, you will need to start the Scenic\nsupervisor in your supervision tree.\n\nLoad a configuration for one or more ViewPorts, then add Scenic to your root\nsupervisor.\n\n    defmodule MyApp do\n\n      def start(_type, _args) do\n        import Supervisor.Spec, warn: false\n\n        # load the viewport configuration from config\n        main_viewport_config = Application.get_env(:my_app :viewport)\n\n        # start the application with the viewport\n        children = [\n          supervisor(Scenic, [viewports: [main_viewport_config]]),\n        ]\n        Supervisor.start_link(children, strategy: :one_for_one)\n      end\n\n    end\n\nNote that you can start the Scenic supervisor without any ViewPort\nConfigurations. In that case, you are responsible for supervising\nthe ViewPorts yourself. This is not recommended for devices\nas Scenic should know how to restart the main ViewPort in the event\nof an error.","ref":"Scenic.html","title":"Scenic","type":"module"},{"doc":"Return the current version of scenic","ref":"Scenic.html#version/0","title":"Scenic.version/0","type":"function"},{"doc":"APIs to create and work with colors.\n\nColors are used in multiple places in Scenic. Fills and Strokes of a\nsingle color are quite common.","ref":"Scenic.Color.html","title":"Scenic.Color","type":"module"},{"doc":"There are multiple ways to define colors.\n\nThe native format of color on modern computers is RGBA. This is four channels\nincluding Red, Green, Blue, and Alpha. Alpha indicates transparency, and is\nused to blend the color being applied at any given location with the color\nthat is already there.\n\nMost of the time, you will use one of the pre-defined named colors from the\nNamed Colors table. However, there are times when you want to work with\nother color formats ranging from simple grayscale to rgb to hsl.\n\nThe following formats are all supported by the `Scenic.Color` module.\nThe values of r, g, b, and a are integers between 0 and 255.\nFor HSL and HSV, h is a float between 0 and 360, while the s, v and l values\nare floats between 0 and 100.\n\n| Format                     | Implicit       | Explicit                    |\n|----------------------------|----------------|-----------------------------|\n| Named Color                | *na*           | See the Named Color Table   |\n| Grayscale                  | `g`            | `{:color_g, g}`               |\n| Gray, Alpha                | `{g, a}`       | `{:color_ga, {g, a}}`         |\n| Red, Green, Blue           | `{r, g, b}`    | `{:color_rgb, {r, g, b}}`     |\n| Red, Green, Blue, Alpha    | `{r, g, b, a}` | `{:color_rgba, {r, g, b, a}}` |\n| Hue, Saturation, Value     | *na*           | `{:color_hsv, {h, s, v}}`     |\n| Hue, Saturation, Lightness | *na*           | `{:color_hsl, {h, s, l}}`     |","ref":"Scenic.Color.html#module-data-format","title":"Data Format - Scenic.Color","type":"module"},{"doc":"The simplest is to used a named color (see the table below). Named colors are simply\nreferred to by an atom, which is their name. Named colors are opaque by default.\nI failed to figure out how to show a table with colored cells in exdoc. So this is\na list of all the color names. I'll eventually add a link to a page that shows them\nvisually.\n\n[:alice_blue, :antique_white, :aqua, :aquamarine, :azure, :beige, :bisque,\n :black, :blanched_almond, :blue, :blue_violet, :brown, :burly_wood,\n :cadet_blue, :chartreuse, :chocolate, :coral, :cornflower_blue, :cornsilk,\n :crimson, :cyan, :dark_blue, :dark_cyan, :dark_golden_rod, :dark_gray,\n :dark_green, :dark_grey, :dark_khaki, :dark_magenta, :dark_olive_green,\n :dark_orange, :dark_orchid, :dark_red, :dark_salmon, :dark_sea_green,\n :dark_slate_blue, :dark_slate_gray, :dark_slate_grey, :dark_turquoise,\n :dark_violet, :deep_pink, :deep_sky_blue, :dim_gray, :dim_grey, :dodger_blue,\n :fire_brick, :floral_white, :forest_green, :fuchsia, :gainsboro, :ghost_white,\n :gold, :golden_rod, :gray, :green, :green_yellow, :grey, :honey_dew, :hot_pink,\n :indian_red, :indigo, :ivory, :khaki, :lavender, :lavender_blush, :lawn_green,\n :lemon_chiffon, :light_blue, :light_coral, :light_cyan, :light_golden_rod,\n :light_golden_rod_yellow, :light_gray, :light_green, :light_grey, :light_pink,\n :light_salmon, :light_sea_green, :light_sky_blue, :light_slate_gray,\n :light_slate_grey, :light_steel_blue, :light_yellow, :lime, :lime_green,\n :linen, :magenta, :maroon, :medium_aqua_marine, :medium_blue, :medium_orchid,\n :medium_purple, :medium_sea_green, :medium_slate_blue, :medium_spring_green,\n :medium_turquoise, :medium_violet_red, :midnight_blue, :mint_cream,\n :misty_rose, :moccasin, :navajo_white, :navy, :old_lace, :olive, :olive_drab,\n :orange, :orange_red, :orchid, :pale_golden_rod, :pale_green, :pale_turquoise,\n :pale_violet_red, :papaya_whip, :peach_puff, :peru, :pink, :plum, :powder_blue,\n :purple, :rebecca_purple, :red, :rosy_brown, :royal_blue, :saddle_brown,\n :salmon, :sandy_brown, :sea_green, :sea_shell, :sienna, :silver, :sky_blue,\n :slate_blue, :slate_gray, :slate_grey, :snow, :spring_green, :steel_blue, :tan,\n :teal, :thistle, :tomato, :turquoise, :violet, :wheat, :white, :white_smoke,\n :yellow, :yellow_green]","ref":"Scenic.Color.html#module-named-colors","title":"Named Colors - Scenic.Color","type":"module"},{"doc":"| Name          | Value                       |\n|---------------|-----------------------------|\n| `:clear` | `{0x80, 0x80, 0x80, 0x00}`       |\n| `:transparent` | `{0x80, 0x80, 0x80, 0x00}` |","ref":"Scenic.Color.html#module-additional-named-colors","title":"Additional Named Colors - Scenic.Color","type":"module"},{"doc":"By using the functions `to_g/1`, `to_ga/1`, `to_rgb/1`, `to_rgb/1`,\n`to_hsl/1`, and `to_hsv/1` you can convert between any implicit or explicit\ncolor type to any explicit color type.","ref":"Scenic.Color.html#module-converting-between-color-formats","title":"Converting Between Color Formats - Scenic.Color","type":"module"},{"doc":"Return map of all named colors and their values","ref":"Scenic.Color.html#named/0","title":"Scenic.Color.named/0","type":"function"},{"doc":"Convert a specified color to G format (just grayscale)\n\nThis is a lossy conversion and will lose any color information other than the gray level.","ref":"Scenic.Color.html#to_g/1","title":"Scenic.Color.to_g/1","type":"function"},{"doc":"Convert a specified color to GA format","ref":"Scenic.Color.html#to_ga/1","title":"Scenic.Color.to_ga/1","type":"function"},{"doc":"Convert a color to the HSL color space","ref":"Scenic.Color.html#to_hsl/1","title":"Scenic.Color.to_hsl/1","type":"function"},{"doc":"Convert a color to the HSV color space","ref":"Scenic.Color.html#to_hsv/1","title":"Scenic.Color.to_hsv/1","type":"function"},{"doc":"Convert a specified color to RGB format","ref":"Scenic.Color.html#to_rgb/1","title":"Scenic.Color.to_rgb/1","type":"function"},{"doc":"Convert a specified color to RGBA format","ref":"Scenic.Color.html#to_rgba/1","title":"Scenic.Color.to_rgba/1","type":"function"},{"doc":"","ref":"Scenic.Color.html#t:explicit/0","title":"Scenic.Color.explicit/0","type":"type"},{"doc":"","ref":"Scenic.Color.html#t:g/0","title":"Scenic.Color.g/0","type":"type"},{"doc":"","ref":"Scenic.Color.html#t:ga/0","title":"Scenic.Color.ga/0","type":"type"},{"doc":"","ref":"Scenic.Color.html#t:hsl/0","title":"Scenic.Color.hsl/0","type":"type"},{"doc":"","ref":"Scenic.Color.html#t:hsv/0","title":"Scenic.Color.hsv/0","type":"type"},{"doc":"","ref":"Scenic.Color.html#t:implicit/0","title":"Scenic.Color.implicit/0","type":"type"},{"doc":"","ref":"Scenic.Color.html#t:rgb/0","title":"Scenic.Color.rgb/0","type":"type"},{"doc":"","ref":"Scenic.Color.html#t:rgba/0","title":"Scenic.Color.rgba/0","type":"type"},{"doc":"","ref":"Scenic.Color.html#t:t/0","title":"Scenic.Color.t/0","type":"type"},{"doc":"","ref":"Scenic.Components.html","title":"Scenic.Components","type":"module"},{"doc":"Components are small scenes that are managed, by another scene.\nThey are useful for reusing bits of UI and containing the logic that\nruns them.","ref":"Scenic.Components.html#module-about-components","title":"About Components - Scenic.Components","type":"module"},{"doc":"This module contains a set of helper functions to make it easy to add, or\nmodify, the standard components.\n\nIn general, each helper function is of the form:\n\n    def name_of_component(graph, data, options \\\\ [])\n\nUnlike primitives, components are scenes in themselves. Each component is\nrun by a `GenServer` and adding a basic component does two things.\n\n1. A new component `GenServer` is started and supervised by the owning scene's\ndynamic scene supervisor.\n1. A reference to the new scene is added to the graph.\n\nThis doesn't happen all at once. These helper functions simply add a\nreference to a to-be-started component to your graph. When you push a graph,\nthe ViewPort then manages the life cycle of the components.\n\nWhen adding components to a graph, each helper function accepts a graph as\nthe first parameter and returns the transformed graph. This makes is very\neasy to build a complex graph by piping helper functions together.\n\n    @graph Graph.build()\n    |> button(\"Press Me\", id: :sample_button)\n\nWhen modifying a graph, you can again use the helpers by passing in the\ncomponent to be modified. The transformed component will be returned.\n\n    Graph.modify(graph, :sample_button, fn(p) ->\n      button(p, \"Continue\")\n    end)\n\n    # or, more compactly...\n\n    Graph.modify(graph, :sample_button, &button(&1, \"Continue\"))\n\nIn each case, the second parameter is a data term that is specific to the\ncomponent being acted on. See the documentation below. If you pass in invalid\ndata for the second parameter an error will be thrown along with some\nexplanation of what it expected.\n\nThe third parameter is a keyword list of options that are to be applied to\nthe component. This includes setting the id, styles, transforms and such.\n\n    @graph Graph.build()\n    |> button(\"Press Me\", id: :sample_button, rotate: 0.4)","ref":"Scenic.Components.html#module-helper-functions","title":"Helper Functions - Scenic.Components","type":"module"},{"doc":"Add a [`Button`](Scenic.Component.Button.html) to a graph\n\nA button is a small scene that is pretty much just some text drawn over a\nrounded rectangle. The button scene contains logic to detect when the button\nis pressed, tracks it as the pointer moves around, and when it is released.","ref":"Scenic.Components.html#button/3","title":"Scenic.Components.button/3","type":"function"},{"doc":"`title`\n\n* `title` - a bitstring describing the text to show in the button","ref":"Scenic.Components.html#button/3-data","title":"Data - Scenic.Components.button/3","type":"function"},{"doc":"If a button press is successful, it sends an event message to the host scene\nin the form of:\n\n    {:click, id}","ref":"Scenic.Components.html#button/3-messages","title":"Messages - Scenic.Components.button/3","type":"function"},{"doc":"Buttons honor the following standard styles\n\n* `:hidden` - If `false` the component is rendered. If `true`, it is skipped.\nThe default is `false`.\n* `:theme` - The color set used to draw. See below. The default is `:primary`","ref":"Scenic.Components.html#button/3-styles","title":"Styles - Scenic.Components.button/3","type":"function"},{"doc":"Buttons honor the following list of additional styles.\n\n* `:width` - pass in a number to set the width of the button.\n* `:height` - pass in a number to set the height of the button.\n* `:radius` - pass in a number to set the radius of the button's rounded\nrectangle.\n* `:alignment` - set the alignment of the text inside the button. Can be one\nof `:left, :right, :center`. The default is `:center`.\n* `:button_font_size` - the size of the font in the button\n\nButtons do not use the inherited `:font_size` style as they should look\nconsistent regardless of what size the surrounding text is.","ref":"Scenic.Components.html#button/3-additional-styles","title":"Additional Styles - Scenic.Components.button/3","type":"function"},{"doc":"Buttons work well with the following predefined themes:\n`:primary`, `:secondary`, `:success`, `:danger`, `:warning`, `:info`,\n`:text`, `:light`, `:dark`\n\nTo pass in a custom theme, supply a map with at least the following entries:\n\n* `:text` - the color of the text in the button\n* `:background` - the normal background of the button\n* `:active` - the background while the button is pressed","ref":"Scenic.Components.html#button/3-theme","title":"Theme - Scenic.Components.button/3","type":"function"},{"doc":"The following example creates a simple button and positions it on the screen.\n\n    graph\n    |> button(\"Example\", id: :button_id, translate: {20, 20})\n\nThe next example makes the same button as before, but colors it as a warning\nbutton. See the options list above for more details.\n\n    graph\n    |> button(\"Example\", id: :button_id, translate: {20, 20}, theme: :warning)","ref":"Scenic.Components.html#button/3-examples","title":"Examples - Scenic.Components.button/3","type":"function"},{"doc":"Generate an uninstantiated button spec, parallel to the concept of\nprimitive specs. This allows buttons to be treated as data.","ref":"Scenic.Components.html#button_spec/2","title":"Scenic.Components.button_spec/2","type":"function"},{"doc":"Add a [`Checkbox`](Scenic.Component.Input.Checkbox.html) to a graph","ref":"Scenic.Components.html#checkbox/3","title":"Scenic.Components.checkbox/3","type":"function"},{"doc":"`{text, checked?}`\n\n* `text` - must be a bitstring\n* `checked?` - must be a boolean and indicates if the checkbox is set.","ref":"Scenic.Components.html#checkbox/3-data","title":"Data - Scenic.Components.checkbox/3","type":"function"},{"doc":"When the state of the checkbox changes, it sends an event message to the\nparent scene in the form of:\n\n`{:value_changed, id, checked?}`","ref":"Scenic.Components.html#checkbox/3-messages","title":"Messages - Scenic.Components.checkbox/3","type":"function"},{"doc":"Buttons honor the following standard styles\n\n* `:hidden` - If `false` the component is rendered. If `true`, it is skipped.\nThe default is `false`.\n* `:theme` - The color set used to draw. See below. The default is `:dark`","ref":"Scenic.Components.html#checkbox/3-styles","title":"Styles - Scenic.Components.checkbox/3","type":"function"},{"doc":"Checkboxes work well with the following predefined themes: `:light`, `:dark`\n\nTo pass in a custom theme, supply a map with at least the following entries:\n\n* `:text` - the color of the text in the button\n* `:background` - the background of the box\n* `:border` - the border of the box\n* `:active` - the border of the box while the button is pressed\n* `:thumb` - the color of the check mark itself","ref":"Scenic.Components.html#checkbox/3-theme","title":"Theme - Scenic.Components.checkbox/3","type":"function"},{"doc":"The following example creates a checkbox and positions it on the screen.\n\n    graph\n    |> checkbox({\"Example\", true}, id: :checkbox_id, translate: {20, 20})","ref":"Scenic.Components.html#checkbox/3-examples","title":"Examples - Scenic.Components.checkbox/3","type":"function"},{"doc":"Generate an uninstantiated checkbox spec, parallel to the concept of\nprimitive specs. See `Components.checkbox` for data and options values.","ref":"Scenic.Components.html#checkbox_spec/2","title":"Scenic.Components.checkbox_spec/2","type":"function"},{"doc":"Add a [`Dropdown`](Scenic.Component.Input.Dropdown.html) to a graph","ref":"Scenic.Components.html#dropdown/3","title":"Scenic.Components.dropdown/3","type":"function"},{"doc":"`{items, initial_id}`\n\n* `items` - must be a list of items, each of which is: `{text, id}`. See below...\n* `initial_item` - the `id` of the initial selected item. It can be any term\nyou want, however it must be an `item_id` in the `items` list. See below.\n\nPer item data:\n\n`{text, item_id}`\n\n* `text` - a string that will be shown in the dropdown.\n* `item_id` - any term you want. It will identify the item that is\ncurrently selected in the dropdown and will be passed back to you during\nevent messages.","ref":"Scenic.Components.html#dropdown/3-data","title":"Data - Scenic.Components.dropdown/3","type":"function"},{"doc":"When the state of the Dropdown changes, it sends an event message to the host scene\nin the form of:\n\n`{:value_changed, id, selected_item_id}`","ref":"Scenic.Components.html#dropdown/3-messages","title":"Messages - Scenic.Components.dropdown/3","type":"function"},{"doc":"Dropdown honors the following list of options.","ref":"Scenic.Components.html#dropdown/3-options","title":"Options - Scenic.Components.dropdown/3","type":"function"},{"doc":"Buttons honor the following styles\n\n* `:hidden` - If `false` the component is rendered. If `true`, it is skipped.\nThe default is `false`.\n* `:theme` - The color set used to draw. See below. The default is `:dark`","ref":"Scenic.Components.html#dropdown/3-styles","title":"Styles - Scenic.Components.dropdown/3","type":"function"},{"doc":"Buttons honor the following list of additional styles.\n\n* `:width` - pass in a number to set the width of the button.\n* `:height` - pass in a number to set the height of the button.\n* `:direction` - what direction should the menu drop. Can be either `:down`\nor `:up`. The default is `:down`.","ref":"Scenic.Components.html#dropdown/3-additional-styles","title":"Additional Styles - Scenic.Components.dropdown/3","type":"function"},{"doc":"Dropdowns work well with the following predefined themes: `:light`, `:dark`\n\nTo pass in a custom theme, supply a map with at least the following entries:\n\n* `:text` - the color of the text\n* `:background` - the background of the component\n* `:border` - the border of the component\n* `:active` - the background of selected item in the dropdown list\n* `:thumb` - the color of the item being hovered over","ref":"Scenic.Components.html#dropdown/3-theme","title":"Theme - Scenic.Components.dropdown/3","type":"function"},{"doc":"The following example creates a dropdown and positions it on the screen.\n\n    graph\n    |> dropdown({[\n      {\"Dashboard\", :dashboard},\n      {\"Controls\", :controls},\n      {\"Primitives\", :primitives}\n    ], :controls}, id: :dropdown_id, translate: {20, 20})","ref":"Scenic.Components.html#dropdown/3-examples","title":"Examples - Scenic.Components.dropdown/3","type":"function"},{"doc":"Generate an uninstantiated dropdown spec, parallel to the concept of\nprimitive specs. See `Components.dropdown` for data and options values.","ref":"Scenic.Components.html#dropdown_spec/2","title":"Scenic.Components.dropdown_spec/2","type":"function"},{"doc":"Add a [`RadioGroup`](Scenic.Component.Input.RadioGroup.html) to a graph","ref":"Scenic.Components.html#radio_group/3","title":"Scenic.Components.radio_group/3","type":"function"},{"doc":"`{radio_buttons, selected_id}`\n\n* `radio_buttons` must be a list of radio button data. See below.\n\nRadio button data:\n\n`{text, radio_id}`\n\n* `text` - must be a bitstring\n* `radio_id` - can be any term you want. It will be passed back to you as the\ngroup's value.","ref":"Scenic.Components.html#radio_group/3-data","title":"Data - Scenic.Components.radio_group/3","type":"function"},{"doc":"When the state of the radio group changes, it sends an event message to the\nhost scene in the form of:\n\n`{:value_changed, id, radio_id}`","ref":"Scenic.Components.html#radio_group/3-messages","title":"Messages - Scenic.Components.radio_group/3","type":"function"},{"doc":"Radio Buttons honor the following list of options.\n\n* `:theme` - This sets the color scheme of the button. This can be one of\npre-defined button schemes `:light`, `:dark`, or it can be a completely custom\nscheme like this: `{text_color, box_background, border_color, pressed_color,\ncheckmark_color}`.","ref":"Scenic.Components.html#radio_group/3-options","title":"Options - Scenic.Components.radio_group/3","type":"function"},{"doc":"Radio Buttons honor the following styles\n\n* `:hidden` - If `false` the component is rendered. If `true`, it is skipped.\nThe default is `false`.\n* `:theme` - The color set used to draw. See below. The default is `:dark`","ref":"Scenic.Components.html#radio_group/3-styles","title":"Styles - Scenic.Components.radio_group/3","type":"function"},{"doc":"Radio buttons work well with the following predefined themes: `:light`,\n`:dark`\n\nTo pass in a custom theme, supply a map with at least the following entries:\n\n* `:text` - the color of the text\n* `:background` - the background of the component\n* `:border` - the border of the component\n* `:active` - the background of the circle while the button is pressed\n* `:thumb` - the color of inner selected-mark","ref":"Scenic.Components.html#radio_group/3-theme","title":"Theme - Scenic.Components.radio_group/3","type":"function"},{"doc":"The following example creates a radio group and positions it on the screen.\n\n    graph\n    |> radio_group([{\n        {\"Radio A\", :radio_a},\n        {\"Radio B\", :radio_b},\n        {\"Radio C\", :radio_c},\n      ], :radio_b}, id: :radio_group, translate: {20, 20})","ref":"Scenic.Components.html#radio_group/3-examples","title":"Examples - Scenic.Components.radio_group/3","type":"function"},{"doc":"Generate an uninstantiated radio_group spec, parallel to the concept of\nprimitive specs. See `Components.radio_group` for data and options values.","ref":"Scenic.Components.html#radio_group_spec/2","title":"Scenic.Components.radio_group_spec/2","type":"function"},{"doc":"Add a [`Slider`](Scenic.Component.Input.Slider.html) to a graph","ref":"Scenic.Components.html#slider/3","title":"Scenic.Components.slider/3","type":"function"},{"doc":"`{ extents, initial_value}`\n\n* `extents` gives the range of values. It can take several forms...\n  * `{min, max}` If `min` and `max` are integers, then the slider value will\n  be an integer.\n  * `{min, max}` If `min` and `max` are floats, then the slider value will be\n  an float.\n  * `[a, b, c]` A list of terms. The value will be one of the terms\n* `initial_value` Sets the initial value (and position) of the slider. It\nmust make sense with the extents you passed in.","ref":"Scenic.Components.html#slider/3-data","title":"Data - Scenic.Components.slider/3","type":"function"},{"doc":"When the state of the slider changes, it sends an event message to the host\nscene in the form of:\n\n`{:value_changed, id, value}`","ref":"Scenic.Components.html#slider/3-messages","title":"Messages - Scenic.Components.slider/3","type":"function"},{"doc":"Sliders honor the following list of options.","ref":"Scenic.Components.html#slider/3-options","title":"Options - Scenic.Components.slider/3","type":"function"},{"doc":"Sliders honor the following styles\n\n* `:hidden` - If `false` the component is rendered. If `true`, it is skipped.\nThe default is `false`.\n* `:theme` - The color set used to draw. See below. The default is `:dark`","ref":"Scenic.Components.html#slider/3-styles","title":"Styles - Scenic.Components.slider/3","type":"function"},{"doc":"Sliders work well with the following predefined themes: `:light`, `:dark`\n\nTo pass in a custom theme, supply a map with at least the following entries:\n\n* `:border` - the color of the slider line\n* `:thumb` - the color of slider thumb","ref":"Scenic.Components.html#slider/3-theme","title":"Theme - Scenic.Components.slider/3","type":"function"},{"doc":"The following example creates a numeric slider and positions it on the screen.\n\n    graph\n    |> slider({{0,100}, 0}, id: :num_slider, translate: {20,20})\n\nThe following example creates a list slider and positions it on the screen.\n\n    graph\n    |> slider({[\n        :white,\n        :cornflower_blue,\n        :green,\n        :chartreuse\n      ], :cornflower_blue}, id: :slider_id, translate: {20,20})","ref":"Scenic.Components.html#slider/3-examples","title":"Examples - Scenic.Components.slider/3","type":"function"},{"doc":"Generate an uninstantiated slider spec, parallel to the concept of\nprimitive specs. See `Components.slider` for data and options values.","ref":"Scenic.Components.html#slider_spec/2","title":"Scenic.Components.slider_spec/2","type":"function"},{"doc":"Add a [`TextField`](Scenic.Component.Input.TextField.html) input to a graph","ref":"Scenic.Components.html#text_field/3","title":"Scenic.Components.text_field/3","type":"function"},{"doc":"`initial_value`\n\n* `initial_value` - is the string that will be the starting value","ref":"Scenic.Components.html#text_field/3-data","title":"Data - Scenic.Components.text_field/3","type":"function"},{"doc":"When the text in the field changes, it sends an event message to the host\nscene in the form of:\n\n`{:value_changed, id, value}`","ref":"Scenic.Components.html#text_field/3-messages","title":"Messages - Scenic.Components.text_field/3","type":"function"},{"doc":"Text fields honor the following styles\n\n* `:hidden` - If `false` the component is rendered. If `true`, it is skipped.\nThe default is `false`.\n* `:theme` - The color set used to draw. See below. The default is `:dark`","ref":"Scenic.Components.html#text_field/3-styles","title":"Styles - Scenic.Components.text_field/3","type":"function"},{"doc":"Text fields honor the following list of additional styles.\n\n* `:filter` - Adding a filter option restricts which characters can be\nentered into the text_field component. The value of filter can be one of:\n  * `:all` - Accept all characters. This is the default\n  * `:number` - Any characters from \"0123456789.,\"\n  * `\"filter_string\"` - Pass in a string containing all the characters you\n  will accept\n  * `function/1` - Pass in an anonymous function. The single parameter will\n  be the character to be filtered. Return `true` or `false` to keep or reject\n  it.\n* `:hint` - A string that will be shown (greyed out) when the entered value\nof the component is empty.\n* `:type` - Can be one of the following options:\n  * `:all` - Show all characters. This is the default.\n  * `:password` - Display a string of '*' characters instead of the value.\n* `:width` - set the width of the control.","ref":"Scenic.Components.html#text_field/3-additional-styles","title":"Additional Styles - Scenic.Components.text_field/3","type":"function"},{"doc":"Text fields work well with the following predefined themes: `:light`, `:dark`\n\nTo pass in a custom theme, supply a map with at least the following entries:\n\n* `:text` - the color of the text\n* `:background` - the background of the component\n* `:border` - the border of the component\n* `:focus` - the border while the component has focus","ref":"Scenic.Components.html#text_field/3-theme","title":"Theme - Scenic.Components.text_field/3","type":"function"},{"doc":"graph\n    |> text_field(\"Sample Text\", id: :text_id, translate: {20,20})\n\n    graph\n    |> text_field(\n      \"\", id: :pass_id, type: :password, hint: \"Enter password\", translate: {20,20}\n    )","ref":"Scenic.Components.html#text_field/3-examples","title":"Examples - Scenic.Components.text_field/3","type":"function"},{"doc":"Generate an uninstantiated text_field spec, parallel to the concept of\nprimitive specs. See `Components.text_field` for data and options values.","ref":"Scenic.Components.html#text_field_spec/2","title":"Scenic.Components.text_field_spec/2","type":"function"},{"doc":"Add [`Toggle`](Scenic.Component.Input.Toggle.html) to a Scenic graph.","ref":"Scenic.Components.html#toggle/3","title":"Scenic.Components.toggle/3","type":"function"},{"doc":"`on?`\n\n* `on?` - `true` if the toggle is on, pass `false` if not.","ref":"Scenic.Components.html#toggle/3-data","title":"Data - Scenic.Components.toggle/3","type":"function"},{"doc":"Toggles honor the following styles. The `:light` and `:dark` styles look nice. The other bundled themes...not so much. You can also [supply your own theme](Scenic.Toggle.Components.html#toggle/3-theme).\n\n* `:hidden` - If `false` the toggle is rendered. If true, it is skipped. The default\n  is `false`.\n* `:theme` - The color set used to draw. See below. The default is `:dark`","ref":"Scenic.Components.html#toggle/3-styles","title":"Styles - Scenic.Components.toggle/3","type":"function"},{"doc":"Toggles also honor the following additional styles.\n\n* `:border_width` - the border width. Defaults to `2`.\n* `:padding` - the space between the border and the thumb. Defaults to `2`\n* `:thumb_radius` - the radius of the thumb. This determines the size of the entire toggle. Defaults to `10`.","ref":"Scenic.Components.html#toggle/3-additional-styles","title":"Additional Styles - Scenic.Components.toggle/3","type":"function"},{"doc":"To pass in a custom theme, supply a map with at least the following entries:\n\n* `:border` - the color of the border around the toggle\n* `:background` - the color of the track when the toggle is `off`.\n* `:text` - the color of the thumb.\n* `:thumb` - the color of the track when the toggle is `on`.\n\nOptionally, you can supply the following entries:\n\n* `:thumb_pressed` - the color of the thumb when pressed. Defaults to `:gainsboro`.","ref":"Scenic.Components.html#toggle/3-theme","title":"Theme - Scenic.Components.toggle/3","type":"function"},{"doc":"The following example creates a toggle.\n    graph\n    |> toggle(true, translate: {20, 20})\n\nThe next example makes a larger toggle.\n    graph\n    |> toggle(true, translate: {20, 20}, thumb_radius: 14)","ref":"Scenic.Components.html#toggle/3-examples","title":"Examples - Scenic.Components.toggle/3","type":"function"},{"doc":"Generate an uninstantiated toggle spec, parallel to the concept of\nprimitive specs. See `Components.toggle` for data and options values.","ref":"Scenic.Components.html#toggle_spec/2","title":"Scenic.Components.toggle_spec/2","type":"function"},{"doc":"The main module for drawing and user input.\n\nNote: The driver model has completely changed in v0.11.\n\nDrivers make up the bottom layer of the Scenic architectural stack. They draw\neverything on the screen and originate the raw user input. In general, different\ndrawing targets will need different drivers.\n\nThe driver interface provides a great deal of flexibility, but is more\nadvanced than writing scenes. You can write drivers that only provide user input,\nonly draw scripts, or do both. There is no assumption at all as to what the\noutput target or user source is.","ref":"Scenic.Driver.html","title":"Scenic.Driver","type":"behaviour"},{"doc":"Drivers are always managed by a ViewPort that hosts them.\n\nThe most common way to instantiate a driver is set it up in the config of\na ViewPort when it starts up.\n\n```elixir\nconfig :my_app, :viewport,\n  size: {800, 600},\n  name: :main_viewport,\n  theme: :dark,\n  default_scene: MyApp.Scene.MainScene,\n  drivers: [\n    [\n      module: Scenic.Driver.Local,\n      name: :local_driver,\n      window: [title: \"My Application\", resizeable: false]\n    ],\n    [\n      module: MyApp.Driver.MyDriver,\n      my_param: \"abc\"\n    ],\n  ]\n```\n\nIn the example above, two drivers are configured to be started when the\n`:main_viewport` starts up. Both drivers drivers will be running at the\nsame time and will receive the same messages from the ViewPort.\n\nDrivers can be dynamically started on a `ViewPort` using\n`Scenic.ViewPort.start_driver/2`. They can be dynamically stopped on\na `ViewPort` using  `Scenic.ViewPort.stop_driver/2`.\n\nDrivers can also define their own configuration options. See the\ndocumentation for the driver you are interested in starting to see the\navailable options.","ref":"Scenic.Driver.html#module-starting-drivers","title":"Starting Drivers - Scenic.Driver","type":"behaviour"},{"doc":"The way a ViewPort communicates with it's drivers is by sending them a\nset of well-known messages. These are picked up by the Driver module and\nsent to your driver through callbacks.\n\n| Callback | Description |\n|---|---|\n| `reset_scene/1` | The `ViewPort` context has been reset. The driver can clean up all scripts and cached media |\n| `request_input/2` | The ViewPort is requesting user inputs from the `keys` list |\n| `update_scene/2` | The scripts identified by `ids` have been update and should be processed |\n| `del_scripts/2` | The script identified by `id` has been deleted and can be cleaned up |\n| `clear_color/2` | The background clear color has been updated |","ref":"Scenic.Driver.html#module-messages-from-the-viewport","title":"Messages from the ViewPort - Scenic.Driver","type":"behaviour"},{"doc":"The main drawing related task of a Driver is to receive the `update_scene/2`\ncallback and then draw the updated scripts to the screen, or whatever output medium the\ndriver supports.\n\nIn a very simple example, it would look something like this.\n\n```elixir\ndef update_scene( ids, driver ) do\n  Enum.each( ids, fn(id) ->\n    with {:ok, script} <- ViewPort.get_script_by_id(vp, id) do\n      script\n      |> Scenic.Script.serialize()\n      |> my_render_script(driver)\n    end\n  end)\n  {:ok, driver}\nend\n```\n\nThe above example is overly simple and just there to get you started. Note that only\nthe ids of the scripts are sent. You still need to fish them out of the `ViewPort`","ref":"Scenic.Driver.html#module-handling-updates","title":"Handling Updates - Scenic.Driver","type":"behaviour"},{"doc":"User input events are created whenever a driver has events to share. The `request_input/2`\ncallback indicates to you which input events are currently being listened to. This is a guide\nthat you can use or not. You can send any valid input event at any time, the `ViewPort` will\nsimply ignore those that aren't being listened to.\n\nIn this example, there is some source of user input that casts messages to our driver.\n\n```elixir\ndef handle_cast( {:my_cursor_press, button, xy}, driver ) do\n  send_input(driver, {:cursor_button, {button, 1, [], xy}} )\n  { :noreply, driver }\nend\n```\n\nNo matter what type of input you are sending, it will be checked to\nmake sure it conforms the [known input types](Scenic.ViewPort.Input.html#t:t/0).","ref":"Scenic.Driver.html#module-user-input","title":"User Input - Scenic.Driver","type":"behaviour"},{"doc":"There are several changes to the input formats in version v0.11.\n\nButton indicators are now atoms that conform to standard linux-like buttons. This\nallows for more buttons on a mouse like device. Do not assume these are the only\nbuttons that can be sent in a `:cursor_button` message.\n\n| New Button | Old Button |\n|---|---|\n| `:btn_left` | `:left` |\n| `:btn_right` | `:right` |\n\nPress and Release messages were atoms and are now numbers. This is to support\nmulti-state buttons and joysticks and the like. Turns out that some buttons\nare pressure sensitive and can have a range of values.\n\n| New Action | Old Action |\n|---|---|\n| `0` | `:release` |\n| `1` | `:press` |\n\nModifier keys were previously a number and you would have had to dig into the GLFW\ndocumentation to see how to interpret it. That was both unintuitive and I wanted to\nmake it more source independent. So now it is a list of atoms. If the atom you\nare interested is in the list, then it is pressed.\n\n```elixir\n[:ctrl, :shift, :alt, :meta]\n```\n\nTest if a modifier key is pressed using the Enum.member?/2 function.\n```elixir\nmods = [:ctrl, :shift]\nEnum.member?( mods, :shift )\n```","ref":"Scenic.Driver.html#module-updated-input-formats","title":"Updated Input Formats - Scenic.Driver","type":"behaviour"},{"doc":"Convenience function to assign a list of values into a driver struct.","ref":"Scenic.Driver.html#assign/2","title":"Scenic.Driver.assign/2","type":"function"},{"doc":"Convenience function to assign a value into a driver struct.","ref":"Scenic.Driver.html#assign/3","title":"Scenic.Driver.assign/3","type":"function"},{"doc":"Convenience function to assign a list or map of new values into a driver struct.\n\nOnly values that do not already exist will be assigned","ref":"Scenic.Driver.html#assign_new/2","title":"Scenic.Driver.assign_new/2","type":"function"},{"doc":"Convenience function to assign a new values into a driver struct.\n\nThe value will only be assigned if it does not already exist in the struct.","ref":"Scenic.Driver.html#assign_new/3","title":"Scenic.Driver.assign_new/3","type":"function"},{"doc":"Called when the background color has changed.\n\nThe color is provided.\n\nThis callback is optional.","ref":"Scenic.Driver.html#c:clear_color/2","title":"Scenic.Driver.clear_color/2","type":"callback"},{"doc":"Called when a script has been deleted and can be cleaned up.\n\nThe deleted id is provided.\n\nThis callback is optional.","ref":"Scenic.Driver.html#c:del_scripts/2","title":"Scenic.Driver.del_scripts/2","type":"callback"},{"doc":"Convenience function to fetch an assigned value out of a driver struct.","ref":"Scenic.Driver.html#fetch/2","title":"Scenic.Driver.fetch/2","type":"function"},{"doc":"Convenience function to get an assigned value out of a driver struct.","ref":"Scenic.Driver.html#get/3","title":"Scenic.Driver.get/3","type":"function"},{"doc":"Initialize a driver process.\n\nThe `ViewPort` and an options list for the driver are passed in. Just like\ninitializing any `GenServer` process, it should return `{:ok, state}`","ref":"Scenic.Driver.html#c:init/2","title":"Scenic.Driver.init/2","type":"callback"},{"doc":"Called when requested input types have changed.\n\nThis informs your driver that the requested input types for the application\nhave changed. This is useful if you want to reduce the amount of data being transferred\nbetween your input source (which might be expensive...) and the driver.\n\nThis callback is optional. If you ignore it and send all input\nevents, then only the ones being listened to will be processed.","ref":"Scenic.Driver.html#c:request_input/2","title":"Scenic.Driver.request_input/2","type":"callback"},{"doc":"Request a scene_updated call.\n\nThis is used when scripts are updated. Some drivers use it to batch updates\ninto a single atomic operation. This call is rate limited by limit_ms.","ref":"Scenic.Driver.html#request_update/1","title":"Scenic.Driver.request_update/1","type":"function"},{"doc":"Called when the scene has been reset.\n\nThis is an opportunity for your driver to clear state that may no longer\nbe relevant. This is typically scripts, inputs, media, etc.","ref":"Scenic.Driver.html#c:reset_scene/1","title":"Scenic.Driver.reset_scene/1","type":"callback"},{"doc":"Send input from the driver.\n\nSend input from the driver to its ViewPort. `:cursor_pos` and `:cursor_scroll`\ninput will be buffered/rate limited according the driver's `:limit_ms` setting.","ref":"Scenic.Driver.html#send_input/2","title":"Scenic.Driver.send_input/2","type":"function"},{"doc":"Set or clear the busy flag.\n\nWhen the busy flag is set, put_script messages will be consolidated until cleared.","ref":"Scenic.Driver.html#set_busy/2","title":"Scenic.Driver.set_busy/2","type":"function"},{"doc":"","ref":"Scenic.Driver.html#terminate/2","title":"Scenic.Driver.terminate/2","type":"function"},{"doc":"Called when the scene has been updated.\n\nThe list of ids is the set of script ids that have changed and should be updated.\n\nNote that the list may be empty if you have requested an update via the\n`request_update/1` function.\n\nThis callback is optional.","ref":"Scenic.Driver.html#c:update_scene/2","title":"Scenic.Driver.update_scene/2","type":"callback"},{"doc":"Validate driver configuration\n\nUsed primarily for dynamic view port creation","ref":"Scenic.Driver.html#validate/1","title":"Scenic.Driver.validate/1","type":"function"},{"doc":"Validate the options passed to a Driver.\n\nThe list of options for a driver are passed in as `opts`. If you decide then are\ngood, return them, or a transformed set of them as `{:ok, opts}`\n\nIf they are invalid, return either one of:\n  * `{:error, String.t()}`\n  * `{:error, NimbleOptions.ValidationError.t()}`\n\nScenic uses `NimbleOptions` internally for options validation, so `NimbleOptions`\nerrors are supported.","ref":"Scenic.Driver.html#c:validate_opts/1","title":"Scenic.Driver.validate_opts/1","type":"callback"},{"doc":"","ref":"Scenic.Driver.html#t:response_opts/0","title":"Scenic.Driver.response_opts/0","type":"type"},{"doc":"","ref":"Scenic.Driver.html#t:t/0","title":"Scenic.Driver.t/0","type":"type"},{"doc":"Behaviour and support functions for mapping physical keys to characters.\n\nThis module is meant to be implemented elsewhere and provided to a driver\nin order to localize key presses into the correct characters.\n\nThe `:scenic_driver_local` driver comes with a USEnglish key map, which it\nuses by default. Look at that one as an example on how to make a custom\nkey mapping.","ref":"Scenic.Driver.KeyMap.html","title":"Scenic.Driver.KeyMap","type":"behaviour"},{"doc":"Is any alt key pressed?","ref":"Scenic.Driver.KeyMap.html#alt?/1","title":"Scenic.Driver.KeyMap.alt?/1","type":"function"},{"doc":"Is the caps lock enabled?\n\nReturns true if any shift key or the caps lock is pressed or active.","ref":"Scenic.Driver.KeyMap.html#caps_lock?/1","title":"Scenic.Driver.KeyMap.caps_lock?/1","type":"function"},{"doc":"Is any ctrl key pressed?","ref":"Scenic.Driver.KeyMap.html#ctrl?/1","title":"Scenic.Driver.KeyMap.ctrl?/1","type":"function"},{"doc":"Translate a key to a codepoint, which is really just a string.\n\nThe first time this is called, state is nil. After that you can return\nany state that makes sense and it will be passed back on the next call.\n\nIf the mapping is successful, i.e. the key press results in a valid character,\nThen this function should return `{ :ok, codepoint, state }`. The returned\ncodepoint will be sent on to the ViewPort as a codepoint input event.\n\nIf the key press does not map to a string (this is common), then the function\nshould return `{ :ok, nil, state }`. This will not result in a codepoint input\nbeing sent to the ViewPort.\n\nIf the data makes no sense at all, then you can return `{ :error, error_msg, state }`.\nThis will not send a codepoint input, but will log the error message, which should\nbe a string.","ref":"Scenic.Driver.KeyMap.html#c:map_key/4","title":"Scenic.Driver.KeyMap.map_key/4","type":"callback"},{"doc":"Is any meta key pressed? This is usually the command button.","ref":"Scenic.Driver.KeyMap.html#meta?/1","title":"Scenic.Driver.KeyMap.meta?/1","type":"function"},{"doc":"Generate the list of pressed modifier keys","ref":"Scenic.Driver.KeyMap.html#mods/1","title":"Scenic.Driver.KeyMap.mods/1","type":"function"},{"doc":"Is the num lock enabled?\n\nReturns true if num lock is pressed or active.","ref":"Scenic.Driver.KeyMap.html#num_lock?/1","title":"Scenic.Driver.KeyMap.num_lock?/1","type":"function"},{"doc":"Is the scroll lock enabled?\n\nReturns true if scroll lock is pressed or active.","ref":"Scenic.Driver.KeyMap.html#scroll_lock?/1","title":"Scenic.Driver.KeyMap.scroll_lock?/1","type":"function"},{"doc":"Is the current set of keys shifted?\n\nReturns true if any shift key or the caps lock is pressed or active.","ref":"Scenic.Driver.KeyMap.html#shift?/1","title":"Scenic.Driver.KeyMap.shift?/1","type":"function"},{"doc":"","ref":"Scenic.Driver.KeyMap.html#t:keys/0","title":"Scenic.Driver.KeyMap.keys/0","type":"type"},{"doc":"","ref":"Scenic.Driver.KeyMap.html#t:mod_keys/0","title":"Scenic.Driver.KeyMap.mod_keys/0","type":"type"},{"doc":"Please see [`Graph Overview`](overview_graph.html) for a high-level description.","ref":"Scenic.Graph.html","title":"Scenic.Graph","type":"module"},{"doc":"There are many types of graphs in the field of Computer Science. There are graphs that\nshow data to a user. There are graphs that give access to databases. Graphs that link\npeople to a social network.\n\nIn Scenic, a Graph is a graph in same way that the DOM in HTML is a graph. It is a\nhierarchical tree of data that describes a set of things to draw on the screen.\n\nYou build a graph by appending primitives (individual things to draw) to the current\nnode in the tree. Nodes are represented by `Scenic.Primitive.Group`.\n\nThe following example builds a simple graph that displays some text, creates a group,\nthen adds more text and a rounded rectangle to it.\n\n```elixir\n@graph  Scenic.Graph.build()\n|> text( \"This is some text\", translate: {20, 20} )\n|> group( fn(graph) ->\n  graph\n  |> text( \"This text is in a group\", translate: {200, 24} )\n  |> rounded_rectangle( {400, 30}, stroke: {2, :blue})\nend, translate: {20, 100}, text_align: :center)\n```\n\nThere is a fair amount going on in the example above. The first line builds an empty\ngraph with only one group as the root node.\n\n```elixir\n@graph Scenic.Graph.build()\n```\n\nBy assigning it to the\ncompile directive `@group`, we know that this group will be built once at compile\ntime and will be very fast to access later during runtime. You could also do this\nat runtime, in your init function for example.\n\nThe empty graph that is returned from `build()` is then passed to\n\n```elixir\n|> text( \"This is some text\", translate: {20, 20} )\n```\n\nThis adds a text primitive to the root group. The graph returned from that call is then\npassed again into\n\n```elixir\n|> group( fn(graph) ->\n  graph\n  |> text( \"This text is in a group\", translate: {200, 24} )\n  |> rounded_rectangle( {400, 30}, stroke: {2, :blue})\nend, translate: {20, 100}, text_align: :center)\n```\n\nThis creates a new group which is filled with several other primitives.\n\nNotice that the anonymous group \"builder\" function receives a graph as its only parameter.\nThis is the same graph that we are building, except that it has a marker indicating\nthat new primitives added to it are inserted into the new group instead of the\nroot of the graph.\n\nFinally, when the group is finished, a translation matrix and a `:text_align`\nstyle (see `Scenic.Primitive.Style.TextAlign`) are added to it. These\nproperties are _inherited_ by the primitives in the group.","ref":"Scenic.Graph.html#module-what-is-a-graph","title":"What is a Graph - Scenic.Graph","type":"module"},{"doc":"An important concept to understand is that both [styles](overview_styles.html) and\n[transforms](overview_styles.html) are inherited down the graph. This means that if\nyou apply a style or transform to any group (including the root), then all primitives\ncontained by that group will have those properties applied to them too. This is true\neven if the primitive is nested in several groups at the same time.\n\n```elixir\n@graph  Scenic.Graph.build(font: :roboto_mono)\n|> text( \"This text inherits the font\", translate: {20, 20} )\n|> group( fn(graph) ->\n  graph\n  |> text( \"This text also inherits the font\", translate: {200, 24} )\n  |> text( \"This text overrides the font\", font: :roboto )\nend, translate: {20, 100}, text_align: :center)\n```\n\nTransforms, such as translate, rotate, scale, also inherit down the graph, but do\nso slightly differently than the styles. With a style, when you set a specific value\non a primitive, that overrides the inherited value of the same type.\n\nWith a transform, the values multiply together. This allows you to position items\nwithin a group relative to the origin {0,0}, then move the group as a whole, keeping\nthe interior positions unchanged.\n\nStyles, however, are NOT inherited by components even though transforms are.","ref":"Scenic.Graph.html#module-inheritance","title":"Inheritance - Scenic.Graph","type":"module"},{"doc":"Scenic was written specifically for Erlang/Elixir, which is a functional programming\nmodel with immutable data.\n\nAs such, once you make a graph, it stays in memory unchanged - until you transform it\nvia `Graph.modify/3`. Technically you never change it (that's the immutable part),\ninstead Graph.modify returns a new graph with different data in it.\n\n[Graph.modify/3](Scenic.Graph.html#modify/3) is the single Graph function that you\nwill use the most.\n\nFor example, lets go back to our graph with the two text items in it.\n\n```elixir\n@graph Graph.build(font: :roboto, font_size: 24, rotate: 0.4)\n  |> text(\"Hello World\", translate: {300, 300}, id: :small_text)\n  |> text(\"Bigger Hello\", font_size: 40, scale: 1.5, id: :big_text)\n```\n\nThis time, we've assigned ids to both of the text primitives. This makes it easy to\nfind and modify that primitive in the graph.\n\n```elixir\ngraph =\n  @graph\n  |> Graph.modify( :small_text, &text(&1, \"Smaller Hello\", font_size: 16))\n  |> Graph.modify( :big_text, &text(&1, \"Bigger Hello\", font_size: 60))\n```\n\nNotice that the graph is modified multiple times in the pipeline. The `push_graph/1`\nfunction is relatively heavy when the graph references other scenes. The recommended\npattern is to make multiple changes to the graph .","ref":"Scenic.Graph.html#module-modifying-a-graph","title":"Modifying a Graph - Scenic.Graph","type":"module"},{"doc":"When using a Graph, it is extremely common to access and modify primitives. The way\nyou do this is by putting an id on the primitives you care about in a graph.\n\n```elixir\n@graph Graph.build()\n  |> text(\"small text\", id: :small_text)\n  |> text(\"bit text\", id: :big_text)\n```\n\nWhen you get primitives, or modify a graph, you specify them by id. This happens\nquickly, but at a cost of using a little memory. If you aren't going to access\na primitive, then don't assign an id to them.\n\nOne interesting note: There is nothing saying you have to use an atom as the id.\nIn fact you can use any Erlang term you want. This can be very powerful, especially\nwhen used to identify components...","ref":"Scenic.Graph.html#module-accessing-primitives","title":"Accessing Primitives - Scenic.Graph","type":"module"},{"doc":"Add a pre-built primitive to the current group in the graph.\n\nThis is usually called during graph construction. When a new Group primitive\nis added to a Graph, it marks the new group as the current one before calling the group's\nbuilder function. This is what allows you to add primitives to the correct place\nin the new Group.\n\nNote: All primitives added to a group are appended to the draw order.","ref":"Scenic.Graph.html#add/2","title":"Scenic.Graph.add/2","type":"function"},{"doc":"Build and add a primitive to the current group in the graph.\n\nThis is usually called during graph construction. When a new Group primitive\nis added to a Graph, it marks the new group as the current one before calling the group's\nbuilder function. This is what allows you to add primitives to the correct place\nin the new Group.\n\nNote: All primitives added to a group are appended to the draw order.","ref":"Scenic.Graph.html#add/4","title":"Scenic.Graph.add/4","type":"function"},{"doc":"Add to a specified group in a graph.\n\nSimilar to adding a group during graph construction, the `add_to` function accepts\na builder function that adds to a graph under the identified group.\n\nPrimitives with the `id` that are not groups are ignored.\n\nIf multiple groups have the given `id`, then the builder is run against each of them.","ref":"Scenic.Graph.html#add_to/3","title":"Scenic.Graph.add_to/3","type":"function"},{"doc":"Compute the bounding box that contains the graph.\n\nReturns `{left, top, right, bottom}` or `nil` if the graph is empty.","ref":"Scenic.Graph.html#bounds/1","title":"Scenic.Graph.bounds/1","type":"function"},{"doc":"Builds and returns an empty graph.\n\nJust like any primitive, you can pass in an option list of styles and transforms.\nThese will be applied to the otherwise empty root group in the new graph.","ref":"Scenic.Graph.html#build/1","title":"Scenic.Graph.build/1","type":"function"},{"doc":"Compile a graph into a script.","ref":"Scenic.Graph.html#compile/1","title":"Scenic.Graph.compile/1","type":"function"},{"doc":"Returns a count of all the primitives in a graph.\n\nThe root Group counts as a primitive, so an empty graph should have a count\nof 1.","ref":"Scenic.Graph.html#count/1","title":"Scenic.Graph.count/1","type":"function"},{"doc":"Returns a count of all the primitives in a graph with a specific id.","ref":"Scenic.Graph.html#count/2","title":"Scenic.Graph.count/2","type":"function"},{"doc":"Permanently delete a primitive from a group by id.\n\nThis will remove a primitive (or many if they have the same id) from a graph. It\nthen returns the modified graph.\n\nIf you delete a group from a graph, then all primitives contained by that\ngroup are deleted as well.","ref":"Scenic.Graph.html#delete/2","title":"Scenic.Graph.delete/2","type":"function"},{"doc":"Find one or more primitives in a graph via a filter function.\n\nPass in a function that accepts a primitive and returns a boolean.\n\nReturns a list of primitives.\n\n__Warning:__ This function crawls the entire graph and is thus slower than\naccessing items via a fully-specified id.","ref":"Scenic.Graph.html#find/2","title":"Scenic.Graph.find/2","type":"function"},{"doc":"Returns a list of primitives from a graph with a specific id.","ref":"Scenic.Graph.html#get/2","title":"Scenic.Graph.get/2","type":"function"},{"doc":"Returns a single primitive from a graph with a specific id.\n\nThis will raise an error if either none or multiple primitives are found with\nthe specified id.","ref":"Scenic.Graph.html#get!/2","title":"Scenic.Graph.get!/2","type":"function"},{"doc":"Map all primitives in a graph into a new graph.\n\nCrawls through the entire graph, passing each primitive to the callback function.\nThe result of the callback replaces that primitive in the graph. The updated\ngraph is returned.","ref":"Scenic.Graph.html#map/2","title":"Scenic.Graph.map/2","type":"function"},{"doc":"Map all primitives in a graph that match a specified id into a new graph.\n\nCrawls through the entire graph, passing each primitive to the callback function.\nThe result of the callback replaces that primitive in the graph. The updated\ngraph is returned.\n\nThis is so similar to the modify function that it may be deprecated in the future.\nFor now I recommend you use `Graph.modify/3` instead of this.","ref":"Scenic.Graph.html#map/3","title":"Scenic.Graph.map/3","type":"function"},{"doc":"Modify one or more primitives in a graph.\n\nRetrieves the primitive (or primitives) specified by id and passes them to\na callback function. The result of the callback function is stored as the new\nversion of that primitive in the graph.\n\nIf multiple primitives match the specified id, then each is passed, in turn,\nto the callback function.\n\nThe id can be either\n* a term to match against (fast)\n* a filter function that returns a boolean (slower)\n\nExamples:\n\n    graph\n    |> Graph.modify( :explicit_id, &text(\"Updated Text 1\") )\n    |> Graph.modify( {:id, 123}, &text(\"Updated Text 2\") )\n    |> Graph.modify( &match?({:id,_},&1), &text(\"Updated Text 3\") )","ref":"Scenic.Graph.html#modify/3","title":"Scenic.Graph.modify/3","type":"function"},{"doc":"Invokes action for each primitive in the graph with the accumulator.\n\nIterates over all primitives in a graph, passing each into the callback function\nwith an accumulator. The return value of the callback is the new accumulator.\n\nThis is extremely similar in behaviour to Elixir's Enum.reduce function, except\nthat it understands how to navigate the tree structure of a Graph.","ref":"Scenic.Graph.html#reduce/3","title":"Scenic.Graph.reduce/3","type":"function"},{"doc":"Invokes action for each primitive that matches an id in the graph with the accumulator.\n\nIterates over all primitives that match a specified id, passing each into the callback\nfunction with an accumulator.\n\nThis is extremely similar in behaviour to Elixir's Enum.reduce function, except\nthat it understands how to navigate the tree structure of a Graph.","ref":"Scenic.Graph.html#reduce/4","title":"Scenic.Graph.reduce/4","type":"function"},{"doc":"","ref":"Scenic.Graph.html#t:bounds/0","title":"Scenic.Graph.bounds/0","type":"type"},{"doc":"","ref":"Scenic.Graph.html#t:deferred/0","title":"Scenic.Graph.deferred/0","type":"type"},{"doc":"","ref":"Scenic.Graph.html#t:t/0","title":"Scenic.Graph.t/0","type":"type"},{"doc":"A set of helper functions to make it easy to add to, or modify,\na graph.\n\nIn general, each helper function is of the form\n\n    def name_of_primitive( graph, data, opts \\\\ [] )\n\nor\n\n    def name_of_primitive_spec( data, opts \\\\ [] )\n\n\nThe first form builds the primitive immediately and adds it to the\ngraph that is passed in. The second form creates a specification for\nthe primitive (basically, a data structure describing how to draw it).\nYou then add this to a graph at some later time.\n\nLet's start by looking at the immediate versions.","ref":"Scenic.Primitives.html","title":"Scenic.Primitives","type":"module"},{"doc":"When adding primitives to a graph, each helper function accepts a\ngraph as the first parameter and returns the transformed graph. This\nmakes it very easy to build a complex graph by piping helper functions\ntogether.\n\n    @graph Graph.build()\n      |> text( \"Hello World\" )\n      |> rectangle( {100, 200} )\n      |> line( {{10,20}, {100, 20}})\n\n\nWhen modifying a graph, you can again use the helpers by passing\nin the primitive to be modified. The transformed primitive will\nbe returned.\n\n    Graph.modify(graph, :rect, fn(p) ->\n      rectangle(p, {200, 300})\n    end)\n\n    # or, more compactly...\n    Graph.modify(graph, :rect, &rectangle(&1, {200, 300}) )\n\nIn each case, the second parameter is a data term that is specific\nto the primitive being acted on. See the documentation below. If you\npass in invalid data for the second parameter, an error will be\nthrown, along with some explanation of what it expected.\n\nThe third parameter is a keyword list of options that are to be\napplied to the primitive. This includes setting the id, styles,\ntransforms and such.\n\n    @graph Graph.build()\n      |> text( \"Hello World\", id: :hello, font_size: 24, rotate: 0.4 )\n      |> rectangle( {100, 200}, translate: {10, 30}, fill: :yellow)\n      |> line( {{10,20}, {100, 20}}, id: :a_line, stroke: {4, :green})","ref":"Scenic.Primitives.html#module-immediate-primitive-helpers","title":"Immediate Primitive Helpers - Scenic.Primitives","type":"module"},{"doc":"Each immediate primitive helper has a corresponding deferred helper.\nThe deferred variant does not add the primitive to a graph. Instead,\nthe deferred helper returns a function. You can then call that\nfunction, passing it a graph, and the primitive will be added to that\ngraph.\n\n    text = text_spec( \"Hello World\" )\n    rect = rectangle_spec( {100, 200} )\n    line = line_spec( {{10,20}, {100, 20}})\n\n    g = Graph.build()\n    g = text.(g)\n    g = rect.(g)\n    g = line.(g)\n\nWritten like this, the deferred helpers aren't compelling. But we\ncould also write\n\n    items = [\n      text_spec( \"Hello World\" ),\n      rectangle_spec( {100, 200} ),\n      line_spec( {{10,20}, {100, 20}}),\n    ]\n\n    g = items\n      |> Enum.reduce(Graph.build(), fn item, g -> item.(g) end)\n\nDeferred helpers let us express primitives as data. This\nmakes it easier to define display graphs at compile time, particularly\nwhen we use the `group_spec/2` helper to express the grouping of\ncomponents:\n\n    @line {{0, 0}, {60, 60}}\n\n    @lines [\n      line_spec(@line, stroke: {4, :red}),\n      line_spec(@line, stroke: {20, :green}, cap: :butt, t: {60, 0}),\n      line_spec(@line, stroke: {20, :yellow}, cap: :round, t: {120, 0}),\n    ]\n\n    @text [\n      text_spec(\"Hello\", translate: {0, 40}),\n      text_spec(\"World\", translate: {90, 40}, fill: :yellow),\n    ]\n\n    @drawing Graph.build() |> add_specs_to_graph([ @lines, @text ])\n\nIf you wanted to put the lines into one group and the text into\nanother, simply interpose the `group_spec/2` helper:\n\n    @drawing Graph.build()\n             |> add_specs_to_graph([\n               group_spec(@lines, t: [100, 50]),\n               group_spec(@text, t: [150, 50])\n             ])\n\nIf you have a smaller graph or just like to see everything in one\nplace, you might prefer using `group_spec_r/2`:\n\n    @line {{0, 0}, {60, 60}}\n\n    @drawing Graph.build()\n             |> add_specs_to_graph([\n               group_spec_r([t: {100, 50}], [\n                 line_spec(@line, stroke: {4, :red}),\n                 line_spec(@line, stroke: {20, :green}, cap: :butt, t: {60, 0}),\n                 line_spec(@line, stroke: {20, :yellow}, cap: :round, t: {120, 0})\n               ]),\n               group_spec_r([t: {150, 50}], [\n                 text_spec(\"Hello\", translate: {0, 40}),\n                 text_spec(\"World\", translate: {90, 40}, fill: :yellow),\n               ])\n             ])\n\nThese examples use `add_specs_to_graph/2`, a simple helper that\nconverts specs into primitives and adds them to a graph.","ref":"Scenic.Primitives.html#module-deferred-primitive-helpers","title":"Deferred Primitive Helpers - Scenic.Primitives","type":"module"},{"doc":"Style options affect the way primitives are drawn. They include options such\nas `:fill`, `:stroke`, `:font` and many more. See the `Scenic.Primitive.Style` documentation\nfor the full list. Style options are inherited down the graph. In other words,\nif you set a style on the root of the graph like this:\n`Graph.build(font_size: 24)`, then all text items in all groups will be\nrendered with a point size of 24 unless they set a different size.\n\nNot every primitive accepts every style. For example, it doesn't make much\nsense to apply a font to a rectangle. If you try, the rectangle will ignore\nthat value. See the documentation for each primitive for a list of what styles\nthey pay attention to.\n\nTransforms that are applied to a Group are inherited by all primitives in\nthat group's branch of the tree. Note that style inheritance does not\ncross SceneRef boundaries.","ref":"Scenic.Primitives.html#module-style-options","title":"Style options - Scenic.Primitives","type":"module"},{"doc":"Transform options affect the size, position and rotation of elements in the\ngraph. Any transform you can express as a 4x4 matrix of floats, you can apply\nto any primitive in the graph, including groups and SceneRefs.\n\nTransform options are applied on the element they are specified on. If\nyou specify a transform on a group, then it is applied to everything\nrendered in that branch of the graph tree.\n\nThis is done mathematically as a \"stack\" of transforms. As the renderer\ntraverses up and down the graph, transforms are pushed and popped from the\nmatrix stack as appropriate. Transform inheritance does cross SceneRef\nboundaries.","ref":"Scenic.Primitives.html#module-transform-options","title":"Transform options - Scenic.Primitives","type":"module"},{"doc":"Primitives will be drawn in the order you add them to the graph.\nFor example, the graph below draws text on top of a filled rectangle. If the order\nof the text and rectangle were reversed, they would both still be rendered, but\nthe text would not be visible because the rectangle would cover it up.\n\n    @graph Graph.build( font: {:roboto, 20} )\n    |> rect( {100, 200}, color: :blue )\n    |> text( \"Hello World\", id: :hello, translate: {10, 10} )","ref":"Scenic.Primitives.html#module-draw-order","title":"Draw Order - Scenic.Primitives","type":"module"},{"doc":"Given a graph and a list of deferred primitive specifications,\nrun the specs in order, adding the primitives to the graph.\n\nExample:\n\n    items = [\n      text_spec(\"hello \"),\n      text_spec(\"world\")\n    ]\n\n    graph = graph |> add_specs_to_graph(items)\n\nIf given a third parameter, the specs are wrapped in a group, and that\nparameter is used as the group's options.\n\n    graph = graph |> add_specs_to_graph(items, t: {100,100})","ref":"Scenic.Primitives.html#add_specs_to_graph/2","title":"Scenic.Primitives.add_specs_to_graph/2","type":"function"},{"doc":"","ref":"Scenic.Primitives.html#add_specs_to_graph/3","title":"Scenic.Primitives.add_specs_to_graph/3","type":"function"},{"doc":"Add an arc to a graph\n\nAn arc is the outer edge of a part of a circle or ellipse. It\nis the sort of thing you would use a compass to draw on a piece\nof paper. It has a radius, and angle that defines how much of\nthe arc to sweep through. The angle is specified in radians.\n\nData:\n\n    {radius, angle}\n\nIf you want something that looks like a piece of pie (maybe for a\npie chart??), then you want a Sector, not an Arc.\n\nTo create an arc of an ellipse, create a normal arc, and apply\na `:scale` transform with unequal x and y sizing.\n\nThe following example will draw a simple arc with a radius of 100,\nstarting straight out to the right, then going down 0.4 radians.\n\n    graph\n    |> arc( {100, 0.6} )","ref":"Scenic.Primitives.html#arc/3","title":"Scenic.Primitives.arc/3","type":"function"},{"doc":"The format for Arc has changed since v0.10. It used to be\n{radius, start_angle, end_angle}. You can achieve the same effect in the\nnew, simpler format by using the same radius and the new angle is the\ndifference between the old end_angle and start_angle. Then you can apply\na rotation transform to get it in the right position.","ref":"Scenic.Primitives.html#arc/3-note","title":"Note - Scenic.Primitives.arc/3","type":"function"},{"doc":"Arcs honor the following styles\n\n* `:hidden` - If `true`, the outline is rendered. If `false`, it is skipped.\n  Default: `false`.\n* `:fill` - Fills in the interior with the specified paint. If not set, the\n  default is to not draw anything in the interior. This is similar to specifying\n  `fill: :clear`, but optimized.\n* `:stroke` - Draws the outline with the specified width and paint. The default\n  if not set is `{1, :white}`.\n\nExample:\n\n    graph\n    |> arc( {100, 0.4}, stroke: {4, :blue} )","ref":"Scenic.Primitives.html#arc/3-styles","title":"Styles - Scenic.Primitives.arc/3","type":"function"},{"doc":"Create the specification that adds an arc to a graph.\n\nSee the documentation for `arc/3` for details.\n\nExample:\n\n    arc = arc_spec( {100, 0, 0.4}, stroke: {4, :blue} )\n    graph = arc.(graph)","ref":"Scenic.Primitives.html#arc_spec/2","title":"Scenic.Primitives.arc_spec/2","type":"function"},{"doc":"The format for Arc has changed since v0.10. It used to be\n{radius, start_angle, end_angle}. You can achieve the same effect in the\nnew, simpler format by using the same radius and the new angle is the\ndifference between the old end_angle and start_angle. Then you can apply\na rotation transform to get it in the right position.","ref":"Scenic.Primitives.html#arc_spec/2-note","title":"Note - Scenic.Primitives.arc_spec/2","type":"function"},{"doc":"Add a Circle to a graph.\n\nCircles are defined by a radius.\n\nThe following example will draw circle with radius 100.\n\n    graph\n    |> circle( 100 )","ref":"Scenic.Primitives.html#circle/3","title":"Scenic.Primitives.circle/3","type":"function"},{"doc":"Circles honor the following styles\n\n* `:hidden` - If `true`, the outline is rendered. If `false`, it is skipped.\n  Default: `false`.\n* `:fill` - Fills in the interior with the specified paint. If not set, the\n  default is to not draw anything in the interior. This is similar to specifying\n  `fill: :clear`, but more optimized.\n* `:stroke` - The width and paint to draw the outline with. If the stroke is not\n  specified, the default stroke is `{1, :white}`.\n\nExample:\n\n    graph\n    |> circle( 40, fill: :red, stroke: {3, :blue}, translate: {100, 200} )\n\nWhile you could apply a `:rotate` transform to a circle, it wouldn't do\nanything visible unless you also add a uneven `:scale` transform to make it\ninto an ellipse.","ref":"Scenic.Primitives.html#circle/3-styles","title":"Styles - Scenic.Primitives.circle/3","type":"function"},{"doc":"Create the specification that adds a circle to a graph.\n\nSee the documentation for `circle/3` for details.\n\nExample:\n\n    circle = circle_spec( 40, stroke: {4, :blue} )\n    graph = circle.(graph)","ref":"Scenic.Primitives.html#circle_spec/2","title":"Scenic.Primitives.circle_spec/2","type":"function"},{"doc":"Add an Ellipse to a graph.\n\nEllipses are defined by two radii.\n\nThe following example will draw an ellipse.\n\n    graph\n    |> ellipse( {100, 140} )\n\nIf you want the ellipse to be on an angle, apply a `:rotate` transform.","ref":"Scenic.Primitives.html#ellipse/3","title":"Scenic.Primitives.ellipse/3","type":"function"},{"doc":"Ellipses honor the following styles\n\n* `:hidden` - If `true`, the outline is rendered. If `false`, it is skipped.\n  Default: `false`.\n* `:fill` - Fills in the interior with the specified paint. If not set, the\n  default is to not draw anything in the interior. This is similar to specifying\n  `fill: :clear`, but optimized.\n* `:stroke` - The width and paint to draw the outline with. If the stroke is not\n  specified, the default stroke is `{1, :white}`\n\nExample:\n\n    graph\n    |> ellipse( {40, 60}, fill: :red, stroke: {3, :blue}, rotate: 0.4 )","ref":"Scenic.Primitives.html#ellipse/3-styles","title":"Styles - Scenic.Primitives.ellipse/3","type":"function"},{"doc":"Create the specification that adds an ellipse to a graph.\n\nSee the documentation for `ellipse/3` for details.\n\nExample:\n\n    ellipse = ellipse_spec( { 40, 60 }, stroke: {4, :blue} )\n    graph = ellipse.(graph)","ref":"Scenic.Primitives.html#ellipse_spec/2","title":"Scenic.Primitives.ellipse_spec/2","type":"function"},{"doc":"Create a new branch in a Graph.\n\nThe Group primitive creates a new branch in the Graph's tree. The data field\nyou pass in is a function callback, which allows you to add more\nprimitives inside the new group.\n\nThe single parameter to your anonymous callback is a transformed graph that\nknows to add new primitives to the right branch in the tree.\n\n    @graph Graph.build( )\n    |> text( \"Hello World\" )\n    |> group(fn(g) ->\n      g\n      |> text( \"I'm in the Group\" )\n    end, translate: {40,200})\n\nNOTE: Unlike other primitives, `group/3` currently only takes a graph and not\nan existing group primitive.","ref":"Scenic.Primitives.html#group/3","title":"Scenic.Primitives.group/3","type":"function"},{"doc":"Groups will accept all styles. They don't use the styles directly, but\nany styles you set on a group become the new defaults for all primitives\nyou add to that group's branch in the graph.\n\nThe `:hidden` style is particularly effective when applied to a group as it\ncauses that entire branch to be drawn, or not.","ref":"Scenic.Primitives.html#group/3-styles","title":"Styles - Scenic.Primitives.group/3","type":"function"},{"doc":"Any transforms you apply to a group are added into the render matrix stack and\nare applied to all items in that branch, including crossing SceneRefs.","ref":"Scenic.Primitives.html#group/3-transforms","title":"Transforms - Scenic.Primitives.group/3","type":"function"},{"doc":"Bundle a list of specifications together, and return a function that,\nwhen called, will add those specs as a group to a graph.\n\nThe options are the same as for `group/3`\n\nExample:\n\n    line = {{0, 0}, {60, 60}}\n\n    lines = [\n      line_spec(@line, stroke: {4, :red}),\n      line_spec(@line, stroke: {20, :green}, cap: :butt, t: {60, 0}),\n      line_spec(@line, stroke: {20, :yellow}, cap: :round, t: {120, 0}),\n    ]\n\n    line_group = group_spec(lines, t: [ 100, 100 ])\n\n    graph = line_group.(graph)\n\nYou can also pass in a single primitive spec:\n\n    line = line_spec({{0, 0}, {60, 60}}, stroke: {4, :red}),\n    line_group = group_spec(line, t: [ 100, 100 ])\n\n    graph = line_group.(graph)","ref":"Scenic.Primitives.html#group_spec/2","title":"Scenic.Primitives.group_spec/2","type":"function"},{"doc":"Bundle a list of specifications together, and return a function that,\nwhen called, will add those specs as a group to a graph.\n\nThe options are the same as for `group_spec/2`, but reversed, making\nit suitable to use when declaring graph specs as big literals due to\nthe increased readability.\n\nExample:\n\n    line = {{0, 0}, {60, 60}}\n\n    line_group = group_spec_r([t: {100, 100}], [\n      line_spec(@line, stroke: {4, :red}),\n      line_spec(@line, stroke: {20, :green}, cap: :butt, t: {60, 0}),\n      line_spec(@line, stroke: {20, :yellow}, cap: :round, t: {120, 0}),\n    ])\n\n    graph = line_group.(graph)\n\nYou can also pass in a single primitive spec:\n\n    line = line_spec({{0, 0}, {60, 60}}, stroke: {4, :red}),\n    line_group = group_spec_r([t: {100, 100}], line)\n\n    graph = line_group.(graph)","ref":"Scenic.Primitives.html#group_spec_r/2","title":"Scenic.Primitives.group_spec_r/2","type":"function"},{"doc":"Add a line to a graph.\n\nLines are pretty simple. They start at one point and go to another.\n\nData:\n\n    { {from_x, from_y}, {to_x,to_y} }\n\nThe following example will draw a diagonal line from the upper left\ncorner `{0,0}` to the point `{100,200}`, which is down and to the right.\n\n    graph\n    |> line( {{0,0}, {100,200}} )","ref":"Scenic.Primitives.html#line/3","title":"Scenic.Primitives.line/3","type":"function"},{"doc":"Lines honor the following styles\n\n* `:hidden` - If `true`, the line is skipped. If `false`, the line is rendered.\n  Default: `false`.\n* `:stroke` - The width and paint to draw the line with. If the stroke is not\n  specified, the default stroke is `{1, :white}`.\n* `:cap` - Specifies the shape of the ends of the line. Can be one of `:round`,\n  `:butt`, or `:square`. If cap is not specified, then the default is `:butt`.\n\nExample:\n\n    graph\n    |> line( {{0,0}, {100,200}}, stroke: {4, :blue}, cap: :round )","ref":"Scenic.Primitives.html#line/3-styles","title":"Styles - Scenic.Primitives.line/3","type":"function"},{"doc":"Create the specification that adds a line to a graph.\n\nSee the documentation for `line/3` for details.\n\nExample:\n\n    line = line_spec( {{0,0}, {100,200}, stroke: {4, :blue} )\n    graph = line.(graph)","ref":"Scenic.Primitives.html#line_spec/2","title":"Scenic.Primitives.line_spec/2","type":"function"},{"doc":"Add custom, complex shape to a graph.\n\nA custom path is defined by a list of actions that the renderer\ncan follow. This is about as close as Scenic gets to immediate\nmode rendering.\n\nSee `Scenic.Primitive.Path` for details.\n\n    graph\n    |> path( [\n        :begin,\n        {:move_to, 10, 20},\n        {:line_to, 30, 40},\n        {:bezier_to, 10, 11, 20, 21, 30, 40},\n        {:quadratic_to, 10, 11, 50, 60},\n        {:arc_to, 70, 80, 90, 100, 20},\n        :close_path,\n      ],\n      stroke: {4, :blue}, cap: :round\n    )","ref":"Scenic.Primitives.html#path/3","title":"Scenic.Primitives.path/3","type":"function"},{"doc":"Create the specification that adds a path to a graph.\n\nSee the documentation for `path/3` for details.\n\nExample:\n\n    path = path_spec( [\n        :begin,\n        {:move_to, 10, 20},\n        {:line_to, 30, 40},\n        {:bezier_to, 10, 11, 20, 21, 30, 40},\n        {:quadratic_to, 10, 11, 50, 60},\n        {:arc_to, 70, 80, 90, 100, 20},\n        :close_path,\n      ],\n      stroke: {4, :blue}, cap: :round\n    )\n\n    graph = path.(graph)","ref":"Scenic.Primitives.html#path_spec/2","title":"Scenic.Primitives.path_spec/2","type":"function"},{"doc":"Add a Quadrilateral (quad) to a graph.\n\nQuads are defined by four points on the screen.\n\nData:\n\n    { {x0,y0}, {x1,y1}, {x2,y2}, {x3,y3} }\n\nThe following example will draw a quad.\n\n    graph\n    |> quad( {{10,20}, {100,20}, {90, 120}, {15, 70}} )","ref":"Scenic.Primitives.html#quad/3","title":"Scenic.Primitives.quad/3","type":"function"},{"doc":"Quads honor the following styles\n\n* `:hidden` - If `true`, the outline is rendered. If `false`, it is skipped.\n  Default: `false`.\n* `:fill` - Fills in the interior with the specified paint. If not set, the\n  default is to not draw anything in the interior. This is similar to specifying\n  fill: :clear, except optimized out to do nothing.\n* `:stroke` - The width and paint to draw the outline with. If the stroke is not\n  specified then the default stroke is `{1, :white}`\n* `:join` - Specifies how the lines are joined together where they meet. Can be\n  one of `:miter`, `:round`, or `:bevel`. If join is not specified, then\n  the default is `:miter`\n* `:miter_limit` - Apply an optional miter limit to the joints. If the angle\n  is very shallow, the pointy bit might extend out far beyond the joint.\n  Specifying `:miter_limit` puts a limit on the joint and bevels it if\n  it goes out too far.\n\nExample:\n\n    graph\n    |> quad( {{10,20}, {100,20}, {90, 120}, {15, 70}},\n      fill: :red, stroke: {3, :blue}, join: :round )","ref":"Scenic.Primitives.html#quad/3-styles","title":"Styles - Scenic.Primitives.quad/3","type":"function"},{"doc":"Create the specification that adds a quad to a graph.\n\nSee the documentation for `quad/3` for details.\n\nExample:\n\n    quad = quad_spec(\n      {{10,20}, {100,20}, {90, 120}, {15, 70}},\n      fill: :red, stroke: {3, :blue}, join: :round\n    )\n\n    graph = quad.(graph)","ref":"Scenic.Primitives.html#quad_spec/2","title":"Scenic.Primitives.quad_spec/2","type":"function"},{"doc":"Shortcut to the `rectangle/3` function.\n\n`rect/3` is the same as calling `rectangle/3`","ref":"Scenic.Primitives.html#rect/3","title":"Scenic.Primitives.rect/3","type":"function"},{"doc":"Create the specification that adds a rectangle to a graph.\n\nSee the documentation for `rectangle/3` for details.\n\nExample:\n\n    rect = rect_spec(\n      {{10,20}, {100,20}},\n      fill: :red, stroke: {3, :blue}, join: :round\n    )\n\n    graph = rect.(graph)","ref":"Scenic.Primitives.html#rect_spec/2","title":"Scenic.Primitives.rect_spec/2","type":"function"},{"doc":"Add a rectangle to a graph.\n\nRectangles are defined by a width and height.\n\nData:\n\n    { width, height }\n\nThe following example will draw a rectangle.\n\n    graph\n    |> rectangle( {100, 200} )","ref":"Scenic.Primitives.html#rectangle/3","title":"Scenic.Primitives.rectangle/3","type":"function"},{"doc":"Rectangles honor the following styles\n\n* `:hidden` - If `true`, the outline is rendered. If `false`, it is skipped.\n  Default: `false`.\n* `:fill` - Fills in the interior with the specified paint. If not set, the\n  default is to not draw anything in the interior. This is similar to specifying\n  fill: :clear, except optimized out to do nothing.\n* `:stroke` - The width and paint to draw the outline with. If the stroke is not\n  specified then the default stroke is `{1, :white}`\n* `:join` - Specifies how the lines are joined together where they meet. Can be\n  one of `:miter`, `:round`, or `:bevel`. If join is not specified, then\n  the default is `:miter`\n* `:miter_limit` - Apply an optional miter limit to the joints. If the angle\n  is very shallow, the pointy bit might extend out far beyond the joint.\n  Specifying `:miter_limit` puts a limit on the joint and bevels it if\n  it goes out too far.\n\n\nExample:\n\n    graph\n    |> rectangle( {100, 200},\n      fill: :red, stroke: {3, :blue}, join: :round )","ref":"Scenic.Primitives.html#rectangle/3-styles","title":"Styles - Scenic.Primitives.rectangle/3","type":"function"},{"doc":"Create the specification that adds a rectangle to a graph.\n\nSee the documentation for `rectangle/3` for details.\n\nExample:\n\n    rect = rectangle_spec(\n      {{10,20}, {100,20}},\n      fill: :red, stroke: {3, :blue}, join: :round\n    )\n\n    graph = rect.(graph)","ref":"Scenic.Primitives.html#rectangle_spec/2","title":"Scenic.Primitives.rectangle_spec/2","type":"function"},{"doc":"Add a rounded rectangle to a graph.\n\nRounded rectangles are defined by a width, height, and radius.\n\nData:\n\n    { width, height, radius }\n\nThe following example will draw a rounded rectangle.\n\n    graph\n    |> rounded_rectangle( {100, 200, 8} )","ref":"Scenic.Primitives.html#rounded_rectangle/3","title":"Scenic.Primitives.rounded_rectangle/3","type":"function"},{"doc":"Rounded rectangles honor the following styles\n\n* `:hidden` - If `true`, the outline is rendered. If `false`, it is skipped.\n  Default: `false`.\n* `:fill` - Fills in the interior with the specified paint. If not set, the\n  default is to not draw anything in the interior. This is similar to specifying\n  fill: :clear, except optimized out to do nothing.\n* `:stroke` - The width and paint to draw the outline with. If the stroke is not\n  specified then the default stroke is `{1, :white}`\n\nExample:\n\n    graph\n    |> rounded_rectangle( {100, 200, 8},\n      fill: :red, stroke: {3, :blue} )","ref":"Scenic.Primitives.html#rounded_rectangle/3-styles","title":"Styles - Scenic.Primitives.rounded_rectangle/3","type":"function"},{"doc":"Create the specification that adds a rounded rectangle to a graph.\n\nSee the documentation for `rounded_rectangle/3` for details.\n\nExample:\n\n    rect = rounded_rectangle_spec(\n      {{10,20}, {100,20}},\n      fill: :red, stroke: {3, :blue}, join: :round\n    )\n\n    graph = rect.(graph)","ref":"Scenic.Primitives.html#rounded_rectangle_spec/2","title":"Scenic.Primitives.rounded_rectangle_spec/2","type":"function"},{"doc":"Shortcut to the `rounded_rectangle/3` function.\n\n`rrect/3` is the same as calling `rounded_rectangle/3`","ref":"Scenic.Primitives.html#rrect/3","title":"Scenic.Primitives.rrect/3","type":"function"},{"doc":"Create the specification that adds a rounded rectangle to a graph.\n\nSee the documentation for `rounded_rectangle/3` for details.\n\nExample:\n\n    rect = rrect_spec(\n      {{10,20}, {100,20}},\n      fill: :red, stroke: {3, :blue}, join: :round\n    )\n\n    graph = rect.(graph)","ref":"Scenic.Primitives.html#rrect_spec/2","title":"Scenic.Primitives.rrect_spec/2","type":"function"},{"doc":"Add a named script to a graph.\n\nScripts are defined by a name, which can be an atom, string, pid or reference.\n\nNOTE: this doesn't add the script itself. Only places a reference to it in\nthe graph. You still need to add the script to the ViewPort via\n`Scenic.ViewPort.put_script/4`.\n\nData:\n\n    name","ref":"Scenic.Primitives.html#script/3","title":"Scenic.Primitives.script/3","type":"function"},{"doc":"Setting styles on a script is similar to setting styles on a group\n\nExample:\n\n    graph\n    |> script( :my_script )","ref":"Scenic.Primitives.html#script/3-styles","title":"Styles - Scenic.Primitives.script/3","type":"function"},{"doc":"Create the specification that adds a script to a graph.\n\nSee the documentation for `script/3` for details.\n\nExample:\n\n    script = script_spec(\"script_name\", translate: {20,30} )","ref":"Scenic.Primitives.html#script_spec/2","title":"Scenic.Primitives.script_spec/2","type":"function"},{"doc":"Add a sector to a graph\n\nA sector looks like a piece of pie. It is wedge shaped with a pointy\nbit on one side and a rounded bit on the other. It has a radius, and angle that\ndefines how much of the arc to sweep through. The angle is specified in radians.\n\nData:\n\n    {radius, angle}\n\nTo create a sector of an ellipse, create a normal sector, and apply\na `:scale` transform with unequal x and y sizing.\n\nThe following example will draw a sector with a radius of 100,\nstarting straight out to the right, then going down 0.4 radians.\n\n    |> sector( {100, 0.4} )","ref":"Scenic.Primitives.html#sector/3","title":"Scenic.Primitives.sector/3","type":"function"},{"doc":"The format for Sector has changed since v0.10. It used to be\n{radius, start_angle, end_angle}. You can achieve the same effect in the\nnew, simpler format by using the same radius and the new angle is the\ndifference between the old end_angle and start_angle. Then you can apply\na rotation transform to get it in the right position.","ref":"Scenic.Primitives.html#sector/3-note","title":"Note - Scenic.Primitives.sector/3","type":"function"},{"doc":"Sectors honor the following styles\n\n* `:hidden` - If `true`, the outline is rendered. If `false`, it is skipped.\n  Default: `false`.\n* `:fill` - Fills in the interior with the specified paint. If not set, the\n  default is to not draw anything in the interior. This is similar to specifying\n  fill: :clear, except optimized out to do nothing.\n* `:stroke` - Draws the outline with the specified width and paint. The default\n  if not set is `{1, :white}`\n\nWhen you apply a stroke to a sector, it goes around the whole piece\nof pie. If you only want to stroke the curvy part, which is common\nin pie charts, overlay an Arc on top of the sector and stroke that.\n\nIf you also put both the sector and the arc together in a Group, you can\nthen apply transforms to the group to position both the primitives as a single\nunit.\n\nExample:\n\n    graph\n    |> group(fn(g) ->\n      g\n      |> sector( {100, 0, 0.4}, fill: :red )\n      |> arc( {100, 0, 0.4}, stroke: {4, :blue} )\n    end, translate: {30, 40})","ref":"Scenic.Primitives.html#sector/3-styles","title":"Styles - Scenic.Primitives.sector/3","type":"function"},{"doc":"Create the specification that adds a sector ref to a graph.\n\nSee the documentation for `sector/3` for details.\n\nExample:\n\n    sector = sector_spec( {100, 0.4}, fill: :red )\n    graph  = sector.(graph)","ref":"Scenic.Primitives.html#sector_spec/2","title":"Scenic.Primitives.sector_spec/2","type":"function"},{"doc":"The format for Sector has changed since v0.10. It used to be\n{radius, start_angle, end_angle}. You can achieve the same effect in the\nnew, simpler format by using the same radius and the new angle is the\ndifference between the old end_angle and start_angle. Then you can apply\na rotation transform to get it in the right position.","ref":"Scenic.Primitives.html#sector_spec/2-note","title":"Note - Scenic.Primitives.sector_spec/2","type":"function"},{"doc":"Add a sprites list to a graph.","ref":"Scenic.Primitives.html#sprites/3","title":"Scenic.Primitives.sprites/3","type":"function"},{"doc":"Create the specification that adds a sprites list to a graph.\n\nSee the documentation for `sprites/3` for details.\n\nExample:\n\n    sprites = sprites_spec({:static, \"source_texure\"}, translate: {20,30} )","ref":"Scenic.Primitives.html#sprites_spec/2","title":"Scenic.Primitives.sprites_spec/2","type":"function"},{"doc":"Adds text to a graph.\n\nText is pretty simple. Specify the string you would like drawn.\n\nThe following example will draw some text on the screen.\n\n    graph\n    |> text( \"Hello World\", translate: {20, 20} )","ref":"Scenic.Primitives.html#text/3","title":"Scenic.Primitives.text/3","type":"function"},{"doc":"Text honors the following styles\n\n* `:hidden` - If `true`, the outline is rendered. If `false`, it is skipped.\n  Default: `false`.\n* `:fill` - The paint to color the text with. If not specified, the default\n  is :white. Note: Text can only be filled with solid colors at this time.\n* `:font` - Specifies font family to draw the text with. The built-in system\n  fonts are `:roboto` and `:roboto_mono`. If not specified, the\n  default is `:roboto`. You can also load your own font into the `Scenic.Cache`,\n  then specify its key for the font.\n* `:font_blur` - Draw the text with a blur effect. If you draw text with blur,\n  then draw it again without blur, slightly offset, you get a nice drop shadow\n  effect. The default is to draw with no blur.\n* `:text_align` - Specify the alignment of the text you are drawing. You will\n  usually specify one of: `:left`, `:center`, or `:right`. See\n  `Scenic.Primitive.Style.TextAlign` for details.\n* `:text_height` - Specify the vertical spacing between rows of text.\n\n\nExample:\n\n    graph\n    |> text( \"Hello World\", fill: :yellow, font: :roboto_mono\n        font_blur: 2.0, text_align: :center )","ref":"Scenic.Primitives.html#text/3-styles","title":"Styles - Scenic.Primitives.text/3","type":"function"},{"doc":"Create the specification that adds text to a graph.\n\nSee the documentation for `text/3` for details.\n\nExample:\n\n    text  = text_spec( \"a wombat is a marsupial\", fill: :red )\n    graph = text.(graph)","ref":"Scenic.Primitives.html#text_spec/2","title":"Scenic.Primitives.text_spec/2","type":"function"},{"doc":"Add a Triangle to a graph.\n\nTriangles are defined by three points on the screen.\n\nData:\n\n    { {x0,y0}, {x1,y1}, {x2,y2} }\n\nThe following example will draw a triangle.\n\n    graph\n    |> triangle( {{10,20}, {100,20}, {50, 120}} )","ref":"Scenic.Primitives.html#triangle/3","title":"Scenic.Primitives.triangle/3","type":"function"},{"doc":"Triangles honor the following styles\n\n* `:hidden` - If `true`, the outline is rendered. If `false`, it is skipped.\n  Default: `false`.\n* `:fill` - Fills in the interior with the specified paint. If not set, the\n  default is to not draw anything in the interior. This is similar to specifying\n  `fill: :clear`, but optimized.\n* `:stroke` - The width and paint to draw the outline with. If the stroke is not\n  specified, the default stroke is `{1, :white}`.\n* `:join` - Specifies how the lines are joined together where they meet. Can be\n  one of `:miter`, `:round`, or `:bevel`. If join is not specified, then\n  the default is `:miter`.\n* `:miter_limit` - Apply an optional miter limit to the joints. If the angle\n  is very shallow, the pointy bit might extend out far beyond the joint.\n  Specifying `:miter_limit` puts a limit on the joint and bevels it if\n  it goes out too far.\n\n\nExample:\n\n    graph\n    |> triangle( {{10,20}, {100,20}, {50, 120}}, fill: :red,\n      stroke: {3, :blue}, join: :round )","ref":"Scenic.Primitives.html#triangle/3-styles","title":"Styles - Scenic.Primitives.triangle/3","type":"function"},{"doc":"Create the specification that adds a triangle to a graph.\n\nSee the documentation for `triangle/3` for details.\n\nExample:\n\n    triangle = triangle_spec({{10,20}, {100,20}, {50, 120}}, fill: :red )\n    graph    = triangle.(graph)","ref":"Scenic.Primitives.html#triangle_spec/2","title":"Scenic.Primitives.triangle_spec/2","type":"function"},{"doc":"Update the options of a primitive without changing its data.\n\nThis is not used during graph creation - only when modifying it later.\n\nAll the primitive-specific helpers require you to specify the\ndata for the primitive. If you only want to modify a transform\nor add a style, then use this function.\n\nExample:\n\n    Graph.modify(graph, :rect, fn(p) ->\n      update_opts(p, rotate: 0.5)\n    end)\n\n    # or, more compactly...\n\n    Graph.modify(graph, :rect, &update_opts(&1, rotate: 0.5) )","ref":"Scenic.Primitives.html#update_opts/2","title":"Scenic.Primitives.update_opts/2","type":"function"},{"doc":"`Scenic.PubSub` is a combination pub/sub server and data cache.\n\nIt is intended to be the interface between sensors (or other data sources) and Scenic scenes.","ref":"Scenic.PubSub.html","title":"Scenic.PubSub","type":"module"},{"doc":"Sensors (or other data sources) and scenes often need to communicate, but tend to operate on different timelines.\n\nSome sensors update fairly slowly or don't behave well when asked to get data at random times by multiple clients.\n`Scenic.PubSub` is backed by a `GenServer` that collects data from a data source in a well-behaved manner,\nyet is able to serve that data on demand or by subscription to many clients.","ref":"Scenic.PubSub.html#module-why-scenic-pubsub","title":"Why Scenic.PubSub - Scenic.PubSub","type":"module"},{"doc":"It is important to note that `Scenic.PubSub` is global in scope. In other words, anything published\ninto `Scenic.PubSub` is visible to all `ViewPorts` and `Scenes`.","ref":"Scenic.PubSub.html#module-global-scope","title":"Global Scope - Scenic.PubSub","type":"module"},{"doc":"Before a process can start publishing data from a source, it must register a source id with `Scenic.PubSub`.\nThis source id should be an atom. This prevents other processes from stepping on that data and alerts any\nsubscribing processes that the data is coming online.\n\n      Scenic.PubSub.register( source_id )\n\nThe `source_id` parameter must be an atom that names the sensor. Subscribers will use this id to request\ndata or subscriptions to the source.\n\nYou can can also unregister data sources if they are no longer available.\n\n      Scenic.PubSub.unregister( source_id )\n\nSimply exiting the data source process does also cleans up its registration.","ref":"Scenic.PubSub.html#module-registering-data-sources","title":"Registering Data Sources - Scenic.PubSub","type":"module"},{"doc":"When a sensor process publishes data, two things happen. First, that data is cached in an `:ets` table so\nthat future requests for that data from scenes happen quickly and don't need to bother the data\nsource process. Second, any processes that have subscribed to that source are sent a message containing the new data.\n\n      Scenic.PubSub.publish( source_id, value )\n\nThe `source_id` parameter must be the atom that was previously registered.\n\nThe `value` parameter can be anything that makes sense for the data source.","ref":"Scenic.PubSub.html#module-publishing-data","title":"Publishing Data - Scenic.PubSub","type":"module"},{"doc":"Scenes (or any other process) can subscribe to a data source. They will receive messages when the source updates its data, comes online, or goes away.\n\n      Scenic.PubSub.subscribe( source_id )\n\nThe `source_id` parameter is the atom registered for the data source. Note that the name source does NOT\nneed to be registered when a listening process subscribes to it. When the source process eventually registers and\nstarts publishing data, the listening subscribers will be notified.\n\n\nThe subscribing process will then start receiving messages that can be handled with `handle_info/2`\n\nevent | message sent to subscribers\n--- | ---\ndata published | `{{Scenic.PubSub, :data}, {source_id, value, timestamp}}` \nsource registered | `{{Scenic.PubSub, :registered}, {source_id, opts}}` \nsource unregistered | `{{Scenic.PubSub, :unregistered}, source_id}` \n\n\n\nScenes can also unsubscribe if they are no longer interested in updates.\n\n      Scenic.PubSub.unsubscribe( source_id )","ref":"Scenic.PubSub.html#module-subscribing-to-a-data-source","title":"Subscribing to a Data Source - Scenic.PubSub","type":"module"},{"doc":"Any process can get data from a source on demand, whether or not it is a subscriber.\n\n      Scenic.PubSub.get( source_id )\n      >> {:ok, data}\n\nAny process can list the currently registered data sources.\n\n      Scenic.PubSub.list()\n      >> [{source_id, opts, pid}]","ref":"Scenic.PubSub.html#module-other-functions","title":"Other functions - Scenic.PubSub","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Scenic.PubSub.html#child_spec/1","title":"Scenic.PubSub.child_spec/1","type":"function"},{"doc":"Retrieve the cached data for a named data source.\n\nThis data is pulled from an `:ets` table and does not put load on the data source itself.","ref":"Scenic.PubSub.html#fetch/1","title":"Scenic.PubSub.fetch/1","type":"function"},{"doc":"* `source_id` an atom that is registered to a data source.","ref":"Scenic.PubSub.html#fetch/1-parameters","title":"Parameters - Scenic.PubSub.fetch/1","type":"function"},{"doc":"{:ok, {source_id, data, timestamp}}\n\n* `source_id` is the atom representing the data source.\n* `data` source_id whatever data the data source last published.\n* `timestamp` is the time - from `:os.system_time(:micro_seconds)` - the last data was published.\n\nIf the data source is either not registered, or has not yet published any data, get returns\n\n      {:error, :no_data}","ref":"Scenic.PubSub.html#fetch/1-return-value","title":"Return Value - Scenic.PubSub.fetch/1","type":"function"},{"doc":"Retrieve the cached data value for a named data source.\n\nThis data is pulled from an `:ets` table and does not put load on the data source itself.","ref":"Scenic.PubSub.html#get/1","title":"Scenic.PubSub.get/1","type":"function"},{"doc":"* `source_id` an atom that is registered to a data source.","ref":"Scenic.PubSub.html#get/1-parameters","title":"Parameters - Scenic.PubSub.get/1","type":"function"},{"doc":"data\n\nIf the data source is either not registered, or has not yet published any data, get returns\n\n      nil","ref":"Scenic.PubSub.html#get/1-return-value","title":"Return Value - Scenic.PubSub.get/1","type":"function"},{"doc":"Retrieve the cached data value for a named data source.\n\nRaises an error if the value is not registered\n\nThis data is pulled from an `:ets` table and does not put load on the data source itself.","ref":"Scenic.PubSub.html#get!/1","title":"Scenic.PubSub.get!/1","type":"function"},{"doc":"* `source_id` an atom that is registered to a data source.","ref":"Scenic.PubSub.html#get!/1-parameters","title":"Parameters - Scenic.PubSub.get!/1","type":"function"},{"doc":"data\n\nIf the data source is either not registered, or has not yet published any data, get returns\n\n      nil","ref":"Scenic.PubSub.html#get!/1-return-value","title":"Return Value - Scenic.PubSub.get!/1","type":"function"},{"doc":"List the registered data sources.","ref":"Scenic.PubSub.html#list/0","title":"Scenic.PubSub.list/0","type":"function"},{"doc":"`list/0` returns a list of registered data sources\n\n      [{source_id, version, description, pid}]\n\n* `source_id` is the atom representing the data source.\n* `opts` options list of metadata about the data source.\n  * `:version` is the version string supplied by the data source during registration.\n  * `:description` is the description string supplied by the data source during registration.\n  * `:registered_at` The system time the data source was registered at.\n* `pid` is the pid of the data source's process.","ref":"Scenic.PubSub.html#list/0-return-value","title":"Return Value - Scenic.PubSub.list/0","type":"function"},{"doc":"Publish a data point from a data source.\n\nWhen a data source uses `publish/2` to publish data, that data is recorded in the\ncache and a\n      {{Scenic.PubSub, :data}, {source_id, my_value, timestamp}}\nmessage is sent to each subscriber. The timestamp is the current time in microseconds as returned\nfrom `:os.system_time(:micro_seconds)`.","ref":"Scenic.PubSub.html#publish/2","title":"Scenic.PubSub.publish/2","type":"function"},{"doc":"* `source_id` an atom that is registered to a data source.\n* `data` the data to publish.","ref":"Scenic.PubSub.html#publish/2-parameters","title":"Parameters - Scenic.PubSub.publish/2","type":"function"},{"doc":"On success, returns `:ok`\n\nIt returns `{:error, :not_registered}` if the caller is not the\nregistered process for the data source.","ref":"Scenic.PubSub.html#publish/2-return-value","title":"Return Value - Scenic.PubSub.publish/2","type":"function"},{"doc":"Retrieve the full cached data for a named data source.\n\nThis data is pulled from an `:ets` table and does not put load on the data source itself.","ref":"Scenic.PubSub.html#query/1","title":"Scenic.PubSub.query/1","type":"function"},{"doc":"* `source_id` an atom that is registered to a data source.","ref":"Scenic.PubSub.html#query/1-parameters","title":"Parameters - Scenic.PubSub.query/1","type":"function"},{"doc":"{:ok, {source_id, data, timestamp}}\n\n* `source_id` is the atom representing the data source.\n* `data` source_id whatever data the data source last published.\n* `timestamp` is the time - from `:os.system_time(:micro_seconds)` - the last data was published.\n\nIf the data source is either not registered, or has not yet published any data, get returns\n\n      {:error, :not_found}","ref":"Scenic.PubSub.html#query/1-return-value","title":"Return Value - Scenic.PubSub.query/1","type":"function"},{"doc":"Register the calling process as a data source for the named id.","ref":"Scenic.PubSub.html#register/2","title":"Scenic.PubSub.register/2","type":"function"},{"doc":"* `source_id` the data source being registered.\n* `opts` optional information about the data source.\n\nSupported options:\n* `:version` (`t:String.t/0`) - Data format version\n\n* `:description` (`t:String.t/0`) - Your appropriate description","ref":"Scenic.PubSub.html#register/2-parameters","title":"Parameters - Scenic.PubSub.register/2","type":"function"},{"doc":"On success, returns `{:ok, source_id}`\n\nIf `source_id` is already registered to another process, it returns\n\n    {:error, :already_registered}","ref":"Scenic.PubSub.html#register/2-return-value","title":"Return Value - Scenic.PubSub.register/2","type":"function"},{"doc":"Subscribe the calling process to receive events about a data source.\n\nThe messages the subscriber will start receiving about a data source are:\n\nevent | message sent to subscribers\n--- | ---\ndata published | `{{Scenic.PubSub, :data}, {source_id, value, timestamp}}` \nsource registered | `{{Scenic.PubSub, :registered}, {source_id, opts}}` \nsource unregistered | `{{Scenic.PubSub, :unregistered}, source_id}`","ref":"Scenic.PubSub.html#subscribe/1","title":"Scenic.PubSub.subscribe/1","type":"function"},{"doc":"* `source_id` an atom that is registered to a data source.","ref":"Scenic.PubSub.html#subscribe/1-parameters","title":"Parameters - Scenic.PubSub.subscribe/1","type":"function"},{"doc":"On success, returns `:ok`","ref":"Scenic.PubSub.html#subscribe/1-return-value","title":"Return Value - Scenic.PubSub.subscribe/1","type":"function"},{"doc":"Unregister the calling process as a data source for a data source.","ref":"Scenic.PubSub.html#unregister/1","title":"Scenic.PubSub.unregister/1","type":"function"},{"doc":"* `source_id` the data source being registered.","ref":"Scenic.PubSub.html#unregister/1-parameters","title":"Parameters - Scenic.PubSub.unregister/1","type":"function"},{"doc":"Returns `:ok`","ref":"Scenic.PubSub.html#unregister/1-return-value","title":"Return Value - Scenic.PubSub.unregister/1","type":"function"},{"doc":"Unsubscribe the calling process from receive events about a data source.\n\nThe caller will stop receiving events about a data source","ref":"Scenic.PubSub.html#unsubscribe/1","title":"Scenic.PubSub.unsubscribe/1","type":"function"},{"doc":"* `source_id` an atom that is registered to a data source.","ref":"Scenic.PubSub.html#unsubscribe/1-parameters","title":"Parameters - Scenic.PubSub.unsubscribe/1","type":"function"},{"doc":"Returns `:ok`","ref":"Scenic.PubSub.html#unsubscribe/1-return-value","title":"Return Value - Scenic.PubSub.unsubscribe/1","type":"function"},{"doc":"","ref":"Scenic.Scene.html","title":"Scenic.Scene","type":"behaviour"},{"doc":"Scenes are the core of the UI model.\n\nA Scene is a type of GenServer that maintains state, handles input,\nevents and other messages, and plays a role managing the supervision of\ncomponents/controls such as buttons and other input.","ref":"Scenic.Scene.html#module-overview","title":"Overview - Scenic.Scene","type":"behaviour"},{"doc":"Before saying anything else I want to emphasize that the rest of your\napplication, meaning device control logic, sensor reading / writing,\nservices, whatever, does not need to have anything to do with Scenes.\n\nIn many cases I recommend treating those as separate GenServers in their\nown supervision trees that you maintain. Then your Scenes would query or send\ninformation to/from them via cast or call messages.\n\nPart of the point of using Elixir/Erlang/OTP is separating this sort of\nlogic into independent trees. That way, an error in one part of your\napplication does not mean the rest of it will fail.","ref":"Scenic.Scene.html#module-a-brief-aside","title":"A brief aside - Scenic.Scene","type":"behaviour"},{"doc":"Scenes are the core of the UI model. A scene consists of one or more\ngraphs, and a set of event handlers and filters to deal with user input\nand other messages.\n\nThink of a scene as being a little like an HTML page. HTML pages have:\n\n* Structure (the DOM)\n* Logic (Javascript)\n* Links to other pages.\n\nA Scene has:\n\n* Structure (graphs),\n* Logic (event handlers and filters)\n* Transitions to other scenes. Well... it can request the [`ViewPort`](overview_viewport.html)\nto go to a different scene.\n\nYour application is a collection of scenes that are in use at different times. There\nis only ever **one** scene showing in a [`ViewPort`](overview_viewport.html) at a given\ntime. However, scenes can instantiate components, effectively embedding their graphs\ninside the main one. More on that below.\n\n\n### [Graphs](Scenic.Graph.html)\n\nEach scene should maintain at least one graph. You can build graphs\nat compile time, or dynamically while your scene is running. Building\nthem at compile time has two advantages\n\n  1. Performance: It is clearly faster to build the graph once during\n  build time than to build it repeatedly during runtime.\n  2. Error checking: If your graph has an error in it, it is much\n  better to have it stop compilation than cause an error during runtime.\n\nExample of building a graph during compile time:\n\n    @graph Scenic.Graph.build(font_size: 24)\n      |> button({\"Press Me\", :button_id}, translate: {20, 20})\n\nRather than having a single scene maintain a massive graph of UI,\ngraphs can reference graphs in other scenes.\n\nOn a typical screen of UI, there is one scene\nthat is the root. Each control, is its own scene process with\nits own state. These child scenes can in turn contain other\nchild scenes. This allows for strong code reuse, isolates knowledge\nand logic to just the pieces that need it, and keeps the size of any\ngiven graph to a reasonable size. For example, the\nhandlers of a check-box scene don't need to know anything about\nhow a slider works, even though they are both used in the same\nparent scene. At best, they only need to know that they\nboth conform to the `Component.Input` behavior, and can thus\nquery or set each others value. Though it is usually\nthe parent scene that does that.\n\nThe application developer is responsible for building and\nmaintaining the scene's graph. It only enters the world of the\n`ViewPort` when you call `push_graph`. Once you have called\n`push_graph`, that graph is sent to the drivers and is out of your\nimmediate control. You update that graph by calling `push_graph`\nagain.","ref":"Scenic.Scene.html#module-scenes","title":"Scenes - Scenic.Scene","type":"behaviour"},{"doc":"The overall structure of a scene has several parts. It is a `GenServer`, which means you\nhave an input function and can implement the GenServer callbacks such as\n`handle_info/2`, `handle_cast/2`, `handle_call/3` and any others. The terms\nyou return from those callbacks is pretty much what you expect with the requirement that\nthe state is always a scene structure.\n\nThe `init/3` callback takes 3 parameters. They are the scene structure (state), params that\nthe parent scene set up, and opts, which includes things like the id, theme, and some styles\nthat were set on the scene.\n\nThere are several additional callbacks that your scene can support. The main ones are\n`handle_input/2`, and `handle_event/3`. If you are making a Component (a reusable scene), then\nthere are additional callbacks that allow it to play nicely with others.","ref":"Scenic.Scene.html#module-scene-structure","title":"Scene Structure - Scenic.Scene","type":"behaviour"},{"doc":"This example shows a simple scene that contains a button. When the button is clicked, the\nscene increments a counter and displays the number of clicks it has received.\n\n```elixir\ndefmodule MySimpleScene do\n  use Scenic.Scene\n\n  alias Scenic.Graph\n  import Scenic.Primitives\n  import Scenic.Components\n\n  @initial_count  0\n\n  # This graph is built at compile time so it doesn't do any work at runtime.\n  # It could also be built in the init function (or any other) if you want\n  # it to be dynamic based on the params or whatever.\n  @graph Graph.build()\n      |> group( fn graph ->\n        graph\n        |> text( \"Count: \" <> inspect(@initial_count), id: :count )\n        |> button( \"Click Me\", id: :btn, translate: {0, 30} )\n      end,\n      translate: {100, 100}\n    )\n\n  # Simple function to return @graph.\n  # @graph is built at compile time and stored directly in the BEAM file every\n  # time it is used. A simple accessor function will cause it to be stored only once.\n  # Do this when you build graphs at compile time to save space in your file.\n  defp graph(), do: @graph\n\n  # The Scenic.Scene init function\n  @impl Scenic.Scene\n  def init(scene, _params, _opts) do\n    scene =\n      scene\n      |> assign( count: @initial_count )\n      |> push_graph( graph() )\n    {:ok, scene}\n  end\n\n  @impl Scenic.Scene\n  def handle_event( {:click, :btn}, _, %{assigns: %{count: count}} = scene ) do\n    count = count + 1\n\n    # modify the graph to show the current click count\n    graph =\n      graph()\n      |> Graph.modify( :count, &text(&1, \"Count: \" <> inspect(count)) )\n\n    # update the count and push the modified graph\n    scene =\n      scene\n      |> assign( count: count )\n      |> push_graph( graph )\n\n    # return the updated scene\n    { :noreply, scene }\n  end\n\nend\n```","ref":"Scenic.Scene.html#module-scene-example","title":"Scene Example - Scenic.Scene","type":"behaviour"},{"doc":"Scenes are just a specialized form of `GenServer`. This means they can react to messages\nand can have state. However, scene state is a bit like socket state in `Phoenix` in that\nIt has a strict format, but you can add anything you want into its `:assigns` map.\n\n\n#### Multiple Graphs\n\nAny given scene can maintain multiple graphs and multiple draw scripts.\nThey are identified from each other with an id that you attach.\n\nNormally when you use push_graph, you don't attach an ID. In that case\nthe scene's id is used as the graph id.\n\nThe act of pushing a graph to the ViewPort causes it to be compiled into\na script, which is stored in an ETS table so that the drivers can quickly\naccess it. To use a second, or third, graph that you scene has pushed, refer\nto it using a `Scenic.Primitive.Script` primitive.\n\n\n```elixir\ndef init( scene, param, opts ) do\n  second_graph = Scenic.Graph.build()\n    |> text( \"Text in the second graph\" )\n\n  main_graph = Scenic.Graph.build()\n    |> script( \"my_fancy_id\" )\n\n  scene =\n    scene\n    |> push_graph( main_graph )\n    |> push_graph( second_graph, \"my_fancy_id\" )\n\n  { :ok, scene }\nend\n```\n\nNote that it doesn't matter which graph you push first. They will link to each other\nvia the string id that you supply.","ref":"Scenic.Scene.html#module-scene-state","title":"Scene State - Scenic.Scene","type":"behaviour"},{"doc":"Scenes are specialized GenServers. As such, they communicate with each other\n(and the rest of your application) through messages. You can receive\nmessages with the standard `handle_info`, `handle_cast`, `handle_call` callbacks just\nlike any other scene.\n\nScenes have two new event handling callbacks that you can *optionally* implement. These\nare about user input vs UI events.","ref":"Scenic.Scene.html#module-communications","title":"Communications - Scenic.Scene","type":"behaviour"},{"doc":"Input is data generated by the drivers and sent up to the scenes\nthrough `Scenic.ViewPort`. There is a limited set of input types and\nthey are standardized so that the drivers can be built independently\nof the scenes. Input follows certain rules about which scene receives them.\n\nEvents are messages that one scene generates for consumption\nby other scenes. For example, a `Scenic.Component.Button` scene would\ngenerate a `{:click, msg}` event that is sent to its parent\nscene.\n\nYou can generate any message you want, however, the standard\ncomponent libraries follow certain patterns to keep things sensible.","ref":"Scenic.Scene.html#module-input-vs-events","title":"Input vs. Events - Scenic.Scene","type":"behaviour"},{"doc":"You handle incoming input events by adding `c:handle_input/3` callback\nfunctions to your scene. Each `c:handle_input/3` call passes in the input\nmessage itself, an input context struct, and your scene's state. You can then\ntake the appropriate actions, including generating events (below) in response.\n\nUnder normal operation, input that is not position dependent\n(keys, window events, more...) is sent to the root scene. Input\nthat does have a screen position (cursor_pos, cursor button\npresses, etc.) is sent to the scene that contains the\ngraph that was hit.\n\nYour scene can \"capture\" all input of a given type so that\nit is sent to itself instead of the default scene for that type.\nthis is how a text input field receives the key input. First,\nthe user selects that field by clicking on it. In response\nto the cursor input, the text field captures text input (and\nmaybe transforms its graph to show that it is selected).\n\nCaptured input types should be released when no longer\nneeded so that normal operation can resume.\n\nThe input messages are passed on to a scene's parent if\nnot processed.","ref":"Scenic.Scene.html#module-input-handling","title":"Input Handling - Scenic.Scene","type":"behaviour"},{"doc":"In response to input, (or anything else... a timer perhaps?),\na scene can generate an event (any term), which is sent backwards\nup the tree of scenes that make up the current aggregate graph.\n\nIn this way, a `Scenic.Component.Button` scene can generate a `{:click, msg}`\nevent that is sent to its parent. If the parent doesn't\nhandle it, it is sent to that scene's parent. And so on until the\nevent reaches the root scene. If the root scene also doesn't handle\nit then the event is dropped.\n\nTo handle events, you add `c:handle_event/3` functions to your scene.\nThis function handles the event, and stops its progress backwards\nup the graph. It can handle it and allow it to continue up the\ngraph. Or it can transform the event and pass the transformed\nversion up the graph.\n\nYou choose the behavior by returning either\n\n    {:cont, msg, state}\n\nor\n\n    {:halt, state}\n\nParameters passed in to `c:handle_event/3` are the event itself, a\nreference to the originating scene (which you can to communicate\nback to it), and your scene's state.\n\nA pattern I'm using is to handle an event at the filter and stop\nits progression. It also generates and sends a new event to its\nparent. I do this instead of transforming and continuing when\nI want to change the originating scene.","ref":"Scenic.Scene.html#module-event-filtering","title":"Event Filtering - Scenic.Scene","type":"behaviour"},{"doc":"There is an optimization you can use. If you know for certain that your component\nwill not attempt to use any components, you can set `has_children` to `false` like this.\n\n    use Scenic.Component, has_children: false\n\nSetting `has_children` to `false` means the scene won't create\na dynamic supervisor for this scene, which saves some resources and imporoves startup\ntime.\n\nFor example, the Button component sets `has_children` to `false`.","ref":"Scenic.Scene.html#module-no-children","title":"No children - Scenic.Scene","type":"behaviour"},{"doc":"Convenience function to assign a list or map of values into a scene struct.","ref":"Scenic.Scene.html#assign/2","title":"Scenic.Scene.assign/2","type":"function"},{"doc":"Convenience function to assign a value into a scene struct.","ref":"Scenic.Scene.html#assign/3","title":"Scenic.Scene.assign/3","type":"function"},{"doc":"Convenience function to assign a list of new values into a scene struct.\n\nOnly values that do not already exist will be assigned","ref":"Scenic.Scene.html#assign_new/2","title":"Scenic.Scene.assign_new/2","type":"function"},{"doc":"Convenience function to assign a new values into a scene struct.\n\nThe value will only be assigned if it does not already exist in the struct.","ref":"Scenic.Scene.html#assign_new/3","title":"Scenic.Scene.assign_new/3","type":"function"},{"doc":"Request one or more types of input that a scene would otherwise not\nreceive if not captured. This is rarely used by scenes and even then\nmostly for things like key events outside of a text field.\n\nAny input types that were previously requested that are no longer in the\nrequest list are dropped. Request [] to cancel all input requests.\n\nreturns :ok or an error\n\nThis is intended be called by a Scene process, but doesn't need to be.","ref":"Scenic.Scene.html#capture_input/2","title":"Scenic.Scene.capture_input/2","type":"function"},{"doc":"","ref":"Scenic.Scene.html#cast_children/2","title":"Scenic.Scene.cast_children/2","type":"function"},{"doc":"Cast a message to a scene's parent","ref":"Scenic.Scene.html#cast_parent/2","title":"Scenic.Scene.cast_parent/2","type":"function"},{"doc":"Get the `pid` of the child with the specified id.\n\nYou can specify the same ID to more than one child. This is why the\nreturn is a list.","ref":"Scenic.Scene.html#child/2","title":"Scenic.Scene.child/2","type":"function"},{"doc":"Get a list of `{id, pid}` pairs for all the scene's children.","ref":"Scenic.Scene.html#children/1","title":"Scenic.Scene.children/1","type":"function"},{"doc":"Convenience function to fetch an assigned value out of a scene struct.","ref":"Scenic.Scene.html#fetch/2","title":"Scenic.Scene.fetch/2","type":"function"},{"doc":"Fetch a list of input captured by the given scene.\n\nThis is intended be called by a Scene process, but doesn't need to be.","ref":"Scenic.Scene.html#fetch_captures/1","title":"Scenic.Scene.fetch_captures/1","type":"function"},{"doc":"Fetch the \"data\" of the child with the specified id.\n\nThis function is intended to be used to query the current data of a component.\nThe component must have implemented the `c:Scenic.Scene.handle_fetch/2` callback.\nAll of the built-in components support this.\n\nUnlike `get_child`, `fetch_child` returns the full data associated with\ncomponent, not just the current value. For example a checkbox component\nmight fetch the value `{\"My Checkbox\", true}`\n\nYou can specify the same ID to more than one child. This is why the\nreturn is a list.","ref":"Scenic.Scene.html#fetch_child/2","title":"Scenic.Scene.fetch_child/2","type":"function"},{"doc":"Fetch a list of input requested by the given scene.\n\nThis is intended be called by a Scene process, but doesn't need to be.","ref":"Scenic.Scene.html#fetch_requests/1","title":"Scenic.Scene.fetch_requests/1","type":"function"},{"doc":"Fetch the \"parent\" matrix that positions this scene.\n\nThis matrix can be used to move from scene \"local\" coordinates to global\ncoordinates.","ref":"Scenic.Scene.html#fetch_transform/1","title":"Scenic.Scene.fetch_transform/1","type":"function"},{"doc":"Convenience function to get an assigned value out of a scene struct.","ref":"Scenic.Scene.html#get/3","title":"Scenic.Scene.get/3","type":"function"},{"doc":"Get the \"value\" of the child with the specified id.\n\nThis function is intended to be used to query the current value of a component.\nThe component must have implemented the `c:Scenic.Scene.handle_get/2` callback.\nAll of the built-in components support this.\n\nFor example, you could use this to query the current value of a checkbox.\n\nYou can specify the same ID to more than one child. This is why the\nreturn is a list.","ref":"Scenic.Scene.html#get_child/2","title":"Scenic.Scene.get_child/2","type":"function"},{"doc":"Get the \"parent\" matrix that positions this scene.\n\nThis matrix can be used to move from scene \"local\" coordinates to global\ncoordinates.","ref":"Scenic.Scene.html#get_transform/1","title":"Scenic.Scene.get_transform/1","type":"function"},{"doc":"Convert a point in global coordinates to scene local coordinates.","ref":"Scenic.Scene.html#global_to_local/2","title":"Scenic.Scene.global_to_local/2","type":"function"},{"doc":"","ref":"Scenic.Scene.html#handle_call/3","title":"Scenic.Scene.handle_call/3","type":"function"},{"doc":"Invoked when the `Scene` receives an event from another scene.\n\nEvents are messages generated by a scene, that are passed backwards up the ViewPort's\nscene supervision tree. This is opposed to \"input\", which comes directly from the drivers.\n\nWhen an event arrives at a scene, you can consume it, or pass it along to the scene above\nyou in the ViewPort's supervision structure.\n\nTo consume the input and have processing stop afterward, return either a `{:halt, ...}` or\n`{:noreply, ...}` value. They are effectively the same thing.\n\nTo allow the scene's parent to process the input, return `{:cont, event, state, ...}`. Note\nthat you can pass along the event unchanged or transform it in the process if you wish.\n\nThe callback supports all the return values of the\n[`init`](https://hexdocs.pm/elixir/GenServer.html#c:handle_cast/2)\ncallback in [`Genserver`](https://hexdocs.pm/elixir/GenServer.html).\n\nIn addition to the normal return values defined by GenServer, a `Scene` can\nadd an optional `{push: graph}` term, which pushes the graph to the viewport.\n\nThis has replaced push_graph() as the preferred way to push a graph.","ref":"Scenic.Scene.html#c:handle_event/3","title":"Scenic.Scene.handle_event/3","type":"callback"},{"doc":"Retrieve the current data associated with the scene and return it to the caller.\n\nIf this callback is not implemented, the caller with get an {:error, :not_implemented}.","ref":"Scenic.Scene.html#c:handle_fetch/2","title":"Scenic.Scene.handle_fetch/2","type":"callback"},{"doc":"Get the current \"value\" associated with the scene and return it to the caller.\n\nIf this callback is not implemented, the caller with receive nil.","ref":"Scenic.Scene.html#c:handle_get/2","title":"Scenic.Scene.handle_get/2","type":"callback"},{"doc":"Invoked when the `Scene` receives input from a driver.\n\nInput is messages sent directly from a driver, usually based on some action by the user.\nThis is opposed to \"events\", which are generated by other scenes.\n\nWhen input arrives at a scene, you can consume it, or pass it along to the scene above\nyou in the ViewPort's supervision structure.\n\nTo consume the input and have processing stop afterward, return either a `{:halt, ...}` or\n`{:noreply, ...}` value. They are effectively the same thing.\n\nTo allow the scene's parent to process the input, return `{:cont, input, state, ...}`. Note\nthat you can pass along the input unchanged or transform it in the process if you wish.\n\nThe callback supports all the return values of the\n[`init`](https://hexdocs.pm/elixir/GenServer.html#c:handle_cast/2)\ncallback in [`Genserver`](https://hexdocs.pm/elixir/GenServer.html).\n\nIn addition to the normal return values defined by GenServer, a `Scene` can\nadd an optional `{push: graph}` term, which pushes the graph to the viewport.\n\nThis has replaced push_graph() as the preferred way to push a graph.","ref":"Scenic.Scene.html#c:handle_input/3","title":"Scenic.Scene.handle_input/3","type":"callback"},{"doc":"Put the current \"value\" associated with the scene .\n\nDoes nothing if this callback is not implemented.","ref":"Scenic.Scene.html#c:handle_put/2","title":"Scenic.Scene.handle_put/2","type":"callback"},{"doc":"Update the data and options of a scene. Usually implemented by Components.\n\nIf this callback is not implemented, then changes to the component in the parent's\ngraph will have no affect.","ref":"Scenic.Scene.html#c:handle_update/3","title":"Scenic.Scene.handle_update/3","type":"callback"},{"doc":"Invoked when the `Scene` is started.\n\n`args` is the argument term you passed in via config or ViewPort.set_root.\n\n`options` is a list of information giving you context about the environment\nthe scene is running in. If an option is not in the list, then it should be\ntreated as nil.\n  * `:viewport` - This is the pid of the ViewPort that is managing this dynamic scene.\n    It will be not set, or nil, if you are managing the Scene in a static\n    supervisor yourself.\n  * `:styles` - This is the map of styles that your scene can choose to inherit\n    (or not) from its parent scene. This is typically used by a child control that\n    wants to visually fit into its parent's look.\n  * `:id` - This is the :id term that the parent set a component when it was invoked.\n\nThe callback supports all the return values of the\n[`init`](https://hexdocs.pm/elixir/GenServer.html#c:init/1)\ncallback in [`Genserver`](https://hexdocs.pm/elixir/GenServer.html).\n\nIn addition to the normal return values defined by GenServer, a `Scene` can\nreturn two new ones that push a graph to the viewport\n\nReturning `{:ok, state, push: graph}` will push the indicated graph\nto the ViewPort. This is preferable to the old push_graph() function.","ref":"Scenic.Scene.html#c:init/3","title":"Scenic.Scene.init/3","type":"callback"},{"doc":"Convert a point in scene local coordinates to global coordinates.","ref":"Scenic.Scene.html#local_to_global/2","title":"Scenic.Scene.local_to_global/2","type":"function"},{"doc":"Get the `pid` of the scene's parent.","ref":"Scenic.Scene.html#parent/1","title":"Scenic.Scene.parent/1","type":"function"},{"doc":"Push a graph to the scene's ViewPort.\n\nThis function compiles a graph into a script, registers any requested inputs and stores\nit all in the ViewPort's ETS tables.\n\nAny components that are created or removed from the scene are\nstarted/stopped/updated as appropriate.","ref":"Scenic.Scene.html#push_graph/3","title":"Scenic.Scene.push_graph/3","type":"function"},{"doc":"Push a named script to the scene's ViewPort.","ref":"Scenic.Scene.html#push_script/4","title":"Scenic.Scene.push_script/4","type":"function"},{"doc":"Put the \"value\" of the child with the specified id.\n\nThis function is intended to be used to change the current value of a component.\nThe component must have implemented the `c:Scenic.Scene.handle_put/2` callback.\nAll of the built-in components support this.\n\nFor example, you could use this to change the current value of a checkbox.\nIn this case, the returned value would be `true` or `false`.\n\nYou can specify the same ID to more than one child. This will cause all the\ncomponents with that id to receive the handle_put call.","ref":"Scenic.Scene.html#put_child/3","title":"Scenic.Scene.put_child/3","type":"function"},{"doc":"release all currently requested input.\n\nThis is intended be called by a Scene process, but doesn't need to be.","ref":"Scenic.Scene.html#release_input/2","title":"Scenic.Scene.release_input/2","type":"function"},{"doc":"Request one or more types of input that a scene would otherwise not\nreceive if not captured. This is rarely used by scenes and even then\nmostly for things like key events outside of a text field.\n\nAny input types that were previously requested that are no longer in the\nrequest list are dropped. Request [] to cancel all input requests.\n\nreturns :ok or an error\n\nThis is intended be called by a Scene process, but doesn't need to be.","ref":"Scenic.Scene.html#request_input/2","title":"Scenic.Scene.request_input/2","type":"function"},{"doc":"Cast a message to a scene's children","ref":"Scenic.Scene.html#send_children/2","title":"Scenic.Scene.send_children/2","type":"function"},{"doc":"Send an event message to a specific scene","ref":"Scenic.Scene.html#send_event/2","title":"Scenic.Scene.send_event/2","type":"function"},{"doc":"Send a message to a scene's parent","ref":"Scenic.Scene.html#send_parent/2","title":"Scenic.Scene.send_parent/2","type":"function"},{"doc":"Send an event message to a scene's parent","ref":"Scenic.Scene.html#send_parent_event/2","title":"Scenic.Scene.send_parent_event/2","type":"function"},{"doc":"Cleanly stop a scene from running","ref":"Scenic.Scene.html#stop/1","title":"Scenic.Scene.stop/1","type":"function"},{"doc":"","ref":"Scenic.Scene.html#terminate/2","title":"Scenic.Scene.terminate/2","type":"function"},{"doc":"release all currently requested input.\n\nThis is intended be called by a Scene process, but doesn't need to be.","ref":"Scenic.Scene.html#unrequest_input/2","title":"Scenic.Scene.unrequest_input/2","type":"function"},{"doc":"Update the \"data\" of the child with the specified id.\n\nThis function is intended to be used to update the current data of a component.\nThe component must have implemented the `c:Scenic.Scene.handle_update/3` callback.\nAll of the built-in components support this.\n\nUnlike `put_child`, `update_child` effectively re-initializes the component with the\nnew data. This would be the same data format you have provided when you created the\ncomponent in the first place. For example, you might update a checkbox component\nwith the value `{\"New Label\", true}`\n\nYou can specify the same ID to more than one child. This will cause all the\ncomponents with that id to receive the handle_put call.","ref":"Scenic.Scene.html#update_child/4","title":"Scenic.Scene.update_child/4","type":"function"},{"doc":"","ref":"Scenic.Scene.html#t:response_opts/0","title":"Scenic.Scene.response_opts/0","type":"type"},{"doc":"","ref":"Scenic.Scene.html#t:t/0","title":"Scenic.Scene.t/0","type":"type"},{"doc":"","ref":"Scenic.Script.html","title":"Scenic.Script","type":"module"},{"doc":"Scenic.Script is the fundamental \"rendering\" data structure for Scenic.\n\nPrior to v0.11, drivers received Graphs from the ViewPort and were responsible\nfor transforming them into a list of drawing commands that would ultimately draw\nthe actual picture that is displayed as the Scenic UI.\n\nAfter some experience, it became apparent that this was a common task for almost\nall drivers and has been moved into the ViewPort and formalized in Scenic.Script.\n\nSimply put, Scenic.Script produces a list of static drawing commands that are\nsent, unmodified, to the drivers through the ViewPort. These scripts are\ngenerated for you when you use `Scenic.Scene.push_graph/3`, or you can create\nthem yourself by using this api.\n\nIf you use Scenic.Script directly, you can create more complicated and/or\nreusable graphics than you could by using Graphs alone.","ref":"Scenic.Script.html#module-overview","title":"Overview - Scenic.Script","type":"module"},{"doc":"Another way to use scripts is to separate large static bits of a graph from\nthat which changes frequently. When a graph is pushed to the ViewPort, the\nentire thing is compiled into a script, which is sent as a whole to the Drivers.\n\nHowever if that graph references a script, only the reference to the script is\nsent, not the contents of the script. This means you can modify the graph\nfrequently without sending the contents of the scripts.\n\nThe opposite is also true. You can generate and push the scripts frequently\nwithout causing the graphs that reference them to be recompiled or resent.\n\nAn example of this might be a graph that implements a chart of some sort. The\ncontents of the chart could be a script that is updated as new data comes in\nwithout needing all the chrome around it to be recompiled or sent for every\nupdate.","ref":"Scenic.Script.html#module-update-isolation","title":"Update Isolation - Scenic.Script","type":"module"},{"doc":"This is a large module with many functions. Most of them are very small, however and simply\nadd individual commands to the script.\n\nThe general pattern is that you start by calling Scenic.Script.start(). This simply returns\nan empty list. Each drawing api adds an element to the head of the list. Then you end with\nScenic.Script.finsh(), which reverses the list and performs some optimizations on it.\n\n```elixir\nalias Scenic.Script\n\nmy_script =\n  Script.start()\n  |> Script.text( \"A very simple script\" )\n  |> Script.finish()\n```\n\nAfter the script is generated, you publish it to the ViewPort through either your\nscene's helper api `Scenic.Scene.push_script/4` or directly throught the ViewPort api\n`Scenic.ViewPort.put_script/4`\n\nFinally, to get the script to draw, you need to reference it from a graph.\n\n```elixir\nmy_graph =\n  Graph.build()\n    |> script( \"my_script_name\" )\n```\n\nIt doesn't matter if you push the script before or after you push the graph that references it.\n\n```elixir\nscene =\n  scene\n  |> push_script( my_script, \"my_script_name\" )\n  |> push_graph( my_graph )\n```","ref":"Scenic.Script.html#module-api-patterns","title":"API Patterns - Scenic.Script","type":"module"},{"doc":"The canonical example is the checkmark symbol used in the `Checkbox` component.\nThis is two lines, with rounded endpoints and rounded joint between them.\nIt could be described using a Path primitive, but there is no need to\nsend its instructions every time it is shown or hidden since its shape\ndoesn't actually change.\n\nThe Checkbox component creates and publishes this script using something very\nsimilar to the following example.\n\n```elixir\nalias Scenic.Script\n\n# build the checkmark script\nchx_script =\n  Script.start()\n  |> Script.push_state()\n  |> Script.join(:round)\n  |> Script.stroke_width(@border_width + 1)\n  |> Script.stroke_color(theme.thumb)\n  |> Script.begin_path()\n  |> Script.move_to(0, 8)\n  |> Script.line_to(5, 13)\n  |> Script.line_to(12, 1)\n  |> Script.stroke_path()\n  |> Script.pop_state()\n  |> Script.finish()\n\nchx_id = scene.id <> \"_chk\"\nscene = push_script(scene, chx_script, chx_id)\n```\n\nBuilding and using a custom script happens in three parts. First, the script itself\nis created using the `Scenic.Script` api.\n\nThen the script is published to the ViewPort using `Scenic.Scene.push_script/4` with a\nunique name.\n\nLater, the graph for the checkbox references this script, which is what triggers it to be drawn.\n\n```elixir\ngraph =\n  Graph.build()\n    |> script(chx_id, id: :chx, hidden: !checked?)\n```","ref":"Scenic.Script.html#module-example-the-checkbox-check-mark","title":"Example: the Checkbox check mark - Scenic.Script","type":"module"},{"doc":"The underlying rendering engine that consumes these scripts and draws the actual\npictures maintains a set of current drawing state, which can be pushed and popped\nfrom a stack via the `push_state/1`, `pop_state/1`, and `pop_push_state/1` apis.\n\nThese functions are analogous to the state\n[save/restore APIs in Canvas](https://developer.mozilla.org/en-US/docs/Web/API/CanvasRenderingContext2D/save).","ref":"Scenic.Script.html#module-script-state","title":"Script State - Scenic.Script","type":"module"},{"doc":"Transforms are applied to the running script by multiplying matrices together. This is very\nsimilar to how games position elements of UI. It takes a little getting used to, but is\nvery powerful.\n\nIf you want to unroll the most recent applied transform, you should push then pop the state\nto get back to the previous transform stack.","ref":"Scenic.Script.html#module-transforms","title":"Transforms - Scenic.Script","type":"module"},{"doc":"The `serialize/3` and `deserialize/1` go back and forth from the list format to a binary\nrepresentation of the script. The `serialize/3` function produces an IO list, and `deserialize`\ngoes back into a list of instructions.\n\nThere is a standard format to the binary, but that needs to be independently documented. You\ncan dig into the code behind `serialize/3` to see it in action.\n\nDrivers, which normally do the serialization call, can intercept/override any command if they\nneed something specific.","ref":"Scenic.Script.html#module-binary-format","title":"Binary Format - Scenic.Script","type":"module"},{"doc":"Adds a new **circle arc** shaped segment to the path.\n\nThis adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#arc/7","title":"Scenic.Script.arc/7","type":"function"},{"doc":"- cx, cy: The coordinates of the arc's center.\n  - r: the radius of the arc.\n  - a0, a1: the angles which the arc is drawn from angle a0 to a1, in radians.\n  - dir: s the direction of the arc sweep:\n    - `1` for counter clockwise sweep;\n    - `2` for clockwise sweep.","ref":"Scenic.Script.html#arc/7-parameters","title":"Parameters - Scenic.Script.arc/7","type":"function"},{"doc":"Add an arc segment to the path using the control points and radius.\n\nThis adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#arc_to/6","title":"Scenic.Script.arc_to/6","type":"function"},{"doc":"Begin a new path.","ref":"Scenic.Script.html#begin_path/1","title":"Scenic.Script.begin_path/1","type":"function"},{"doc":"Add a bezier curve segment to the path using the control points.\n\nThis adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#bezier_to/7","title":"Scenic.Script.bezier_to/7","type":"function"},{"doc":"Set the current end cap style.\n\nCan be any one of `:butt`, `:round`, or `:square`","ref":"Scenic.Script.html#cap/2","title":"Scenic.Script.cap/2","type":"function"},{"doc":"Add a circle to the current path.\n\nThis adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#circle/2","title":"Scenic.Script.circle/2","type":"function"},{"doc":"Erase the entire drawing field output.\n\nThe `clear/1` function is equivalent to setting a color, creating a new rect path\nthat covers the entire draw field, then filling it. `clear/1` does all this in a\nsingle, compact script command.","ref":"Scenic.Script.html#clear/2","title":"Scenic.Script.clear/2","type":"function"},{"doc":"Close the current path.\n\nThis effectively adds a line segment from the current draw position back to\nwhere the path was started.","ref":"Scenic.Script.html#close_path/1","title":"Scenic.Script.close_path/1","type":"function"},{"doc":"Transform a binary or io list into a readable script list.\n\nThis is intended to help with debugging.\n\nDeserialization will only work for scripts serialized using the standard, un-hooked format.","ref":"Scenic.Script.html#deserialize/1","title":"Scenic.Script.deserialize/1","type":"function"},{"doc":"Draw an arc defined by radius and an angle. Can be filled or stroked.\n\nCreates a new path and draws it.","ref":"Scenic.Script.html#draw_arc/4","title":"Scenic.Script.draw_arc/4","type":"function"},{"doc":"Draw a circle defined by a radius. Can be filled or stroked.\n\nCreates a new path and draws it.","ref":"Scenic.Script.html#draw_circle/3","title":"Scenic.Script.draw_circle/3","type":"function"},{"doc":"Draw an ellipse defined by two radii. Can be filled or stroked.\n\nCreates a new path and draws it.","ref":"Scenic.Script.html#draw_ellipse/4","title":"Scenic.Script.draw_ellipse/4","type":"function"},{"doc":"draw_flag is a helper function to choose the appropriate fill and/or stroke flag\ngiven a map of styles.","ref":"Scenic.Script.html#draw_flag/1","title":"Scenic.Script.draw_flag/1","type":"function"},{"doc":"Draw a line from a start point to a finish point. Can only be stroked.\n\nCreates a new path and draws it.","ref":"Scenic.Script.html#draw_line/6","title":"Scenic.Script.draw_line/6","type":"function"},{"doc":"Draw a quad defined by four points. Can be filled or stroked.\n\nCreates a new path and draws it.","ref":"Scenic.Script.html#draw_quad/10","title":"Scenic.Script.draw_quad/10","type":"function"},{"doc":"Draw a rectangle defined by height and width. Can be filled or stroked.\n\nCreates a new path and draws it.","ref":"Scenic.Script.html#draw_rectangle/4","title":"Scenic.Script.draw_rectangle/4","type":"function"},{"doc":"Draw a rounded rectangle defined by height, width, and radius. Can be filled or stroked.\n\nCreates a new path and draws it.","ref":"Scenic.Script.html#draw_rounded_rectangle/5","title":"Scenic.Script.draw_rounded_rectangle/5","type":"function"},{"doc":"Draw a sector defined by radius and an angle. Can be filled or stroked.\n\nCreates a new path and draws it.","ref":"Scenic.Script.html#draw_sector/4","title":"Scenic.Script.draw_sector/4","type":"function"},{"doc":"Draw a collection of sprites.\n\nDraws one or more subsection from a single source image.","ref":"Scenic.Script.html#draw_sprites/3","title":"Scenic.Script.draw_sprites/3","type":"function"},{"doc":"Draw a a block of text. Can be filled.\n\nCreates a new path and draws it.","ref":"Scenic.Script.html#draw_text/2","title":"Scenic.Script.draw_text/2","type":"function"},{"doc":"Draw a a block of text with automatic new lines. Can be filled.\n\nCreates a new path and draws it.","ref":"Scenic.Script.html#draw_text/3","title":"Scenic.Script.draw_text/3","type":"function"},{"doc":"Draw a triangle defined by three points. Can be filled or stroked.\n\nCreates a new path and draws it.","ref":"Scenic.Script.html#draw_triangle/8","title":"Scenic.Script.draw_triangle/8","type":"function"},{"doc":"Draw a rounded rectangle defined by height, width, radius1, radius2, radius3 and radius4. Can be filled or stroked.\n\nRadii values will be set as follow:\n\n- Upper left corner: radius1\n- Upper right corner: radius2\n- Lower right corner: radius3\n- Lower left corner: radius4\n\nCreates a new path and draws it.","ref":"Scenic.Script.html#draw_variable_rounded_rectangle/8","title":"Scenic.Script.draw_variable_rounded_rectangle/8","type":"function"},{"doc":"Add an ellipse to the current path.\n\nThis adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#ellipse/3","title":"Scenic.Script.ellipse/3","type":"function"},{"doc":"Set the current fill to an single color.\n\nThis only sets the fill paint type. You still need to call `fill_path/1` or one of the\ndraw_* apis to actually draw something.","ref":"Scenic.Script.html#fill_color/2","title":"Scenic.Script.fill_color/2","type":"function"},{"doc":"Set the current fill to an image from the Static asset library.\n\nThis image will be automatically repeated both horizontally and vertically.\n\nThis only sets the fill paint type. You still need to call `fill_path/1` or one of the\ndraw_* apis to actually draw something.","ref":"Scenic.Script.html#fill_image/2","title":"Scenic.Script.fill_image/2","type":"function"},{"doc":"Set the current fill to linear gradient that goes between two colors.\n\nThis only sets the fill paint type. You still need to call `fill_path/1` or one of the\ndraw_* apis to actually draw something.","ref":"Scenic.Script.html#fill_linear/7","title":"Scenic.Script.fill_linear/7","type":"function"},{"doc":"Fill the current path with the currently selected fill paint.","ref":"Scenic.Script.html#fill_path/1","title":"Scenic.Script.fill_path/1","type":"function"},{"doc":"Set the current fill to radial gradient that goes between two colors.\n\nThis only sets the fill paint type. You still need to call `fill_path/1` or one of the\ndraw_* apis to actually draw something.","ref":"Scenic.Script.html#fill_radial/7","title":"Scenic.Script.fill_radial/7","type":"function"},{"doc":"Set the current fill to an image from an asset stream.\n\nThis image will be automatically repeated both horizontally and vertically.\n\nThis only sets the fill paint type. You still need to call `fill_path/1` or one of the\ndraw_* apis to actually draw something.","ref":"Scenic.Script.html#fill_stream/2","title":"Scenic.Script.fill_stream/2","type":"function"},{"doc":"Finish a script, preparing it to be sent to the ViewPort.\n\nThis function cleans up the script, which should have been created by first\ncalling `start/0` then and series of calls to Scenic.Script functions that add\ncommands to the script.\n\n`finish/1` cleans up the script, reverses it, and runs an optimization pass.\n\nThe resulting script is ready to be stored in the ViewPort.","ref":"Scenic.Script.html#finish/1","title":"Scenic.Script.finish/1","type":"function"},{"doc":"Set the current font. Must be a valid reference into your static assets library.","ref":"Scenic.Script.html#font/2","title":"Scenic.Script.font/2","type":"function"},{"doc":"Set the current font size.","ref":"Scenic.Script.html#font_size/2","title":"Scenic.Script.font_size/2","type":"function"},{"doc":"Set the current line joint style.\n\nCan be any one of `:bevel`, `:round`, or `:miter`","ref":"Scenic.Script.html#join/2","title":"Scenic.Script.join/2","type":"function"},{"doc":"Add a new line segment from the current position to a specified location.\n\nThis adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#line_to/3","title":"Scenic.Script.line_to/3","type":"function"},{"doc":"Extract a map of all the media (both static assets and streams) used in a script.","ref":"Scenic.Script.html#media/1","title":"Scenic.Script.media/1","type":"function"},{"doc":"Set the current miter limit for joints.","ref":"Scenic.Script.html#miter_limit/2","title":"Scenic.Script.miter_limit/2","type":"function"},{"doc":"Move the current draw position without adding a line segment.","ref":"Scenic.Script.html#move_to/3","title":"Scenic.Script.move_to/3","type":"function"},{"doc":"Reverts the style/transform state of the script then immediately pushes it again.\n\n`pop_push_state/1` is for when you have made changes that you want to revert, but then\nknow you are going to make more changes that you revert again. This is functionally\nequivalent to calling `pop_state/1` followed immediately by `push_state/1`, except that\nit is done as a single operation in the script instead of two. This saves drawtime\ncompute and makes the script smaller. Any adjacent pop/push pairs in the script will\nbe converted to pop_push in the optimization phase of the `finish/1` function.\n\n`pop_push_state/1` must be preceded with either `push_state/1` and followed by either\n`pop_state/1` or another `pop_push_state/1`","ref":"Scenic.Script.html#pop_push_state/1","title":"Scenic.Script.pop_push_state/1","type":"function"},{"doc":"Reverts the style/transform state of the script to the most recently pushed state.\n\nThis function restores the style and transform states from a stack of\nstates. The idea is that you can make changes, then \"pop\" back to where\nthe state was before.\n\n`push_state/1` must be preceded with either `push_state/1` or `pop_push_state/1`","ref":"Scenic.Script.html#pop_state/1","title":"Scenic.Script.pop_state/1","type":"function"},{"doc":"Saves the current style/transform state of the script as it is running.\n\nThis function saves the current style and transform states in a stack of\nstates. The idea is that you can make changes, then \"pop\" back to where\nthe state was before.\n\n`push_state/1` must be paired with an eventual `pop_state/1` or `pop_push_state/1`","ref":"Scenic.Script.html#push_state/1","title":"Scenic.Script.push_state/1","type":"function"},{"doc":"Add a quad to the current path.\n\nThis adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#quad/9","title":"Scenic.Script.quad/9","type":"function"},{"doc":"Add a quadratic curve segment to the path using the control points.\n\nThis adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#quadratic_to/5","title":"Scenic.Script.quadratic_to/5","type":"function"},{"doc":"Add a rectangle to the current path.\n\nThis adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#rectangle/3","title":"Scenic.Script.rectangle/3","type":"function"},{"doc":"Recursively draw a script by reference.\n\nThis adds a command that pauses the current script being rendered and\nrecursively draws another script that is referenced by id.\n\nThe new script being drawn starts with the currently set draw state and the\ncurrent state is automatically restored with the script is completed. Then\nthe current script continues drawing.","ref":"Scenic.Script.html#render_script/2","title":"Scenic.Script.render_script/2","type":"function"},{"doc":"Apply a rotation transform to the current transform stack.","ref":"Scenic.Script.html#rotate/2","title":"Scenic.Script.rotate/2","type":"function"},{"doc":"Add a rounded rectangle to the current path.\n\nThis adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#rounded_rectangle/4","title":"Scenic.Script.rounded_rectangle/4","type":"function"},{"doc":"Apply a scale transform to the current transform stack.","ref":"Scenic.Script.html#scale/3","title":"Scenic.Script.scale/3","type":"function"},{"doc":"Set the current scissor rect.\n\nTo remove the scissor rect, push the state before you use the scissor, then\npop it afterwards.","ref":"Scenic.Script.html#scissor/3","title":"Scenic.Script.scissor/3","type":"function"},{"doc":"Add a sector to the current path.\n\nThis adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#sector/3","title":"Scenic.Script.sector/3","type":"function"},{"doc":"Transform a script list into a binary IO list.\n\nUsually called from a driver.\n\nReturns an IO list.\n\n```elixir\nwith {:ok, script} <- ViewPort.get_script_by_id(vp, \"my_script_id\") do\n  Scenic.Script.serialize(script)\n  |> my_render_function()\nend\n```\n\nThere are times when a driver will want to customize the serialization. For example,\nGLFW driver wants fixed width names for the streams. So it hooks the serialization\nof certain commands.\n\n```elixir\n  io_list = Script.serialize(script, fn\n    {:font, id} -> my_serialize_font(id)\n    {:fill_stream, id} -> my_serialize_fill_stream(id)\n    {:stroke_stream, id} -> my_serialize_stroke_stream(id)\n    other -> other\nend\n```","ref":"Scenic.Script.html#serialize/1","title":"Scenic.Script.serialize/1","type":"function"},{"doc":"Transform a script list into a binary IO list with a map like interceptor function.\n\nUsually called from a driver.\n\nReturns an IO list.\n\n```elixir\nwith {:ok, script} <- ViewPort.get_script(vp, id) do\n  io_list = Script.serialize(script, fn\n    {:font, id} -> my_serialize_font(id)\n    {:fill_stream, id} -> my_serialize_fill_stream(id)\n    {:stroke_stream, id} -> my_serialize_stroke_stream(id)\n    other -> other\n  end)\nend\n```","ref":"Scenic.Script.html#serialize/2","title":"Scenic.Script.serialize/2","type":"function"},{"doc":"Transform a script list into a binary IO list with a map_reduce like interceptor function.\n\nUsually called from a driver.\n\nReturns an IO list.\n\n```elixir\n  {io_list, count} = Script.serialize(script, 0, fn\n    {:font, id}, c -> {my_serialize_font(id), c+1}\n    {:fill_stream, id}, c -> {my_serialize_fill_stream(id), c+1}\n    {:stroke_stream, id}, c -> {my_serialize_stroke_stream(id), c+1}\n    other, c -> {other, c+1}\n  end)\n```","ref":"Scenic.Script.html#serialize/3","title":"Scenic.Script.serialize/3","type":"function"},{"doc":"Create a new Script.","ref":"Scenic.Script.html#start/0","title":"Scenic.Script.start/0","type":"function"},{"doc":"Set the current stroke to an single color.\n\nThis only sets the stroke paint type. You still need to call `stroke_path/1` or one of the\ndraw_* apis to actually draw something.","ref":"Scenic.Script.html#stroke_color/2","title":"Scenic.Script.stroke_color/2","type":"function"},{"doc":"Set the current stroke to an image from the Static asset library.\n\nThis image will be automatically repeated both horizontally and vertically.\n\nThis only sets the stroke paint type. You still need to call `stroke_path/1` or one of the\ndraw_* apis to actually draw something.","ref":"Scenic.Script.html#stroke_image/2","title":"Scenic.Script.stroke_image/2","type":"function"},{"doc":"Set the current stroke to linear gradient that goes between two colors.\n\nThis only sets the stroke paint type. You still need to call `stroke_path/1` or one of the\ndraw_* apis to actually draw something.","ref":"Scenic.Script.html#stroke_linear/7","title":"Scenic.Script.stroke_linear/7","type":"function"},{"doc":"Stroke the current path with the currently selected stroke width/paint.","ref":"Scenic.Script.html#stroke_path/1","title":"Scenic.Script.stroke_path/1","type":"function"},{"doc":"Set the current stroke to radial gradient that goes between two colors.\n\nThis only sets the stroke paint type. You still need to call `stroke_path/1` or one of the\ndraw_* apis to actually draw something.","ref":"Scenic.Script.html#stroke_radial/7","title":"Scenic.Script.stroke_radial/7","type":"function"},{"doc":"Set the current stroke to an image from an asset stream.\n\nThis image will be automatically repeated both horizontally and vertically.\n\nThis only sets the stroke paint type. You still need to call `stroke_path/1` or one of the\ndraw_* apis to actually draw something.","ref":"Scenic.Script.html#stroke_stream/2","title":"Scenic.Script.stroke_stream/2","type":"function"},{"doc":"Set the current stroke width.\n\nThis only sets the stroke sidth. You still need to call `stroke_path/1` or one of the\ndraw_* apis to actually draw something.","ref":"Scenic.Script.html#stroke_width/2","title":"Scenic.Script.stroke_width/2","type":"function"},{"doc":"Set the current horizontal text alignment.\n\nCan be any one of `:left`, `:right`, or `:center`","ref":"Scenic.Script.html#text_align/2","title":"Scenic.Script.text_align/2","type":"function"},{"doc":"Set the current vertical text alignment.\n\nCan be any one of `:top`, `:middle`, `:alphabetic`, or `:bottom`","ref":"Scenic.Script.html#text_base/2","title":"Scenic.Script.text_base/2","type":"function"},{"doc":"Apply an arbitrary transform to the current transform stack.","ref":"Scenic.Script.html#transform/7","title":"Scenic.Script.transform/7","type":"function"},{"doc":"Apply a translation transform to the current transform stack.","ref":"Scenic.Script.html#translate/3","title":"Scenic.Script.translate/3","type":"function"},{"doc":"Add a triangle to the current path.\n\nThis adds to the current path. It does not fill or stroke anything.","ref":"Scenic.Script.html#triangle/7","title":"Scenic.Script.triangle/7","type":"function"},{"doc":"","ref":"Scenic.Script.html#t:fill_stroke/0","title":"Scenic.Script.fill_stroke/0","type":"type"},{"doc":"","ref":"Scenic.Script.html#t:id/0","title":"Scenic.Script.id/0","type":"type"},{"doc":"","ref":"Scenic.Script.html#t:script_op/0","title":"Scenic.Script.script_op/0","type":"type"},{"doc":"","ref":"Scenic.Script.html#t:t/0","title":"Scenic.Script.t/0","type":"type"},{"doc":"","ref":"Scenic.ViewPort.html","title":"Scenic.ViewPort","type":"module"},{"doc":"The job of the `ViewPort` is to coordinate the flow of information between\nthe scenes and the drivers. Scenes and Drivers should not know anything\nabout each other. An app should work identically from its point of view\nno matter if there is one, multiple, or no drivers currently running.\n\nDrivers are all about rendering output and collecting input from a single\nsource. Usually hardware, but can also be the network or files. Drivers\nonly care about graphs and should not need to know anything about the\nlogic or state encapsulated in Scenes.\n\nThe goal is to isolate app data and logic from render data and logic. The\nViewPort is the connection between them that makes sense of the flow\nof information.","ref":"Scenic.ViewPort.html#module-overview","title":"Overview - Scenic.ViewPort","type":"module"},{"doc":"Practically speaking, the `ViewPort` is the owner of the ETS tables that\ncarry the graphs (and any other necessary support info). If the ViewPort\ncrashes, then all that information needs to be rebuilt. The ViewPort monitors\nall running scenes and does the appropriate cleanup when any of them\ngoes DOWN.\n\nThe scene is responsible for generating graphs and writing them to\nthe graph ETS table. (**Note:** We also tried casting the graph to the ViewPort\nso that the table could be non-public, but that had issues)\n\nThe drivers should only read from the graph tables.","ref":"Scenic.ViewPort.html#module-output","title":"OUTPUT - Scenic.ViewPort","type":"module"},{"doc":"When user input happens, the drivers send it to the `ViewPort`.\nInput that does not depend on screen position (key presses, audio\nwindow events, etc.) is sent to the root scene unless some other\nscene has captured that type of input (see captured input below).\n\nIf the input event does depend on position (cursor position, cursor\nbutton presses, scrolling, etc.) then the ViewPort needs to\nscan the hierarchical graph of graphs, to find the correct\nscene, and the item in that scene that was \"hit\". The ViewPort\nthen sends the event to that scene, with the position projected\ninto the scene's local coordinate space (via the built-up stack\nof matrix transformations)","ref":"Scenic.ViewPort.html#module-input","title":"INPUT - Scenic.ViewPort","type":"module"},{"doc":"A scene can request to \"capture\" all input events of a certain type.\nThis means that all events of that type are sent to a certain\nscene process regardless of position or root. In this way, a\ntext input scene nested deep in the tree can capture key presses.\nOr a button can capture cursor_pos events after it has been pressed.\n\nIf a scene has \"captured\" a position dependent input type, that\nposition is projected into the scene's coordinate space before\nsending the event. Note that instead of walking the graph of graphs,\nthe transforms provided in the input \"context\" field are used. You\ncould, in theory change that to something else before capturing,\nbut I wouldn't really recommend it.\n\nAny scene can cancel the current capture. This would probably\nleave the scene that thinks it has \"captured\" the input in an inconsistent\nstate, so this is not recommended.","ref":"Scenic.ViewPort.html#module-captured-input","title":"CAPTURED INPUT - Scenic.ViewPort","type":"module"},{"doc":"Pass in the same set of opts that you would use when starting `Scenic` in your\nsupervision tree. For example:\n\n    # Assuming you use the default view port name from the generator\n    {:ok, view_port} = Scenic.ViewPort.info(:main_viewport)\n\n    opts = [\n      module: Scenic.Driver.Local,\n      window: [resizeable: false, title: \"My Example Scenic App\"],\n      on_close: :stop_system\n    ]\n\n    {:ok, [opts]} = Scenic.Driver.validate([opts])\n    Scenic.ViewPort.start_driver(view_port, opts)","ref":"Scenic.ViewPort.html#module-dynamically-creating-view-ports","title":"Dynamically Creating View Ports - Scenic.ViewPort","type":"module"},{"doc":"Retrieves a list of all registered script ids.","ref":"Scenic.ViewPort.html#all_script_ids/1","title":"Scenic.ViewPort.all_script_ids/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Scenic.ViewPort.html#child_spec/1","title":"Scenic.ViewPort.child_spec/1","type":"function"},{"doc":"Delete a graph by name.\n\nSame as del_script/2","ref":"Scenic.ViewPort.html#del_graph/2","title":"Scenic.ViewPort.del_graph/2","type":"function"},{"doc":"Delete a script by name.\n\nAlso unregisters the name/id pairing","ref":"Scenic.ViewPort.html#del_script/2","title":"Scenic.ViewPort.del_script/2","type":"function"},{"doc":"Find a scene_pid/primitive under the given point in global coordinates","ref":"Scenic.ViewPort.html#find_point/2","title":"Scenic.ViewPort.find_point/2","type":"function"},{"doc":"Retrieve a script","ref":"Scenic.ViewPort.html#get_script/2","title":"Scenic.ViewPort.get_script/2","type":"function"},{"doc":"","ref":"Scenic.ViewPort.html#handle_continue_input/2","title":"Scenic.ViewPort.handle_continue_input/2","type":"function"},{"doc":"Retrieve a `%ViewPort{}` struct given just the viewport's pid","ref":"Scenic.ViewPort.html#info/1","title":"Scenic.ViewPort.info/1","type":"function"},{"doc":"Send raw input to a viewport.\n\nThis is used primarily by drivers to send raw user input to the viewport. Having said that,\nnothing stops a scene from using it to send input into the system. There are a few cases\nwhere that is useful.\n\nSee the [input docs](Scenic.ViewPort.Input.html#t:t/0) for the input formats you can send.","ref":"Scenic.ViewPort.html#input/2","title":"Scenic.ViewPort.input/2","type":"function"},{"doc":"Returns a list of the valid input types","ref":"Scenic.ViewPort.html#input_types/0","title":"Scenic.ViewPort.input_types/0","type":"function"},{"doc":"Put a graph by name.\n\nThis compiles the graph to a collection of scripts","ref":"Scenic.ViewPort.html#put_graph/4","title":"Scenic.ViewPort.put_graph/4","type":"function"},{"doc":"Put a script by name.\n\nreturns `{:ok, id}`","ref":"Scenic.ViewPort.html#put_script/4","title":"Scenic.ViewPort.put_script/4","type":"function"},{"doc":"Returns the id of the first script in the drawing tree\n\nUsed by drivers","ref":"Scenic.ViewPort.html#root_id/0","title":"Scenic.ViewPort.root_id/0","type":"function"},{"doc":"Set the root scene/graph of the ViewPort.\n\nThis will stop the currently running scene, including all of it's child components.\nThen it starts the new scene including all of it's child components.","ref":"Scenic.ViewPort.html#set_root/3","title":"Scenic.ViewPort.set_root/3","type":"function"},{"doc":"Set the root theme for the ViewPort.\n\n> #### Warning {: .error}\n>\n> This will restart the current root scene","ref":"Scenic.ViewPort.html#set_theme/2","title":"Scenic.ViewPort.set_theme/2","type":"function"},{"doc":"Start a new ViewPort","ref":"Scenic.ViewPort.html#start/1","title":"Scenic.ViewPort.start/1","type":"function"},{"doc":"","ref":"Scenic.ViewPort.html#start_driver/2","title":"Scenic.ViewPort.start_driver/2","type":"function"},{"doc":"Stop a running viewport","ref":"Scenic.ViewPort.html#stop/1","title":"Scenic.ViewPort.stop/1","type":"function"},{"doc":"","ref":"Scenic.ViewPort.html#stop_driver/2","title":"Scenic.ViewPort.stop_driver/2","type":"function"},{"doc":"","ref":"Scenic.ViewPort.html#t:event/0","title":"Scenic.ViewPort.event/0","type":"type"},{"doc":"","ref":"Scenic.ViewPort.html#t:t/0","title":"Scenic.ViewPort.t/0","type":"type"},{"doc":"The low-level interface for working in input into and out of a `ViewPort`.\n\nYou will typically use the input related functions in `Scenic.Scene`, which\nwrap this module and make them easy to use from a Scene module.\n\nIf you wanted monitor input from some other `GenServer`, or inject input into\na `ViewPort`, then this is the API to use.\n\nInput events begin when a driver sends an event to the `ViewPort` it is attached\nto. In order to keep scenes simple, and to reduce the amount of work and data\ntransferred when input is created (for example, a moving mouse...), events are\nonly sent to any scenes that have indicated that they are listening.\n\nThere are two ways a scene indicates that it is interested in an input event.","ref":"Scenic.ViewPort.Input.html","title":"Scenic.ViewPort.Input","type":"module"},{"doc":"Normally, a scene \"requests\" input. This will route any keyboard or other\nlocation independent events to the scene. However, any positional input, such\nas `:cursor_button` will only be received it if is over an item in a graph\nmanaged by a scene that has the `input: true` style.\n\n```elixir\ngraph\n  |> rect( {20, 40}, t: {10, 10}, id: :rect_in, input: true, fill: :blue )\n  |> rect( {20, 40}, t: {10, 50}, id: :rect_other, fill: :blue )\n```\n\nIn the above example, the scene would only receive :cursor_button events if the\n:rect_in rect is clicked. This is because it is the only rect that has the \n`input: true` style on it.\n\nCursor clicks over the `:rect_other` rect, are not delivered to the scene.","ref":"Scenic.ViewPort.Input.html#module-requested-input","title":"Requested Input - Scenic.ViewPort.Input","type":"module"},{"doc":"If you look at the code behind components such as Button or Slider, you will see\nthat when the button is clicked, it \"captures\" the `:cursor_button` input type.\n\nThis causes the caller to receive *all* input events of that type, regardless of\nthe `:input` style. This means that even `:cursor_button` events that would be\notherwise be routed to some other scene are sent *only* to the scene that has\ncaptured the input. The other scene that has only \"requested\" the event does\nnot receive it.\n\nIf multiple scenes have captured an input type, the most recent call wins. When\nscene releases the capture, the event type remains captured but is now sent to\nthe second scene that had been overridden.","ref":"Scenic.ViewPort.Input.html#module-captured-input","title":"Captured Input - Scenic.ViewPort.Input","type":"module"},{"doc":"When a driver (or any other caller, but it is typically a `Scenic.Driver`)\nwants to send an input event to the ViewPort, it creates a message and sends\nit to it's ViewPort with the `Scenic.ViewPort.Input.send/2` function.\n\nDrivers have no knowledge of the running scenes. The `ViewPort` takes care of\nthat routing.\n\nInput events are validated against `Scenic.ViewPort.Input.validate/1` function.","ref":"Scenic.ViewPort.Input.html#module-sending-input","title":"Sending Input - Scenic.ViewPort.Input","type":"module"},{"doc":"Capture one or more types of input.\n\nReturns `:ok` or an error","ref":"Scenic.ViewPort.Input.html#capture/3","title":"Scenic.ViewPort.Input.capture/3","type":"function"},{"doc":"* `:pid` - Send input to the specified pid instead of the caller process.","ref":"Scenic.ViewPort.Input.html#capture/3-options","title":"Options - Scenic.ViewPort.Input.capture/3","type":"function"},{"doc":"Retrieve a list of input captured by the caller.\n\nReturns: { :ok, list }","ref":"Scenic.ViewPort.Input.html#fetch_captures/2","title":"Scenic.ViewPort.Input.fetch_captures/2","type":"function"},{"doc":"Retrieve a list of input captured by all processes.\n\nReturns: { :ok, list }","ref":"Scenic.ViewPort.Input.html#fetch_captures!/1","title":"Scenic.ViewPort.Input.fetch_captures!/1","type":"function"},{"doc":"Retrieve a list of input requested by the caller or the process requested_by.\n\nReturns: { :ok, inputs }","ref":"Scenic.ViewPort.Input.html#fetch_requests/2","title":"Scenic.ViewPort.Input.fetch_requests/2","type":"function"},{"doc":"Retrieve a list of input requested by all processes.\n\nReturns: { :ok, inputs }","ref":"Scenic.ViewPort.Input.html#fetch_requests!/1","title":"Scenic.ViewPort.Input.fetch_requests!/1","type":"function"},{"doc":"Release the captured inputs from the calling process.","ref":"Scenic.ViewPort.Input.html#release/3","title":"Scenic.ViewPort.Input.release/3","type":"function"},{"doc":"* `:pid` - Release from the specified pid instead of the caller process.","ref":"Scenic.ViewPort.Input.html#release/3-options","title":"Options - Scenic.ViewPort.Input.release/3","type":"function"},{"doc":"Release the captured inputs from ALL processes","ref":"Scenic.ViewPort.Input.html#release!/2","title":"Scenic.ViewPort.Input.release!/2","type":"function"},{"doc":"Request one or more types of input.\n\nReturns :ok or an error","ref":"Scenic.ViewPort.Input.html#request/3","title":"Scenic.ViewPort.Input.request/3","type":"function"},{"doc":"* `:pid` - Send input to the specified pid instead of the caller process.","ref":"Scenic.ViewPort.Input.html#request/3-options","title":"Options - Scenic.ViewPort.Input.request/3","type":"function"},{"doc":"Send raw input to a viewport.\n\nThis is used primarily by drivers to send raw user input to the viewport. Having said that,\nnothing stops a scene or any other process from using it to send input into the system.\nThere are a few cases where that is useful.\n\nSee the [input types](Scenic.ViewPort.Input.html#t:t/0) for the input formats you can send.","ref":"Scenic.ViewPort.Input.html#send/2","title":"Scenic.ViewPort.Input.send/2","type":"function"},{"doc":"Unrequest the captured inputs from the calling process.","ref":"Scenic.ViewPort.Input.html#unrequest/3","title":"Scenic.ViewPort.Input.unrequest/3","type":"function"},{"doc":"* `:pid` - Unrequest from the specified pid instead of the caller process.","ref":"Scenic.ViewPort.Input.html#unrequest/3-options","title":"Options - Scenic.ViewPort.Input.unrequest/3","type":"function"},{"doc":"Validate an input message.\n\nReturns `:ok` if the message is valid.\n\nReturns `{:error, :invalid}` if the message is not valid.","ref":"Scenic.ViewPort.Input.html#validate/1","title":"Scenic.ViewPort.Input.validate/1","type":"function"},{"doc":"","ref":"Scenic.ViewPort.Input.html#t:class/0","title":"Scenic.ViewPort.Input.class/0","type":"type"},{"doc":"","ref":"Scenic.ViewPort.Input.html#t:positional/0","title":"Scenic.ViewPort.Input.positional/0","type":"type"},{"doc":"","ref":"Scenic.ViewPort.Input.html#t:t/0","title":"Scenic.ViewPort.Input.t/0","type":"type"},{"doc":"Manages static assets, which are resources such as fonts or images (jpg or png) that\nship with your application and do not change over time.\n\nThese assets live as seperate files and are hashed so that they are rejected if they\nchange in any way after you compile your application. They are cacheable by the\nrelay server if you remote your Scenic UI.\n\nIn previous versions of Scenic, static assets were rather complicated to set up\nand maintain. Starting with v0.11, Scenic has an assets build pipeline that manages\nthe static assets library for you.","ref":"Scenic.Assets.Static.html","title":"Scenic.Assets.Static","type":"module"},{"doc":"Setting up the static asset pipeline requites several inputs that need to be maintained.\n\n* __Assets Directory__: Typically `/assets` in your main app source directory. This is the\n  folder that holds your raw asset files.\n* __Assets Module__: A module in your application that builds and holds the asset library.\n* __Assets Config__: Configuration scripts in your application that indicates where the\n  assets directory is and your assets module.\n\n#### Assets Directory\nThe assets directory typically is typically called `/assets` and lives at the root of\nyour application source directory. This can be changed in the config options.\n\nExample:\n\n```\nmy_app_src\n  assets\n    fonts\n      roboto.ttf\n      custom_font.ttf\n    images\n      parrot.jpg\n      my_logo.png\n  config\n  lib\n  etc...\n```\n\nOnce the rest of the configuration is complete, adding a new font is as simple as dropping\nthe *.ttf file into the /assets/fonts directory and compiling your assets module. Similar\nis true for images.\n\n#### Assets Library\nWhen your application is running, there needs to be a module that contains the built asset\nlibrary referring to your static assets. This library holds things like the hash of the\ncontents of each asset, and it's parsed metadata.\n\nYou must create this module and compile it with your application. The following example\nis what this module should look like. Replace `MyApplication` and `:my_application` with\nthe actual name of your application.\n\n```elixir\ndefmodule MyApplication.Assets do\n  use Scenic.Assets.Static,\n    otp_app: :my_application,\n    sources: [\n      \"assets\",\n      {:scenic, \"deps/scenic/assets\"}\n    ],\n    alias: [\n      parrot: \"images/parrot.jpg\"\n    ]\nend\n```\n\nNotice that there are several configuration sections in your assets module. Sources is the list\nof folders to look in to find assets. For example, if you take a dependency on a package that\ncontains assets, you will need to add it's assets folder here. If can omit the sources section\nif you only use a single assets folder and scenic's default fonts. In other words, the sources\nconfiguration shown above is also the default.\n\nThe `:alias` list creates shortcuts that refer to the files in the assets library. This is useful\nif you think an asset id may change during development but want a constant way to refer to it\nin your code. In the above example, the atom :parrot is mapped to the file `images/parrot.jpb`\nand are interchangeable with each other in a graph.\n\nIn this example, the two rect fills are identical as the `:parrot` alias was created\nin the configuration script.\n\n```elixir\nGraph.build()\n  |> rect({100, 50}, fill: {:image, \"images/parrot.jpg\"})\n  |> rect({100, 50}, fill: {:image, :parrot})\n```\n\nThe fonts `fonts/roboto.ttf` and `fonts/roboto_mono.ttf` are considered the default\nfonts for Scenic and are automatically aliased to `:roboto` and `:roboto_mono`.\nIt is expected that you will include those two fonts in your `/assets/fonts` directory.\n\n\nIMPORTANT NOTE: When you add a new asset to the assets directory, you may need to force this\nmodule to recompile for them to be usable. Adding or removing a return at the end should do\nthe trick. In the future, there will be a file system watcher (much like Phoenix has) that\nwill do this automatically. Until then, it is pretty easy to do manually.\n\n#### Assets Configuration\nThe final piece is some configuration that connects scenic and your assets module\ntogther. Put this in your application's `config.exs` file.\n\n```elixir\nconfig :scenic, :assets,\n  module: MyApplication.Assets\n```","ref":"Scenic.Assets.Static.html#module-required-configuration","title":"Required Configuration - Scenic.Assets.Static","type":"module"},{"doc":"If you have added an asset to your assets directory and you think it should be in\nyour library, but it isn't, or you can't compile a scene because the asset can't\nbe found, then start troubleshooting with the following steps.\n\n1) Force your assets module to rebuild. Touch it in some way such as adding or removing a\ncarriage return at the end, then compile again.\n2) Check that you are using the correct id for the asset in your graph.\n3) If you are using an alias, check it's spelling and its assignment in the config script.\n4) Confirm that the asset itself has valid contents, whether it is a font (.ttf)\n  or an image (.jpg or .jpeg or .png)\n\nThat usually does it.","ref":"Scenic.Assets.Static.html#module-troubleshooting","title":"Troubleshooting - Scenic.Assets.Static","type":"module"},{"doc":"When your assets module is compiled, several steps are executed by `Scenic.Assets.Static`\n  1) The files in your assets directory are parsed for validity and metadata.\n    Valid files move on to the next step\n  2) The valid assets files are hashed to create a cryptographic signature that is used\n    later when the files are loaded to confirm that they are unchanged.\n  3) The asset files are copied into the `/priv/static` directory, which is where they\n    are actually loaded from at run time. The name of the file in this directory is\n    a `Base.url_encode64/2` version of the hash of the file's contents.\n  4) A map is created, which is the actual asset library used at runtime. This map\n    has the original file name as keys and holds the hashes, and parsed metadata\n    as the contents. This map is stored as a literal object in your assets module\n    and is the reason it needs to be compiled when you add a new asset.\n\nIf you are curious and want to see the library yourself, you can query the\n`MyApplication.Assets.library/0` function, which is added at compile time. Alternately,\nthe function `Scenic.Assets.Static.library/0` should return the same library.","ref":"Scenic.Assets.Static.html#module-under-the-covers","title":"Under the Covers - Scenic.Assets.Static","type":"module"},{"doc":"There are two pieces of work to the static assets pipeline that are planned for the future.\n\nFirst is a file system watcher that automatically flags your assets module to be recompiled\nwhen the contents of the assets directory changes. This would work in a similar way to the\nfile system watcher used by Phoenix.\n\nThe second, larger, piece of work is to include optional transform scripts/code when\nyour assets module is compiled. This would let you do things like putting a very\nhigh resolution image in the sources folder and down-scaling at compile time as\nappropriate for the target device you are compiling for. In the meantime, just put\nin the assets you want to use directly.","ref":"Scenic.Assets.Static.html#module-future-work","title":"Future Work - Scenic.Assets.Static","type":"module"},{"doc":"","ref":"Scenic.Assets.Static.html#assign/4","title":"Scenic.Assets.Static.assign/4","type":"function"},{"doc":"Return the compiled asset library.","ref":"Scenic.Assets.Static.html#library/0","title":"Scenic.Assets.Static.library/0","type":"function"},{"doc":"Load the binary contents of an asset given it's id or hash.\n\nReturn is in the form of `{:ok, bin}`\n\nIf the asset is not in the library, `{:error, :not_found}` is returned.\n\nThe contents of the file will be hashed and compared against the hash found in\nthe library. If this test fails, `{:error, :hash_failed}` is returned.\n\nIf the output file cannot be read, it returns a posix error.","ref":"Scenic.Assets.Static.html#load/1","title":"Scenic.Assets.Static.load/1","type":"function"},{"doc":"","ref":"Scenic.Assets.Static.html#load/2","title":"Scenic.Assets.Static.load/2","type":"function"},{"doc":"Fetch the metadata for an asset by id.\n\nReturn is in the form of `{:ok, metadata}`\n\nIf the hash is not in the library, `:error` is returned.\n\nExample:\n```elixir\n{:ok, meta} = Scenic.Assets.Static.meta( :parrot )\n```","ref":"Scenic.Assets.Static.html#meta/1","title":"Scenic.Assets.Static.meta/1","type":"function"},{"doc":"","ref":"Scenic.Assets.Static.html#meta/2","title":"Scenic.Assets.Static.meta/2","type":"function"},{"doc":"Return the configured asset library module.","ref":"Scenic.Assets.Static.html#module/0","title":"Scenic.Assets.Static.module/0","type":"function"},{"doc":"Transform an asset id into the file hash.\n\nIf you pass in a valid hash, it is returned unchanged\n\nExample:\n```elixir\nalias Scenic.Assets.Static\nlibrary = Static.library()\n\n{:ok, \"VvWQFjblIwTGsvGx866t8MIG2czWyIc8by6Xc88AOns\"} = Static.hash( library, :parrot )\n{:ok, \"VvWQFjblIwTGsvGx866t8MIG2czWyIc8by6Xc88AOns\"} = Static.hash( library, \"images/parrot.png\" )\n{:ok, \"VvWQFjblIwTGsvGx866t8MIG2czWyIc8by6Xc88AOns\"} = Static.hash( library, \"VvWQFjblIwTGsvGx866t8MIG2czWyIc8by6Xc88AOns\" )\n```","ref":"Scenic.Assets.Static.html#to_hash/1","title":"Scenic.Assets.Static.to_hash/1","type":"function"},{"doc":"","ref":"Scenic.Assets.Static.html#to_hash/2","title":"Scenic.Assets.Static.to_hash/2","type":"function"},{"doc":"","ref":"Scenic.Assets.Static.html#t:id/0","title":"Scenic.Assets.Static.id/0","type":"type"},{"doc":"","ref":"Scenic.Assets.Static.html#t:t/0","title":"Scenic.Assets.Static.t/0","type":"type"},{"doc":"Manage streaming assets (for now only compressed images and bitmaps) that are available\nto all Scenes and ViewPorts.\n\nThe `Scenic.Assets.Stream` API gives to access to a running GenServer that manages an\n`:ets` table and subscriptions to changes to named streams. This means that streaming\nassets are available globally to all Scenes and ViewPorts.\n\nYou should be aware that if you have a GenServer that is rapidly updating a stream,\nbut no scene's are listening, then you are doing unnecessary work. If you have only a\nsingle Scene in a single ViewPort listening to that stream, then create the stream\nin the scene.\n\nIf you have multiple Scenes listening to a stream, or the same stream in multiple\nViewPorts, then create and update the stream in an independent GenServer that you\nmanage outside of Scenic.","ref":"Scenic.Assets.Stream.html","title":"Scenic.Assets.Stream","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Scenic.Assets.Stream.html#child_spec/1","title":"Scenic.Assets.Stream.child_spec/1","type":"function"},{"doc":"Fully delete a named stream.\n\nIf you recreate the stream after deleting it, you can place any asset type into\nthe new stream.","ref":"Scenic.Assets.Stream.html#delete/1","title":"Scenic.Assets.Stream.delete/1","type":"function"},{"doc":"Check if a named stream has been published.\n\nReturns a `:ok` if the stream is published. Raises an error if it is not.","ref":"Scenic.Assets.Stream.html#exists!/1","title":"Scenic.Assets.Stream.exists!/1","type":"function"},{"doc":"Check if a named stream has been published.\n\nReturns a boolean indicating if the stream is published.","ref":"Scenic.Assets.Stream.html#exists?/1","title":"Scenic.Assets.Stream.exists?/1","type":"function"},{"doc":"Fetch the currently published asset in a named stream.\n\nReturns `{:ok, asset}` on success.\n\nReturns `{:error, :not_found}` if the stream is not available.","ref":"Scenic.Assets.Stream.html#fetch/1","title":"Scenic.Assets.Stream.fetch/1","type":"function"},{"doc":"Put a streamable asset into a named stream.\n\nIf the named stream does not exist yet, it is created. If it already exists, then\nit's content is updated with the asset.\n\nReturns `:ok` on success.\n\nNote: Once a stream is create, the asset being updated must be the same type as the\nasset that was originally created. I.e. you can't replace a Bitmap with an Image. This\nwill make more sense in the future as other assets types (audio) become supported.\n\nThe contents of the asset is (lightly) validated as it is put into the :ets table.\nIf the content is invalid, or a different type than what is already in the stream,\nthen it returns `{:error, :invalid, asset_type}`.","ref":"Scenic.Assets.Stream.html#put/2","title":"Scenic.Assets.Stream.put/2","type":"function"},{"doc":"Same as put, but reverses the params order (making it pipe-able) and raises on failures.\n\nReturns the asset on success.","ref":"Scenic.Assets.Stream.html#put!/2","title":"Scenic.Assets.Stream.put!/2","type":"function"},{"doc":"Subscribe to changes in a named stream.\n\nCall this from a GenServer, typically a `Driver` or something you manage yourself.\n\nWhen an asset stream is updated you will receive the following message.\n\n`{{Stream, :put}, stream_type, id}`\n\nYou can match against stream_type to select certain kids of assets. Use the id\nto fetch the contents of the asset.\n\nWhen an asset stream is deleted, you will receive the following message.\n`{{Stream, :delete}, stream_type, id}`\n\nYou can subscribe to an stream before it has been published. You will then start\nreceiving put messages when it is created. Your subscription will not end if the\nstream is deleted.","ref":"Scenic.Assets.Stream.html#subscribe/1","title":"Scenic.Assets.Stream.subscribe/1","type":"function"},{"doc":"Unsubscribe to changes in a named stream.\n\nOnce your process unsubscribes to a named stream, it will stop receiving all\nmessages related to it","ref":"Scenic.Assets.Stream.html#unsubscribe/1","title":"Scenic.Assets.Stream.unsubscribe/1","type":"function"},{"doc":"","ref":"Scenic.Assets.Stream.html#t:asset/0","title":"Scenic.Assets.Stream.asset/0","type":"type"},{"doc":"","ref":"Scenic.Assets.Stream.html#t:id/0","title":"Scenic.Assets.Stream.id/0","type":"type"},{"doc":"This module helps you to prepare images, in the form of a bitmap, that are to be streamed\nand displayed through the `Scenic.Assets.Stream` module.\n\nA bitmap is a rectangular field of pixels. Each pixel can be addressed and assigned a color.\nWhen the bitmap is put into `Scenic.Assets.Stream` it becomes an image that can be displayed\nin a scene via `Scenic.Primitive.Style.Paint.Stream`.","ref":"Scenic.Assets.Stream.Bitmap.html","title":"Scenic.Assets.Stream.Bitmap","type":"module"},{"doc":"Bitmaps are interesting because a typical pattern is to change the color of many pixels in\na rapid burst, then send the image up. The bitmaps can become quite large tho, so if we\nwere to make a copy of it every time a single pixel was changed, that could become quite\nslow.\n\nUnfortunately, writing a NIF that manipulates individual pixels quickly and without making\na copy, breaks the immutable, functional model of Erlang/Elixir.\n\nThe compromise is that a Bitmap can be either in a \"commited\" state, which can be put\ninto `Scenic.Assets.Stream`, but not changed, or in a \"mutable\" state, which can be\nmanipulated rapidly, but not streamed to scenes.\n\nWhen a new bitmap is built, it starts in the mutable state, unless the `commit: true` option is set.\n\n```elixir\nalias Scenic.Assets.Stream.Bitmap\n\nbitmap = Bitmap.build( :rgb, 20, 10, clear: :blue )\n  |> Bitmap.put( 2, 3, :red )\n  |> Bitmap.put( 9, 10, :yellow )\n  |> Bitmap.commit()\n\nScenic.Assets.Stream.put( \"stream_id\", bitmap )\n```\n\nIn the above example, a new bitmap is created, that can hold an rgb color in every pixel,\nis 20 pixels wide, 10 pixels high, and starts with the entire image set to the color `:blue`.\nThe `:commit` option is not set, so it is mutable.\n\nThen two of the pixels are set to other colors. One `:red` and the other `:yellow`.\n\nFinally, the image is committed, making it usable, but no longer mutable. After the image is\ncompleted, it is sent to `Scenic.Assets.Stream`, which makes it available for use in a scene.","ref":"Scenic.Assets.Stream.Bitmap.html#module-committed-vs-mutable","title":"Committed vs. Mutable - Scenic.Assets.Stream.Bitmap","type":"module"},{"doc":"Bitmaps can be one of four depths. Each consumes a different amount of memory per pixel.\nIf you are running on a constrained memory device, or are worried about bandwidth when remoting\nthe UI, then you should choose the depth that you actually use. If you have lots of memory,\nthen `:rgba` is usually the fastest format.\n\n| Depth          | Bytes per pixel        | Notes   |\n|---------------|------------------------|-----------|\n|  `:g` | 1 | Simple Greyscale. 256 shades of grey |\n|  `:ga` | 2 | Greyscale plus an alhpa channel |\n|  `:rgb` | 3 | Red/Green/Blue Millions of colors |\n|  `:rgba` | 4 | Red/Green/Blue/Alpha |","ref":"Scenic.Assets.Stream.Bitmap.html#module-color-depth","title":"Color Depth - Scenic.Assets.Stream.Bitmap","type":"module"},{"doc":"Build a new bitmap with a given depth, width and height.\n\nBuild creates a new bitmap in memory. It begins in a mutable state\nand will be set to transparent black unless the :clear option is specified.\n\nThe valid depths are :g, :ga, :rgb, :rgba as explained in the following table\n\n| Depth          | Bytes per pixel        | Notes   |\n|---------------|------------------------|-----------|\n|  `:g` | 1 | Simple Greyscale. 256 shades of grey |\n|  `:ga` | 2 | Greyscale plus an alhpa channel |\n|  `:rgb` | 3 | Red/Green/Blue Millions of colors |\n|  `:rgba` | 4 | Red/Green/Blue/Alpha |","ref":"Scenic.Assets.Stream.Bitmap.html#build/4","title":"Scenic.Assets.Stream.Bitmap.build/4","type":"function"},{"doc":"* `:clear` Set the new bitmap so that every pixel is the specified color.\n* `:commit` Set to true to start the bitmap committed. Set to false for mutable. The default if not specified is mutable.","ref":"Scenic.Assets.Stream.Bitmap.html#build/4-options","title":"Options - Scenic.Assets.Stream.Bitmap.build/4","type":"function"},{"doc":"Set the color value of all pixels in a bitmap. This effectively erases the bitmap,\nreplacing it with a solid field of the supplied color.\n\nOnly works with mutable bitmaps.\n\nThe color you provide can be any valid value from the `Scenic.Color` module.\n\nIf the color you provide doesn't match the depth of the bitmap, this will\ntransform the color as appropriate to fit. For example, putting an `:rgb`\ncolor into a `:g` (greyscale) bit map, will set the level of grey to be the average\nvalue of the red, green, and blue channels of the supplied color","ref":"Scenic.Assets.Stream.Bitmap.html#clear/2","title":"Scenic.Assets.Stream.Bitmap.clear/2","type":"function"},{"doc":"Change a bitmap from mutable to committed.\n\nCommitted bitmaps can be used by `Scenic.Assets.Stream`. They will not\nwork with the `put` and `clear` functions in this module.","ref":"Scenic.Assets.Stream.Bitmap.html#commit/1","title":"Scenic.Assets.Stream.Bitmap.commit/1","type":"function"},{"doc":"Get the color value of a single pixel in a bitmap.\n\nWorks with either committed or mutable bitmaps.","ref":"Scenic.Assets.Stream.Bitmap.html#get/3","title":"Scenic.Assets.Stream.Bitmap.get/3","type":"function"},{"doc":"Change a bitmap from committed to mutable.\n\nThis makes a copy of the bitmap's memory to preserve the Erlang model.\n\nMutable bitmaps are not usable by `Scenic.Assets.Stream`.","ref":"Scenic.Assets.Stream.Bitmap.html#mutable/1","title":"Scenic.Assets.Stream.Bitmap.mutable/1","type":"function"},{"doc":"Set the color value of a single pixel in a bitmap.\n\nOnly works with mutable bitmaps.\n\nThe color you provide can be any valid value from the `Scenic.Color` module.\n\nIf the color you provide doesn't match the depth of the bitmap, this will\ntransform the color as appropriate to fit. For example, putting an `:rgb`\ncolor into a `:g` (greyscale) bit map, will set the level of grey to be the average\nvalue of the red, green, and blue channels of the supplied color","ref":"Scenic.Assets.Stream.Bitmap.html#put/4","title":"Scenic.Assets.Stream.Bitmap.put/4","type":"function"},{"doc":"Set the color value of a single pixel in a bitmap using an offset from the start.\n\nOnly works with mutable bitmaps.\n\nThe color you provide can be any valid value from the `Scenic.Color` module.\n\nUnlike the `put` function, which specifies the pixel by `x` and `y` position,\n`put_offset` takes an offset directly into the data.\n\nThe offset would be the same as y * width + x.","ref":"Scenic.Assets.Stream.Bitmap.html#put_offset/3","title":"Scenic.Assets.Stream.Bitmap.put_offset/3","type":"function"},{"doc":"","ref":"Scenic.Assets.Stream.Bitmap.html#t:depth/0","title":"Scenic.Assets.Stream.Bitmap.depth/0","type":"type"},{"doc":"","ref":"Scenic.Assets.Stream.Bitmap.html#t:m/0","title":"Scenic.Assets.Stream.Bitmap.m/0","type":"type"},{"doc":"","ref":"Scenic.Assets.Stream.Bitmap.html#t:meta/0","title":"Scenic.Assets.Stream.Bitmap.meta/0","type":"type"},{"doc":"","ref":"Scenic.Assets.Stream.Bitmap.html#t:t/0","title":"Scenic.Assets.Stream.Bitmap.t/0","type":"type"},{"doc":"This module helps you to prepare images, in the form of a compressed blob such as \na jpg or png file, that are to be streamed and displayed through the\n`Scenic.Assets.Stream` module.\n\nA typical use case is receiving pre-compressed images from a physical camera, then\nstreaming them as the fill of a rect in a scene.\n\nThis module is very simple. The only function is from_binary/1, where you supply a\nbinary that is a valid compressed image format. That format is verified and the\nmetadata is parsed out of it.\n\nThe result is a term that can be supplied to the Scenic.Assets.Stream module.\n\nExample:\n\n```elixir\nalias Scenic.Assets.Stream\n\ndef handle_info( {:camera_frame, bin}, state ) do\n  # If the supplied bin is not a valid image, let it crash\n  {:ok, img} = Stream.Image.from_binary( bin )\n  Stream.put( \"camera\", img )\n  { :noreply, state }\nend\n```","ref":"Scenic.Assets.Stream.Image.html","title":"Scenic.Assets.Stream.Image","type":"module"},{"doc":"Create a streamable image resource from a compressed image binary.\n\nOn success, this returns `{:ok, img}`\n\nThe supplied binary must be a valid jpeg or png format. If it is either invalid or an\nunrecognized format, this will return `{:error, :invalid}`","ref":"Scenic.Assets.Stream.Image.html#from_binary/1","title":"Scenic.Assets.Stream.Image.from_binary/1","type":"function"},{"doc":"","ref":"Scenic.Assets.Stream.Image.html#t:meta/0","title":"Scenic.Assets.Stream.Image.meta/0","type":"type"},{"doc":"","ref":"Scenic.Assets.Stream.Image.html#t:t/0","title":"Scenic.Assets.Stream.Image.t/0","type":"type"},{"doc":"A Component is Scene that is optimized to be used as a child of another scene.\n\nThese are typically controls that you want to define once and use in multiple places.","ref":"Scenic.Component.html","title":"Scenic.Component","type":"behaviour"},{"doc":"Scenic includes a several standard components that you can use in your\nscenes. These were chosen to be in the main library because:\n  * They are used frequently\n  * Their use promotes a certain amount of \"common\" look and feel\n\nAll of these components are typically added/modified via the helper functions in the\n[`Scenic.Components`](Scenic.Components.html) module.\n\n| Helper | Component Module | Description |\n|---|---|---|\n| [`button/3`](Scenic.Components.html#button/3) | `Scenic.Component.Button` | A simple button |\n| [`checkbox/3`](Scenic.Components.html#checkbox/3) | `Scenic.Component.Input.Checkbox` | A boolean checkbox control |\n| [`dropdown/3`](Scenic.Components.html#dropdown/3) | `Scenic.Component.Input.Dropdown` | A menu-like dropdown control |\n| [`radio_group/3`](Scenic.Components.html#radio_group/3) | `Scenic.Component.Input.RadioGroup` | A group of radio controls |\n| [`slider/3`](Scenic.Components.html#slider/3) | `Scenic.Component.Input.Slider` | A slider ranging from one value to another |\n| [`text_field/3`](Scenic.Components.html#text_field/3) | `Scenic.Component.Input.TextField` | A text input field. |\n| [`toggle/3`](Scenic.Components.html#toggle/3) | `Scenic.Component.Input.Toggle` | A boolean toggle control. |\n\n```elixir\ndefmodule MyApp.Scene.MyScene do\n  use Scenic.Scene\n  import Scenic.Components\n\n  @impl Scenic.Scene\n  def init(scene, text, opts) do\n    graph =\n      Scenic.Graph.build()\n      |> button( \"Press Me\", id: :press_me )\n      |> slider( {{0,100}, 0}, id: :slide_me )\n\n    { :ok, push_graph(scene, graph) }\n  end\nend\n```","ref":"Scenic.Component.html#module-standard-components","title":"Standard Components - Scenic.Component","type":"behaviour"},{"doc":"Creating a custom component that you can use in your scenes is just like creating a scene\nwith an extra validation function. This validation function is used when the graph that \nuses your component is built in order to make sure it uses data that conforms to what your\ncomponent expects.\n\n```elixir\n  defmodule MyApp.Component.Fancy do\n    use Scenic.Component\n\n    @impl Scenic.Component\n    def validate(data) when is_bitstring(data), do: {:ok, data}\n    def validate(_), do: {:error, \"Descriptive error message goes here.\"}\n\n    @impl Scenic.Scene\n    def init(scene, data, opts) do\n      { :ok, scene }\n    end\n  end\n```","ref":"Scenic.Component.html#module-creating-custom-components","title":"Creating Custom Components - Scenic.Component","type":"behaviour"},{"doc":"Communication from a component to it's parent is usually done via event messages. Scenic knows how\nto route events to a component's parent. If that parent doesn't handle it, then it is automatically\nrouted to the parent's parent. If it gets all the way to the ViewPort itself, then it is ignored.\n\n```elixir\n  defmodule MyApp.Component.Fancy do\n    \n  # ... validate, and other setup ...\n\n    @impl Scenic.Scene\n    def init(scene, data, opts) do\n      # setup and push a graph here...\n      { :ok, assign(scene, id: opts[:id] }\n    end\n\n    @impl Scenic.Scene\n    def handle_input( {:cursor_button, {0, :release, _, _}}, :btn,\n          %Scene{assigns: %{id: id}} = scene\n        ) do\n      :ok = send_parent_event( scene, {:click, id}  )\n      { :noreply, scene }\n    end\n\n  end\n```\n\nNotice how the component saved the original `id` that was passed in to the `init` function via\nthe `opts` list. This is then used to identify the click to the parent. This is a common pattern.","ref":"Scenic.Component.html#module-generating-sending-events","title":"Generating/Sending Events - Scenic.Component","type":"behaviour"},{"doc":"If you would like the parent scene to be able to query your component's state without waiting\nfor the component to send events, you can optionally implement the following handle_call functions.\n\nThis is an \"informal\" spec... You don't have to implement it, but it is nice when you do.\n\n```elixir\ndefmodule MyApp.Component.Fancy do\n  use Scenic.Component\n  \n  # ... init, validate, and other functions ...\n\n  def handle_call(:fetch, _, %{assigns: %{value: value}} = scene) do\n    { :reply, {:ok, value}, scene }\n  end\n\n  def handle_call({:put, value}, _, scene) when is_bitstring(value) do\n    { :reply, :ok, assign(scene, value: value) }\n  end\n\n  def handle_call({:put, _}, _, scene) do\n    {:reply, {:error, :invalid}, scene}\n  end\nend\n```\n\nTo make the above example more practical, you would probably also modify and push a graph when\nhandling the `:put` message. See the code for the standard input components for deeper examples.","ref":"Scenic.Component.html#module-optional-fetch-put-handlers","title":"Optional: Fetch/Put Handlers - Scenic.Component","type":"behaviour"},{"doc":"If you know for certain that your component will not itself use any components, you can\nset `:has_children` to `false` like this.\n\n```elixir\ndefmodule MyApp.Component.Fancy do\n  use Scenic.Component, has_children: false\n  # ...\nend\n```\n\nWhen `:has_children` is set to `false`, no `DynamicSupervisor` is started to manage the\nscene's children, overall resource use is improved, and startup time is faster. You will not,\nhowever, be able to nested components in any scene where `:has_children` is `false`.\n\nFor example, the `Scenic.Component.Button` component sets `:has_children` to `false`.\n\nThis option is available for any Scene, not just components.","ref":"Scenic.Component.html#module-optional-has_children-false","title":"Optional: `has_children: false` - Scenic.Component","type":"behaviour"},{"doc":"Add this component to a Graph.\n\nA standard `add_to_graph/3` is automatically added to your component. Override this\ncallback if you want to customize it.","ref":"Scenic.Component.html#c:add_to_graph/3","title":"Scenic.Component.add_to_graph/3","type":"callback"},{"doc":"Compute the bounding box of the component.\n\nThis function can be called outside of the context of a running component. The box\nshould be computed as if it was running with the given data and styles.","ref":"Scenic.Component.html#c:bounds/2","title":"Scenic.Component.bounds/2","type":"callback"},{"doc":"Provide a default pin for this component.\n\nIf this callback is not implemented, then the default pin will be {0,0}.","ref":"Scenic.Component.html#c:default_pin/2","title":"Scenic.Component.default_pin/2","type":"callback"},{"doc":"Validate that the data for a component is correctly formed.\n\nThis callback is required.","ref":"Scenic.Component.html#c:validate/1","title":"Scenic.Component.validate/1","type":"callback"},{"doc":"Add a button to a graph\n\nA button is a small scene that is pretty much just some text drawn over a\nrounded rectangle. The button scene contains logic to detect when the button\nis pressed, tracks it as the pointer moves around, and when it is released.","ref":"Scenic.Component.Button.html","title":"Scenic.Component.Button","type":"module"},{"doc":"`title`\n\n* `title` - a bitstring describing the text to show in the button","ref":"Scenic.Component.Button.html#module-data","title":"Data - Scenic.Component.Button","type":"module"},{"doc":"If a button press is successful, it sends an event message to the host scene\nin the form of:\n\n    `{:click, id}`\n\nThis event is only sent after the button is released. There're also, though,\ntwo other events that you can receive:\n\n    `{:btn_pressed, id}`\n\nand\n\n    `{:btn_released, id}`\n\nThese messages can be received and handled in your scene via\n`c:Scenic.Scene.handle_event/3`. For example:\n\n```\n...\n\n@impl Scenic.Scene\ndef init(_, _opts) do\n  graph =\n    Graph.build()\n    |> Scenic.Components.button(\"Sample Button\", id: :sample_btn_id, t: {10, 10})\n\n  state = %{}\n\n  {:ok, state, push: graph}\nend\n\n@impl Scenic.Scene\ndef handle_event({:click, :sample_btn_id}, _from, state) do\n  IO.puts(\"Sample button was clicked!\")\n  {:cont, event, state}\nend\n```","ref":"Scenic.Component.Button.html#module-messages","title":"Messages - Scenic.Component.Button","type":"module"},{"doc":"Buttons honor the following standard styles\n\n* `:hidden` - If `false` the component is rendered. If `true`, it is skipped.\nThe default is `false`.\n* `:theme` - The color set used to draw. See below. The default is `:primary`","ref":"Scenic.Component.Button.html#module-styles","title":"Styles - Scenic.Component.Button","type":"module"},{"doc":"Styles can be sent directly to the Button Component by adding a :styles list.\n\n    graph\n    |> button(\n      \"Example\",\n      styles: [font_size: 32, text_align: :right]\n    )\n\nThe following standard styles are supported\n\n* `:font` - The default is :roboto\n* `:font_size` - The default is 20\n* `:text_align` - The default is :center","ref":"Scenic.Component.Button.html#module-sendable-styles","title":"Sendable Styles - Scenic.Component.Button","type":"module"},{"doc":"Buttons the following options.\n\n* `:width` - :auto (default) or pass in a number to set the width of the button\n* `:height` - :auto (default) or pass in a number to set the height of the button.\n* `:radius` - pass in a number to set the radius of the button's rounded\nrectangle. The default is 3\n\nButtons do not use the inherited `:font_size` style as they should look\nconsistent regardless of what size the surrounding text is.","ref":"Scenic.Component.Button.html#module-options","title":"Options - Scenic.Component.Button","type":"module"},{"doc":"Buttons work well with the following predefined themes:\n`:primary`, `:secondary`, `:success`, `:danger`, `:warning`, `:info`,\n`:text`, `:light`, `:dark`\n\nTo pass in a custom theme, supply a map with at least the following entries:\n\n* `:text` - the color of the text in the button\n* `:background` - the normal background of the button\n* `:border` - the border of the button\n* `:active` - the background while the button is pressed","ref":"Scenic.Component.Button.html#module-theme","title":"Theme - Scenic.Component.Button","type":"module"},{"doc":"You should add/modify components via the helper functions in\n[`Scenic.Components`](Scenic.Components.html#button/3)","ref":"Scenic.Component.Button.html#module-usage","title":"Usage - Scenic.Component.Button","type":"module"},{"doc":"The following example creates a simple button and positions it on the screen.\n\n    graph\n    |> button(\"Example\", id: :button_id, translate: {20, 20})\n\nThe next example makes the same button as before, but colors it as a warning\nbutton. See the options list above for more details.\n\n    graph\n    |> button(\"Example\", id: :button_id, translate: {20, 20}, theme: :warning)\n\nThe final example changes the text size and alignment\n\n    graph\n    |> button(\n      \"Example\",\n      id: :button_id,\n      translate: {20, 20},\n      theme: :warning,\n      styles: [text_size: 32, text_align: :right]\n    )","ref":"Scenic.Component.Button.html#module-examples","title":"Examples - Scenic.Component.Button","type":"module"},{"doc":"","ref":"Scenic.Component.Button.html#add_to_graph/3","title":"Scenic.Component.Button.add_to_graph/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Scenic.Component.Button.html#child_spec/1","title":"Scenic.Component.Button.child_spec/1","type":"function"},{"doc":"Add a blinking text-input caret to a graph.","ref":"Scenic.Component.Input.Caret.html","title":"Scenic.Component.Input.Caret","type":"module"},{"doc":"`height`\n\n* `height` - The height of the caret. The caller (TextEdit) calculates this based\n  on its :font_size (often the same thing).","ref":"Scenic.Component.Input.Caret.html#module-data","title":"Data - Scenic.Component.Input.Caret","type":"module"},{"doc":"* `color` - any [valid color](Scenic.Primitive.Style.Paint.Color.html).\n\nYou can change the color of the caret by setting the color option\n\n```elixir\nGraph.build()\n  |> caret( 20, color: :white )\n```","ref":"Scenic.Component.Input.Caret.html#module-options","title":"Options - Scenic.Component.Input.Caret","type":"module"},{"doc":"The caret component is used by the TextField component and usually isn't accessed directly,\nalthough you are free to do so if it fits your needs. There is no short-cut helper\nfunction so you will need to add it to the graph manually.\n\nThe following example adds a blue caret to a graph.\n\n```elixir\ngraph\n  |> Caret.add_to_graph(24, id: :caret, color: :blue )\n```","ref":"Scenic.Component.Input.Caret.html#module-usage","title":"Usage - Scenic.Component.Input.Caret","type":"module"},{"doc":"","ref":"Scenic.Component.Input.Caret.html#add_to_graph/3","title":"Scenic.Component.Input.Caret.add_to_graph/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Scenic.Component.Input.Caret.html#child_spec/1","title":"Scenic.Component.Input.Caret.child_spec/1","type":"function"},{"doc":"Add a checkbox to a graph","ref":"Scenic.Component.Input.Checkbox.html","title":"Scenic.Component.Input.Checkbox","type":"module"},{"doc":"`{text, checked?}`\n\n* `text` - must be a bitstring\n* `checked?` - must be a boolean and indicates if the checkbox is set.","ref":"Scenic.Component.Input.Checkbox.html#module-data","title":"Data - Scenic.Component.Input.Checkbox","type":"module"},{"doc":"When the state of the checkbox, it sends an event message to the host scene\nin the form of:\n\n`{:value_changed, id, checked?}`","ref":"Scenic.Component.Input.Checkbox.html#module-messages","title":"Messages - Scenic.Component.Input.Checkbox","type":"module"},{"doc":"Buttons honor the following styles\n\n* `:hidden` - If `false` the component is rendered. If `true`, it is skipped.\nThe default is `false`.\n* `:theme` - The color set used to draw. See below. The default is `:dark`","ref":"Scenic.Component.Input.Checkbox.html#module-styles","title":"Styles - Scenic.Component.Input.Checkbox","type":"module"},{"doc":"Checkboxes work well with the following predefined themes: `:light`, `:dark`\n\nTo pass in a custom theme, supply a map with at least the following entries:\n\n* `:text` - the color of the text in the button\n* `:background` - the background of the box\n* `:border` - the border of the box\n* `:active` - the border of the box while the button is pressed\n* `:thumb` - the color of the check mark itself","ref":"Scenic.Component.Input.Checkbox.html#module-theme","title":"Theme - Scenic.Component.Input.Checkbox","type":"module"},{"doc":"You should add/modify components via the helper functions in\n[`Scenic.Components`](Scenic.Components.html#checkbox/3)","ref":"Scenic.Component.Input.Checkbox.html#module-usage","title":"Usage - Scenic.Component.Input.Checkbox","type":"module"},{"doc":"The following example creates a checkbox and positions it on the screen.\n\n    graph\n    |> checkbox({\"Example\", true}, id: :checkbox_id, translate: {20, 20})","ref":"Scenic.Component.Input.Checkbox.html#module-examples","title":"Examples - Scenic.Component.Input.Checkbox","type":"module"},{"doc":"","ref":"Scenic.Component.Input.Checkbox.html#add_to_graph/3","title":"Scenic.Component.Input.Checkbox.add_to_graph/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Scenic.Component.Input.Checkbox.html#child_spec/1","title":"Scenic.Component.Input.Checkbox.child_spec/1","type":"function"},{"doc":"Add a dropdown to a graph","ref":"Scenic.Component.Input.Dropdown.html","title":"Scenic.Component.Input.Dropdown","type":"module"},{"doc":"`{items, initial_item}`\n\n* `items` - must be a list of items, each of which is: `{text, id}`. See below...\n* `initial_item` - the `id` of the initial selected item. It can be any term\nyou want, however it must be an `item_id` in the `items` list. See below.\n\nPer item data:\n\n`{text, item_id}`\n\n* `text` - a string that will be shown in the dropdown.\n* `item_id` - any term you want. It will identify the item that is\ncurrently selected in the dropdown and will be passed back to you during\nevent messages.","ref":"Scenic.Component.Input.Dropdown.html#module-data","title":"Data - Scenic.Component.Input.Dropdown","type":"module"},{"doc":"When the state of the checkbox, it sends an event message to the host scene\nin the form of:\n\n`{:value_changed, id, selected_item_id}`\n\nIt also send the following events:\n\n`{:dropdown_opened, id}` - sent when the dropdown opens\n`{:dropdown_closed, id}` - sent when the dropdown closes\n`{:dropdown_item_hover, id, item_id}` - sent when and item is hovered","ref":"Scenic.Component.Input.Dropdown.html#module-messages","title":"Messages - Scenic.Component.Input.Dropdown","type":"module"},{"doc":"Dropdowns honor the following list of options.","ref":"Scenic.Component.Input.Dropdown.html#module-options","title":"Options - Scenic.Component.Input.Dropdown","type":"module"},{"doc":"Buttons honor the following styles\n\n* `:hidden` - If `false` the component is rendered. If `true`, it is skipped.\nThe default is `false`.\n* `:theme` - The color set used to draw. See below. The default is `:dark`","ref":"Scenic.Component.Input.Dropdown.html#module-styles","title":"Styles - Scenic.Component.Input.Dropdown","type":"module"},{"doc":"Buttons honor the following list of additional styles.\n\n* `:width` - pass in a number to set the width of the button.\n* `:height` - pass in a number to set the height of the button.\n* `:direction` - what direction should the menu drop. Can be either `:down`\nor `:up`. The default is `:down`.","ref":"Scenic.Component.Input.Dropdown.html#module-additional-styles","title":"Additional Styles - Scenic.Component.Input.Dropdown","type":"module"},{"doc":"Dropdowns work well with the following predefined themes: `:light`, `:dark`\n\nTo pass in a custom theme, supply a map with at least the following entries:\n\n* `:text` - the color of the text\n* `:background` - the background of the component\n* `:border` - the border of the component\n* `:active` - the background of selected item in the dropdown list\n* `:thumb` - the color of the item being hovered over","ref":"Scenic.Component.Input.Dropdown.html#module-theme","title":"Theme - Scenic.Component.Input.Dropdown","type":"module"},{"doc":"You should add/modify components via the helper functions in\n[`Scenic.Components`](Scenic.Components.html#dropdown/3)","ref":"Scenic.Component.Input.Dropdown.html#module-usage","title":"Usage - Scenic.Component.Input.Dropdown","type":"module"},{"doc":"The following example creates a dropdown and positions it on the screen.\n\n    graph\n    |> dropdown({[\n      {\"Dashboard\", :dashboard},\n      {\"Controls\", :controls},\n      {\"Primitives\", :primitives}\n    ], :controls}, id: :dropdown_id, translate: {20, 20})","ref":"Scenic.Component.Input.Dropdown.html#module-examples","title":"Examples - Scenic.Component.Input.Dropdown","type":"module"},{"doc":"","ref":"Scenic.Component.Input.Dropdown.html#add_to_graph/3","title":"Scenic.Component.Input.Dropdown.add_to_graph/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Scenic.Component.Input.Dropdown.html#child_spec/1","title":"Scenic.Component.Input.Dropdown.child_spec/1","type":"function"},{"doc":"Add a single radio button to a graph.","ref":"Scenic.Component.Input.RadioButton.html","title":"Scenic.Component.Input.RadioButton","type":"module"},{"doc":"`{text, id}`\n`{text, id, selected?}`\n\n* `text` - a bitstring of the text to display\n* `id` - any term. Identifies the radio button.\n* `selected?` - boolean. `true` if selected. `false if not`. Default is `false` if\nthis term is not provided.","ref":"Scenic.Component.Input.RadioButton.html#module-data","title":"Data - Scenic.Component.Input.RadioButton","type":"module"},{"doc":"The RadioButton component is used by the RadioGroup component and usually isn't accessed\ndirectly, although you are free to do so if it fits your needs. There is no short-cut\nhelper function so you will need to add it to the graph manually.\n\nThe following example adds a caret to a graph.\n\n    graph\n    |> RadioButton.add_to_graph({\"A button\", :an_id, true})","ref":"Scenic.Component.Input.RadioButton.html#module-usage","title":"Usage - Scenic.Component.Input.RadioButton","type":"module"},{"doc":"","ref":"Scenic.Component.Input.RadioButton.html#add_to_graph/3","title":"Scenic.Component.Input.RadioButton.add_to_graph/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Scenic.Component.Input.RadioButton.html#child_spec/1","title":"Scenic.Component.Input.RadioButton.child_spec/1","type":"function"},{"doc":"Add a radio group to a graph\n\nThe data format for RadioGroup has changed since v0.10!","ref":"Scenic.Component.Input.RadioGroup.html","title":"Scenic.Component.Input.RadioGroup","type":"module"},{"doc":"`{radio_buttons, checked_id}`\n\n* `radio_buttons` must be a list of radio button data. See below.\n* `checked_id` Is the id of the currently selected radio from the list.\n\nradio_buttons list:\n\n`{text, radio_id}`\n\n* `text` - must be a bitstring\n* `button_id` - can be any term you want. It will be passed back to you as the\ngroup's value.\n* `checked?` - must be a boolean and indicates if the button is selected.\n`checked?` is not required and will default to `false` if not supplied.\n\nExample showing the full data format\n```elixir\n{[{\"One\", :one}, {\"Two\", :two}, {\"Three\", :three}], :two}\n```","ref":"Scenic.Component.Input.RadioGroup.html#module-data","title":"Data - Scenic.Component.Input.RadioGroup","type":"module"},{"doc":"When the state of the radio group changes, it sends an event message to the\nhost scene in the form of:\n\n`{:value_changed, id, radio_id}`","ref":"Scenic.Component.Input.RadioGroup.html#module-messages","title":"Messages - Scenic.Component.Input.RadioGroup","type":"module"},{"doc":"Radio Buttons honor the following list of options.\n\n* `:theme` - This sets the color scheme of the button. This can be one of\npre-defined button schemes `:light`, `:dark`, or it can be a completely custom\nscheme like this: `{text_color, box_background, border_color, pressed_color,\ncheckmark_color}`.","ref":"Scenic.Component.Input.RadioGroup.html#module-options","title":"Options - Scenic.Component.Input.RadioGroup","type":"module"},{"doc":"Radio Buttons honor the following styles\n\n* `:hidden` - If `false` the component is rendered. If `true`, it is skipped.\nThe default is `false`.\n* `:theme` - The color set used to draw. See below. The default is `:dark`","ref":"Scenic.Component.Input.RadioGroup.html#module-styles","title":"Styles - Scenic.Component.Input.RadioGroup","type":"module"},{"doc":"Radio buttons work well with the following predefined themes: `:light`,\n`:dark`\n\nTo pass in a custom theme, supply a map with at least the following entries:\n\n* `:text` - the color of the text\n* `:background` - the background of the component\n* `:border` - the border of the component\n* `:active` - the background of the circle while the button is pressed\n* `:thumb` - the color of inner selected-mark","ref":"Scenic.Component.Input.RadioGroup.html#module-theme","title":"Theme - Scenic.Component.Input.RadioGroup","type":"module"},{"doc":"You should add/modify components via the helper functions in\n[`Scenic.Components`](Scenic.Components.html#radio_group/3)","ref":"Scenic.Component.Input.RadioGroup.html#module-usage","title":"Usage - Scenic.Component.Input.RadioGroup","type":"module"},{"doc":"The following example creates a radio group and positions it on the screen.\n\n    graph\n    |> radio_group({[\n        {\"Radio A\", :radio_a},\n        {\"Radio B\", :radio_b},\n        {\"Radio C\", :radio_c},\n      ], :radio_b}, \n      id: :radio_group_id, translate: {20, 20})","ref":"Scenic.Component.Input.RadioGroup.html#module-examples","title":"Examples - Scenic.Component.Input.RadioGroup","type":"module"},{"doc":"","ref":"Scenic.Component.Input.RadioGroup.html#add_to_graph/3","title":"Scenic.Component.Input.RadioGroup.add_to_graph/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Scenic.Component.Input.RadioGroup.html#child_spec/1","title":"Scenic.Component.Input.RadioGroup.child_spec/1","type":"function"},{"doc":"Add a slider to a graph","ref":"Scenic.Component.Input.Slider.html","title":"Scenic.Component.Input.Slider","type":"module"},{"doc":"`{ extents, initial_value}`\n\n* `extents` gives the range of values. It can take several forms...\n  * `{min, max}` If `min` and `max` are integers, then the slider value will\n  be an integer.\n  * `{min, max}` If `min` and `max` are floats, then the slider value will be\n  an float.\n  * `[a, b, c]` A list of terms. The value will be one of the terms\n* `initial_value` Sets the initial value (and position) of the slider. It\nmust make sense with the extents you passed in.","ref":"Scenic.Component.Input.Slider.html#module-data","title":"Data - Scenic.Component.Input.Slider","type":"module"},{"doc":"When the state of the slider changes, it sends an event message to the host\nscene in the form of:\n\n`{:value_changed, id, value}`","ref":"Scenic.Component.Input.Slider.html#module-messages","title":"Messages - Scenic.Component.Input.Slider","type":"module"},{"doc":"Sliders honor the following list of options.","ref":"Scenic.Component.Input.Slider.html#module-options","title":"Options - Scenic.Component.Input.Slider","type":"module"},{"doc":"Sliders honor the following styles\n\n* `:hidden` - If `false` the component is rendered. If `true`, it is skipped.\nThe default is `false`.\n* `:theme` - The color set used to draw. See below. The default is `:dark`","ref":"Scenic.Component.Input.Slider.html#module-styles","title":"Styles - Scenic.Component.Input.Slider","type":"module"},{"doc":"Sliders work well with the following predefined themes: `:light`, `:dark`\n\nTo pass in a custom theme, supply a map with at least the following entries:\n\n* `:border` - the color of the slider line\n* `:thumb` - the color of slider thumb","ref":"Scenic.Component.Input.Slider.html#module-theme","title":"Theme - Scenic.Component.Input.Slider","type":"module"},{"doc":"You should add/modify components via the helper functions in\n[`Scenic.Components`](Scenic.Components.html#slider/3)","ref":"Scenic.Component.Input.Slider.html#module-usage","title":"Usage - Scenic.Component.Input.Slider","type":"module"},{"doc":"The following example creates a numeric slider and positions it on the screen.\n\n    graph\n    |> slider({{0,100}, 0}, id: :num_slider, translate: {20,20})\n\nThe following example creates a list slider and positions it on the screen.\n\n    graph\n    |> slider({[\n        :white,\n        :cornflower_blue,\n        :green,\n        :chartreuse\n      ], :cornflower_blue}, id: :slider_id, translate: {20,20})","ref":"Scenic.Component.Input.Slider.html#module-examples","title":"Examples - Scenic.Component.Input.Slider","type":"module"},{"doc":"","ref":"Scenic.Component.Input.Slider.html#add_to_graph/3","title":"Scenic.Component.Input.Slider.add_to_graph/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Scenic.Component.Input.Slider.html#child_spec/1","title":"Scenic.Component.Input.Slider.child_spec/1","type":"function"},{"doc":"Add a text field input to a graph","ref":"Scenic.Component.Input.TextField.html","title":"Scenic.Component.Input.TextField","type":"module"},{"doc":"`initial_value`\n\n* `initial_value` - is the string that will be the starting value","ref":"Scenic.Component.Input.TextField.html#module-data","title":"Data - Scenic.Component.Input.TextField","type":"module"},{"doc":"When the text in the field changes, it sends an event message to the host\nscene in the form of:\n\n`{:value_changed, id, value}`\n\nIt also sends other two events when focus is gained or lost, respectively:\n\n`{:focus, id}`\n`{:blur, id}`","ref":"Scenic.Component.Input.TextField.html#module-messages","title":"Messages - Scenic.Component.Input.TextField","type":"module"},{"doc":"Text fields honor the following styles\n\n* `:hidden` - If `false` the component is rendered. If `true`, it is skipped.\nThe default is `false`.\n* `:theme` - The color set used to draw. See below. The default is `:dark`","ref":"Scenic.Component.Input.TextField.html#module-styles","title":"Styles - Scenic.Component.Input.TextField","type":"module"},{"doc":"Text fields honor the following list of additional options.\n\n* `:filter` - Adding a filter option restricts which characters can be\nentered into the text_field component. The value of filter can be one of:\n  * `:all` - Accept all characters. This is the default\n  * `:number` - Any characters from \"0123456789.,\"\n  * `\"filter_string\"` - Pass in a string containing all the characters you\n  will accept\n  * `function/1` - Pass in an anonymous function. The single parameter will\n  be the character to be filtered. Return `true` or `false` to keep or reject\n  it.\n* `:hint` - A string that will be shown (greyed out) when the entered value\nof the component is empty.\n* `:hint_color` - any [valid color](Scenic.Primitive.Style.Paint.Color.html).\n* `:type` - Can be one of the following options:\n  * `:all` - Show all characters. This is the default.\n  * `:password` - Display a string of '*' characters instead of the value.\n* `:width` - set the width of the control.","ref":"Scenic.Component.Input.TextField.html#module-additional-options","title":"Additional Options - Scenic.Component.Input.TextField","type":"module"},{"doc":"Text fields work well with the following predefined themes: `:light`, `:dark`\n\nTo pass in a custom theme, supply a map with at least the following entries:\n\n* `:text` - the color of the text\n* `:background` - the background of the component\n* `:border` - the border of the component\n* `:focus` - the border while the component has focus","ref":"Scenic.Component.Input.TextField.html#module-theme","title":"Theme - Scenic.Component.Input.TextField","type":"module"},{"doc":"You should add/modify components via the helper functions in\n[`Scenic.Components`](Scenic.Components.html#text_field/3)","ref":"Scenic.Component.Input.TextField.html#module-usage","title":"Usage - Scenic.Component.Input.TextField","type":"module"},{"doc":"graph\n    |> text_field(\"Sample Text\", id: :text_id, translate: {20,20})\n\n    graph\n    |> text_field(\n      \"\", id: :pass_id, type: :password, hint: \"Enter password\", translate: {20,20}\n    )","ref":"Scenic.Component.Input.TextField.html#module-examples","title":"Examples - Scenic.Component.Input.TextField","type":"module"},{"doc":"","ref":"Scenic.Component.Input.TextField.html#add_to_graph/3","title":"Scenic.Component.Input.TextField.add_to_graph/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Scenic.Component.Input.TextField.html#child_spec/1","title":"Scenic.Component.Input.TextField.child_spec/1","type":"function"},{"doc":"Add toggle to a Scenic graph.","ref":"Scenic.Component.Input.Toggle.html","title":"Scenic.Component.Input.Toggle","type":"module"},{"doc":"`on?`\n\n* `on?` - `true` if the toggle is on, pass `false` if not.","ref":"Scenic.Component.Input.Toggle.html#module-data","title":"Data - Scenic.Component.Input.Toggle","type":"module"},{"doc":"Toggles honor the following styles. The `:light` and `:dark` styles look nice. The other bundled themes...not so much. You can also [supply your own theme](Scenic.Toggle.Components.html#toggle/3-theme).\n\n* `:hidden` - If `false` the toggle is rendered. If true, it is skipped. The default\n  is `false`.\n* `:theme` - The color set used to draw. See below. The default is `:dark`","ref":"Scenic.Component.Input.Toggle.html#module-styles","title":"Styles - Scenic.Component.Input.Toggle","type":"module"},{"doc":"Toggles also honor the following additional options.\n\n* `:border_width` - the border width. Defaults to `2`.\n* `:padding` - the space between the border and the thumb. Defaults to `2`\n* `:thumb_radius` - the radius of the thumb. This determines the size of the entire toggle. Defaults to `10`.\n* `:compat` - use the pre-v0.11 positioning. The default is `false`","ref":"Scenic.Component.Input.Toggle.html#module-additional-options","title":"Additional Options - Scenic.Component.Input.Toggle","type":"module"},{"doc":"To pass in a custom theme, supply a map with at least the following entries:\n\n* `:border` - the color of the border around the toggle\n* `:background` - the color of the track when the toggle is `off`.\n* `:text` - the color of the thumb.\n* `:thumb` - the color of the track when the toggle is `on`.\n\nOptionally, you can supply the following entries:\n\n* `:thumb_pressed` - the color of the thumb when pressed. Defaults to `:gainsboro`.","ref":"Scenic.Component.Input.Toggle.html#module-theme","title":"Theme - Scenic.Component.Input.Toggle","type":"module"},{"doc":"You should add/modify components via the helper functions in\n[`Scenic.Components`](Scenic.Components.html#toggle/3)","ref":"Scenic.Component.Input.Toggle.html#module-usage","title":"Usage - Scenic.Component.Input.Toggle","type":"module"},{"doc":"The following example creates a toggle.\n    graph\n    |> toggle(true, translate: {20, 20})\n\nThe next example makes a larger toggle.\n    graph\n    |> toggle(true, translate: {20, 20}, thumb_radius: 14)","ref":"Scenic.Component.Input.Toggle.html#module-examples","title":"Examples - Scenic.Component.Input.Toggle","type":"module"},{"doc":"","ref":"Scenic.Component.Input.Toggle.html#add_to_graph/3","title":"Scenic.Component.Input.Toggle.add_to_graph/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Scenic.Component.Input.Toggle.html#child_spec/1","title":"Scenic.Component.Input.Toggle.child_spec/1","type":"function"},{"doc":"Please see [`Primitives Overview`](overview_primitives.html) for a high-level description.","ref":"Scenic.Primitive.html","title":"Scenic.Primitive","type":"behaviour"},{"doc":"A primitive is the simplest thing Scenic knows how to draw on the screen. There is \na, fixed set of them, but they can be combined in a graph to draw very complicated\nimages.\n\nIn general, each Primitive has a piece of data that it expects to operate on. For\nexample, Primitive.Text requires a bitstring. Primitive.Circle requires a radius. Please\nsee the documentation for each primitive for details.","ref":"Scenic.Primitive.html#module-what-is-a-primitive","title":"What is a primitive - Scenic.Primitive","type":"behaviour"},{"doc":"By far, the easiest way to use primitives is to import the helper functions in\n`Scenic.Primitives`. These helpers can both add primitives to\na scene you are building and modify later as you react to events.\n\n```elixir\nimport Scenic.Primitives\n\n@graph Scenic.Graph.build()\n       |> rect({100, 50}, stroke: {1, :yellow})\n       |> rectangle({100, 50}, stroke: {1, :yellow})\n```\n\nOnce you get a primitive out of a graph via functions such as `Graph.modify`, or `Graph.get`,\nYou can use the generic helpers in this module to access or manipulate them.","ref":"Scenic.Primitive.html#module-how-to-use-primitives","title":"How to use primitives - Scenic.Primitive","type":"behaviour"},{"doc":"The set of primitives supported in Scenic is fixed in any given version. They have been chosen\nto provide the maximum flexibility when combined together, while still requiring the minimal\namount of code and maintenance.\n\nSee the documentation for each primitive's module for details on it's data type.\n\n| Helper | Primitive Module | Description |\n|---|---|---|\n| [`arc/3`](`Scenic.Primitives.arc/3`) | `Scenic.Primitive.Arc` | Draw an arc around a circle |\n| [`circle/3`](`Scenic.Primitives.circle/3`) | `Scenic.Primitive.Circle` | Draw a full circle |\n| [`ellipse/3`](`Scenic.Primitives.ellipse/3`) | `Scenic.Primitive.Ellipse` | Draw an ellipse |\n| [`group/3`](`Scenic.Primitives.group/3`) | `Scenic.Primitive.Group` | Create a group |\n| [`line/3`](`Scenic.Primitives.line/3`) | `Scenic.Primitive.Line` | Draw a line |\n| [`path/3`](`Scenic.Primitives.path/3`) | `Scenic.Primitive.Path` | Draw a complicated path |\n| [`quad/3`](`Scenic.Primitives.quad/3`) | `Scenic.Primitive.Quad` | Draw a quad |\n| [`rect/3`](`Scenic.Primitives.rect/3`) | `Scenic.Primitive.Rectangle` | Draw a rectangle |\n| [`rrect/3`](`Scenic.Primitives.rrect/3`) | `Scenic.Primitive.RoundedRectangle` | Draw a rounded rectangle |\n| [`script/3`](`Scenic.Primitives.script/3`) | `Scenic.Primitive.Script` | Run a referenced draw script |\n| [`sector/3`](`Scenic.Primitives.sector/3`) | `Scenic.Primitive.Sector` | A boolean toggle control. |\n| [`sprites/3`](`Scenic.Primitives.sprites/3`) | `Scenic.Primitive.Sprites` | Draw a sector |\n| [`text/3`](`Scenic.Primitives.text/3`) | `Scenic.Primitive.Text` | Draw a string of text |\n| [`triangle/3`](`Scenic.Primitives.triangle/3`) | `Scenic.Primitive.Triangle` | Draw a triangle |","ref":"Scenic.Primitive.html#module-standard-primitives","title":"Standard Primitives - Scenic.Primitive","type":"behaviour"},{"doc":"Generic builder to create a new primitive.\n\nThis function is used internally. You should almost always use the helpers in\n`Scenic.Primitives` instead.\n\nParameters:\n* `module` - The module of the primitive you are building\n* `data` - the primitive-specific data being set into the primitive\n* `opts` - a list of style and transform options to apply to the primitive\n\nReturns the built primitive.","ref":"Scenic.Primitive.html#build/3","title":"Scenic.Primitive.build/3","type":"function"},{"doc":"","ref":"Scenic.Primitive.html#c:compile/2","title":"Scenic.Primitive.compile/2","type":"callback"},{"doc":"Determines if a point is contained within a primitive.\n\nThe supplied point must already be projected into the local coordinate space\nof the primitive. In other words, this test does NOT take into account any\ntransforms that have been applied to the primitive.\n\nThe input mechanism takes care of this for you by projecting incoming points\nby the inverse-matrix of a primitive before calling this function...\n\nNote that some primitives, such as Group, do not inherently have a notion of\ncontaining a point. In those cases, this function will always return false.\n\nParameters:\n* `primitive` - The primitive\n* `point` - The point to test\n\nReturns `true` or `false`.","ref":"Scenic.Primitive.html#contains_point?/2","title":"Scenic.Primitive.contains_point?/2","type":"function"},{"doc":"Deletes a specified style from a primitive.\n\nDoes nothing if the style is not set.\n\nParameters:\n* `primitive` - The primitive\n* `type` - atom representing the style to delete.\n\nReturns the updated primitive.","ref":"Scenic.Primitive.html#delete_style/2","title":"Scenic.Primitive.delete_style/2","type":"function"},{"doc":"Deletes a specified transform from a primitive.\n\nDoes nothing if the transform is not set.\n\nParameters:\n* `primitive` - The primitive\n* `type` - atom representing the transform to delete.\n\nReturns the updated primitive.","ref":"Scenic.Primitive.html#delete_transform/2","title":"Scenic.Primitive.delete_transform/2","type":"function"},{"doc":"Get the value of the primitive-specific data.\n\nParameters:\n* `primitive` - The primitive\n\nReturns the value of the primitive-specific data.","ref":"Scenic.Primitive.html#get/1","title":"Scenic.Primitive.get/1","type":"function"},{"doc":"Get the value of a specific style set on the primitive.\n\nIf the style is not set, it returns default\n\nParameters:\n* `primitive` - The primitive\n* `type` - atom representing the style to get.\n* `default` - default value to return if the style is not set.\n\nReturns the value of the style.","ref":"Scenic.Primitive.html#get_style/3","title":"Scenic.Primitive.get_style/3","type":"function"},{"doc":"Get the styles map from a primitive.\n\nParameters:\n* `primitive` - The primitive\n\nReturns the map of styles set directly onto this primitive. This does\nnot include any inherited styles.","ref":"Scenic.Primitive.html#get_styles/1","title":"Scenic.Primitive.get_styles/1","type":"function"},{"doc":"Get the value of a specific transform set on the primitive.\n\nIf the transform is not set, it returns default\n\nParameters:\n* `primitive` - The primitive\n* `type` - atom representing the transform to get.\n* `default` - default value to return if the transform is not set.\n\nReturns the value of the transform.","ref":"Scenic.Primitive.html#get_transform/3","title":"Scenic.Primitive.get_transform/3","type":"function"},{"doc":"Get the transforms map from a primitive.\n\nParameters:\n* `primitive` - The primitive\n\nReturns the map of transforms set directly onto this primitive. This does\nnot include any inherited transforms.","ref":"Scenic.Primitive.html#get_transforms/1","title":"Scenic.Primitive.get_transforms/1","type":"function"},{"doc":"Merge an options-list of styles and transforms onto a primitive.\n\nThis function might go through a name-change in the future. It is really\nmore of a merge. The supplied list of styles and transforms\n\nParameters:\n* `primitive` - The primitive\n\nReturns the value of the primitive-specific data.","ref":"Scenic.Primitive.html#merge_opts/2","title":"Scenic.Primitive.merge_opts/2","type":"function"},{"doc":"Put primitive-specific data onto the primitive.\n\nLike many of the functions in the `Scenic.Primitive` module, you are usually better\noff using the helper functions in `Scenic.Primitives` instead.\n\nParameters:\n* `primitive` - The primitive\n* `data` - The data to set\n* `opts` - A list of style/transform options to merge\n\nReturns the updated primitive.","ref":"Scenic.Primitive.html#put/3","title":"Scenic.Primitive.put/3","type":"function"},{"doc":"Update the value of a specific style set on the primitive.\n\nParameters:\n* `primitive` - The primitive\n* `type` - atom representing the style to get.\n* `data` - the value to set on the style.\n\nReturns the updated primitive.","ref":"Scenic.Primitive.html#put_style/3","title":"Scenic.Primitive.put_style/3","type":"function"},{"doc":"Update the styles map in a primitive.\n\nParameters:\n* `primitive` - The primitive\n* `styles` - The new styles map\n\nReturns the primitive with the updated styles.","ref":"Scenic.Primitive.html#put_styles/2","title":"Scenic.Primitive.put_styles/2","type":"function"},{"doc":"Update the value of a specific transform set on the primitive.\n\nParameters:\n* `primitive` - The primitive\n* `type` - atom representing the transform to get.\n* `data` - the value to set on the transform.\n\nReturns the updated primitive.","ref":"Scenic.Primitive.html#put_transform/3","title":"Scenic.Primitive.put_transform/3","type":"function"},{"doc":"Update the transforms map in a primitive.\n\nParameters:\n* `primitive` - The primitive\n* `transforms` - The new transforms map\n\nReturns the primitive with the updated transforms.","ref":"Scenic.Primitive.html#put_transforms/2","title":"Scenic.Primitive.put_transforms/2","type":"function"},{"doc":"","ref":"Scenic.Primitive.html#c:valid_styles/0","title":"Scenic.Primitive.valid_styles/0","type":"callback"},{"doc":"","ref":"Scenic.Primitive.html#c:validate/1","title":"Scenic.Primitive.validate/1","type":"callback"},{"doc":"","ref":"Scenic.Primitive.html#t:t/0","title":"Scenic.Primitive.t/0","type":"type"},{"doc":"Draw an arc on the screen.\n\nAn arc is a segment that traces part of the outline of a circle. If you are\nlooking for something shaped like a piece of pie, then you want a segment.\n\nArcs are often drawn on top of a segment to get an affect where a piece of pie\nis filled in, but only the curvy edge is stroked.\n\nNote that you can fill an arc, but that will result in a shape that looks\nlike a potato wedge.","ref":"Scenic.Primitive.Arc.html","title":"Scenic.Primitive.Arc","type":"module"},{"doc":"`{radius, angle}`\n\nThe data for an arc is a tuple.\n* `radius` - the radius of the arc\n* `angle` - the angle the arc is swept through in radians","ref":"Scenic.Primitive.Arc.html#module-data","title":"Data - Scenic.Primitive.Arc","type":"module"},{"doc":"The format for Arc has changed since v0.10. It used to be\n{radius, start_angle, end_angle}. You can achieve the same effect in the\nnew, simpler format by using the same radius and the new angle is the\ndifference between the old end_angle and start_angle. Then you can apply\na rotation transform to get it in the right position.","ref":"Scenic.Primitive.Arc.html#module-note","title":"Note - Scenic.Primitive.Arc","type":"module"},{"doc":"This primitive recognizes the following styles\n* [`hidden`](Scenic.Primitive.Style.Hidden.html) - show or hide the primitive\n* [`scissor`](Scenic.Primitive.Style.Scissor.html) - \"scissor rectangle\" that drawing will be clipped to.\n* [`fill`](Scenic.Primitive.Style.Fill.html) - fill in the area of the primitive\n* [`cap`](Scenic.Primitive.Style.Cap.html) - says how to draw the ends of the arc.\n* [`stroke`](Scenic.Primitive.Style.Stroke.html) - stroke the outline of the primitive. In this case, only the curvy part.","ref":"Scenic.Primitive.Arc.html#module-styles","title":"Styles - Scenic.Primitive.Arc","type":"module"},{"doc":"You should add/modify primitives via the helper functions in\n[`Scenic.Primitives`](Scenic.Primitives.html#arc/3)\n\n```elixir\ngraph\n  |> arc( {100, 1.5}, stroke: {1, :yellow} )\n```","ref":"Scenic.Primitive.Arc.html#module-usage","title":"Usage - Scenic.Primitive.Arc","type":"module"},{"doc":"Compile the data for this primitive into a mini script. This can be combined with others to\ngenerate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Arc.html#compile/2","title":"Scenic.Primitive.Arc.compile/2","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Arc.html#valid_styles/0","title":"Scenic.Primitive.Arc.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Arc.html#t:styles_t/0","title":"Scenic.Primitive.Arc.styles_t/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Arc.html#t:t/0","title":"Scenic.Primitive.Arc.t/0","type":"type"},{"doc":"Draw a circle on the screen.","ref":"Scenic.Primitive.Circle.html","title":"Scenic.Primitive.Circle","type":"module"},{"doc":"`radius`\n\nThe data for an arc is a single number.\n* `radius` - the radius of the arc","ref":"Scenic.Primitive.Circle.html#module-data","title":"Data - Scenic.Primitive.Circle","type":"module"},{"doc":"This primitive recognizes the following styles\n* [`hidden`](Scenic.Primitive.Style.Hidden.html) - show or hide the primitive\n* [`scissor`](Scenic.Primitive.Style.Scissor.html) - \"scissor rectangle\" that drawing will be clipped to.\n* [`fill`](Scenic.Primitive.Style.Fill.html) - fill in the area of the primitive\n* [`stroke`](Scenic.Primitive.Style.Stroke.html) - stroke the outline of the primitive. In this case, only the curvy part.","ref":"Scenic.Primitive.Circle.html#module-styles","title":"Styles - Scenic.Primitive.Circle","type":"module"},{"doc":"You should add/modify primitives via the helper functions in\n[`Scenic.Primitives`](Scenic.Primitives.html#circle/3)\n\n```elixir\ngraph\n  |> circle( 100, stroke: {1, :yellow} )\n```","ref":"Scenic.Primitive.Circle.html#module-usage","title":"Usage - Scenic.Primitive.Circle","type":"module"},{"doc":"Compile the data for this primitive into a mini script. This can be combined with others to\ngenerate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Circle.html#compile/2","title":"Scenic.Primitive.Circle.compile/2","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Circle.html#valid_styles/0","title":"Scenic.Primitive.Circle.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Circle.html#t:styles_t/0","title":"Scenic.Primitive.Circle.styles_t/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Circle.html#t:t/0","title":"Scenic.Primitive.Circle.t/0","type":"type"},{"doc":"Add a child component to a graph.\n\nWhen a scene pushes a graph containing a Component to its ViewPort,\na new scene, containing the component, is created and added as a child\nto the scene that created it.\n\nAny events the new component creates are sent up the parent. The parent\ncan use functions in the `Scenic.Scene` module to manage its children,\nsend them messages and such.\n\nThe standard components, such as button, slider, etc. have wrapper functions\nmaking them very easy to add to a graph. However, if you have a custom\ncomponent you can add it to any graph manually using the `add_to_graph/3`\nfunction.\n\nYou typically want to give components an `:id`. This will be used to identify\nevents coming from that components back to your scene.\n\n```elixir\nimport Components  # contains the button helper\n\ngraph\n|> button(\"Press Me\", id: :press_me)\n|> MyComponent.add_to_graph({\"Some data\", 123}, id: :my_component)\n```","ref":"Scenic.Primitive.Component.html","title":"Scenic.Primitive.Component","type":"module"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Component.html#valid_styles/0","title":"Scenic.Primitive.Component.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Component.html#t:styles_t/0","title":"Scenic.Primitive.Component.styles_t/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Component.html#t:t/0","title":"Scenic.Primitive.Component.t/0","type":"type"},{"doc":"Draw an ellipse on the screen.","ref":"Scenic.Primitive.Ellipse.html","title":"Scenic.Primitive.Ellipse","type":"module"},{"doc":"`{radius_1, radius_2}`\n\nThe data for an arc is a single number.\n* `radius_1` - the radius of the ellipse in one direction\n* `radius_2` - the radius of the ellipse in the other direction","ref":"Scenic.Primitive.Ellipse.html#module-data","title":"Data - Scenic.Primitive.Ellipse","type":"module"},{"doc":"This primitive recognizes the following styles\n* [`hidden`](Scenic.Primitive.Style.Hidden.html) - show or hide the primitive\n* [`scissor`](Scenic.Primitive.Style.Scissor.html) - \"scissor rectangle\" that drawing will be clipped to.\n* [`fill`](Scenic.Primitive.Style.Fill.html) - fill in the area of the primitive\n* [`stroke`](Scenic.Primitive.Style.Stroke.html) - stroke the outline of the primitive. In this case, only the curvy part.\n\nNote: you can achieve the same effect with a Circle primitive\nby applying a `:scale` transform to it with unequal values on the axes","ref":"Scenic.Primitive.Ellipse.html#module-styles","title":"Styles - Scenic.Primitive.Ellipse","type":"module"},{"doc":"You should add/modify primitives via the helper functions in\n[`Scenic.Primitives`](Scenic.Primitives.html#ellipse/3)\n\n```elixir\ngraph\n  |> ellipse( {75, 100}, stroke: {1, :yellow} )\n```","ref":"Scenic.Primitive.Ellipse.html#module-usage","title":"Usage - Scenic.Primitive.Ellipse","type":"module"},{"doc":"Compile the data for this primitive into a mini script. This can be combined with others to\ngenerate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Ellipse.html#compile/2","title":"Scenic.Primitive.Ellipse.compile/2","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Ellipse.html#valid_styles/0","title":"Scenic.Primitive.Ellipse.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Ellipse.html#t:styles_t/0","title":"Scenic.Primitive.Ellipse.styles_t/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Ellipse.html#t:t/0","title":"Scenic.Primitive.Ellipse.t/0","type":"type"},{"doc":"A container to hold other primitives.\n\nAny styles placed on a group will be inherited by the primitives in the \ngroup. Any transforms placed on a group will be multiplied into the transforms\nin the primitives in the group.","ref":"Scenic.Primitive.Group.html","title":"Scenic.Primitive.Group","type":"module"},{"doc":"`uids`\n\nThe data for an arc is a list of internal uids for the primitives it contains.\n\nYou will not typically add these ids yourself. You should use the helper functions\nwith a callback to do that for you. See Usage below.","ref":"Scenic.Primitive.Group.html#module-data","title":"Data - Scenic.Primitive.Group","type":"module"},{"doc":"The group is special in that it accepts all styles and transforms, even if they\nare non-standard. These are then inherited by any primitives, including SceneRefs.\n\nAny styles you place on the group itself will be inherited by the primitives\ncontained in the group. However, these styles will not be inherited by any\ncomponent in the group.","ref":"Scenic.Primitive.Group.html#module-styles","title":"Styles - Scenic.Primitive.Group","type":"module"},{"doc":"If you add a transform to a group, then everything in the group will also be\nmoved by that transform, including child components. This is a very handy way\nto create some UI, then position, scale, or rotate it as needed without having\nto adjust the inner elements.","ref":"Scenic.Primitive.Group.html#module-transforms","title":"Transforms - Scenic.Primitive.Group","type":"module"},{"doc":"You should add/modify primitives via the helper functions in\n[`Scenic.Primitives`](Scenic.Primitives.html#group/3)\n\n```elixir\ngraph\n  |> group( fn(g) ->\n    g\n    |> rect( {200, 100}, fill: :blue )\n    |> test( \"In a Group\", fill: :yellow, translate: {20, 40} )\n  end,\n  translate: {100, 100},\n  font: :roboto\n)\n```","ref":"Scenic.Primitive.Group.html#module-usage","title":"Usage - Scenic.Primitive.Group","type":"module"},{"doc":"","ref":"Scenic.Primitive.Group.html#delete/2","title":"Scenic.Primitive.Group.delete/2","type":"function"},{"doc":"","ref":"Scenic.Primitive.Group.html#increment/2","title":"Scenic.Primitive.Group.increment/2","type":"function"},{"doc":"","ref":"Scenic.Primitive.Group.html#insert_at/3","title":"Scenic.Primitive.Group.insert_at/3","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Group.html#valid_styles/0","title":"Scenic.Primitive.Group.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Group.html#t:styles_t/0","title":"Scenic.Primitive.Group.styles_t/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Group.html#t:t/0","title":"Scenic.Primitive.Group.t/0","type":"type"},{"doc":"Draw a line on the screen.","ref":"Scenic.Primitive.Line.html","title":"Scenic.Primitive.Line","type":"module"},{"doc":"`{point_a, point_b}`\n\nThe data for a line is a tuple containing two points.\n* `point_a` - position to start drawing from\n* `point_b` - position to draw to","ref":"Scenic.Primitive.Line.html#module-data","title":"Data - Scenic.Primitive.Line","type":"module"},{"doc":"This primitive recognizes the following styles\n* [`hidden`](Scenic.Primitive.Style.Hidden.html) - show or hide the primitive\n* [`scissor`](Scenic.Primitive.Style.Scissor.html) - \"scissor rectangle\" that drawing will be clipped to.\n* [`cap`](Scenic.Primitive.Style.Cap.html) - says how to draw the ends of the line.\n* [`stroke`](Scenic.Primitive.Style.Stroke.html) - stroke the outline of the primitive. In this case, only the curvy part.","ref":"Scenic.Primitive.Line.html#module-styles","title":"Styles - Scenic.Primitive.Line","type":"module"},{"doc":"You should add/modify primitives via the helper functions in\n[`Scenic.Primitives`](Scenic.Primitives.html#line/3)\n\n```elixir\ngraph\n  |> line( {{0, 0}, {20, 40}}, stroke: {1, :yellow} )\n```","ref":"Scenic.Primitive.Line.html#module-usage","title":"Usage - Scenic.Primitive.Line","type":"module"},{"doc":"","ref":"Scenic.Primitive.Line.html#bounds/3","title":"Scenic.Primitive.Line.bounds/3","type":"function"},{"doc":"Returns the midpoint of the line. This is used as the default pin when applying\nrotate or scale transforms.","ref":"Scenic.Primitive.Line.html#centroid/1","title":"Scenic.Primitive.Line.centroid/1","type":"function"},{"doc":"Compile the data for this primitive into a mini script. This can be combined with others to\ngenerate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Line.html#compile/2","title":"Scenic.Primitive.Line.compile/2","type":"function"},{"doc":"","ref":"Scenic.Primitive.Line.html#default_pin/2","title":"Scenic.Primitive.Line.default_pin/2","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Line.html#valid_styles/0","title":"Scenic.Primitive.Line.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Line.html#t:styles_t/0","title":"Scenic.Primitive.Line.styles_t/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Line.html#t:t/0","title":"Scenic.Primitive.Line.t/0","type":"type"},{"doc":"Draw a complex path on the screen described by a list of actions.","ref":"Scenic.Primitive.Path.html","title":"Scenic.Primitive.Path","type":"module"},{"doc":"`list_of_commands`\n\nThe data for a path is a list of commands. They are interpreted in order\nwhen the path is drawn. See below for the commands it will accept.","ref":"Scenic.Primitive.Path.html#module-data","title":"Data - Scenic.Primitive.Path","type":"module"},{"doc":"This primitive recognizes the following styles\n* [`hidden`](Scenic.Primitive.Style.Hidden.html) - show or hide the primitive\n* [`scissor`](Scenic.Primitive.Style.Scissor.html) - \"scissor rectangle\" that drawing will be clipped to.\n* [`fill`](Scenic.Primitive.Style.Fill.html) - fill in the area of the primitive\n* [`stroke`](Scenic.Primitive.Style.Stroke.html) - stroke the outline of the primitive. In this case, only the curvy part.\n* [`cap`](Scenic.Primitive.Style.Cap.html) - says how to draw the ends of the line.\n* [`join`](Scenic.Primitive.Style.Join.html) - control how segments are joined.\n* [`miter_limit`](Scenic.Primitive.Style.MiterLimit.html) - control how segments are joined.","ref":"Scenic.Primitive.Path.html#module-styles","title":"Styles - Scenic.Primitive.Path","type":"module"},{"doc":"* `:begin` - start a new path segment\n* `:close_path` - draw a line back to the start of the current segment\n* `{:move_to, x, y}` - move the current draw position\n* `{:line_to, x, y}` - draw a line from the current position to a new location.\n* `{:bezier_to, c1x, c1y, c2x, c2y, x, y}` - draw a bezier curve from the current position to a new location.\n* `{:quadratic_to, cx, cy, x, y}` - draw a quadratic curve from the current position to a new location.\n* `{:arc_to, x1, y1, x2, y2, radius}` - draw an arc from the current position to a new location.\n\n## `Path` vs. `Script`\n\nBoth the `Path` and the `Script` primitives use the `Scenic.Script` to create scripts that\nare sent to the driver for drawing. The difference is that a Path is far more limited\nin what it can do, and is inserted inline with the compiled graph that created it.\n\nThe script primitive, on the other hand, has full access to the API set of\n`Scenic.Script` and accesses scripts by reference.\n\nThe inline vs. reference difference is important. A simple path will consume\nfewer resources. BUT it will cause the entire graph to be recompiled and resent\nto the driver if you change it.\n\nA script primitive references a script that you create separately from the\ngraph. This means that any changes to the graph (such as an animation) will\nNOT need to recompile or resend the script.","ref":"Scenic.Primitive.Path.html#module-commands","title":"Commands - Scenic.Primitive.Path","type":"module"},{"doc":"You should add/modify primitives via the helper functions in\n[`Scenic.Primitives`](Scenic.Primitives.html#path/3)\n\n```elixir\ngraph\n  |> path( [\n      :begin,\n      {:move_to, 0, 0},\n      {:bezier_to, 0, 20, 0, 50, 40, 50},\n      {:line_to, 30, 60},\n      :close_path\n    ],\n    fill: :blue\n  )\n```","ref":"Scenic.Primitive.Path.html#module-usage","title":"Usage - Scenic.Primitive.Path","type":"module"},{"doc":"Compile the data for this primitive into a mini script. This can be combined with others to\ngenerate a larger script and is called when a graph is compiled.\n\nNote: Path is a \"Meta\" primitive. It isn't really a primitive that is represented in a\ndraw script. Instead, it generates it's own mini-script, which is included inline to the\ngraph it is contained in.\n\nNote: The compiled script is backwards. This is an inline script, which means\nit is inserted into a larger script as part of the graph compile process and\nScript.finish() will be called on that later.","ref":"Scenic.Primitive.Path.html#compile/2","title":"Scenic.Primitive.Path.compile/2","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Path.html#valid_styles/0","title":"Scenic.Primitive.Path.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Path.html#t:cmd/0","title":"Scenic.Primitive.Path.cmd/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Path.html#t:styles_t/0","title":"Scenic.Primitive.Path.styles_t/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Path.html#t:t/0","title":"Scenic.Primitive.Path.t/0","type":"type"},{"doc":"Draw a quad on the screen.","ref":"Scenic.Primitive.Quad.html","title":"Scenic.Primitive.Quad","type":"module"},{"doc":"`{point_a, point_b, point_c, point_d}`\n\nThe data for a line is a tuple containing four points.\n* `point_a` - position to start drawing from\n* `point_b` - position to draw to\n* `point_c` - position to draw to\n* `point_d` - position to draw to","ref":"Scenic.Primitive.Quad.html#module-data","title":"Data - Scenic.Primitive.Quad","type":"module"},{"doc":"This primitive recognizes the following styles\n* [`hidden`](Scenic.Primitive.Style.Hidden.html) - show or hide the primitive\n* [`scissor`](Scenic.Primitive.Style.Scissor.html) - \"scissor rectangle\" that drawing will be clipped to.\n* [`fill`](Scenic.Primitive.Style.Fill.html) - fill in the area of the primitive\n* [`stroke`](Scenic.Primitive.Style.Stroke.html) - stroke the outline of the primitive. In this case, only the curvy part.\n* [`join`](Scenic.Primitive.Style.Join.html) - control how segments are joined.\n* [`miter_limit`](Scenic.Primitive.Style.MiterLimit.html) - control how segments are joined.","ref":"Scenic.Primitive.Quad.html#module-styles","title":"Styles - Scenic.Primitive.Quad","type":"module"},{"doc":"You should add/modify primitives via the helper functions in\n[`Scenic.Primitives`](Scenic.Primitives.html#quad/3)\n\n```elixir\ngraph\n  |> quad(\n    {{10, 0}, {20, 40}, {17, 50}, {0, 10}},\n    stroke: {1, :yellow}\n  )\n```","ref":"Scenic.Primitive.Quad.html#module-usage","title":"Usage - Scenic.Primitive.Quad","type":"module"},{"doc":"Returns the centroid of the quad. This is used as the default pin when applying\nrotate or scale transforms.","ref":"Scenic.Primitive.Quad.html#centroid/1","title":"Scenic.Primitive.Quad.centroid/1","type":"function"},{"doc":"Compile the data for this primitive into a mini script. This can be combined with others to\ngenerate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Quad.html#compile/2","title":"Scenic.Primitive.Quad.compile/2","type":"function"},{"doc":"","ref":"Scenic.Primitive.Quad.html#default_pin/2","title":"Scenic.Primitive.Quad.default_pin/2","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Quad.html#valid_styles/0","title":"Scenic.Primitive.Quad.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Quad.html#t:styles_t/0","title":"Scenic.Primitive.Quad.styles_t/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Quad.html#t:t/0","title":"Scenic.Primitive.Quad.t/0","type":"type"},{"doc":"Draw a rectangle on the screen.","ref":"Scenic.Primitive.Rectangle.html","title":"Scenic.Primitive.Rectangle","type":"module"},{"doc":"`{width, height}`\n\nThe data for a line is a tuple containing two numbers.\n* `width` - width of the rectangle\n* `height` - height of the rectangle","ref":"Scenic.Primitive.Rectangle.html#module-data","title":"Data - Scenic.Primitive.Rectangle","type":"module"},{"doc":"This primitive recognizes the following styles\n* [`hidden`](Scenic.Primitive.Style.Hidden.html) - show or hide the primitive\n* [`scissor`](Scenic.Primitive.Style.Scissor.html) - \"scissor rectangle\" that drawing will be clipped to.\n* [`fill`](Scenic.Primitive.Style.Fill.html) - fill in the area of the primitive\n* [`stroke`](Scenic.Primitive.Style.Stroke.html) - stroke the outline of the primitive. In this case, only the curvy part.\n* [`join`](Scenic.Primitive.Style.Join.html) - control how segments are joined.\n* [`miter_limit`](Scenic.Primitive.Style.MiterLimit.html) - control how segments are joined.","ref":"Scenic.Primitive.Rectangle.html#module-styles","title":"Styles - Scenic.Primitive.Rectangle","type":"module"},{"doc":"You should add/modify primitives via the helper functions in\n[`Scenic.Primitives`](Scenic.Primitives.html#rectangle/3)\n\n```elixir\ngraph\n  |> rect( {100, 50}, stroke: {1, :yellow} )\n  |> rectangle( {100, 50}, stroke: {1, :yellow} )\n```\n\nNote: `rect` is a shortcut for `rectangle` and they can be used interchangeably.","ref":"Scenic.Primitive.Rectangle.html#module-usage","title":"Usage - Scenic.Primitive.Rectangle","type":"module"},{"doc":"Returns the centroid of the rectangle. This is used as the default pin when applying\nrotate or scale transforms.","ref":"Scenic.Primitive.Rectangle.html#centroid/1","title":"Scenic.Primitive.Rectangle.centroid/1","type":"function"},{"doc":"Compile the data for this primitive into a mini script. This can be combined with others to\ngenerate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Rectangle.html#compile/2","title":"Scenic.Primitive.Rectangle.compile/2","type":"function"},{"doc":"","ref":"Scenic.Primitive.Rectangle.html#default_pin/2","title":"Scenic.Primitive.Rectangle.default_pin/2","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Rectangle.html#valid_styles/0","title":"Scenic.Primitive.Rectangle.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Rectangle.html#t:styles_t/0","title":"Scenic.Primitive.Rectangle.styles_t/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Rectangle.html#t:t/0","title":"Scenic.Primitive.Rectangle.t/0","type":"type"},{"doc":"Draw a rectangle with rounded corners on the screen.","ref":"Scenic.Primitive.RoundedRectangle.html","title":"Scenic.Primitive.RoundedRectangle","type":"module"},{"doc":"`{width, height, radius}`\n\nThe data for a line is a tuple containing three numbers.\n* `width` - width of the rectangle\n* `height` - height of the rectangle\n* `radius` - radius of the corners","ref":"Scenic.Primitive.RoundedRectangle.html#module-data","title":"Data - Scenic.Primitive.RoundedRectangle","type":"module"},{"doc":"This primitive recognizes the following styles\n* [`hidden`](Scenic.Primitive.Style.Hidden.html) - show or hide the primitive\n* [`scissor`](Scenic.Primitive.Style.Scissor.html) - \"scissor rectangle\" that drawing will be clipped to.\n* [`fill`](Scenic.Primitive.Style.Fill.html) - fill in the area of the primitive\n* [`stroke`](Scenic.Primitive.Style.Stroke.html) - stroke the outline of the primitive. In this case, only the curvy part.","ref":"Scenic.Primitive.RoundedRectangle.html#module-styles","title":"Styles - Scenic.Primitive.RoundedRectangle","type":"module"},{"doc":"You should add/modify primitives via the helper functions in\n[`Scenic.Primitives`](Scenic.Primitives.html#rounded_rectangle/3)\n\n```elixir\ngraph\n  |> rrect( {100, 50, 4}, stroke: {1, :yellow} )\n  |> rounded_rectangle( {100, 50, 4}, stroke: {1, :yellow} )\n```\n\nNote: `rrect` is a shortcut for `rounded_rectangle` and they can be used\ninterchangeably.","ref":"Scenic.Primitive.RoundedRectangle.html#module-usage","title":"Usage - Scenic.Primitive.RoundedRectangle","type":"module"},{"doc":"Returns the centroid of the rectangle. This is used as the default pin when applying\nrotate or scale transforms.","ref":"Scenic.Primitive.RoundedRectangle.html#centroid/1","title":"Scenic.Primitive.RoundedRectangle.centroid/1","type":"function"},{"doc":"Compile the data for this primitive into a mini script. This can be combined with others to\ngenerate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.RoundedRectangle.html#compile/2","title":"Scenic.Primitive.RoundedRectangle.compile/2","type":"function"},{"doc":"","ref":"Scenic.Primitive.RoundedRectangle.html#default_pin/2","title":"Scenic.Primitive.RoundedRectangle.default_pin/2","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.RoundedRectangle.html#valid_styles/0","title":"Scenic.Primitive.RoundedRectangle.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.RoundedRectangle.html#t:styles_t/0","title":"Scenic.Primitive.RoundedRectangle.styles_t/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.RoundedRectangle.html#t:t/0","title":"Scenic.Primitive.RoundedRectangle.t/0","type":"type"},{"doc":"A reference to a draw script.\n\nThe `Script` primitive is used to refer to a script that you created\nand loaded into the ViewPort separately from the graph. This script also\nhas full access to the `Scenic.Script` API.\n\nFor example, the check mark shape in the `Checkbox` control is a draw\nscript that is reference by the checkbox control's graph. A graph\ncan reference the same script multiple times, which is very efficient\nas the script is only sent to the drivers once.\n\nIf the graph is modified later, then any scripts it references will not\nneed to be resent to the drivers. This is an isolation of concerns. The same\nis true in reverse. If you rebuild a script and send it to the\n`ViewPort`, the script will be sent to the drivers, but any graphs that\nreference it do not need to be.\n\n## `Script` vs. `Path`\n\nBoth the `Path` and the `Script` primitives use the `Scenic.Script` to create scripts that\nare sent to the driver for drawing. The difference is that a Path is far more limited\nin what it can do, and is inserted inline with the compiled graph that created it.\n\nThe script primitive, on the other hand, has full access to the API set of\n`Scenic.Script` and accesses scripts by reference.\n\nThe inline vs. reference difference is important. A simple path will consume\nfewer resources. BUT it will cause the entire graph to be recompiled and resent\nto the driver if you change it.\n\nA script primitive references a script that you create separately from the\ngraph. This means that any changes to the graph (such as an animation) will\nNOT need to recompile or resend the script.","ref":"Scenic.Primitive.Script.html","title":"Scenic.Primitive.Script","type":"module"},{"doc":"You should add/modify primitives via the helper functions in\n[`Scenic.Primitives`](Scenic.Primitives.html#script/3)\n\nThis example is based on the check mark script from the Checkbox control.\n\n```elixir\n  alias Scenic.Script\n\n  # build the checkmark script\n  my_script =\n    Script.start()\n    |> Script.push_state()\n    |> Script.join(:round)\n    |> Script.stroke_width(3)\n    |> Script.stroke_color(:light_blue)\n    |> Script.begin_path()\n    |> Script.move_to(0, 8)\n    |> Script.line_to(5, 13)\n    |> Script.line_to(12, 1)\n    |> Script.stroke_path()\n    |> Script.pop_state()\n    |> Script.finish()\n\n  # push the script to the ViewPort\n  scene = push_script(scene, my_script, \"My Script\")\n\n  # refer to the script in a graph, and position it\n  graph\n  |> script(\"My Script\", translate: {3, 2})\n```","ref":"Scenic.Primitive.Script.html#module-usage","title":"Usage - Scenic.Primitive.Script","type":"module"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Script.html#valid_styles/0","title":"Scenic.Primitive.Script.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Script.html#t:styles_t/0","title":"Scenic.Primitive.Script.styles_t/0","type":"type"},{"doc":"Draw an sector on the screen.\n\nAn sector is a shape that looks like a piece of pie.","ref":"Scenic.Primitive.Sector.html","title":"Scenic.Primitive.Sector","type":"module"},{"doc":"`{radius, angle}`\n\nThe data for an Sector is a tuple.\n* `radius` - the radius of the Sector\n* `angle` - the angle the Sector is swept through in radians","ref":"Scenic.Primitive.Sector.html#module-data","title":"Data - Scenic.Primitive.Sector","type":"module"},{"doc":"The format for Sector has changed since v0.10. It used to be\n{radius, start_angle, end_angle}. You can achieve the same effect in the\nnew, simpler format by using the same radius and the new angle is the\ndifference between the old end_angle and start_angle. Then you can apply\na rotation transform to get it in the right position.","ref":"Scenic.Primitive.Sector.html#module-note","title":"Note - Scenic.Primitive.Sector","type":"module"},{"doc":"This primitive recognizes the following styles\n* [`hidden`](Scenic.Primitive.Style.Hidden.html) - show or hide the primitive\n* [`scissor`](Scenic.Primitive.Style.Scissor.html) - \"scissor rectangle\" that drawing will be clipped to.\n* [`fill`](Scenic.Primitive.Style.Fill.html) - fill in the area of the primitive\n* [`stroke`](Scenic.Primitive.Style.Stroke.html) - stroke the outline of the primitive. In this case, only the curvy part.","ref":"Scenic.Primitive.Sector.html#module-styles","title":"Styles - Scenic.Primitive.Sector","type":"module"},{"doc":"You should add/modify primitives via the helper functions in\n[`Scenic.Primitives`](Scenic.Primitives.html#sector/3)\n\n```elixir\ngraph\n  |> sector( {100, 1.5}, stroke: {1, :yellow} )\n```","ref":"Scenic.Primitive.Sector.html#module-usage","title":"Usage - Scenic.Primitive.Sector","type":"module"},{"doc":"","ref":"Scenic.Primitive.Sector.html#bounds/2","title":"Scenic.Primitive.Sector.bounds/2","type":"function"},{"doc":"Compile the data for this primitive into a mini script. This can be combined with others to\ngenerate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Sector.html#compile/2","title":"Scenic.Primitive.Sector.compile/2","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Sector.html#valid_styles/0","title":"Scenic.Primitive.Sector.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Sector.html#t:styles_t/0","title":"Scenic.Primitive.Sector.styles_t/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Sector.html#t:t/0","title":"Scenic.Primitive.Sector.t/0","type":"type"},{"doc":"Draw one or more sprites from a single source image.","ref":"Scenic.Primitive.Sprites.html","title":"Scenic.Primitive.Sprites","type":"module"},{"doc":"The term \"sprite\" means one or more subsections of a larger image\nthat get rendered to the screen. You can do many things with sprites\nincluding animations and zooming in and out of an image and more.","ref":"Scenic.Primitive.Sprites.html#module-overview","title":"Overview - Scenic.Primitive.Sprites","type":"module"},{"doc":"{ source_image_id, draw_commands }\n\n`source_image_id` refers to an image in the `Scenic.Assets.Static`\nlibrary. This can be either the file name from your asset sources\nor an alias that you set up in your configuration scripts.\n\n`draw_commands` is a list of source/destination drawing commands that\nare executed in order when the primitive renders.\n\n`[ {{src_x, src_y}, {src_w, src_h}, {dst_x, dst_y}, {dst_w, dst_h}} ]`\nor\n`[ {{src_x, src_y}, {src_w, src_h}, {dst_x, dst_y}, {dst_w, dst_h}}, alpha ]`\n\nEach draw command is an x/y position and width/height of a rectangle in\nthe source image, followed by the x/y position and width/height\nrectangle in the destination space.\n\nAn optional alpha channel can be set in last position to apply a transparency\neffect on the sprite.\n\nIn other words, This copies rectangular images from the source\nindicated by image_id and draws them in the coordinate space of\nthe graph.\n\nThe size of the destination rectangle does NOT need to be the same as the\nsource. This allows you to grow or shrink the image as needed. You can\nuse this to zoom in or zoom out of the source image.","ref":"Scenic.Primitive.Sprites.html#module-data-format","title":"Data Format - Scenic.Primitive.Sprites","type":"module"},{"doc":"Sprites are common in the game industry and can be used to\ncreate animations, manage large numbers of small images and more.\n\nFor example, in many games a character walking is built as a series\nof frames in an animation that all live together in a single image\nfile. When it comes time to draw, the different frames are rendered\nto the screen one after the other to give the appearance that the\ncharacter is animating.\n\nA simpler example would be an image of a device with a blinking\nlight on it. The same device would be in the source image twice.\nOnce with the light on, and once with it off. Then you render the\nappropriate portion of source image on a timer.","ref":"Scenic.Primitive.Sprites.html#module-animations","title":"Animations - Scenic.Primitive.Sprites","type":"module"},{"doc":"You should add/modify primitives via the helper functions in\n[`Scenic.Primitives`](Scenic.Primitives.html#sprites/3)\n\nThis example draws the same source rectangle three times in different locations.\nThe first is at full size, the second is expanded 10x, the third is with a\n50% transparency effect.\n\n```elixir\ngraph\n  |> sprites( { \"images/my_sprites.png\", [\n    {{0,0}, {10, 20}, {10, 10}, {10, 20}},\n    {{0,0}, {10, 20}, {100, 100}, {100, 200}},\n    {{0,0}, {10, 20}, {100, 100}, {100, 200}, 0.5}\n  ]})\n```","ref":"Scenic.Primitive.Sprites.html#module-usage","title":"Usage - Scenic.Primitive.Sprites","type":"module"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Sprites.html#valid_styles/0","title":"Scenic.Primitive.Sprites.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Sprites.html#t:draw_cmd/0","title":"Scenic.Primitive.Sprites.draw_cmd/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Sprites.html#t:draw_cmds/0","title":"Scenic.Primitive.Sprites.draw_cmds/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Sprites.html#t:styles_t/0","title":"Scenic.Primitive.Sprites.styles_t/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Sprites.html#t:t/0","title":"Scenic.Primitive.Sprites.t/0","type":"type"},{"doc":"Draw text on the screen.","ref":"Scenic.Primitive.Text.html","title":"Scenic.Primitive.Text","type":"module"},{"doc":"`text`\n\nThe data for a Text primitive is a bitstring\n* `text` - the text to draw","ref":"Scenic.Primitive.Text.html#module-data","title":"Data - Scenic.Primitive.Text","type":"module"},{"doc":"This primitive recognizes the following styles\n* [`hidden`](Scenic.Primitive.Style.Hidden.html) - show or hide the primitive\n* [`scissor`](Scenic.Primitive.Style.Scissor.html) - \"scissor rectangle\" that drawing will be clipped to.\n* [`fill`](Scenic.Primitive.Style.Fill.html) - fill in the area of the text. Only solid colors!\n* [`font`](Scenic.Primitive.Style.Font.html) - name (or key) of font to use\n* [`font_size`](Scenic.Primitive.Style.FontSize.html) - point size of the font\n* [`text_align`](Scenic.Primitive.Style.TextAlign.html) - horizontal alignment of lines of text\n* [`text_base`](Scenic.Primitive.Style.TextBase.html) - vertical alignment of lines of text\n* [`line_height`](Scenic.Primitive.Style.LineHeight.html) - spacing between lines of text","ref":"Scenic.Primitive.Text.html#module-styles","title":"Styles - Scenic.Primitive.Text","type":"module"},{"doc":"You should add/modify primitives via the helper functions in\n[`Scenic.Primitives`](Scenic.Primitives.html#text/3)\n\n```elixir\ngraph\n  |> text( \"Some example text\", fill: :green, font: :roboto_mono, font_size: 64 )\n```","ref":"Scenic.Primitive.Text.html#module-usage","title":"Usage - Scenic.Primitive.Text","type":"module"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Text.html#valid_styles/0","title":"Scenic.Primitive.Text.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Text.html#t:styles_t/0","title":"Scenic.Primitive.Text.styles_t/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Text.html#t:t/0","title":"Scenic.Primitive.Text.t/0","type":"type"},{"doc":"Draw a triangle on the screen.","ref":"Scenic.Primitive.Triangle.html","title":"Scenic.Primitive.Triangle","type":"module"},{"doc":"`{point_a, point_b, point_c}`\n\nThe data for a line is a tuple containing three points.\n* `point_a` - position to start drawing from\n* `point_b` - position to draw to\n* `point_c` - position to draw to","ref":"Scenic.Primitive.Triangle.html#module-data","title":"Data - Scenic.Primitive.Triangle","type":"module"},{"doc":"This primitive recognizes the following styles\n* [`hidden`](Scenic.Primitive.Style.Hidden.html) - show or hide the primitive\n* [`scissor`](Scenic.Primitive.Style.Scissor.html) - \"scissor rectangle\" that drawing will be clipped to.\n* [`fill`](Scenic.Primitive.Style.Fill.html) - fill in the area of the primitive\n* [`stroke`](Scenic.Primitive.Style.Stroke.html) - stroke the outline of the primitive. In this case, only the curvy part.\n* [`join`](Scenic.Primitive.Style.Join.html) - control how segments are joined.\n* [`miter_limit`](Scenic.Primitive.Style.MiterLimit.html) - control how segments are joined.","ref":"Scenic.Primitive.Triangle.html#module-styles","title":"Styles - Scenic.Primitive.Triangle","type":"module"},{"doc":"You should add/modify primitives via the helper functions in\n[`Scenic.Primitives`](Scenic.Primitives.html#triangle/3)\n\n```elixir\ngraph\n  |> triangle(\n    {{10, 0}, {20, 40}, 0, 20}},\n    stroke: {1, :yellow}\n  )\n```","ref":"Scenic.Primitive.Triangle.html#module-usage","title":"Usage - Scenic.Primitive.Triangle","type":"module"},{"doc":"Returns the centroid of the triangle. This is used as the default pin when applying\nrotate or scale transforms.","ref":"Scenic.Primitive.Triangle.html#centroid/1","title":"Scenic.Primitive.Triangle.centroid/1","type":"function"},{"doc":"Compile the data for this primitive into a mini script. This can be combined with others to\ngenerate a larger script and is called when a graph is compiled.","ref":"Scenic.Primitive.Triangle.html#compile/2","title":"Scenic.Primitive.Triangle.compile/2","type":"function"},{"doc":"","ref":"Scenic.Primitive.Triangle.html#default_pin/2","title":"Scenic.Primitive.Triangle.default_pin/2","type":"function"},{"doc":"Returns a list of styles recognized by this primitive.","ref":"Scenic.Primitive.Triangle.html#valid_styles/0","title":"Scenic.Primitive.Triangle.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Triangle.html#t:styles_t/0","title":"Scenic.Primitive.Triangle.styles_t/0","type":"type"},{"doc":"","ref":"Scenic.Primitive.Triangle.html#t:t/0","title":"Scenic.Primitive.Triangle.t/0","type":"type"},{"doc":"Modify the look of a primitive by applying a Style.\n\nStyles are optional modifiers that you can put on any primitive. Each style does a\nspecific thing and some only affect certain primitives.\n\n```elixir\nGraph.build()\n  |> rect( {100, 50}, fill: blue, stroke: {2, :yellow} )\n```\n\nThe above example draws a rectangle, that is filled with blue and outlined in yellow.\nThe primitive is `Scenic.Primitive.Rectangle` and the styles are `:fill` and `:stroke`.","ref":"Scenic.Primitive.Style.html","title":"Scenic.Primitive.Style","type":"behaviour"},{"doc":"Styles are inherited by primitives that are placed in a group. This allows you to set\nstyles that will be used by many primitives. Those primitives can override the style\nset on the group by setting it again.\n\nExample:\n\n```elixir\nGraph.build( font: :roboto, font_size: 24 )\n  |> text( \"Some text drawn using roboto\" )\n  |> text( \"Text using roboto_mono\", font: :roboto_mono )\n  |> text( \"back to drawing in roboto\" )\n```\n\nIn the above example, the text primitives inherit the fonts set on the root group\nwhen the Graph is created. The middle text primitive overrides the `:font` style,\nbut keeps using the `:font_size` set on the group.","ref":"Scenic.Primitive.Style.html#module-inheritance","title":"Inheritance - Scenic.Primitive.Style","type":"behaviour"},{"doc":"In general, styles are NOT inherited across a component boundary unless they are\nexplicitly set on the component itself. This allows components to manage their own\nconsistent look and feel.\n\nThe exception to this rule is the `:theme` style. This IS inherited across groups\nand into components. This allows you to set an overall color scheme such as\n`:light` or `:dark` that makes sense with the components.","ref":"Scenic.Primitive.Style.html#module-components","title":"Components - Scenic.Primitive.Style","type":"behaviour"},{"doc":"The default styles if none are set.\n\n```elixir\n%{font: :roboto, font_size: 24, line_height: 1.2, text_align: :left, text_base: :alphabetic}\n```","ref":"Scenic.Primitive.Style.html#default/0","title":"Scenic.Primitive.Style.default/0","type":"function"},{"doc":"List of the valid style types","ref":"Scenic.Primitive.Style.html#valid_styles/0","title":"Scenic.Primitive.Style.valid_styles/0","type":"function"},{"doc":"","ref":"Scenic.Primitive.Style.html#c:validate/1","title":"Scenic.Primitive.Style.validate/1","type":"callback"},{"doc":"","ref":"Scenic.Primitive.Style.html#t:t/0","title":"Scenic.Primitive.Style.t/0","type":"type"},{"doc":"Set how to draw the end of a line.\n\nExample:\n\n    graph\n    |> line( {{0,0}, {100,100}}, cap: :round )","ref":"Scenic.Primitive.Style.Cap.html","title":"Scenic.Primitive.Style.Cap","type":"module"},{"doc":"Cap can be any of the following values:\n\n* `:butt` - End of the line is flat, passing through the end point.\n* `:round` - End of the line is round, radiating from the end point.\n* `:square` - End of the line is flat, but projecting a square around the end point.","ref":"Scenic.Primitive.Style.Cap.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.Cap","type":"module"},{"doc":"Fill primitives with the specified paint.\n\nExample:\n\n    graph\n    |> rectangle( {10, 20}, fill: :blue )","ref":"Scenic.Primitive.Style.Fill.html","title":"Scenic.Primitive.Style.Fill","type":"module"},{"doc":"Any valid paint. This can any be any paint format defined by the following modules:\n\n* `Scenic.Primitive.Style.Paint.Color`\n* `Scenic.Primitive.Style.Paint.Image`\n* `Scenic.Primitive.Style.Paint.LinearGradient`\n* `Scenic.Primitive.Style.Paint.RadialGradient`\n* `Scenic.Primitive.Style.Paint.Stream`\n\nSee the documentation for the paint module for further details.","ref":"Scenic.Primitive.Style.Fill.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.Fill","type":"module"},{"doc":"Set the font used to draw text.\n\nExample:\n\n```elixir\ngraph\n  |> text( \"Hello World\", font: \"fonts/my_fancy_font.ttf\" )\n```","ref":"Scenic.Primitive.Style.Font.html","title":"Scenic.Primitive.Style.Font","type":"module"},{"doc":"You can use any font loaded into your static assets library. You can also\nrefer to the font by either it's library file name, or an alias that you\nhave configured.\n\nThe following example shows both ways to identify a font.\n```elixir\nGraph.build()\n  |> text( \"By name\", font: \"fonts/roboto.ttf\" )\n  |> text( \"By alias\", font: :roboto )\n```\n\n# Standard Fonts\n\nYou are highly encouraged to use Roboto and Roboto Mono as the standard system\nfonts for Scenic. Aliases are automatically set up for them.\n\n| Alias          | Font  |\n|---------------|------------------------|\n|  `:roboto` | \"fonts/roboto.ttf\" |\n|  `:roboto_mono` | \"fonts/roboto_mono.ttf\" |\n\nIt is expected that you will include the roboto.ttf and roboto_mono.ttf files\nin your asset source folder. You don't technically need to, but if you don't\nthen those aliases won't work.","ref":"Scenic.Primitive.Style.Font.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.Font","type":"module"},{"doc":"","ref":"Scenic.Primitive.Style.Font.html#err_invalid/1","title":"Scenic.Primitive.Style.Font.err_invalid/1","type":"function"},{"doc":"The point-size to draw text in.\n\nExample:\n\n```elixir\ngraph\n  |> text( \"Small\", font_size: 12.5 )\n  |> text( \"Large\", font_size: 64 )\n```","ref":"Scenic.Primitive.Style.FontSize.html","title":"Scenic.Primitive.Style.FontSize","type":"module"},{"doc":"Any number greater than or equal to 6.","ref":"Scenic.Primitive.Style.FontSize.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.FontSize","type":"module"},{"doc":"Flags whether or not to draw a primitive.\n\nExample:\n\n```elixir\ngraph\n  |> rect( {100, 200}, hidden: true )\n```","ref":"Scenic.Primitive.Style.Hidden.html","title":"Scenic.Primitive.Style.Hidden","type":"module"},{"doc":"* `true` - \"Hide\" the primitive. Drawing is skipped.\n* `false` - \"Show\" the primitive. Drawing is run.\n\nNote: setting `hidden: true` on a group will hide all the primitives in\nthe group. This is very efficient as it simply skips drawing the group\nand everything in it.\n\nThe Hidden style is a handy way to create a set of primitives that you can\nquickly show and hide on demand.","ref":"Scenic.Primitive.Style.Hidden.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.Hidden","type":"module"},{"doc":"Flags whether or not track `cursor_button` events on this primitive.\n\nExample:\n\n```elixir\ngraph\n  |> rect( {100, 200}, id: :my_rect, input: :cursor_button )\n```","ref":"Scenic.Primitive.Style.Input.html","title":"Scenic.Primitive.Style.Input","type":"module"},{"doc":"The data for the input style is the type of input you want to receive when the cursor\nis positioned over the primitive. This can be any single member or combination (in a list)\nof the following input types\n\n* `:cursor_button` - Went when a button on the cursor (mouse) was used.\n* `:cursor_pos` - Sent when the cursor moves over the primitive.\n* `:cursor_scroll` - Sent when the cursor's scroll wheel moves.\n\n\n```elixir\ngraph\n  |> rect( {100, 200}, id: :my_rect, input: [:cursor_button, :cursor_pos] )\n```","ref":"Scenic.Primitive.Style.Input.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.Input","type":"module"},{"doc":"Set how to connect two lines in a path.\n\nWorks with primitives that have clear joints, such as Rectangle,\nQuad, Triangle, and Path.\n\nExample:\n\n```elixir\ngraph\n  |> triangle( {{0,40},{40,40},{40,0}}\n    join: :round,\n    stroke: {2, :green}\n  )\n```","ref":"Scenic.Primitive.Style.Join.html","title":"Scenic.Primitive.Style.Join","type":"module"},{"doc":"Join can be any of the following values:\n\n* `:miter` - Miter the pointy part of the joint.\n* `:round` - Round the entire joint.\n* `:bevel` - Bevel the joint.","ref":"Scenic.Primitive.Style.Join.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.Join","type":"module"},{"doc":"Adjust the vertical spacing of lines of text in a single block.","ref":"Scenic.Primitive.Style.LineHeight.html","title":"Scenic.Primitive.Style.LineHeight","type":"module"},{"doc":"This is expressed as a percentage of the size of the font. So a value of `1.2`\nwould mean 120% the font size as the spacing from baseline to baseline.\n\nThe behavior of this style is intended to be very similar to the `line_height` CSS\nstyle.\n\nExample:\n\n```elixir\ngraph\n  |> text( \"Some Text\\r\\nMore Text\", line_height: 1.1 )\n```\n\nThe default if `:line_height` is not specified is `1.2`. Set this style if\nyou want to override it.","ref":"Scenic.Primitive.Style.LineHeight.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.LineHeight","type":"module"},{"doc":"This style is not actually represented in the low-level `Scenic.Script` format.\nInstead it is a hint that is processed when a graph is \"compiled\" into a script.\nEssentially it instructs the graph compiler to automatically apply transforms to\neach line in a multi-line text string that separate out the lines of text from\neach other.","ref":"Scenic.Primitive.Style.LineHeight.html#module-note","title":"Note - Scenic.Primitive.Style.LineHeight","type":"module"},{"doc":"Automatically miter joints if they are too sharp.\n\nExample:\n\n```elixir\ngraph\n  |> triangle({{0, 40}, {40, 40}, {40, 0}},\n    miter_limit: 2,\n    stroke: {2, :green}\n  )\n```","ref":"Scenic.Primitive.Style.MiterLimit.html","title":"Scenic.Primitive.Style.MiterLimit","type":"module"},{"doc":"A number greater than zero.","ref":"Scenic.Primitive.Style.MiterLimit.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.MiterLimit","type":"module"},{"doc":"Define a \"Scissor Rectangle\" that drawing will be clipped to.\n\nExample:\n\n```elixir\ngraph\n  |> triangle({{0, 40}, {40, 40}, {40, 0}},\n    miter_limit: 2,\n    fill: :green,\n    scissor: {20, 40}\n  )\n```","ref":"Scenic.Primitive.Style.Scissor.html","title":"Scenic.Primitive.Style.Scissor","type":"module"},{"doc":"`{width, height}`\n\n* `width` - Width of the scissor rectangle.\n* `height` - Height of the scissor rectangle.","ref":"Scenic.Primitive.Style.Scissor.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.Scissor","type":"module"},{"doc":"Draw an outline around a primitive with the given paint.\n\nExample:\n\n```elixir\ngraph\n  |> triangle( {{0,40},{40,40},{40,0}}\n    miter_limit: 2,\n    stroke: {2, :green}\n  )\n```","ref":"Scenic.Primitive.Style.Stroke.html","title":"Scenic.Primitive.Style.Stroke","type":"module"},{"doc":"`{width, paint}`\n\n* `width` - Width of the border being stroked.\n* `paint` - Any paint data.\n\nThe paint can any be any format defined by the following modules:\n\n* `Scenic.Primitive.Style.Paint.Color`\n* `Scenic.Primitive.Style.Paint.Image`\n* `Scenic.Primitive.Style.Paint.LinearGradient`\n* `Scenic.Primitive.Style.Paint.RadialGradient`\n* `Scenic.Primitive.Style.Paint.Stream`\n\nSee the documentation for the paint module for further details.","ref":"Scenic.Primitive.Style.Stroke.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.Stroke","type":"module"},{"doc":"Set the horizontal alignment of the text with regard to the start point.\n\nExample:\n\n```elixir\ngraph\n|> text(\"Some Text\", text_align: :center)\n```","ref":"Scenic.Primitive.Style.TextAlign.html","title":"Scenic.Primitive.Style.TextAlign","type":"module"},{"doc":"TextAlign can be any one of the following values\n\n* `:left` - Left side alignment.\n* `:right` - Right side alignment.\n* `:center` - Centered alignment.","ref":"Scenic.Primitive.Style.TextAlign.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.TextAlign","type":"module"},{"doc":"Set the vertical alignment of text.\n\nExample:\n\n```elixir\ngraph\n  |> text( \"Some Text\", text_base: :alphabetic )\n```","ref":"Scenic.Primitive.Style.TextBase.html","title":"Scenic.Primitive.Style.TextBase","type":"module"},{"doc":"TextBase can be any one of the following values\n\n* `:top` - The top of the em square.\n* `:middle` - The middle of the em square.\n* `:alphabetic` - The normal alphabetic baseline.\n* `:bottom` - The bottom of the bounding box.\n\nThe default if `:text_base` is undefined is `:alphabetic`.\n\nThe alphabetic baseline is at the bottom of characters such as \"a\", but above the\nbottom of characters with descending tails, such as \"g\" or \"y\". This the standard\nbaseline from the world of typography. It may be unintuitive if you expected it\nto be at the top of the characters, like most of the primitives in Scenic.\nIf that is what you want, then set `:text_base` to `:top`","ref":"Scenic.Primitive.Style.TextBase.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.TextBase","type":"module"},{"doc":"Themes are a way to bundle up a set of colors that are intended to be used\nby components invoked by a scene.\n\nThere are a set of pre-defined themes.\nYou can also pass in a map of color values.\n\nUnlike other styles, The currently set theme is given to child components.\nEach component gets to pick, choose, or ignore any colors in a given style.","ref":"Scenic.Primitive.Style.Theme.html","title":"Scenic.Primitive.Style.Theme","type":"module"},{"doc":"* `:dark` - This is the default and most common. Use when the background is dark.\n* `:light` - Use when the background is light colored.","ref":"Scenic.Primitive.Style.Theme.html#module-predefined-themes","title":"Predefined Themes - Scenic.Primitive.Style.Theme","type":"module"},{"doc":"The remaining themes are designed to color the standard components and don't really\nmake much sense when applied to the root of a graph. You could, but it would be...\ninteresting.\n\nThe most obvious place to use them is with [`Button`](Scenic.Component.Button.html)\ncomponents.\n\n* `:primary` - Blue background. This is the primary button type indicator.\n* `:secondary` - Grey background. Not primary type indicator.\n* `:success` - Green background.\n* `:danger` - Red background. Use for irreversible or dangerous actions.\n* `:warning` - Orange background.\n* `:info` - Lightish blue background.\n* `:text` - Transparent background.","ref":"Scenic.Primitive.Style.Theme.html#module-specialty-themes","title":"Specialty Themes - Scenic.Primitive.Style.Theme","type":"module"},{"doc":"Paint is used to \"fill\" the area of primitives.\n\nWhen you apply the `:fill` style to a primitive, you must supply valid\npaint data.\n\nThere are five types of paint.\n\n* `Scenic.Primitive.Style.Paint.Color`\n* `Scenic.Primitive.Style.Paint.Image`\n* `Scenic.Primitive.Style.Paint.LinearGradient`\n* `Scenic.Primitive.Style.Paint.RadialGradient`\n* `Scenic.Primitive.Style.Paint.Stream`\n\nSee the documentation for the paint module for further details.","ref":"Scenic.Primitive.Style.Paint.html","title":"Scenic.Primitive.Style.Paint","type":"module"},{"doc":"Fill a primitive with a single color\n\nThe color paint is used as the data for the [`:fill`](Scenic.Primitive.Style.Fill.html) style.","ref":"Scenic.Primitive.Style.Paint.Color.html","title":"Scenic.Primitive.Style.Paint.Color","type":"module"},{"doc":"`{:color, valid_color}`\n\nThe full format is a tuple with two parameters. The first is the :color atom indicating\nthat this is color paint data. The second is any valid color (see below).","ref":"Scenic.Primitive.Style.Paint.Color.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.Paint.Color","type":"module"},{"doc":"You can pass in any color format that is supported by the `Scenic.Color.to_rgba/1` function.\n\nThis includes any named color. See the documentation for `Scenic.Color` for more information.\n\nExample:\n\n```elixir\ngraph\n  |> rect( {100,200}, fill: {:color, :blue} )\n  |> rect( {100,200}, stroke: {1, {:color, :green}} )\n```","ref":"Scenic.Primitive.Style.Paint.Color.html#module-valid-colors","title":"Valid Colors - Scenic.Primitive.Style.Paint.Color","type":"module"},{"doc":"`valid_color`\n\nBecause the color paint type is used so frequently, you can simply pass in any valid\ncolor and the `:fill` style will infer that it is to be used as paint.\n\nExample:\n\n```elixir\ngraph\n  |> rect( {100,200}, fill: :blue )\n  |> rect( {100,200}, stroke: {1, :green} )\n```","ref":"Scenic.Primitive.Style.Paint.Color.html#module-shortcut-format","title":"Shortcut Format - Scenic.Primitive.Style.Paint.Color","type":"module"},{"doc":"Fill a primitive with an image from Scenic.Assets.Static","ref":"Scenic.Primitive.Style.Paint.Image.html","title":"Scenic.Primitive.Style.Paint.Image","type":"module"},{"doc":"`{:image, id}`\n\nFill with the static image indicated by `id`\n\nThe `id` can be either the name of the file when the static assets library was built\nor an alias that you set up in your conig. The following example has the alias\n`:parrot` pointing to the `\"images/parrot.png\"` file, so both fills are identical.\n\n```elixir\nGraph.build()\n  |> rect({100, 50}, fill: {:image, \"images/parrot.jpg\"})\n  |> rect({100, 50}, fill: {:image, :parrot})\n```\n\nNote that this is a fill, and the images will repeat automatically if the primitive\nbeing filled is larger than the source image.\n\nIf you want more control, such as no repeats, a subsection of the image, or scaling\nthe image up or down when you draw it, use the `Sprites` primitive.","ref":"Scenic.Primitive.Style.Paint.Image.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.Paint.Image","type":"module"},{"doc":"Fill a primitive with a linear gradient between two colors","ref":"Scenic.Primitive.Style.Paint.LinearGradient.html","title":"Scenic.Primitive.Style.Paint.LinearGradient","type":"module"},{"doc":"`{:linear, {start_x, start_y, end_x, end_y, color_start, color_end}}`\n\nThis example fills with a smooth linear gradient that goes from blue in the upper left\ncorner of the rect to yellow in the lower right corner.\n\n```elixir\nGraph.build()\n  |> rect( {100, 50}, fill: {:linear, {0, 0, 100, 50, :blue, :yellow}} )\n```","ref":"Scenic.Primitive.Style.Paint.LinearGradient.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.Paint.LinearGradient","type":"module"},{"doc":"Fill a primitive with a radial gradient between two colors","ref":"Scenic.Primitive.Style.Paint.RadialGradient.html","title":"Scenic.Primitive.Style.Paint.RadialGradient","type":"module"},{"doc":"`{:radial, {center_x, center_y, inner_radius, outer_radius, color_start, color_end}}`\n\nThis example fills a rect with a smooth linear gradient that goes from blue in the\ncenter and transitions to yellow in an outer ring.\n\n```elixir\nGraph.build()\n  |> rect( {100, 50}, fill: {:radial, {50, 25, 10, 45, :blue, :yellow}} )\n```","ref":"Scenic.Primitive.Style.Paint.RadialGradient.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.Paint.RadialGradient","type":"module"},{"doc":"Fill a primitive with an image or bitmap from Scenic.Assets.Stream","ref":"Scenic.Primitive.Style.Paint.Stream.html","title":"Scenic.Primitive.Style.Paint.Stream","type":"module"},{"doc":"`{:stream, key}`\n\nFill with the static image indicated by `key`\n\nThis example fills a rect with the contents of the `\"color_cycle\"` stream.\nWhen the source of the stream updates the bitmap it contains, the rect's\nfill will automatically be updated.\n\n```elixir\nGraph.build()\n  |> rect( {100, 50}, fill: {:stream, \"color_cycle\"} )\n```\n\nSee the documentation for `Scenic.Assets.Stream` for more information on how to\ncreate and manage streams.","ref":"Scenic.Primitive.Style.Paint.Stream.html#module-data-format","title":"Data Format - Scenic.Primitive.Style.Paint.Stream","type":"module"},{"doc":"Change the position, rotation, scale and more of a primitive.\n\nUnlike html, which uses auto-layout to position items on the screen, Scenic moves primitives around using matrix transforms. This is common in video games and provides powerful control of your primitives.\n\nA [matrix](https://en.wikipedia.org/wiki/Matrix_(mathematics)) is an array of numbers that can be used to change the positions, rotations, scale and more of locations.\n\n**Don't worry!** You will not need to look at any matrices unless you want to get fancy. In Scenic, you will rarely (if ever) create matrices on your own (you can if you know what you are doing!), and will instead use the transform helpers.\n\nMultiple transforms can be applied to any primitive. Transforms combine down the graph to create a very flexible way to manage your scene.\n\nThere are a fixed set of transform helpers that create matrices for you.\n\n* [`Matrix`](Scenic.Primitive.Transform.Matrix.html) hand specify a matrix.\n* [`Pin`](Scenic.Primitive.Transform.Pin.html) set a pin to rotate or scale around. Most primitives define a sensible default pin.\n* [`Rotate`](Scenic.Primitive.Transform.Rotate.html) rotate around the pin.\n* [`Scale`](Scenic.Primitive.Transform.Scale.html) scale larger or smaller. Centered around the pin.\n* [`Translate`](Scenic.Primitive.Transform.Translate.html) move/translate horizontally and veritcally.","ref":"Scenic.Primitive.Transform.html","title":"Scenic.Primitive.Transform","type":"behaviour"},{"doc":"You apply transforms to a primitive the same way you specify styles.\n\n```elixir\ngraph =\n  Graph.build\n  |> circle( 100, fill: {:color, :green}, translate: {200, 200} )\n  |> ellipse( {40, 60, fill: {:color, :red}, rotate: 0.4, translate: {100, 100} )\n```\n\nDon't worry about the order you apply transforms to a single object. Scenic will multiply them together in the correct way when it comes time to render them.","ref":"Scenic.Primitive.Transform.html#module-specifying-transforms","title":"Specifying Transforms - Scenic.Primitive.Transform","type":"behaviour"},{"doc":"Given a Map describing the transforms on a primitive, calculate the combined matrix\nthat should be applied.\n\nThis is trickier than just multiplying them together. Rotations, translations and scale,\nneed to be done in the right order, which is why this function is provided.\n\nYou will not normally need to use this function. It is used internally by the input system.","ref":"Scenic.Primitive.Transform.html#combine/1","title":"Scenic.Primitive.Transform.combine/1","type":"function"},{"doc":"","ref":"Scenic.Primitive.Transform.html#c:validate/1","title":"Scenic.Primitive.Transform.validate/1","type":"callback"},{"doc":"Apply an arbitrary matrix.\n\nApplies an arbitrary 4x4 matrix to a primitive. For now, only the 2-D part\nof the matrix actually does anything. Am using 4x4 though for future compatibility.\n\nExample:\n\n```elixir\n@matrix [ 0, 1, 2, 3,\n          4, 5, 6, 7,\n          8, 9, 10, 11,\n          12, 13, 14, 15 ]\n  |> Scenic.Math.Matrix.Matrix.Utils.to_binary()\n\ngraph\n  |> text(\"Transformer!\", matrix: @matrix)\n```","ref":"Scenic.Primitive.Transform.Matrix.html","title":"Scenic.Primitive.Transform.Matrix","type":"module"},{"doc":"","ref":"Scenic.Primitive.Transform.Matrix.html#validate/1","title":"Scenic.Primitive.Transform.Matrix.validate/1","type":"function"},{"doc":"Set the pin for rotate and scale transforms.\n\nWhen rotating or scaling, you need to set the point that doesn't move. This is\nthe pin. If you don't set one, Scenic will try to use a sensible default for\nwhatever primitive you are transforming.\n\nUse the `:pin` option to set it explicitly\n\n`{pin_x, pin_y}`  \n\nExample:\n\n```elixir\ngraph\n  |> text( \"Rotated!\", rotate: 1.2, pin: {10, 20} )\n```","ref":"Scenic.Primitive.Transform.Pin.html","title":"Scenic.Primitive.Transform.Pin","type":"module"},{"doc":"","ref":"Scenic.Primitive.Transform.Pin.html#validate/1","title":"Scenic.Primitive.Transform.Pin.validate/1","type":"function"},{"doc":"Apply a rotation matrix.\n\nAlways rotates around the z-axis (coming out of the screen).\n\nThe value is given in radians.\n\nPositive values rotate clockwise.\n\nThe rotation is pinned to the sensible default for each primitive, or to the\n[`:pin`](Scenic.Primitive.Transform.Pin.html) that you assign explicitly.\n\nExample:\n\n```elixir\ngraph\n  |> text(\"Rotated!\", rotate: 1.2)\n  |> text(\"Rotated!\", rotate: 1.2, pin: {10, 20})\n```","ref":"Scenic.Primitive.Transform.Rotate.html","title":"Scenic.Primitive.Transform.Rotate","type":"module"},{"doc":"Rotation is common enough that you can use `:r` as a shortcut.\n\nExample:\n    graph\n    |> text(\"Rotated!\", r: 1.2)","ref":"Scenic.Primitive.Transform.Rotate.html#module-shortcut","title":"Shortcut - Scenic.Primitive.Transform.Rotate","type":"module"},{"doc":"","ref":"Scenic.Primitive.Transform.Rotate.html#validate/1","title":"Scenic.Primitive.Transform.Rotate.validate/1","type":"function"},{"doc":"Apply a scale matrix.\n\nIncrease or shrink by the provided multiplier. This can take two forms:\n\n* `multiplier` - scale both x and y directions by the same multiplier\n* `{mul_x, mul_y}` - scale x and y directions independently\n\nScaling is pinned to the sensible default for each primitive, or to the\n[`:pin`](Scenic.Primitive.Transform.Pin.html) that you assign explicitly.\n\nExample:\n\n```elixir\ngraph\n  |> text(\"Scaled!\", scale: 1.2)\n  |> text(\"Scaled!\", scale: {1.0, 1.2}, pin: {10, 20})\n```","ref":"Scenic.Primitive.Transform.Scale.html","title":"Scenic.Primitive.Transform.Scale","type":"module"},{"doc":"Scaling is common enough that you can use `:s` as a shortcut.\n\nExample:\n```elixir\ngraph\n  |> text(\"Scaled!\", s: 1.2)\n```","ref":"Scenic.Primitive.Transform.Scale.html#module-shortcut","title":"Shortcut - Scenic.Primitive.Transform.Scale","type":"module"},{"doc":"","ref":"Scenic.Primitive.Transform.Scale.html#validate/1","title":"Scenic.Primitive.Transform.Scale.validate/1","type":"function"},{"doc":"Apply a translation matrix.\n\nThis is used to position primitives on the screen\n\n`{x, y}` - move the primitive by the given amounts\n\nExample:\n\n```elixir\ngraph\n  |> text(\"Scaled!\", translate: {10, 20})\n```","ref":"Scenic.Primitive.Transform.Translate.html","title":"Scenic.Primitive.Transform.Translate","type":"module"},{"doc":"Translating is common enough that you can use `:t` as a shortcut.\n\nExample:\n\n```elixir\ngraph\n  |> text(\"Scaled!\", t: {10, 20})\n```","ref":"Scenic.Primitive.Transform.Translate.html#module-shortcut","title":"Shortcut - Scenic.Primitive.Transform.Translate","type":"module"},{"doc":"","ref":"Scenic.Primitive.Transform.Translate.html#validate/1","title":"Scenic.Primitive.Transform.Translate.validate/1","type":"function"},{"doc":"Helper functions that support Scenic mathematical operations.\n\nThe math functions are fairly straightforward. When performance is needed some\nhave been broken out into a NIF.\n\nThe NIF functions are currently written for compatibility over top speed and\nas such, there is an opportunity to further improve them by calling out to\nCPU-specific vector instructions in the future.","ref":"Scenic.Math.html","title":"Scenic.Math","type":"module"},{"doc":"","ref":"Scenic.Math.html#t:line/0","title":"Scenic.Math.line/0","type":"type"},{"doc":"","ref":"Scenic.Math.html#t:matrix/0","title":"Scenic.Math.matrix/0","type":"type"},{"doc":"","ref":"Scenic.Math.html#t:matrix_list/0","title":"Scenic.Math.matrix_list/0","type":"type"},{"doc":"","ref":"Scenic.Math.html#t:point/0","title":"Scenic.Math.point/0","type":"type"},{"doc":"","ref":"Scenic.Math.html#t:quad/0","title":"Scenic.Math.quad/0","type":"type"},{"doc":"","ref":"Scenic.Math.html#t:triangle/0","title":"Scenic.Math.triangle/0","type":"type"},{"doc":"","ref":"Scenic.Math.html#t:vector_2/0","title":"Scenic.Math.vector_2/0","type":"type"},{"doc":"A collection of functions to work with lines.\n\nLines are always two points in a tuple.\n\n    {point_a, point_b}\n    {{x0, y0}, {x1, y1}}","ref":"Scenic.Math.Line.html","title":"Scenic.Math.Line","type":"module"},{"doc":"Find the point of intersection between two lines.\n\nParameters:\n* `line_a` - A line defined by two points. `{point_a, point_b}`\n* `line_b` - A line defined by two points. `{point_a, point_b}`\n\nReturns:\nA point","ref":"Scenic.Math.Line.html#intersection/2","title":"Scenic.Math.Line.intersection/2","type":"function"},{"doc":"iex> Scenic.Math.Line.intersection({{1, 1}, {3, 3}}, {{3, 1}, {1, 3}})\n  {2.0, 2.0}","ref":"Scenic.Math.Line.html#intersection/2-examples","title":"Examples - Scenic.Math.Line.intersection/2","type":"function"},{"doc":"Find a new line that is parallel to the given line and separated\nby the given distance.\n\nParameters:\n\n* `line` - A line defined by two points. `{point_a, point_b}`\n* `distance` - The perpendicular distance to the new line.\n\nReturns:\nA line","ref":"Scenic.Math.Line.html#parallel/2","title":"Scenic.Math.Line.parallel/2","type":"function"},{"doc":"iex> Scenic.Math.Line.parallel({{1, 1}, {1, 2}}, 2)\n    {{3.0, 1.0}, {3.0, 2.0}}","ref":"Scenic.Math.Line.html#parallel/2-examples","title":"Examples - Scenic.Math.Line.parallel/2","type":"function"},{"doc":"Round the points that define a line so that they are made\nup of integers.\n\nParameters:\n\n* `line` - A line defined by two points. {point_a, point_b}\n\nReturns:\n\nA line","ref":"Scenic.Math.Line.html#round/1","title":"Scenic.Math.Line.round/1","type":"function"},{"doc":"iex> Scenic.Math.Line.round({{1.5, 1.6}, {2.1, 2.56}})\n    {{2, 2}, {2, 3}}","ref":"Scenic.Math.Line.html#round/1-examples","title":"Examples - Scenic.Math.Line.round/1","type":"function"},{"doc":"Truncate the points that define a line so that they are made\nup of integers.\n\nParameters:\n\n* `line` - A line defined by two points. `{point_a, point_b}`\n\nReturns:\n\nA line","ref":"Scenic.Math.Line.html#trunc/1","title":"Scenic.Math.Line.trunc/1","type":"function"},{"doc":"iex> Scenic.Math.Line.trunc({{1.1, 1.1}, {2.0, 2.0}})\n    {{1, 1}, {2, 2}}\n    iex> Scenic.Math.Line.trunc({{-1, 1}, {-2.0, 2.0}})\n    {{-1, 1}, {-2, 2}}","ref":"Scenic.Math.Line.html#trunc/1-examples","title":"Examples - Scenic.Math.Line.trunc/1","type":"function"},{"doc":"A collection of functions to work with matrices.\n\nAll the matrix fucntions in this module work exclusively with the binary form\nof a matrix, which is a compact binary of 16 4-byte floats.\n\nIf you would like to convert back and forth from the more human friendly list\nversion, then please use the functions in [Scenic.Math.Matrix.Utils](Scenic.Math.Matrix.Utils)","ref":"Scenic.Math.Matrix.html","title":"Scenic.Math.Matrix","type":"module"},{"doc":"Add two matrices together.\n\nThis operation is implemented as a NIF for performance.\n\nParameters:\n* matrix_a: The first matrix\n* matrix_b: The second matrix\n\nReturns:\nThe resulting matrix","ref":"Scenic.Math.Matrix.html#add/2","title":"Scenic.Math.Matrix.add/2","type":"function"},{"doc":"Calculate the adjugate of a matrix\n\nThis operation is implemented as a NIF for performance.\n\nParameters:\n* matrix: A matrix\n\nReturns:\nThe resulting matrix","ref":"Scenic.Math.Matrix.html#adjugate/1","title":"Scenic.Math.Matrix.adjugate/1","type":"function"},{"doc":"Build a matrix that represents a 2D rotation around a point.\n\nParameters:\n* angle: the amount to rotate, in radians\n* pin: position to pin the rotation around\n\nReturns:\nA binary matrix","ref":"Scenic.Math.Matrix.html#build_rotate_around/2","title":"Scenic.Math.Matrix.build_rotate_around/2","type":"function"},{"doc":"Build a matrix that represents a 2D rotation around the origin.\n\nParameters:\n* angle: the amount to rotate, in radians\n\nReturns:\nA binary matrix","ref":"Scenic.Math.Matrix.html#build_rotation/1","title":"Scenic.Math.Matrix.build_rotation/1","type":"function"},{"doc":"Build a matrix that represents a scaling operation.\n\nParameters:\n* scale: the amount to scale by. Can be either a number or a vector_2\n\nReturns:\nA binary matrix","ref":"Scenic.Math.Matrix.html#build_scale/1","title":"Scenic.Math.Matrix.build_scale/1","type":"function"},{"doc":"Build a matrix that represents a simple translation.\n\nParameters:\n* vector_2: the vector defining how much to translate\n\nReturns:\nA binary matrix","ref":"Scenic.Math.Matrix.html#build_translation/1","title":"Scenic.Math.Matrix.build_translation/1","type":"function"},{"doc":"Test if two matrices are close in value to each other.\n\nParameters:\n* matrix_a: The first matrix\n* matrix_b: The second matrix\n* tolerance: Defines what close means. Defaults to: +0.000001\n\nReturns:\nA boolean","ref":"Scenic.Math.Matrix.html#close?/3","title":"Scenic.Math.Matrix.close?/3","type":"function"},{"doc":"Calculate the determinant of a matrix\n\nThis operation is implemented as a NIF for performance.\n\nParameters:\n* matrix: A matrix\n\nReturns:\nThe resulting matrix","ref":"Scenic.Math.Matrix.html#determinant/1","title":"Scenic.Math.Matrix.determinant/1","type":"function"},{"doc":"Divide a matrix by a scalar.\n\nThis operation is implemented as a NIF for performance.\n\nParameters:\n* matrix: A matrix\n* divisor: A number (scalar) to divide by\n\nReturns:\nThe resulting matrix","ref":"Scenic.Math.Matrix.html#div/2","title":"Scenic.Math.Matrix.div/2","type":"function"},{"doc":"Get a single value out of a binary matrix.\n\nParameters:\n* matrix: The source matrix\n* x: the column to pull the data from\n* y: the row to pull the data from\n\nReturns:\nA number","ref":"Scenic.Math.Matrix.html#get/3","title":"Scenic.Math.Matrix.get/3","type":"function"},{"doc":"Extract the 2D vector represented by the matrix.\n\nParameters:\n* matrix: The source matrix\n\nReturns:\nA vector_2","ref":"Scenic.Math.Matrix.html#get_xy/1","title":"Scenic.Math.Matrix.get_xy/1","type":"function"},{"doc":"The identity matrix","ref":"Scenic.Math.Matrix.html#identity/0","title":"Scenic.Math.Matrix.identity/0","type":"function"},{"doc":"Inverte a matrix.\n\nThis operation is implemented as a NIF for performance.\n\nParameters:\n* matrix: A matrix\n\nReturns:\nThe resulting matrix","ref":"Scenic.Math.Matrix.html#invert/1","title":"Scenic.Math.Matrix.invert/1","type":"function"},{"doc":"Multiply a list of matrices together.\n\nThis operation is implemented as a NIF for performance.\n\nParameters:\n* matrix_list: A list of matrices\n\nReturns:\nThe resulting matrix","ref":"Scenic.Math.Matrix.html#mul/1","title":"Scenic.Math.Matrix.mul/1","type":"function"},{"doc":"Multiply a matrix by another matrix or a scalar.\n\nThis operation is implemented as a NIF for performance.\n\nParameters:\n* matrix: A matrix\n* multiplier: A number (scalar) or a matrix to multiply by\n\nReturns:\nThe resulting matrix","ref":"Scenic.Math.Matrix.html#mul/2","title":"Scenic.Math.Matrix.mul/2","type":"function"},{"doc":"Project a vector by a matrix.\n\nThis operation is implemented as a NIF for performance.\n\nParameters:\n* matrix: A matrix\n* vector: The vector to project\n\nReturns:\nThe projected vector","ref":"Scenic.Math.Matrix.html#project_vector/2","title":"Scenic.Math.Matrix.project_vector/2","type":"function"},{"doc":"Project a list of vectors by a matrix.\n\nThis operation is implemented as a NIF for performance.\n\nParameters:\n* matrix: A matrix\n* vectors: The list of vectors to project\n\nReturns:\nA list of projected vectors","ref":"Scenic.Math.Matrix.html#project_vectors/2","title":"Scenic.Math.Matrix.project_vectors/2","type":"function"},{"doc":"Put a single value into a binary matrix.\n\nParameters:\n* matrix: The source matrix\n* x: the column to pull the data from\n* y: the row to pull the data from\n* v: the value to put into the matrix. Must be a number.\n\nReturns:\nA number","ref":"Scenic.Math.Matrix.html#put/4","title":"Scenic.Math.Matrix.put/4","type":"function"},{"doc":"Multiply a matrix by a rotation.\n\nParameters:\n* matrix: The incoming source matrix\n* angle: the amount to rotate, in radians or nil (which does nothing\n\nReturns:\nA binary matrix","ref":"Scenic.Math.Matrix.html#rotate/2","title":"Scenic.Math.Matrix.rotate/2","type":"function"},{"doc":"Multiply a matrix by a scale factor.\n\nParameters:\n* matrix: The incoming source matrix\n* scale: the amount to scale by. Can be either a number, a vector, or nil (which does nothing)\n\nReturns:\nA binary matrix","ref":"Scenic.Math.Matrix.html#scale/2","title":"Scenic.Math.Matrix.scale/2","type":"function"},{"doc":"Subtract one matrix from another.\n\nThis operation is implemented as a NIF for performance.\n\nParameters:\n* matrix_a: The first matrix\n* matrix_b: The second matrix, which is subtracted from the first\n\nReturns:\nThe resulting matrix","ref":"Scenic.Math.Matrix.html#sub/2","title":"Scenic.Math.Matrix.sub/2","type":"function"},{"doc":"Multiply a matrix by a translation.\n\nParameters:\n* matrix: The incoming source matrix\n* vector_2: the vector to translate by or nil (which does nothing)\n\nReturns:\nA binary matrix","ref":"Scenic.Math.Matrix.html#translate/2","title":"Scenic.Math.Matrix.translate/2","type":"function"},{"doc":"Transpose a matrix\n\nThis operation is implemented as a NIF for performance.\n\nParameters:\n* matrix: A matrix\n\nReturns:\nThe resulting matrix","ref":"Scenic.Math.Matrix.html#transpose/1","title":"Scenic.Math.Matrix.transpose/1","type":"function"},{"doc":"A matrix where all the values are 0","ref":"Scenic.Math.Matrix.html#zero/0","title":"Scenic.Math.Matrix.zero/0","type":"function"},{"doc":"Helper functions for working with matrices.\n\nThe matrix format for the main `Scenic.Math.Matrix` functions is a 64 byte\nbinary blob containing 16 4-byte floats. This is great for doing the math in\ncode, but not so great for reading or understanding the values by a human.\n\nThese functions transform more readable/writable formats into the binary blob\nand vice versa.","ref":"Scenic.Math.Matrix.Utils.html","title":"Scenic.Math.Matrix.Utils","type":"module"},{"doc":"Convert a readable format into a binary blob.\n\nParameters:\n* `matrix_list` - a list of 16 numbers\n\nReturns:\nA binary matrix blob","ref":"Scenic.Math.Matrix.Utils.html#to_binary/1","title":"Scenic.Math.Matrix.Utils.to_binary/1","type":"function"},{"doc":"Convert a binary matrix into a list of 16 numbers.\n\nParameters:\n* `matrix` - a binary matrix\n\nReturns:\nA list of 16 numbers","ref":"Scenic.Math.Matrix.Utils.html#to_list/1","title":"Scenic.Math.Matrix.Utils.to_list/1","type":"function"},{"doc":"A collection of functions to work with 2D vectors.\n\n2D vectors are always two numbers in a tuple.\n\n    {3, 4}\n    {3.5, 4.7}","ref":"Scenic.Math.Vector2.html","title":"Scenic.Math.Vector2","type":"module"},{"doc":"Add two vectors together.\n\nParameters:\n* `vector2_a` - the first vector to be added\n* `vector2_b` - the second vector to be added\n\nReturns:\nA new vector which is the result of the addition","ref":"Scenic.Math.Vector2.html#add/2","title":"Scenic.Math.Vector2.add/2","type":"function"},{"doc":"iex> Scenic.Math.Vector2.add({1.0, 5.0}, {3.0, 3.0})\n    {4.0, 8.0}","ref":"Scenic.Math.Vector2.html#add/2-examples","title":"Examples - Scenic.Math.Vector2.add/2","type":"function"},{"doc":"Given a list of vectors, find the {left, top, right, bottom} of the bounding box.","ref":"Scenic.Math.Vector2.html#bounds/1","title":"Scenic.Math.Vector2.bounds/1","type":"function"},{"doc":"Clamp a vector to the space between two other vectors.\n\nParameters:\n* `vector2` - the vector to be clamped\n* `min` - the vector defining the minimum boundary\n* `max` - the vector defining the maximum boundary\n\nReturns:\nA vector derived from the space between two other vectors","ref":"Scenic.Math.Vector2.html#clamp/3","title":"Scenic.Math.Vector2.clamp/3","type":"function"},{"doc":"Calculates the cross product of two vectors.\n\nParameters:\n* `vector2_a` - the first vector\n* `vector2_b` - the second vector\n\nReturns:\nA number which is the result of the cross product","ref":"Scenic.Math.Vector2.html#cross/2","title":"Scenic.Math.Vector2.cross/2","type":"function"},{"doc":"","ref":"Scenic.Math.Vector2.html#distance/2","title":"Scenic.Math.Vector2.distance/2","type":"function"},{"doc":"","ref":"Scenic.Math.Vector2.html#distance_squared/2","title":"Scenic.Math.Vector2.distance_squared/2","type":"function"},{"doc":"Divide a vector by a scalar.\n\nParameters:\n* `vector2` - the vector\n* `scalar` - the scalar value\n\nReturns:\nA new vector which is the result of the division","ref":"Scenic.Math.Vector2.html#div/2","title":"Scenic.Math.Vector2.div/2","type":"function"},{"doc":"Calculates the dot product of two vectors.\n\nParameters:\n* `vector2_a` - the first vector\n* `vector2_b` - the second vector\n\nReturns:\nA number which is the result of the dot product","ref":"Scenic.Math.Vector2.html#dot/2","title":"Scenic.Math.Vector2.dot/2","type":"function"},{"doc":"A vector that points straight down by 1.","ref":"Scenic.Math.Vector2.html#down/0","title":"Scenic.Math.Vector2.down/0","type":"function"},{"doc":"Determine if a vector is in the bounds (or clamp space) between\ntwo other vectors.\n\nParameters:\n* `vector2` - the vector to be tested\n* `bounds` - a vector defining the boundary\n\nReturns:\ntrue or false","ref":"Scenic.Math.Vector2.html#in_bounds?/2","title":"Scenic.Math.Vector2.in_bounds?/2","type":"function"},{"doc":"Determine if a vector is in the bounds (or clamp space) between\ntwo other vectors.\n\nParameters:\n* `vector2` - the vector to be tested\n* `min` - the vector defining the minimum boundary\n* `max` - the vector defining the maximum boundary\n\nReturns:\nA vector derived from the space between two other vectors","ref":"Scenic.Math.Vector2.html#in_bounds?/3","title":"Scenic.Math.Vector2.in_bounds?/3","type":"function"},{"doc":"Invert a vector.\n\nParameters:\n* `vector_2` - the vector to be inverted\n\nReturns:\nThe inverted vector","ref":"Scenic.Math.Vector2.html#invert/1","title":"Scenic.Math.Vector2.invert/1","type":"function"},{"doc":"iex> Scenic.Math.Vector2.invert({2, 2})\n    {-2, -2}","ref":"Scenic.Math.Vector2.html#invert/1-examples","title":"Examples - Scenic.Math.Vector2.invert/1","type":"function"},{"doc":"A vector that points left by 1.","ref":"Scenic.Math.Vector2.html#left/0","title":"Scenic.Math.Vector2.left/0","type":"function"},{"doc":"Calculates the length of the vector.\n\nThis is slower than calculating the squared length.\n\nParameters:\n* `vector2` - the vector\n\nReturns:\nA number which is the length","ref":"Scenic.Math.Vector2.html#length/1","title":"Scenic.Math.Vector2.length/1","type":"function"},{"doc":"Calculates the squared length of the vector.\n\nThis is faster than calculating the length if all you want to do is\ncompare the lengths of two vectors against each other.\n\nParameters:\n* `vector2` - the vector\n\nReturns:\nA number which is the square of the length","ref":"Scenic.Math.Vector2.html#length_squared/1","title":"Scenic.Math.Vector2.length_squared/1","type":"function"},{"doc":"Calculate the lerp of two vectors.\n\n[See This explanation for more info.](https://keithmaggio.wordpress.com/2011/02/15/math-magician-lerp-slerp-and-nlerp/)\n\nParameters:\n* `vector_a` - the first vector\n* `vector_b` - the second vector\n* `t` - the \"t\" value (see link above). Must be between 0 and 1.\n\nReturns:\nA vector, which is the result of the lerp.","ref":"Scenic.Math.Vector2.html#lerp/3","title":"Scenic.Math.Vector2.lerp/3","type":"function"},{"doc":"Find a new vector derived from the highest `x` and `y` from two given vectors.\n\nParameters:\n* `vector2_a` - the first vector\n* `vector2_b` - the second vector\n\nReturns:\nA vector derived from the highest `x` and `y` from two given vectors","ref":"Scenic.Math.Vector2.html#max/2","title":"Scenic.Math.Vector2.max/2","type":"function"},{"doc":"Find a new vector derived from the lowest `x` and `y` from two given vectors.\n\nParameters:\n* `vector2_a` - the first vector\n* `vector2_b` - the second vector\n\nReturns:\nA vector derived from the lowest `x` and `y` from two given vectors","ref":"Scenic.Math.Vector2.html#min/2","title":"Scenic.Math.Vector2.min/2","type":"function"},{"doc":"Multiply a vector by a scalar.\n\nParameters:\n* `vector2` - the vector\n* `scalar` - the scalar value\n\nReturns:\nA new vector which is the result of the multiplication","ref":"Scenic.Math.Vector2.html#mul/2","title":"Scenic.Math.Vector2.mul/2","type":"function"},{"doc":"Calculate the nlerp (normalized lerp) of two vectors.\n\n[See This explanation for more info.](https://keithmaggio.wordpress.com/2011/02/15/math-magician-lerp-slerp-and-nlerp/)\n\nParameters:\n* `vector_a` - the first vector\n* `vector_b` - the second vector\n* `t` - the \"t\" value (see link above). Must be between 0 and 1.\n\nReturns:\nA vector, which is the result of the nlerp.","ref":"Scenic.Math.Vector2.html#nlerp/3","title":"Scenic.Math.Vector2.nlerp/3","type":"function"},{"doc":"Normalize a vector so it has the same angle, but a length of 1.\n\nParameters:\n* `vector2` - the vector\n\nReturns:\nA vector with the same angle as the original, but a length of 1","ref":"Scenic.Math.Vector2.html#normalize/1","title":"Scenic.Math.Vector2.normalize/1","type":"function"},{"doc":"A vector that points to {1,1}.","ref":"Scenic.Math.Vector2.html#one/0","title":"Scenic.Math.Vector2.one/0","type":"function"},{"doc":"Project a vector into the space defined by a matrix\n\nParameters:\n* `vector` - the vector, or a list of vectors\n* `matrix` - the matrix\n\nReturns:\nA projected vector (or list of vectors)","ref":"Scenic.Math.Vector2.html#project/2","title":"Scenic.Math.Vector2.project/2","type":"function"},{"doc":"A vector that points right by 1.","ref":"Scenic.Math.Vector2.html#right/0","title":"Scenic.Math.Vector2.right/0","type":"function"},{"doc":"Round the values of a vector to the nearest integers.\n\nParameters:\n* `vector_2` - the vector to be rounded\n\nReturns:\nThe integer vector","ref":"Scenic.Math.Vector2.html#round/1","title":"Scenic.Math.Vector2.round/1","type":"function"},{"doc":"iex> Scenic.Math.Vector2.round({1.2, 1.56})\n    {1, 2}","ref":"Scenic.Math.Vector2.html#round/1-examples","title":"Examples - Scenic.Math.Vector2.round/1","type":"function"},{"doc":"Subtract one vector from another.\n\nParameters:\n* `vector2_a` - the first vector\n* `vector2_b` - the second vector, which will be subtracted from the first\n\nReturns:\nA new vector which is the result of the subtraction","ref":"Scenic.Math.Vector2.html#sub/2","title":"Scenic.Math.Vector2.sub/2","type":"function"},{"doc":"Truncate the values of a vector into integers.\n\nParameters:\n* `vector_2` - the vector to be truncated\n\nReturns:\nThe integer vector","ref":"Scenic.Math.Vector2.html#trunc/1","title":"Scenic.Math.Vector2.trunc/1","type":"function"},{"doc":"iex> Scenic.Math.Vector2.trunc({1.6, 1.2})\n    {1, 1}","ref":"Scenic.Math.Vector2.html#trunc/1-examples","title":"Examples - Scenic.Math.Vector2.trunc/1","type":"function"},{"doc":"A vector that points to {1,0}.","ref":"Scenic.Math.Vector2.html#unity_x/0","title":"Scenic.Math.Vector2.unity_x/0","type":"function"},{"doc":"A vector that points to {0,1}.","ref":"Scenic.Math.Vector2.html#unity_y/0","title":"Scenic.Math.Vector2.unity_y/0","type":"function"},{"doc":"A vector that points straight up by 1.","ref":"Scenic.Math.Vector2.html#up/0","title":"Scenic.Math.Vector2.up/0","type":"function"},{"doc":"A vector that points to the origin.","ref":"Scenic.Math.Vector2.html#zero/0","title":"Scenic.Math.Vector2.zero/0","type":"function"},{"doc":"","ref":"Scenic.Driver.Error.html","title":"Scenic.Driver.Error","type":"exception"},{"doc":"# Upgrading to v0.11","ref":"upgrading_to_v0-11.html","title":"Upgrading to v0.11","type":"extras"},{"doc":"Version v0.11 is a MAJOR overhaul from the top to the bottom. For the first time, Scenic feels like something approaching a 1.0 in design.\n\nThis guide is a good first pass. If you see things that need improving, please contribute!\n\n\n  * `Scenic.Cache` is gone. It is replaced by a **much** easier to use asset pipeline.\n  * `push_graph` is back. WHAT! Didn't it go away last time? Yes. I've been struggling with the way scene state is handled. Coupled with the scene state change (next in this list), it finally makes sense.\n  * State for a scene is now tracked similar to how you add state to a socket in a Phoenix Channel or a Plug conn. The state is always a `%Scene{}` object and you can assign() state into it.\n  * The driver engine is a complete re-write. Existing drivers that render will need to be re-written. Sorry. The good news is that they all pretty much did the same thing in generating a \"script\" of draw commands that was sent over to some renderer. This is now standardized and moved to the ViewPort layer. Drivers are MUCH simpler as a result and more portable.\n  * The ViewPort, and even the Scene engines themselves are also re-writes, but their API is very similar to the old version, so not much news there except for the way Scene state is tracked.\n  * There is an entirely new Script engine for generating draw scripts that can be sent to drivers. This is quite powerful\n  * There are numerous other additions to Scenic\n    * The Component primitive is used to refer to, and start components.\n    * The Script primitive refers to arbitrary scripts that you can send to drivers.\n    * The `:line_height` style now sets the spacing between lines of text. Works like CSS.\n    * The `:text_base` style lets you align text vertically.\n    * There is a new Scenic.Asset.Stream type for dynamic textures.\n    * New Sprite Sheet support via the Sprites primitive\n    * Built-in mouse cursor support on Nerves (works, but is not optimized yet)\n  * There are multiple smaller deprecations. Notably\n    * The `:text_height` style is replaced by :line_height, which works the same way line_height does in CSS.\n    * The `Path` primitive (which almost got cut, but survived) no longer has the solid and hole commands.\n    * The Box Gradient fill is gone.\n    * The `:clear_color` style (which was always weird) is gone. You can now set a theme on the viewport (in config), which sets the background color.\n    * The SceneRef primitive is gone, and replaced with a combination of Component and Script primitives.\n    * The `:font_blur` primitive is gone. Sorry. Didn't have a close enough analog in Canvas\n    * Input events are no longer implicitly requested for a scene. You can explicitly request the input events you want using `Scene.request_input/2` or `Scene.capture_input/2`\n    * The format of the input messages have changed - see the docs\n    * The optional styles on some of the standard components (Button) have changed to be more consistent with the standard styles. See documentation.\n\n__Important__\n  * `:scenic_driver_local` is the new standard renderer for Scenic. Both `:scenic_driver_glfw` and `:scenic_drives_nerves_rpi` are retired as of v0.11.\n\nThe options for the new local driver are NOT the same as they were for the glfw driver. Please read the docs for it. Please see the new [driver overview](overview_driver.html).\n\n\nI'm sure there's more. Feel free to add any notes if you find something that isn't covered.","ref":"upgrading_to_v0-11.html#overview","title":"Overview - Upgrading to v0.11","type":"extras"},{"doc":"The primary motivation for Scenic has always been to provide control surface UI for devices that don't necessarily have a human nearby watching over them. This means IoT, Industrial Control, Critical Systems, Infrastructure, etc... It can be used for other thing (and has been!), but the design choices are more about devices than flash.\n\nI like to say that there are 3 kinds of UI. Think of these as 3 layers, with highest fidelity and lowest latency requirements at the top, and lowest fidelity but best latency tolerance at the bottom.\n\n* __Category 1:__ At the top are games and anything else that uses all the available resources, renders to maximum fidelity. These applications are power hungry, run on local hardware due to latency sensitivity (although there is a lot of research going into cloud hosting) and they strive for the maximum in visual fidelity.\n* __Category 2:__ The middle layer is still UI that has latency sensitivity and is meant to be used by consumers in real-time, but the fidelity is dialed way back. Examples in this category are Flutter, QT, and most modern client-heavy web frameworks. When you see consumer appliances with a pretty interface that seems slightly sluggish, but is still trying to be pretty, that is in this layer. They walk the line between using the least expensive hardware they can, and still being pretty for everyday consumers.\n* __Category 3:__ The bottom layer knows it is running on inexpensive hardware and usually doesn't have a human using the actual device it runs on directly. It is designed up front to be latency tolerant, consume few resources, to be functional over flashy. Examples include old-school web 1.0 servers, X11 and... Scenic.\n\nScenic's prime target has always been devices that are deployed in the field. They may or may not have a screen / human interface directly attached (most often don't) and are operated remotely.\n\nCategory 3 devices do jobs that are more valuable than the device is. The small controller device that operates the solar farm is worth less than the farm or the electricity it produces. In contrast, our fancy Thermomix blender has a Category 2 UI, and is way more expensive than any of the meals it makes. Or even many meals put together.\n\nThe requirements for a category 3 UI on devcies are\n* Must be highly robust. Or at least recover quickly and not affect the rest of the device.\n* Must be conservative with resources.\n* Must be remotable. (The UI can be displayed and used on a different device)\n* Must be latency tolerant.\n\nIn versions 0.10 and early, Scenic did well on robustness and conservative resource use. It was designed to be latency tolerant, but that was never put to the test as it was not at all remotable. - yet.\n\nVersion 0.11 finally takes a crack at making Scenic remotable. Enough time and use has passed that usage patterns have become visible. Some things have worked well (the pattern of scene/primitives/styles/transforms/components) and some things have not (the driver model repeated the same basic complicated code in every driver and the static assets cache was a constant struggle).\n\nNow that the Kry10 Operating System is operational (Scenic long awaited design target), it was time to fix the things that didn't work so well and properly build remoting. These are the sorts of changes that have ripples up the stack and create breaking changes. So best to get it all done in fell swoop.","ref":"upgrading_to_v0-11.html#motivation","title":"Motivation - Upgrading to v0.11","type":"extras"},{"doc":"* Update mix.exs\n\nDelete your old scenic dependencies in `mix.exs`, they now look like this:\n\n```\n{:scenic, \"~> 0.11.0\"},\n{:scenic_driver_local, \"~> 0.11.0\"},\n```\n\nYou may need to use `mix deps.clean --all` and/or `mix deps.unlock` to get it to work.\n\n* Change the incoming viewport options to be a keyword list\n\nThe main options for your Scenic app have changed from a map to a Keyword list. For example, if this was your old options map:\n\n```\n%{\n  name: :main_viewport,\n  size: {1200, 600},\n  default_scene: {MyProject.RootScene, nil},\n  drivers: [\n    %{\n      module: Scenic.Driver.Glfw,\n      name: :glfw,\n      opts: [resizeable: false, title: @title]\n    }\n  ]\n}\n```\n\nIt would now look like this:\n\n```\n[\n  name: :main_viewport,\n  size: {1200, 600},\n  default_scene: {MyProject.RootScene, nil},\n  drivers: [\n    [\n      module: Scenic.Driver.Local,\n      name: :local\n    ]\n  ]\n]\n```\n\nFinally, where you are adding Scenic to the supervision tree, you will probably have to wrap these options in another list, assuming you use the above config exactly as is:\n\n```\nchildren = [\n  {Scenic, [default_viewport_config()]},\n]\n```\n\nwhere default_viewport_config() resolves to the above config list.\n\n* Change the driver module\n\nAssuming you have already upgraded your dependencies in mix.exs, you just need to make sure that you're using the correct driver module in your config.\n\n```\ndrivers: [\n    [\n      module: Scenic.Driver.Local,\n      name: :local\n    ]\n  ]\n```","ref":"upgrading_to_v0-11.html#upgrading-a-v0-10-project-to-v0-11","title":"Upgrading a v0.10 project to v0.11 - Upgrading to v0.11","type":"extras"},{"doc":"The most immediate change that you will need to be addressed is now state in a scene is stored and how scenes are started up.\n\nIn the old system, I was trying to hard to keep the developer focused on the functionality of their scene, and less with the mechanics of how it worked in the deeper layers. This created a state problem. Essentially, the scene developer needs to keep state for whatever the scene is supposed to be doing. But, the scene engine itself also needs to keep state in order track child components, its `ViewPort`, push graphs to the ViewPort, etc. I've tried various things to keep these states separate and clean. In end... it was all messy.\n\nThe only thing that really works is to adopt the same state model as sockets/conns from Phoenix and Plug. That is, there is no state kept under the covers. The state presented to a scene is always now a `%Scenic.Scene{}` struct. Just like Plug and Sockets, there is an `:assigns` map in the struct that the scene developer uses to store their state. Just like those others systems, `assigns()` helpers are provided.\n\nThis will require some porting work as you move to v0.11, but at least it feels like the right long-term solution.","ref":"upgrading_to_v0-11.html#scene-state","title":"Scene State - Upgrading to v0.11","type":"extras"},{"doc":"* Upgrade init/2 to init/3\n\nPreviously `init/2` accepted params, and a list of options. Now it also accepts a scene as the first parameter. This scene must be saved into the state, or set as the entire state of the scene. An example implementation is below.\n\n```\n@impl Scenic.Scene\ndef init(scene, _params, _opts) do\n  # put your init logic here\n  {:ok, scene}\nend\n```\n\n* Update the scene to use push_graph/2\n\nPreviously in v0.10, graphs were pushed by including a `push: graph` option at the end of each callback:\n\n```\ndef handle_cast(msg, state) do\n  new_graph = calc_new_graph(state)\n  {:noreply, %{state|graph: new_graph}, push: new_graph}\nend\n```\n\nThis has now been deprecated, in favour of the function `push_graph/2`\n\nExample:\n\n```\ndef handle_cast(msg, scene) do\n  new_graph = calc_new_graph(scene, msg)\n  new_scene =\n    scene\n    |> assign(graph: new_graph)\n    |> push_graph(new_graph)\n  {:noreply, new_scene}\nend\n```\n\nNote that, in this example, we are holding the `Scene` variable inside the state. This scene is passed in as the new param to `init/3` now, and we MUST use this scene when we perform a push_graph. We CANNOT simply construct a new scene and use that, it must be the orginal one.","ref":"upgrading_to_v0-11.html#upgrade-steps","title":"Upgrade steps - Upgrading to v0.11","type":"extras"},{"doc":"```elixir\ndefmodule MyDevice.Scene.Example do\n  use Scenic.Scene\n  import Scenic.Primitives\n\n  def init(scene, _param, _opts) do\n    graph = Scenic.Graph.build( font: :roboto )\n      |> text( \"This is an example\", id: :text )\n\n    scene =\n      scene\n      |> assign( some_state: 123, graph: graph )\n      |> push_graph( graph )\n\n    {:ok, scene }\n  end\n\n  # display any received events\n  def handle_event(event, _, %{assigns: %{graph: graph}} = scene) do\n    graph = Graph.modify( graph, :text, &text(&1, inspect(event)))\n\n    scene =\n      scene\n      |> assign( graph: graph )\n      |> push_graph( graph )\n\n    {:noreply, scene}\n  end\n\nend\n```\n\n\n## `push_graph` is back!\nAs part of my struggles to find the right scene state model, the `push_graph` function came, and went, and is now back again.\n\n`push_graph/2` is the way you send a graph from a scene to the scene's `ViewPort` for compilation and eventual display through the drivers. Now that all of the scene's state is stored in one place it is finally clear that push_graph can take a scene and a graph, and return a modified scene. It is important to track the scene that is returned, as that is how any components that the graph may spin up are accounted for.\n\n\n```elixir\n  def init(scene, _param, _opts) do\n\n    graph = Scenic.Graph.build( font: :roboto )\n      |> button( \"Press Me\", id: :press_me )\n\n    scene = push_graph( scene, graph )\n\n    {:ok, scene }\n  end\nend\n```\n\nIn the above example, the scene/process that runs the button labeled `:press_me` is not started until it is pushed to the ViewPort. This function does quite a bit of work and can start or stop child component processes, tracks pids, compiles the graph for rendering, prepares any input records for input events and more. You can call it as often as you want, but be aware that you may end up causing work to no benefit as the drivers all update on their own heartbeat. In other words, you can push a graph 1000 times per second, but it will still only be drawn 30 times per second or less as as the driver sees fit.\n\n## `handle_input` signature has changed\n\nThis is another breaking changed. The old version of handle_input in a scene or component included the relevant id in the input message, which was mixing metaphors, and include a fairly opaque context object that was only there because of the way scene state was handled.\n\nNow that scene state is completely explicit and passed through to the scene, this can be cleaned up. The new `handle_input` function takes three parameters and looks like this.\n\n```elixir\n  def handle_input( input_event, hit_id, scene )\n```\n\nThe input event is now just that. Nothing else is added to it. The hit id in your graph (if any) is passed as the second parameter. It is `nil` if there was nothing hit or if the input event didn't make sense for that sort of thing.\n\nHere is an example from the Button control. In this case, update_color calls the push_graph function and returns the updated state.\n\n```elixir\n  # pressed in the button\n  @impl Scenic.Scene\n  def handle_input( {:cursor_button, {0, :press, _, _}}, :btn, scene ) do\n    :ok = capture_input( scene, :cursor_button )\n\n    scene =\n      scene\n      |> update_color( true, true )\n      |> assign( pressed: true )\n\n    {:noreply, scene}\n  end\n```\n\nAlso notice that which mouse button was clicked is now a number instead of :left or :right. it was presumptive to assume that :left was the primary button. This is neutral and no longer handedness-biased.","ref":"upgrading_to_v0-11.html#example","title":"Example - Upgrading to v0.11","type":"extras"},{"doc":"* Change verify/1 to validate/1\n\nThe name of the function which validates incoming parameters has changed, but the behaviour is essentially the same. An example implementation is below.\n\n```\n@impl Scenic.Component\ndef validate(data) when is_bitstring(data), do: {:ok, data}\ndef validate(_), do: {:error, \"Descriptive error message goes here.\"}\n```\n\n\n## [The Static Asset Library](overview_assets.html)\n\n\nI, and everybody else, always struggled with the various attempts at the `Scenic.Cache modules`. It was close, but not quite right. The goal is to sensibly load and use static assets like images and fonts, while maintaining cryptographic hashes for security purposes. The old system worked, but required byzantine steps to get it running.\n\nThe new asset pipeline is designed to feel familiar to the Phoenix static asset system.\n\nYou create an \"assets\" directory in the root of your project, set up some config to point to it, and create your own Assets module to hold the data. (This part is more like NimblePublisher than Phoenix, but it works really well.)\n\nThen you can just drop images or fonts into you assets folder and they show up and are usable.\n\nExample directory structure\n```\nmy_cool_project\n  assets\n    fonts\n      roboto.ttf\n      my_font.ttf\n    images\n      parrot.jpg\n```\n\nExample config\n```elixir\nconfig :scenic, :assets, module: MyCoolProject.Assets\n```\n\nExample Assets Module\n```elixir\ndefmodule MyCoolProject.Assets do\n  use Scenic.Assets.Static,\n    otp_app: :my_cool_project,\n    alias: [\n      parrot: \"images/parrot.jpg\"\n    ]\nend\n\n```\n\nExample use in a Scene\n```elixir\nGraph.build()\n  |> text( \"Some Text\", font: \"fonts/my_font.ttf\" )\n  |> rect( {100, 200}, fill: {:image, \"images/parrot.jpg\"} )\n  |> rect( {100, 200}, fill: {:image, :parrot} )                # uses the alias set up in config\n```","ref":"upgrading_to_v0-11.html#upgrading-custom-scenic-components","title":"Upgrading custom Scenic.Components - Upgrading to v0.11","type":"extras"},{"doc":"What used to be called the `Scenic.Cache.Dynamic`, is now Scenic.Assets.Stream and Scenic.Assets.Stream.Texture. This is for images that you generate on the fly (charts, bit rendered game screens, rotating colors, etc) or frames that you capture live from a camera.\n\nThe goal is to seperate the source of these images from the consumers (the drivers) in a way that is latency/bandwidth friendly and is easy to use.\n\nThe `Scenic.Assets.Stream` module is a process/api that manages an `:ets` table of streaming assets. This allows a camera to capture frames at whatever rate makes sense for it and to put them into the table when it sees fit. This data is then distributed to any listening drivers, who can do the right thing with it.\n\nExample camera source - ( from some camera source... tbd by developer... )\n```elixir\ndef handle_info( {:camera_0, texture}, state ) do\n  :ok = Stream.put( \"camera_0\", texture )\nend\n```\n\nExample use in a Scene\n```elixir\nGraph.build()\n  |> rect( {100, 200}, fill: {:stream, \"camera_0\"} )\n```","ref":"upgrading_to_v0-11.html#the-streaming-asset-pipeline","title":"The Streaming Asset Pipeline - Upgrading to v0.11","type":"extras"},{"doc":"The old `Scenic.Utilities.Texture` API has been improved and promoted to `Scenic.Assets.Stream.Texture`.\n\nThe changes center around the fact that the NIF behind the `put` and `clear` functions breaks the immutable assumptions of the Erlang and Elixir languages. In other words, they operate directly on the backing memory of the texture instead of making a new copy and then changing it. This is for performance reasons. It also create several very hard to track down bugs.\n\nThe new API fits better into the erlang world adding the `mutable/1` and `commit/1` function calls. When a texture is mutable, it is not usable by the Stream api. When it is commited, it is usable by Stream, but no longer editable.\n\n```elixir\n    t = Texture.build( :rgb, 10, 20 )\n      |> Texture.clear( :blue )\n      |> Texture.commit()\n\n    :ok = Stream.put( \"example\", t )\n```\n\nYou can also specify new textures to be cleared with a specific color and/or committed as build options\n\n```elixir\n    t = Texture.build( :rgb, 10, 20, clear: blue, commit: true )\n    :ok = Stream.put( \"example\", t )\n```","ref":"upgrading_to_v0-11.html#texture-api","title":"Texture API - Upgrading to v0.11","type":"extras"},{"doc":"The new standard render driver for all Scenic apps is `:scenic_driver_local`.\n\nBoth `:scenic_driver_glfw` and `:scenic_drives_nerves_rpi` are retired.\n\nThis driver provides a single rendering code base for both hosted (Mac/PC/Linux) and Nerves environments. The seperate drivers were 95% the same anyway and it was getting difficult to keep fixes for them in sync.","ref":"upgrading_to_v0-11.html#standard-driver","title":"Standard Driver - Upgrading to v0.11","type":"extras"},{"doc":"Another big change to Scenic is the re-write of the driver model. If your work is all at the scene layer, then this shouldn't affect you. But if you have a custom driver that renders graphs, it will need to be re-written.\n\nThe old model sent graphs directly to the drivers. They would then traverse these graphs, translating them into some render specific linear list of commands, which were then, in turn, passed to the actual renderer. It was complicated, repeated the same difficult code in every driver, and was difficult to maintain.\n\nThe new model moves the traversal or \"compilation\" of the graphs into the ViewPort layer and standardizes the set of draw commands in the form of a linear script. This means the difficult part of all drivers has been done once in the ViewPort layer and drivers themselves have become much simpler.\n\nDrivers are still in charge of how often to render, how to deal with latency, and can intercept/customize the serialization of these scripts into binary form.\n\nSee driver documentation for more details. (may not be complete yet...)","ref":"upgrading_to_v0-11.html#driver-model","title":"Driver Model - Upgrading to v0.11","type":"extras"},{"doc":"As part of the driver re-write, the concept of Draw Scripts has been introduced. When you use `push_graph/2` to send a graph to the ViewPort, it is being compiled into a standard draw script and that is what is actually stored for distribution to the drivers.\n\nThis script API is also exposed to scenes, so you can make your own scripts that go outside the confines of the primitives. In fact, that I almost cut the Path primitive as a custom script is almost always a better way to go, but it lives on as a way to insert a limited inline script.\n\nScripts can be created, and referred to in a graph as an easy to way to use them.\n\n```elixir\n  alias Scenic.Script\n\n  def init(scene, _param, _opts) do\n\n    script = Script.start()\n      |> Script.fill_color( :green )\n      |> Script.draw_rect( 100, 200, :fill )\n      |> Script.finish()\n\n    scene = push_graph( scene, graph )\n\n    {:ok, scene }\n  end\n```\n\nSee the `Scenic.Script` module for the full API.","ref":"upgrading_to_v0-11.html#scripts","title":"Scripts - Upgrading to v0.11","type":"extras"},{"doc":"An important point to call out is Scripts are top level objects at the ViewPort. This means that when a Scene creates a script and then refers to it in a graph, the graph and the script are tracked & send to drivers separately. This is a way of separating concerns. A script that is changing rapidly doesn't cause the potentially large and complex graph that references it to update, and vice versa.\n\nIn fact, Graphs are now just compiled into scripts. They are no longer stored directly on the ViewPort at all. It is scripts all the way down.","ref":"upgrading_to_v0-11.html#scripts-vs-scenes","title":"Scripts vs Scenes - Upgrading to v0.11","type":"extras"},{"doc":"# Scenic\n\nScenic is an application framework written directly on the Elixir/Erlang/OTP\nstack. With it, you can build client-side applications that operate identically\nacross all supported operating systems, including MacOS, Ubuntu, Nerves/Linux,\nand more.\n\nScenic is primarily aimed at fixed screen connected devices (IoT), but can also\nbe used to build portable applications.","ref":"welcome.html","title":"Scenic","type":"extras"},{"doc":"If you have used versions before v0.11, please see the [Upgrading to v0.11 Guide](upgrading_to_v0-11.html).","ref":"welcome.html#__important__-upgrading-to-v0-11","title":"__IMPORTANT__ - Upgrading to v0.11 - Scenic","type":"extras"},{"doc":"If you are new to Scenic, then you should read the following guides.\n\n* [Install Dependencies](install_dependencies.html)\n* [General Overview](overview_general.html)\n* [Getting Started](getting_started.html)\n* [Getting Started with Nerves (IoT)](getting_started_nerves.html)\n* [Structure of a Scene](overview_scene.html)\n* [Life-cycle of a Scene](scene_lifecycle.html)\n* [Graph Overview](overview_graph.html)\n* [Primitives](Scenic.Primitives.html)\n* [Standard Components](Scenic.Components.html)\n* [Styles](overview_styles.html)\n* [Transforms](overview_transforms.html)\n* [Contributing](contributing.html)\n* [Code of Conduct](code_of_conduct.html)","ref":"welcome.html#how-to-get-started","title":"How to get started? - Scenic","type":"extras"},{"doc":"* [ViewPort Overview](overview_viewport.html)\n* [Driver Overview](overview_driver.html)\n* [Nerves](getting_started_nerves.html)","ref":"welcome.html#wip","title":"WIP - Scenic","type":"extras"},{"doc":"# Install Dependencies\n\nThe design of Scenic goes to great lengths to minimize its dependencies to just\nthe minimum. Namely, it needs Erlang/Elixir and OpenGL.\n\nRendering your application into a window on your local computer (MacOS, Ubuntu\nand others) is done by the\n[`scenic_driver_local`](https://github.com/ScenicFramework/scenic_driver_local)\ndriver. It uses the GLFW and GLEW libraries to connect to OpenGL.\n\nThe instructions below assume you have already installed Elixir/Erlang. If you\nneed to install Elixir/Erlang there are instructions on the [elixir-lang\nwebsite](https://elixir-lang.org/install.html).","ref":"install_dependencies.html","title":"Install Dependencies","type":"extras"},{"doc":"The easiest way to install on MacOS is to use Homebrew. Just run the following\nin a terminal:\n\n```bash\nbrew update\nbrew install glfw3 glew pkg-config\n```\n\nOnce these components have been installed, you should be able to build the\n`scenic_driver_local` driver.","ref":"install_dependencies.html#on-macos","title":"On MacOS - Install Dependencies","type":"extras"},{"doc":"Some initial setup is required for windows. You'll need windows services for\nlinux (WSL) and VcXsrv, [Jeffrey Borchert's article details these\nsteps.](https://medium.com/@jeffborch/running-the-scenic-elixir-gui-framework-on-windows-10-using-wsl-f9c01fd276f6)","ref":"install_dependencies.html#on-windows","title":"On Windows - Install Dependencies","type":"extras"},{"doc":"The easiest way to install on Ubuntu is to use apt-get. Just run the following:\n\n```bash\nsudo apt-get update\nsudo apt-get install pkgconf libglfw3 libglfw3-dev libglew1.13 libglew-dev\n```\n\nOnce these components have been installed, you should be able to build the\n`scenic_driver_glfw` driver.","ref":"install_dependencies.html#on-ubuntu-16","title":"On Ubuntu 16 - Install Dependencies","type":"extras"},{"doc":"The easiest way to install on Ubuntu is to use apt-get. Just run the following:\n\n```bash\nsudo apt-get update\nsudo apt-get install pkgconf libglfw3 libglfw3-dev libglew2.0 libglew-dev\n```\n\nOnce these components have been installed, you should be able to build the\n`scenic_driver_glfw` driver.","ref":"install_dependencies.html#on-ubuntu-18","title":"On Ubuntu 18 - Install Dependencies","type":"extras"},{"doc":"The easiest way to install on Fedora is to use dnf. Just run the following:\n\n```bash\ndnf install glfw glfw-devel pkgconf glew glew-devel\n```\n\nOnce these components have been installed, you should be able to build the\n`scenic_driver_glfw` driver.","ref":"install_dependencies.html#on-fedora","title":"On Fedora - Install Dependencies","type":"extras"},{"doc":"The easiest way to install on Archlinux is to use pacman. Just run the\nfollowing:\n\n```bash\nsudo pacman -S glfw-x11 glew\n```\n\nIf you're using wayland, you'll probably need `glfw-wayland` instead of\n`glfw-x11` and `glew-wayland` instead of `glew`","ref":"install_dependencies.html#on-archlinux","title":"On Archlinux - Install Dependencies","type":"extras"},{"doc":"Next, you should read about [General Overview](overview_general.html).","ref":"install_dependencies.html#what-to-read-next","title":"What to read next? - Install Dependencies","type":"extras"},{"doc":"# General Overview\n\nScenic is a client application framework written directly on the\nElixir/Erlang/OTP stack. With it, you can build applications that operate\nidentically across all supported operating systems, including MacOS, Ubuntu,\nNerves/Linux, and more.\n\nScenic is primarily aimed at fixed screen connected devices (IoT), but can also\nbe used to build portable applications.","ref":"overview_general.html","title":"General Overview","type":"extras"},{"doc":"- **Available:** Scenic takes full advantage of OTP supervision trees to create\n  applications that are fault-tolerant, self-healing, and highly available under\n  adverse conditions.\n\n- **Small and Fast:** The only core dependencies are Erlang/OTP and OpenGL.\n\n- **Self Contained:** \"Never trust a device if you don't know where it keeps its\n  brain.\" The logic to run a device should be on the device and it should remain\n  operational even if the service it talks to becomes unavailable.\n\n- **Maintainable:** Each device knows how to run itself. This lets teams focus\n  on new products and only updating the old ones as the business needs.\n\n- **Remotable:** Scenic devices know how to run themselves, but can still be\n  accessed remotely. Remote traffic attempts to be as small so it can be used\n  over the Internet, cellular modems, Bluetooth, etc.\n\n- **Reusable:** Collections of UI can be packaged up for reuse with, and across\n  applications. I expect to see Hex packages of controls, graphs, and more\n  available for Scenic applications.\n\n- **Flexible:** Scenic uses matrices similar to game development to position\n  everything. This makes reuse, scale, positioning and more very flexible and\n  simple.\n\n- **Secure:** Scenic is designed with an eye towards security. For now, the main\n  effort is to keep it simple. No browser, Javascript, and other complexity\n  presenting vulnerabilities. There will be much more to say about security\n  later.","ref":"overview_general.html#goals","title":"Goals - General Overview","type":"extras"},{"doc":"- **Browser:** Scenic is **not** a web browser. It is aimed at a fixed screen\n  devices and certain types of windowed apps. It knows nothing about HTML.\n\n- **3D:** Scenic is a 2D UI framework. It uses techniques from game development\n  (such as transform matrices), but it does not support 3D drawing at this time.\n\n- **Immediate Mode:** In graphics speak, Scenic is a retained mode system. If\n  you need immediate mode, then Scenic isn't for you. If you don't know what\n  retained and immediate modes are, then you are probably just fine. For\n  reference: HTML is a retained mode model.","ref":"overview_general.html#non-goals","title":"Non-Goals - General Overview","type":"extras"},{"doc":"Scenic is built as a three-layer architectural cake.\n\n### [Scene Layer](overview_scene.html)\n\nAt the top is the [**Scene Layer**](overview_scene.html), which encapsulates all\napplication business logic. The developer will do most of their Scenic work in\nthe Scene layer.\n\n### [ViewPort Layer](overview_viewport.html)\n\nIn the middle is the [**ViewPort Layer**](overview_viewport.html), which acts as\na bridge between the Scenes and the Drivers. The ViewPort controls the scene\nlife-cycle (More on that in [Scene Overview](overview_scene.html)), sends graphs\ndown to the drivers, and routes user input up to the correct scene.\n\n### [Driver layer](overview_driver.html)\n\nAt the bottom is the [**Driver layer**](overview_driver.html), which is where\nknowledge of the graphics hardware and/or remote configuration lives. Drivers\ndraw everything on the screen and originate the raw user input. Developers can\nwrite their own drivers, but that will be rare if at all. Dealing with Sensors\nand other hardware is a different problem space.","ref":"overview_general.html#architecture","title":"Architecture - General Overview","type":"extras"},{"doc":"Scenic is definitely not a browser and has nothing to do with HTML. However, its\ndesign attempts to draw analogies to web design so that a developer with\nexperience building web pages will catch on very quickly.\n\nThe following terms include HTML analogies as appropriate…","ref":"overview_general.html#mental-model","title":"Mental Model - General Overview","type":"extras"},{"doc":"","ref":"overview_general.html#terms-and-definitions","title":"Terms and Definitions - General Overview","type":"extras"},{"doc":"Scenes are sort of like a web page. Each scene is a GenServer process that\ncontains state and business logic to handle user input. As the device navigates\nto different screens, it is moving between scenes.","ref":"overview_general.html#scene","title":"Scene - General Overview","type":"extras"},{"doc":"A Graph is a sort of like the DOM. It is a hierarchical set of data that\ndescribes things to draw on the screen. The Graph is immutable in the functional\ncoding sense and is manipulated through transform functions.","ref":"overview_general.html#graph","title":"Graph - General Overview","type":"extras"},{"doc":"Each node in a Graph is a Primitive. There is relatively small, fixed set of\nprimitives, but they can be combined to draw pretty much any UI you need.","ref":"overview_general.html#primitive","title":"Primitive - General Overview","type":"extras"},{"doc":"A component is a Scene, with added sugar so that it can be referenced/used by\nother Scenes. This allows you to build libraries of reusable components and\nisolates logic into sensible containers. Standard controls such as Button,\nRadioGroup, Slider and more are written as components.","ref":"overview_general.html#component","title":"Component - General Overview","type":"extras"},{"doc":"Styles are sort of analogous to CSS styles. Styles are optional parameters you\ncan add to any primitive in a graph. They are inherited down the graph.","ref":"overview_general.html#style","title":"Style - General Overview","type":"extras"},{"doc":"All positioning, rotation, scale and such is expressed by applying transform\nmatrices to nodes in a Graph. Transforms are inherited down the graph. You will\nalmost never interact directly with the matrices, as there are very easy helpers\nthat manage them for you.","ref":"overview_general.html#transform","title":"Transform - General Overview","type":"extras"},{"doc":"A ViewPort is a sort of like a tab in your browser. It manages the scene\nlife-cycle, routes graphs to the drivers, and input back up to the scenes. If\nyou want two windows in your app, you need to start two ViewPorts.","ref":"overview_general.html#viewport","title":"ViewPort - General Overview","type":"extras"},{"doc":"Drivers know nothing about scenes but are able to render Graphs to a specific\ndevice. That could be a graphics chip or the network… Drivers also collect raw\nuser input and route it back up to the ViewPort.","ref":"overview_general.html#driver","title":"Driver - General Overview","type":"extras"},{"doc":"There is a fixed set of user input data (mouse, keyboard, touch, etc.) that\ndrivers generate and hand up to the ViewPort. The ViewPort, in turn, sends the\ninput as a message to the appropriate Scene. Scenes handle raw user input via\nthe `handle_input/3` callback.","ref":"overview_general.html#input","title":"Input - General Overview","type":"extras"},{"doc":"In response to user input (or timers or any other message), a component can\ngenerate an event that it sends up to its parent scene. Unlike user input, if\nthe parent doesn't handle it, it is passed up again to that component's parent\nuntil it reaches the root scene. Scenes handle events that are bubbling up to\nthe chain via the `handle_event/3` callback. This is analogous to event bubbling\non a web page.","ref":"overview_general.html#event","title":"Event - General Overview","type":"extras"},{"doc":"If you are new to Scenic, you should read and follow the exercise in [Getting Started](getting_started.html).\n\nIf you want to dig deeper into the structure of a Scene, then read the [Scene Overview](overview_scene.html).","ref":"overview_general.html#what-to-read-next","title":"What to read next? - General Overview","type":"extras"},{"doc":"# Getting Started\n\nThis guide will walk you through installing the new project generator, then\nbuilding your first Scenic application.","ref":"getting_started.html","title":"Getting Started","type":"extras"},{"doc":"See [Install Dependencies](install_dependencies.html)","ref":"getting_started.html#install-dependencies","title":"Install Dependencies - Getting Started","type":"extras"},{"doc":"The Scenic Archive is the home of the `scenic.new` mix task, which lays out a\nstarter application for you. This is the easiest way to set up a new Scenic\nproject.\n\nInstall the Scenic Archive like this\n\n```bash\nmix archive.install hex scenic_new\n```","ref":"getting_started.html#install-scenic-new","title":"Install `scenic.new` - Getting Started","type":"extras"},{"doc":"First, navigate the command-line to the directory where you want to create your\nnew Scenic app. Then run the following commands: (change `my_app` to the name\nof your app...)\n\n```bash\nmix scenic.new my_app\ncd my_app\nmix do deps.get, scenic.run\n```\n\nIf you want to explore the more full-on example, then follow the instructions below.","ref":"getting_started.html#build-the-basic-app","title":"Build the Basic App - Getting Started","type":"extras"},{"doc":"First, navigate the command-line to the directory where you want to create your\nnew Scenic app. Then run the following commands: (change `my_app` to the name\nof your app...)\n\n```bash\nmix scenic.new.example my_app\ncd my_app\nmix do deps.get, scenic.run\n```","ref":"getting_started.html#build-the-example-app","title":"Build the Example App - Getting Started","type":"extras"},{"doc":"In order to start Scenic, you should first build a configuration for one or more\nViewPorts.\n\nThese configuration maps will be passed in to the main Scenic supervisor. These\nconfigurations should live in your app's config.exs file.\n\n    import Config\n\n    # Configure the main viewport for the Scenic application\n    config :my_app, :viewport, [\n      name: :main_viewport,\n      size: {700, 600},\n      default_scene: MyApp.Scene.Example,\n      drivers: [\n        [\n          module: Scenic.Driver.Local,\n          name: :local,\n          window: [resizeable: false, title: \"Example Application\"],\n        ]\n      ]\n    ]\n\nThen use that config to start your supervisor with the `Scenic` supervisor.\n\n```elixir\ndefmodule MyApp do\n  # ...\n\n  def start(_type, _args) do\n    # 1. Load the viewport configuration from config\n    main_viewport_config = Application.get_env(:my_app, :viewport)\n\n    # 2. Start the application with the viewport\n    children = [\n      # ...\n      {Scenic, [main_viewport_config]},\n    ]\n\n    Supervisor.start_link(children, strategy: :one_for_one)\n  end\n\nend\n```\n\nIn the ViewPort configuration you can do things like set a name for the ViewPort\nprocess, its size, the default scene and start one or more drivers.\n\nSee the documentation for [ViewPort Configuration](Scenic.ViewPort.Config.html)\nto learn more about how to set the options on a viewport.\n\nNote that all the drivers are in separate Hex packages as you should choose the\ncorrect one for your application. For example, the `Scenic.Driver.Glfw` driver\ndraws your scenes into a window under MacOS and Ubuntu. It should work on other\nOS's as well, such as other flavors of Unix or Windows, but I haven't worked on\nor tested those yet.","ref":"getting_started.html#configure-scenic","title":"Configure Scenic - Getting Started","type":"extras"},{"doc":"Once the app and its dependencies are set up, there are two main ways to run it.\n\nIf you want to run your app under IEx so that you can debug it, simply run\n\n```bash\niex -S mix\n```\n\nThis works just like any other Elixir application.\n\nIf you want to run your app outside of iex, you should start it like this:\n\n```bash\nmix scenic.run\n```","ref":"getting_started.html#running-and-debugging","title":"Running and Debugging - Getting Started","type":"extras"},{"doc":"The starter app created by the generator above shows the basics of building a\nScenic application. It has four scenes, two components, and a simulated sensor.\n\n- **Splash:** The Splash scene is configured to run when the app is started in\n  the `config/config.exs` file. It runs a simple animation, then transitions to\n  the Sensor scene. It also shows how to intercept basic user input to exit the\n  scene early.\n\n- **Sensor:** The Sensor scene depicts a simulated temperature sensor. The\n  sensor is always running and updates its data through the\n  `Scenic.SensorPubSub` server.\n\n- **Primitives:** The Primitives scenes displays an overview of the basic\n  primitive types and some of the styles that can be applied to them.\n\n- **Components:** The Components scene shows the basic components that come with\n  Scenic. The crash button will cause a match error that will crash the scene,\n  showing how the supervision tree restarts the scene. It also shows how to\n  receive events from components.","ref":"getting_started.html#the-starter-app","title":"The Starter App - Getting Started","type":"extras"},{"doc":"- **Nav:** The nav bar at the top of the main scenes shows how to navigate\n  between scenes and how to construct a simple component and pass a parameter to\n  it. Note that it references a clock, creating a nested component. The clock is\n  positioned by dynamically querying the width of the ViewPort\n\n- **Notes:** The notes section at the bottom of each scene is very simple and\n  also shows passing in custom data from the parent.\n\nThe simulated temperature sensor doesn't collect any actual data, but does show\nhow you would set up a real sensor and publish data from it into the\nScenic.SensorPubSub service.","ref":"getting_started.html#components","title":"Components - Getting Started","type":"extras"},{"doc":"Next, you should read about the [structure of a scene](overview_scene.html).\nThis will explain the parts of a scene, how to send and receive messages and how\nto push the graph to the ViewPort.","ref":"getting_started.html#what-to-read-next","title":"What to read next? - Getting Started","type":"extras"},{"doc":"# Getting Started with [Nerves](https://nerves-project.org/)\n\n[Nerves](https://nerves-project.org/) is a tool chain that builds your application\ninto a minimal boot image that you can use to run on devices such as the Raspberry Pi, \nBeagleBone Black, and many more.\n\nScenic has everything you need to run on in this environment. In fact, this is the\ntype of system that Scenic was made for! When built with Nerves, the boot-image (this\nincludes Linux, Erlang, Elixir, Scenic, several fonts, etc.) is on the order of 30Mb in\nsize, which is a welcome relief.\n\nThis guide assumes you have some familiarity with [Nerves](https://nerves-project.org/).","ref":"getting_started_nerves.html","title":"Getting Started with Nerves","type":"extras"},{"doc":"The Scenic Archive is the home of the `scenic.new` mix task, which lays out a\nstarter application for you. This is the easiest way to set up a new Scenic\nproject.\n\nInstall the Scenic Archive like this\n\n```bash\nmix archive.install hex scenic_new\n```","ref":"getting_started_nerves.html#install-scenic-new","title":"Install `scenic.new` - Getting Started with Nerves","type":"extras"},{"doc":"First, navigate the command-line to the directory where you want to create your\nnew Scenic app. Then run the following commands:  (change `my_app` to the name\nof your app...)\n\n```bash\nmix scenic.new.nerves my_app\ncd my_app\n```\n\nAt this point you have a choice. Do you want to build it locally to run on your\ndev machine (device specific things won't be there or need to be emulated), or\ndo you want to build a boot image","ref":"getting_started_nerves.html#create-the-basic-nerves-app","title":"Create the Basic Nerves App - Getting Started with Nerves","type":"extras"},{"doc":"The first time you build a nerves app, you need to set the `MIX_TARGET`, which tells\nit where you intend to run your app. Then you can install the dependencies. Do that on the command line like this:\n\n```bash\nexport MIX_TARGET=host\nmix deps.get\n```\n\nThen you can run the app on your dev machine the same way you would a non-nerves app.\n\n```bash\nmix scenic.run\n```","ref":"getting_started_nerves.html#build-and-run-on-your-dev-machine","title":"Build and Run on Your Dev Machine - Getting Started with Nerves","type":"extras"},{"doc":"The first time you build a nerves app, you need to set the `MIX_TARGET`, which tells\nit where you intend to run your app. Then you can install the dependencies. When targeting\nan embedded device, you will also need to create a release file.\n\nDo that on the command line like this:\n\n```bash\nexport MIX_TARGET=rpi3\nmix deps.get\nmix compile\nmix nerves.release.init\n```\n\nThen you can build the boot image and burn it to your micro-SD card.\n\n```bash\nmix firmware.burn\n```","ref":"getting_started_nerves.html#build-and-run-on-a-raspberry-pi-3","title":"Build and Run on a Raspberry Pi 3 - Getting Started with Nerves","type":"extras"},{"doc":"At the moment, the only supported devices are Raspberry Pis. In fact, the only one I've really tested is the Raspberry Pi 3, although it should work on the others.\n\nSupport for the BeagleBone is coming, but isn't ready yet.","ref":"getting_started_nerves.html#supported-devices","title":"Supported Devices - Getting Started with Nerves","type":"extras"},{"doc":"Next, you should read about the [structure of a scene](overview_scene.html).\nThis will explain the parts of a scene, how to send and receive messages and how\nto push the graph to the ViewPort.","ref":"getting_started_nerves.html#what-to-read-next","title":"What to read next? - Getting Started with Nerves","type":"extras"},{"doc":"# Structure of a Scene\n\nA `Scenic.Scene` is a `GenServer` process which creates and manages a [Graph](overview_graph.html) that gets drawn to the screen. Scenes also respond to user input and other events.\n\nScenes can reference each other, creating a logical hierarchy that lives above\nthe Graphs themselves. This allows scenes to be reusable, small, and simple. A\nproperly designed scene should do one job, and do it well. Then it can be reused\nalong with other simple scenes to create a complex screen of UI.\n\nScenes that are specifically meant to be reused are called components.\nComponents have sugar apis that make them very easy to use inside of a parent\nscene.\n\nFor example, if you create a dashboard, it may have buttons, text input,\nsliders, or other input controls in it. Each of those controls is a component\nscene that is dynamically created when the dashboard scene is started. This\ncollection of scenes forms a graph, which can be quite deep (scenes using scenes\nusing scenes).\n\nAll these scenes communicate with each other by generating events and passing\nthem as messages. This is [explained more below](#events).\n\nThe life-cycle of scenes (when they start, stop, etc.) is explained in the\n[life-cycle of a scene](scene_lifecycle.html) guide.","ref":"overview_scene.html","title":"Structure of a Scene","type":"extras"},{"doc":"The most important state a Scene is responsible for is its Graph. The Graph\ndefines what is to be drawn to the screen, any referenced components, and the\noverall draw order. When the Scene decides the graph is ready to be drawn to the\nscreen, it pushes it to the ViewPort.\n\nIn general, a graph is an immutable data structure that you manipulate through\ntransform functions. In the example below `Graph.build()` creates an empty\ngraph, which is piped into functions that add things to it. The `text/3`\nfunction accepts a graph, adds some text to it, then applies a list of options\nto the text.\n\nThe `button/3` is similar to `text/3`. It accepts a graph, adds a button and\napplies a list of options to.\n\nText is a [Primitive](overview_primitives.html), which can be drawn directly to\nthe screen. The `text/3` helper function is imported from the\n`Scenic.Primitives` module. Button is a [component](Scenic.Components.html)\nwhose helper function is imported from the `Scenic.Components` module.\n\n      defmodule MyApp.Scene.Example do\n        use Scenic.Scene\n        alias Scenic.Graph\n        import Scenic.Primitives\n        import Scenic.Components\n\n        @graph Graph.build()\n          |> text(\"Hello World\", font_size: 22, translate: {20, 80})\n          |> button(\"Do Something\", translate: {20, 180})\n\n        def init( scene, _param, _opts ) do\n          scene = push_graph( scene, @graph )\n          {:ok, scene}\n        end\n\n        ...\n\n      end\n\nIf you can, **build your graphs at compile time instead of at run time**. This\nboth reduces load/power use on the device and surfaces any errors early instead\nof when the device is in use. In the example above, the graph is built at\ncompile time by assigning it to the module attribute `@graph`. You can read more\nabout module attributes in [Elixir's module attribute\ndocumentation](https://elixir-lang.org/getting-started/module-attributes.html).\n\nIn the above example, the graph is pushed to the ViewPort during the `init/2`\ncallback function.\n\nThere is more detail on how to build and manipulate Graph data in the [Graph\nOverview](overview_graph.html).","ref":"overview_scene.html#the-graph","title":"The Graph - Structure of a Scene","type":"extras"},{"doc":"The only required callback a Scene must implement is `init/3`. This function is\ncalled when the scene is started and is where you should initialize your state.\nPushing the graph here is optional, but recommended. If you wait too long to\nbuild and push your first graph, the user will see a blank space or screen until\nyou are ready.\n\nNote that a Scene's state is always a %Scenic.Scene{} struct. Just like Socket in\nphoenix, it has an `:assigns` field that is used to store your state\n\n    def init( scene, _param, _opts ) do\n      graph =  @graph\n\n      scene =\n        scene\n        |> assign( graph: graph, my_value: 123 )\n        |> push_graph( graph )\n\n      {:ok, scene}\n    end\n\nThe second argument, `param`, is any term that you pass to your scene when\nyou reference it or otherwise configure it in the ViewPort. Look at an example\nconfiguration of a ViewPort from the config.exs file...\n\n      import Config\n\n      # Configure the main viewport for the Scenic application\n      config :my_app, :viewport, [\n            name: :main_viewport,\n            size: {700, 600},\n            default_scene: {MyApp.Scene.Example, :scene_init_data},\n            drivers: [\n              [\n                module: Scenic.Driver.Local,\n                name: :local,\n                window: [resizeable: false, title: \"Example Application\"],\n              ]\n            ]\n          ]\n\nThe line `default_scene: {MyApp.Scene.Example, :scene_init_data}`\nconfigures the ViewPort to always start the scene defined by the\n`MyApp.Scene.Example` module and to pass in `:scene_init_data` as the\n`param` argument of its `init/3` function.\n\nThat `:scene_init_data` term could be any data structure you want. It will be\npassed to the scene's `init/3` function unchanged.\n\nThe `opts` parameter is a Keyword list of contextual/optional data that\nis generated by the ViewPort and passed to your scene. The main options are:\n\noption      | description\n----------- | -----------\n`:id`       | If this scene is a component, then the id that was assigned to its reference in the parent's graph is passed in as the `:id` option. Typically, controls that generate and send events to its parent scene use this id to identify themselves. If this is the root scene, the id will not be set.","ref":"overview_scene.html#initialization","title":"Initialization - Structure of a Scene","type":"extras"},{"doc":"A Scene also responds to messages. The two types of messages Scenic will send to\nthe scene are user input and events.\n\nInput is usually comes from the driver, such as mouse clicks and key presses, it\ncan be handled with `c:Scenic.Scene.handle_input/3`.\n\nMessages are generally sent from child components (such as a button) and can be\nhandled with `c:Scenic.Scene.handle_event/3`.","ref":"overview_scene.html#user-input","title":"User Input - Structure of a Scene","type":"extras"},{"doc":"You are free to send your own messages to scenes just as you would with any\nother GenServer process. You can use the `handle_info/2`, `handle_cast/2` and\n`handle_call/3` callbacks as you would normally.","ref":"overview_scene.html#events","title":"Events - Structure of a Scene","type":"extras"},{"doc":"Components are simply scenes with a little extra sugar added to make them easy\nto use from within another scene. To make a component, call the\n`use Scenic.Component` macro instead of the Scene version.\n\nYou will then need to add `info/0` and `verify/1` callbacks. The `verify/1`\naccepts the `scene_args` parameter that will be passed to the `init/2` function\nand verifies that it is correctly formatted. If it is correct, return\n`{:ok, data}`. If it is not ok, return `:invalid_data`.\n\nIn the event that `verify/1` returns `:invalid_data`, then the `info/1` callback\nis called to get a bitstring describing useful information to the developer.\nThis will be included in the error that gets raised.\n\n      defmodule MyApp.MyComponent do\n        use Scenic.Component\n        import Scenic.Primitives, only: [{:text, 3}, {:update_opts, 2}]\n\n        def verify( text ) when is_bitstring(text), do: {:ok, text}\n        def verify( _ ), do: :invalid_data\n\n        def init( scene, text, opts ) do\n\n          # modify the already built graph\n          graph = Graph.build()\n            |> text(\"\", text_align: :center, translate: {100, 200}, id: :text)\n\n          scene =\n            scene\n            |> assign( graph: graph, my_value: 123 )\n            |> push_graph( graph )\n\n          {:ok, scene}\n        end\n\n        ...\n\n      end\n\nOther than verifying the incoming information, Components work the same as any\nother scene.","ref":"overview_scene.html#components","title":"Components - Structure of a Scene","type":"extras"},{"doc":"You can add a component (like the one above) to a scene's graph via the\n`add_to_graph/3` public function that is added to your component via the `use\nScenic.Component` macro.\n\n      defmodule MyApp.Scene.ExampleScene do\n        @graph Graph.build()\n        |> MyApp.MyComponent.add_to_graph(:init_data, translate: {10, 20})\n        ...\n      end\n\nThe first time this graph is submitted to the ViewPort via `push_graph/1`, that\nwill trigger the [life-cycle](scene_lifecycle.html) management of the\n`MyApp.MyComponent` scene process.\n\nIf this is a component you intend to make available to other developers, then\nyou should also create a helper function to make this more compact. Look at the\nsource code for the `Scenic.Components` module for examples. This entire module\nis a collection of helper functions whose job is to provide sugary access to the\nbasic components' `add_to_graph/3` functions.\n\nWith helper functions, the above graph would be re-written like this:\n\n        @graph Graph.build()\n        |> my_component( :init_data, translate: {10, 20} )","ref":"overview_scene.html#adding-components-to-a-parent-scene","title":"Adding Components to a Parent Scene - Structure of a Scene","type":"extras"},{"doc":"Next, you should read about the [life-cycle of a scene](scene_lifecycle.html).\nThis will explain how scenes get started, when they stop, and how they relate to\neach other.","ref":"overview_scene.html#what-to-read-next","title":"What to read next? - Structure of a Scene","type":"extras"},{"doc":"# Life-cycle of a Scene\n\nA very important part of Scenic is the Scene life-cycle management. Most scenes' life-cycles will be managed automatically by their [ViewPort](overview_viewport.html). The ViewPort determines when to start and stop these dynamic scenes.\n\nIn effect, when you create a graph and add components like `button`, `checkbox` and more, you are doing more than just saying, \"Draw a button here\". You are instructing the `ViewPort` how and when to start and stop the processes that drive those components.","ref":"scene_lifecycle.html","title":"Life-cycle of a Scene","type":"extras"},{"doc":"This process starts when you set a root scene into the ViewPort. This is first done when you configure your ViewPort in `config.exs`\n\n      config :my_app, :viewport, %{\n        name: :main_viewport,\n        size: {700, 600},\n        default_scene: {MyApp.Scene.MyFancyScene, :some_init_data},\n        ...\n      }\n\nIn the above configuration, when Scenic first starts up, it will start the configured ViewPort. This ViewPort will, in turn, start up the scene defined in the module `MyApp.Scene.MyFancyScene` and pass in `:some_init_data` as the first parameter to its `init/2` function.\n\nAfterwards, you can dynamically change the root scene by calling `Scenic.ViewPort.set_root/3`. Both ways of setting the root scene effectively do the same thing.","ref":"scene_lifecycle.html#the-root-scene","title":"The Root Scene - Life-cycle of a Scene","type":"extras"},{"doc":"As `MyApp.Scene.MyFancyScene` initializes, it eventually calls its `push_graph/1` function.\n\nWhen a scene calls `push_graph/1`, the primitives in the graph are sent out for rendering and the components in the graph are started or stopped as needed.\n\nTo say it another way, when you reference components like `button`, `checkbox` and the others, you are programming the supervision tree for your scene.\n\nYour scene has an internal `DynamicSupervisor`, which supervises these dynamic scenes that you asked for in your graph. Each of these can also have a dynamic supervisor and spin up more scenes in a nested tree.\n\nAt some point, depending on your target processor, you will start to have performance issues if you nest too many components too deeply.\n\nThe good news is that as you switch away to different root scenes, all the old components are automatically cleaned up for you.","ref":"scene_lifecycle.html#dynamically-supervised-scenes","title":"Dynamically Supervised Scenes - Life-cycle of a Scene","type":"extras"},{"doc":"If you are exploring Scenic, then you should read the [Graph Overview](overview_graph.html) next.","ref":"scene_lifecycle.html#what-to-read-next","title":"What to read next? - Life-cycle of a Scene","type":"extras"},{"doc":"# Graph Overview\n\nThe most important state a Scene is responsible for is its Graph. The Graph\ndefines what is to be drawn to the screen, any referenced components, and the\noverall draw order. When a Scene decides the graph is ready to be drawn to the\nscreen, it pushes it to the ViewPort.\n\nGraphs are made out of a handful of primitives, each of which knows how to draw\none thing. When multiple primitives are put together, almost any standard UI can be drawn.\n\nFor example, the graph below shows the words \"Hello World\" around them.\n\n    @graph Graph.build(font: :roboto, font_size: 24)\n      |> text(\"Hello World\", text_align: :center, translate: {300, 300})\n      |> circle(100, stroke: {2, :green}, translate: {300, 300})\n\nIn the example above, the first line creates a new graph and assigns two font styles to its root. The next two lines form a pipeline that adds primitives to the root\nnode of the new graph. Each of these primitives also assigns styles.","ref":"overview_graph.html","title":"Graph Overview","type":"extras"},{"doc":"There is a fixed set of primitives that Scenic knows how to draw. These form the base set of things that you can do. While they seem simple, when combined you draw pretty much any 2D UI that you need.\n\n[Read more about the primitives here.](overview_primitives.html)\n\nIn general, each primitive renders one thing to the screen. The Group primitive is\nsort of like a ` ` tag in html in that it creates a new node in the graph hierarchy that more primitives can be organized beneath.\n\nEach primitive can also be assigned styles and transforms, which affect how (or whether) they are drawn and where.","ref":"overview_graph.html#primitives","title":"Primitives - Graph Overview","type":"extras"},{"doc":"In addition to the fixed set of primitives, there is also a fixed set of primitive styles. (Some components support more styles, but they really get boiled down to the primitive styles when it is time to render)\n\n[Read more about the styles here.](overview_styles.html)\n\nStyles are inherited down the graph hierarchy. This means that if you set a style on the root of a graph, or in a group, then any primitives below that node inherit those styles without needing to explicitly set them on every single primitive.\n\nFor example, in the following graph, the font and font_size styles are set at the root. Both text primitives inherit those values, although the second one overrides the size with something bigger.\n\n    @graph Graph.build(font: :roboto, font_size: 24)\n      |> text(\"Hello World\", translate: {300, 300})\n      |> text(\"Bigger Hello\", font_size: 40, translate: {400, 300})","ref":"overview_graph.html#styles","title":"Styles - Graph Overview","type":"extras"},{"doc":"The final type of primitive control is transforms. Unlike html, which uses auto-layout to position items on the screen, Scenic moves primitives around using matrix transforms. This is common in video games and provides powerful control of your primitives.\n\nA [matrix](https://en.wikipedia.org/wiki/Matrix_(mathematics)) is an array of numbers that can be used to change the positions, rotations, scale and more of locations.\n\n**Don't worry!** You will not need to look at any matrices unless you want to get fancy. In Scenic, you will rarely (if ever) create matrices on your own (you can if you know what you are doing!), and will instead use the transform helpers.\n\n[You can read about the transform types here.](overview_transforms.html)\n\nTransforms are inherited down the graph hierarchy. This means that if you place a rotation transform at the root of a graph, then all the primitives will be rotated around a common point.\n\nIf you want to zoom in, scroll, or rotate a UI, or just pieces of the UI, you can do that very easily by applying transforms.\n\nIn the example below, the first text line is translated, and the second is scaled bigger, and the whole graph rotated 0.4 radians.\n\n    @graph Graph.build(font: :roboto, font_size: 24, rotate: 0.4)\n      |> text(\"Hello World\", translate: {300, 300})\n      |> text(\"Bigger Hello\", font_size: 40, scale: 1.5)","ref":"overview_graph.html#transforms","title":"Transforms - Graph Overview","type":"extras"},{"doc":"Scenic was written specifically for Erlang/Elixir, which is a functional programming model with immutable data.\n\nAs such, once you make a graph, it stays in memory unchanged - until you change it via `Graph.modify/3`. Technically you never change it (that's the immutable part), instead Graph.modify returns a new graph with different data in it.\n\n[Graph.modify/3](Scenic.Graph.html#modify/3) is the single Graph function that you will use the most.\n\nFor example, lets go back to our graph with the two text items in it.\n\n    @graph Graph.build(font: :roboto, font_size: 24, rotate: 0.4)\n      |> text(\"Hello World\", translate: {300, 300}, id: :small_text)\n      |> text(\"Bigger Hello\", font_size: 40, scale: 1.5, id: :big_text)\n\nThis time, we've assigned ids to both of the text primitives. This makes it easy to find and modify that primitive in the graph.\n\n    graph =\n      @graph\n      |> Graph.modify( :small_text, &text(&1, \"Smaller Hello\", font_size: 16))\n      |> Graph.modify( :big_text, &text(&1, \"Bigger Hello\", font_size: 60))\n\nNotice that the graph is modified multiple times in the pipeline.","ref":"overview_graph.html#modifying-a-graph","title":"Modifying a graph - Graph Overview","type":"extras"},{"doc":"If you are exploring Scenic, then you should read the [Primitives Overview](overview_primitives.html) next.","ref":"overview_graph.html#what-to-read-next","title":"What to read next? - Graph Overview","type":"extras"},{"doc":"# ViewPort Overview\n\nGive an overview of a viewport here\n\nComing soon","ref":"overview_viewport.html","title":"ViewPort Overview","type":"extras"},{"doc":"# Driver Overview\n\nDrivers live at the bottom of the scenic stack. Drivers know nothing about the scenes you are running. They receive compiled scripts and assets from the viewport and are responsible for rendering them into pretty pictures on the screen.\n\nDrivers also receive input from the user and send that into the ViewPort for processing.","ref":"overview_driver.html","title":"Driver Overview","type":"extras"},{"doc":"In Scenic v0.11 the main driver you use to render locally (meaning on a screen attached to the same computer your app is running on) is the `:scenic_driver_local`.\n\nIn older versions of Scenic, you used a glfw specific driver to render on a Mac/PC/Linux machine and a separate driver to render on Nerves. These drivers were 95% the same and only really differed in how it initialized the graphics sub systems.\n\nThis create a situation that was difficult to maintain and difficult to explain.\n\nThese drivers have been combined into a new driver that covers both scenarios. So you can use `:scenic_driver_local` on Mac, PC, Linux, and Nerves.","ref":"overview_driver.html#scenic-driver-local","title":"Scenic.Driver.Local - Driver Overview","type":"extras"},{"doc":"The configuration options for `:scenic_driver_local` are similar to, but not the same as, those for the previous drivers. This is because as a unified driver, we can't make certain assumptions.\n\nFor example, the window title, or whether or not it is resizable has no meaning on an embedded device, but is still used on a PC.\n\nAnother example is that the actions it should take when the driver closes is different. An embedded device should always do its best to stay running, whereas closing the window on a Mac should probably cause it to stop the app.\n\nYou will need to make a few config tweaks.\n\nThere are a few new options that probably make more sense on an embedded device but are very cool... You can now rotate the UI, scale it to fit a screen, center it, etc, just by setting config options.\n\nThis is an example of a config (which is in turn part of a ViewPort config) that is oriented toward running on a Mac/PC/Linux machine.\n\n```elixir\n[\n  module: Scenic.Driver.Local,\n  window: [title: \"Local Window\", resizeable: true],\n  on_close: :stop_system\n]\n```\n\nThis is an example of a embedded style config.\n\n```elixir\n[\n  module: Scenic.Driver.Local,\n  position: [scaled: true, centered: true, orientation: :normal]\n],\n```\n\nPlease see the docs for `:scenic_driver_local` for the full set of options.","ref":"overview_driver.html#configuration-of-scenic-driver-local","title":"Configuration of Scenic.Driver.Local - Driver Overview","type":"extras"},{"doc":"# Styles Overview\n\nStyles are optional modifiers that you can put on any primitive. Each style does a specific thing and some only affect certain primitives.\n\nThere is a fixed list of primitive styles which are understood by the drivers. Some Components may introduce their own optional styles, but the only ones sent down to the drivers for rendering are contained in the list below.\n\nIn general, the primitive styles are each defined in their own module, but you apply them as options in a primitive's option list.\n\nFor example, to use the style defined in the module Scenic.Primitive.Style.Font you would define an option on a text primitive like this:\n\n    graph =\n      Graph.build\n      |> text( \"Styled Text\", font: :roboto_mono )\n      |> text( \"Custom Text\", font: \"fonts/my_font.ttf\" )","ref":"overview_styles.html","title":"Styles Overview","type":"extras"},{"doc":"* [`Cap`](Scenic.Primitive.Style.Cap.html) sets how to draw the end of a line.\n* [`Fill`](Scenic.Primitive.Style.Fill.html) fills in a primitive with a [paint style](overview_styles.html#primitive-paint-styles).\n* [`Font`](Scenic.Primitive.Style.Font.html) sets the font to use to draw text.\n* [`FontSize`](Scenic.Primitive.Style.FontSize.html) sets the point size text.\n* [`Hidden`](Scenic.Primitive.Style.Hidden.html) a flag that sets if a primitive is drawn at all.\n* [`Input`](Scenic.Primitive.Style.Input.html) send cursor related input to your scene when the cursor is over the primitve.\n* [`Join`](Scenic.Primitive.Style.Join.html) sets how to render the intersection of two lines. Works on the intersections of other primitives as well.\n* [`LineHeight`](Scenic.Primitive.Style.LineHeight.html) adjust the vertical distance between lines of text. Works similar to line height in css.\n* [`MiterLimit`](Scenic.Primitive.Style.MiterLimit.html) sets whether or not to miter a joint if the intersection of two lines is very sharp.\n* [`Scissor`](Scenic.Primitive.Style.Scissor.html) defines a rectangle that drawing will be clipped to.\n* [`Stroke`](Scenic.Primitive.Style.Stroke.html) defines how to draw the edge of a primitive. Specifies both a width and a [paint style](overview_styles.html#primitive-paint-styles).\n* [`TextAlign`](Scenic.Primitive.Style.TextAlign.html) sets the horizontal alignment of text relative to the starting point. Examples: :left, :center, or :right\n* [`TextBase`](Scenic.Primitive.Style.TextBase.html) sets the vertical alignment of text relative to the starting point. Examples: :top, :middle, :alphabetic, or :bottom\n* [`Theme`](Scenic.Primitive.Style.Theme.html) a collection of default colors. Usually passed to components, telling them how to draw in your preferred color scheme.","ref":"overview_styles.html#primitive-styles","title":"Primitive Styles - Styles Overview","type":"extras"},{"doc":"The `Fill` and `Stroke` styles accept a paint type. This describes what to fill or stroke the primitive with.\n\nThere is a fixed set of paint types that the drivers know how to render.\n\n* [`Color`](Scenic.Primitive.Style.Paint.Color.html) fills a primitive with a solid color. \n* [`Image`](Scenic.Primitive.Style.Paint.Image.html) fills a primitive with an image that is loaded into `Scenic.Cache`.\n* [`LinearGradient`](Scenic.Primitive.Style.Paint.LinearGradient.html) fills a primitive with a linear gradient.\n* [`RadialGradient`](Scenic.Primitive.Style.Paint.RadialGradient.html) fills a primitive with a radial gradient.\n* [`Stream`](Scenic.Primitive.Style.Paint.Stream.html) fills a primitive with a streaming image.","ref":"overview_styles.html#primitive-paint-styles","title":"Primitive Paint Styles - Styles Overview","type":"extras"},{"doc":"When you use either the `Fill` and `Stroke` you specify the paint in a tuple like this.\n\n    graph =\n      Graph.build\n      |> circle( 100, fill: {:color, :green}, stroke: {2, {:color, :blue}} )\n\nEach paint type has specific values it expects in order to draw. See the documentation for that paint type for details.","ref":"overview_styles.html#specifying-paint","title":"Specifying Paint - Styles Overview","type":"extras"},{"doc":"Specifying a solid color to paint is very common, so has a shortcut. If you simply set a valid color as the paint type, it is assumed that you mean `Color`.\n\n    graph =\n      Graph.build\n      |> circle( 100, fill: :green, stroke: {2, :blue} )  # simple color\n      |> rect( {100, 200}, fill: {:green, 128} )          # color with alpha\n      |> rect( {100, 100}, fill: {10, 20, 30, 40} )       # red, green, blue, alpha","ref":"overview_styles.html#color-paint","title":"Color Paint - Styles Overview","type":"extras"},{"doc":"If you are exploring Scenic, then you should read the [Transforms Overview](overview_transforms.html) next.","ref":"overview_styles.html#what-to-read-next","title":"What to read next? - Styles Overview","type":"extras"},{"doc":"# Transforms Overview\n\nUnlike html, which uses auto-layout to position items on the screen, Scenic moves primitives around using matrix transforms. This is common in video games and provides powerful control of your primitives.\n\nA [matrix](https://en.wikipedia.org/wiki/Matrix_(mathematics)) is an array of numbers that can be used to change the positions, rotations, scale and more of locations.\n\n**Don't worry!** You will not need to look at any matrices unless you want to get fancy. In Scenic, you will rarely (if ever) create matrices on your own (you can if you know what you are doing!), and will instead use the transform helpers.\n\nMultiple transforms can be applied to any primitive. Transforms combine down the graph to create a very flexible way to manage your scene.\n\nThere are a fixed set of transform helpers that create matrices for you.\n\n* [`Matrix`](Scenic.Primitive.Transform.Matrix.html) hand specify a matrix.\n* [`Pin`](Scenic.Primitive.Transform.Pin.html) set a pin to rotate or scale around. Most primitives define a sensible default pin.\n* [`Rotate`](Scenic.Primitive.Transform.Rotate.html) rotate around the pin.\n* [`Scale`](Scenic.Primitive.Transform.Scale.html) scale larger or smaller. Centered around the pin.\n* [`Translate`](Scenic.Primitive.Transform.Translate.html) move/translate horizontally and vertically.","ref":"overview_transforms.html","title":"Transforms Overview","type":"extras"},{"doc":"You apply transforms to a primitive the same way you specify styles.\n\n    graph =\n      Graph.build\n      |> circle( 100, fill: {:color, :green}, translate: {200, 200} )\n      |> ellipse( {40, 60, fill: {:color, :red}, rotate: 0.4, translate: {100, 100} )\n\nDon't worry about the order you apply transforms to a single object. Scenic will multiply them together in the correct way when it comes time to render them.","ref":"overview_transforms.html#specifying-transforms","title":"Specifying Transforms - Transforms Overview","type":"extras"},{"doc":"If you are exploring Scenic, then you should read the [ViewPort Overview](overview_viewport.html) next.","ref":"overview_transforms.html#what-to-read-next","title":"What to read next? - Transforms Overview","type":"extras"},{"doc":"# Primitives Overview\n\nPrimitives are the simplest thing that Scenic know how to draw to the screen. Everything that you see in a Scenic application is drawn by combining multiple primitives together to make complex UIs.\n\nThere is a fixed set of primitives. This simplifies the internals of Scenic, particularly when it comes to communicating to the drivers. New primitives may be added in the future, but those require serious thought and coordination.\n\n* [`Arc`](Scenic.Primitive.Arc.html) draws an arc. This would be a line cut out of a part of the edge of a circle. If you want a shape that looks like a piece of pie, then you should use the [`Sector`](Scenic.Primitive.Sector.html).\n* [`Circle`](Scenic.Primitive.Circle.html) draws a circle. \n* [`Component`](Scenic.Primitive.Component.html) doesn't draw anything by itself. Instead starts a component (another scene) and tells it where to draw.\n* [`Ellipse`](Scenic.Primitive.Ellipse.html) draws an ellipse.\n* [`Group`](Scenic.Primitive.Group.html) doesn't draw anything. Instead, it creates a node in the graph that you can insert more primitives into. Any styles or transforms you apply to the Group are inherited by all the primitives below it.\n* [`Line`](Scenic.Primitive.Line.html) draws a line.\n* [`Path`](Scenic.Primitive.Path.html) is sort of an escape valve for complex shapes not covered by the other primitives. You supply a list of instructions, such as :move_to, :line_to, :bezier_to, etc. to generate a complex shape.\n* [`Quad`](Scenic.Primitive.Quad.html) draws polygon with four sides.\n* [`Rectangle`](Scenic.Primitive.Rectangle.html) draws a rectangle.\n* [`RoundedRectangle`](Scenic.Primitive.RoundedRectangle.html) draws a rectangle with the corners rounded by a given radius.\n* [`Script`](Scenic.Primitive.Script.html) draws a pre-build script.\n* [`Sector`](Scenic.Primitive.Sector.html) draws a shape that looks like a piece of pie. If you want to stroke just the curved edge, then combine it with an [`Arc`](Scenic.Primitive.Arc.html).\n* [`Sprites`](Scenic.Primitive.Sprites.html) draws one or more sub-images from a single source image.\n* [`Text`](Scenic.Primitive.Text.html) draws a string of text.\n* [`Triangle`](Scenic.Primitive.Triangle.html) draws a triangle.","ref":"overview_primitives.html","title":"Primitives Overview","type":"extras"},{"doc":"The easiest way to insert primitives into your graph is to import the functions in `Scenic.Primitives` into your scene module. This adds a helper function for each primitive that you can use in a pipeline to build a graph.\n\n      defmodule MyApp.Scene.Example do\n        use Scenic.Scene\n        alias Scenic.Graph\n        import Scenic.Primitives\n\n        @graph Graph.build(font: :roboto, font_size: 22)\n          |> text(\"Hello World\", text_align: :center, translate: {300, 350})\n          |> circle(150, fill: :green, translate: {300, 350})\n\n        ...\n\n      end\n\nIn the example above, the scene calls `import Scenic.Primitives`, which imports helpers for all the primitives. Since the graph only uses text and circle, you could save a tiny bit of memory by just importing what you need.\n\n        import Scenic.Primitives, only: [{:text,3}, {:circle, 3}]\n\nOnce the helpers are imported, you call each call appends a primitive to the graph.","ref":"overview_primitives.html#using-primitives","title":"Using Primitives - Primitives Overview","type":"extras"},{"doc":"In addition to the fixed set of primitives, there is also a fixed set of primitive styles. (Some components support more styles, but they really get boiled down to the primitive styles when it is time to render)\n\n[Read more about the styles here.](overview_styles.html)\n\nStyles are inherited down the graph hierarchy. This means that if you set a style on the root of a graph, or in a group, then any primitives below that node inherit those styles without needing to explicitly set them on every single primitive.\n\nFor example, in the following graph, the font and font_size styles are set at the root. Both text primitives inherit those values, although the second one overrides the size with something bigger.\n\n    @graph Graph.build(font: :roboto, font_size: 24)\n      |> text(\"Hello World\", translate: {300, 300})\n      |> text(\"Bigger Hello\", font_size: 40, translate: {400, 300})","ref":"overview_primitives.html#styles","title":"Styles - Primitives Overview","type":"extras"},{"doc":"The final type of primitive control is transforms. Unlike html, which uses auto-layout to position items on the screen, Scenic moves primitives around using matrix based transforms. This is common in video games and provides powerful control of your primitives.\n\nA [matrix](https://en.wikipedia.org/wiki/Matrix_(mathematics)) is an array of numbers that can be used to change the positions, rotations, scale and more of locations.\n\n**Don't worry!** You will not need to look at any matrices unless you want to get fancy. In Scenic, you will rarely (if ever) create matrices on your own (you can if you know what you are doing!), and will instead use the transform helpers.\n\n[You can read about the transform types here.](overview_transforms.html)\n\nTransforms are inherited down the graph hierarchy. This means that if you place a rotation transform at the root of a graph, then all the primitives will be rotated around a common point.\n\nIf you want to zoom in, scroll, or rotate a UI, or just pieces of the UI, you can do that very easily by applying transforms.\n\nIn the example below, the first text line is translated, and the second is scaled bigger, and the whole graph rotated 0.4 radians.\n\n    @graph Graph.build(font: :roboto, font_size: 24, rotate: 0.4)\n      |> text(\"Hello World\", translate: {300, 300})\n      |> text(\"Bigger Hello\", font_size: 40, scale: 1.5)","ref":"overview_primitives.html#transforms","title":"Transforms - Primitives Overview","type":"extras"},{"doc":"Scenic was written specifically for Erlang/Elixir, which is a functional programming model with immutable data.\n\nAs such, once you make a graph, it stays in memory unchanged - until you change it via `Graph.modify/3`. Technically you never change it (that's the immutable part), instead Graph.modify returns a new graph with different data in it.\n\n    @graph Graph.build(font: :roboto, font_size: 24, rotate: 0.4)\n      |> text(\"Hello World\", translate: {300, 300}, id: :small_text)\n      |> text(\"Bigger Hello\", font_size: 40, scale: 1.5, id: :big_text)\n\nIn the above graph, we've assigned `:id` values to both primitives. This makes it easy to find and modify that primitive in the graph. `Graph.modify/3` is very fast at finding primitives marked with an `:id`. If you marked multiple primitives withe `id: :small_text`, then they would all be modified by the call to  `Graph.modify/3`\n\n    graph =\n      @graph\n      |> Graph.modify( :small_text, &text(&1, \"Smaller Hello\", font_size: 16))\n      |> Graph.modify( :big_text, &text(&1, \"Bigger Hello\", font_size: 60))\n\nNotice that the graph is modified multiple times in the pipeline.\n\nThe last parameter to `Graph.modify/3` is a pointer to a function that receives a primitive and returns the new primitive that should be inserted in its place.\n\nThe following is the same as one of the calls above, but in expanded form to make it easier to see what is going on\n\n    graph = Graph.modify( graph, :small_text, fn(primitive) ->\n      text(primitive, \"Smaller Hello\", font_size: 16)\n    end)","ref":"overview_primitives.html#modifying-a-primitive","title":"Modifying a Primitive - Primitives Overview","type":"extras"},{"doc":"If you are exploring Scenic, then you should read the [Styles Overview](overview_styles.html) next.","ref":"overview_primitives.html#what-to-read-next","title":"What to read next? - Primitives Overview","type":"extras"},{"doc":"# Assets Overview\n\nThe assets system has been completely overhauled as of Scenic v0.11. \n\nAny good-looking UI is a combination of vector drawing via primitives and/or scripts and assets. Assets are the fonts, images, or other types of art that are displayed to the user. These tend to be standard formats, such as a .jpg, .png, or .ttf files.\n\nWe can split the world of assets into two categories. These are Static and Streaming assets. Static assets, as the name implies, are set up in advance and never change. They are cache-able, both in memory and via servers. Streaming assets, on the other hand, change over time. They are named, but not cache-able.","ref":"overview_assets.html","title":"Assets Overview","type":"extras"},{"doc":"The new static asset pipeline is designed to feel familiar to the Phoenix static asset system. With a bit of configuration, you end up with an \"assets\" directory in your project directory. The supported files in this directory\nare \"built\" during the compilation process and automatically end up as hashed files that can be loaded at run time.\n\nThe Static Assets Library consists of several parts\n  * An asset module that you create in your project. This is where the actual library is stored and built.\n  * A source directory that contains the assets you want to use in your project.\n  * A config.exs item that links Scenic to you Assets module.\n\n\nOnce those pieces are configured, then your assets are built when you compile your application. You can add more assets by simply dropping them into the assets directory. Note, they must be one of the supported types.\n\nExample directory structure\n```\nmy_cool_project\n  assets\n    fonts\n      custom_font.ttf\n      another_font.ttf\n    images\n      parrot.jpg\n```\n\nExample Assets Module\n```elixir\ndefmodule MyApplication.Assets do\n  use Scenic.Assets.Static,\n    otp_app: :my_application,\n    alias: [\n      parrot: \"images/parrot.jpg\"\n    ]\nend\n\n```\n\nExample config\n```elixir\nconfig :scenic, :assets, module: MyApplication.Assets\n```\n\nExample use in a Scene\n```elixir\nGraph.build()\n  |> text( \"Some Text\", font: \"fonts/custom_font.ttf\" )\n  |> rect( {100, 200}, fill: {:image, \"images/parrot.jpg\"} )\n  |> rect( {100, 200}, fill: {:image, :parrot} )                # uses the alias set up in MyApplication.Assets\n```\n\nBoth of the rectangles in the above example render the same image. One uses a string that gives the local path in your assets folder. The other uses an alias that is configured to point to the same image in the Assets Module.","ref":"overview_assets.html#static-assets","title":"Static Assets - Assets Overview","type":"extras"},{"doc":"Several things happen under the covers when you build your project\n1) The use Scenic.Assets.Static part of your Assets module, activates some code that scans your assets directory - looking for assets of known types.\n2) It computes a cryptographic hash for asset, parses out metadata, and builds a library of metadata and hashes.\n3) That library is stored as a term in Assets module.\n4) The contents of the assets file is copied into a new file in your build directory. The name of that file is the bin-hex of the computed hash.\n\nIf you want to see the contents of your asset library, you can get to it like this:\n\n```elixir\nMyApplication.Assets.library()\n\n# or\n\nScenic.Assets.Static.library()\n```\n\nWhen you add new assets to your assets directory, you need to kick off this process by touching your assets module. Add a return or a space or something. Eventually, we will have a file watcher that does this for you.","ref":"overview_assets.html#under-the-covers","title":"Under the covers - Assets Overview","type":"extras"},{"doc":"What used to be called the `Scenic.Cache.Dynamic`, is now Scenic.Assets.Stream and Scenic.Assets.Stream.Texture. This is for images that you generate on the fly (charts, bit rendered game screens, rotating colors, etc...) or frames that you capture live from a camera.\n\nThe goal is to separate the source of these images from the consumers (the drivers) in a way that is latency/bandwidth friendly and is easy to use.\n\nThe `Scenic.Assets.Stream` module is a process/api that manages an `:ets` table of streaming assets. This allows a camera to capture frames at whatever rate makes sense for it and to put them into the table when it sees fit. This data is then distributed to any listening drivers, who can do the right thing with it.\n\nExample camera source - ( from some camera source... tbd by developer... )\n```elixir\ndef handle_info( {:camera_0, texture}, state ) do\n  :ok = Stream.put( \"camera_0\", texture )\nend\n```\n\nExample use in a Scene\n```elixir\nGraph.build()\n  |> rect( {100, 200}, fill: {:stream, \"camera_0\"} )\n```","ref":"overview_assets.html#streaming-assets","title":"Streaming Assets - Assets Overview","type":"extras"},{"doc":"# Contributor Code of Conduct\n\nAs contributors and maintainers of this project, and in the interest of\nfostering an open and welcoming community, we pledge to respect all people who\ncontribute through reporting issues, posting feature requests, updating\ndocumentation, submitting pull requests or patches, and other activities.\n\nWe are committed to making participation in this project a harassment-free\nexperience for everyone, regardless of the level of experience, gender, gender\nidentity and expression, sexual orientation, disability, personal appearance,\nbody size, race, ethnicity, age, religion, or nationality.\n\nExamples of unacceptable behavior by participants include:\n\n* The use of sexualized language or imagery\n* Personal attacks\n* Trolling or insulting/derogatory comments\n* Public or private harassment\n* Publishing other's private information, such as physical or electronic\n  addresses, without explicit permission\n* Other unethical or unprofessional conduct.\n\nProject maintainers have the right and responsibility to remove, edit, or reject\ncomments, commits, code, wiki edits, issues, and other contributions that are\nnot aligned to this Code of Conduct. By adopting this Code of Conduct, project\nmaintainers commit themselves to fairly and consistently applying these\nprinciples to every aspect of managing this project. Project maintainers who do\nnot follow or enforce the Code of Conduct may be permanently removed from the\nproject team.\n\nThis code of conduct applies both within project spaces and in public spaces\nwhen an individual is representing the project or its community.\n\nInstances of abusive, harassing or otherwise unacceptable behavior may be\nreported by opening an issue or contacting one or more of the project\nmaintainers.\n\nThis Code of Conduct is adapted from the [Contributor\nCovenant](http://contributor-covenant.org), version 1.2.0, available at\n[http://contributor-covenant.org/version/1/2/0/](http://contributor-covenant.org/version/1/2/0/)","ref":"code_of_conduct.html","title":"Contributor Code of Conduct","type":"extras"},{"doc":"# Contributing to Scenic\n\nPlease take a moment to review this document in order to make the contribution\nprocess easy and effective for everyone involved! Also, make sure you read our\n[Code of Conduct](CODE_OF_CONDUCT.md) that outlines our commitment towards an\nopen and welcoming environment.","ref":"contributing.html","title":"Contributing to Scenic","type":"extras"},{"doc":"There are many components that could be written and shared with the community.\nOnly a few really core ones should be in the Scenic package itself. If you have\nideas for components, I would love the see the community supply optional\npackages of them for developers to use.\n\nEach component package should have the component models themselves, and a\n\"Components\" module that contains helper functions to make adding the new\ncomponents very simple.\n\nSee the code for `Scenic.Components` for example helper functions.","ref":"contributing.html#components","title":"Components - Contributing to Scenic","type":"extras"},{"doc":"Use the issues tracker for:\n\n* [Bug Reports](#bug-reports)\n* [Submitting Pull Requests](#pull-requests)\n\nPlease **do not** use the issue tracker for personal support requests nor\nfeature requests. Support requests should be sent to:\n\nStill working on this bit...\n\nFor now, please play around with it. I would gladly accept help documenting it.\n\nOver the coming weeks, I'll set up discussion mailing lists and whatever. Simply\nhaven't gotten there yet.\n\n\nWe do our best to keep the issue tracker tidy and organized, making it useful\nfor everyone. For example, we classify open issues per perceived difficulty,\nmaking it easier for developers to [contribute to Scenic](#pull-requests).","ref":"contributing.html#using-the-issue-tracker","title":"Using the issue tracker - Contributing to Scenic","type":"extras"},{"doc":"A bug is either a _demonstrable problem_ that is caused by the code in the\nrepository or indicate missing, unclear, or misleading documentation. Good bug\nreports are extremely helpful - thank you!\n\nGuidelines for bug reports:\n\n1. **Use the GitHub issue search** &mdash; check if the issue has already been\n   reported.\n\n2. **Check if the issue has been fixed** &mdash; try to reproduce it using the\n   `main` branch in the repository.\n\n3. **Isolate and report the problem** &mdash; ideally, create a reduced test\n   case.\n\nPlease try to be as detailed as possible in your report. Include information\nabout your Operating System, as well as your Erlang, Elixir and Scenic versions.\nPlease provide steps to reproduce the issue as well as the outcome you were\nexpecting! All these details will help developers to fix any potential bugs.\n\nExample:\n\n```md\nShort and descriptive example bug report title\n\nA summary of the issue and the environment in which it occurs. If suitable,\ninclude the steps required to reproduce the bug.\n\n1. This is the first step\n2. This is the second step\n3. Further steps, etc.\n\n` ` - a link to the reduced test case (e.g. a GitHub Gist)\n\nAny other information you want to share that is relevant to the issue being\nreported. This might include the lines of code that you have identified as\ncausing the bug, and potential solutions (and your opinions on their merits).\n```","ref":"contributing.html#bug-reports","title":"Bug reports - Contributing to Scenic","type":"extras"},{"doc":"Feature requests are welcome and should be currently be discussed as an issue\nin github. This will change to either a topic in Elixir forum or a mail-list soon.\n\nBefore you make a request however, please take a moment to\nfind out whether your idea fits with the scope and aims of the project. It's up\nto *you* to make a strong case to convince the community of the merits of this\nfeature. Please provide as much detail and context as possible.","ref":"contributing.html#feature-requests","title":"Feature requests - Contributing to Scenic","type":"extras"},{"doc":"Code documentation (`@doc`, `@moduledoc`, `@typedoc`) has a special convention:\nthe first paragraph is considered to be a short summary.\n\nFor functions, macros and callbacks say what it will do. For example write,\nsomething like:\n\n```elixir\n@doc \"\"\"\nMarks the given value as HTML safe.\n\"\"\"\ndef safe({:safe, value}), do: {:safe, value}\n```\n\nFor modules, protocols and types say what it is. For example, write something\nlike:\n\n```elixir\ndefmodule MyModule.HTML do\n  @moduledoc \"\"\"\n  Conveniences for working HTML strings and templates.\n  ...\n  \"\"\"\n```\n\nKeep in mind that the first paragraph might show up in a summary somewhere, long\ntexts in the first paragraph create very ugly summaries. As a rule of thumb,\nanything longer than 80 characters is too long.\n\nTry to keep unnecessary details out of the first paragraph, it's only there to\ngive a user a quick idea of what the documented \"thing\" does/is. The rest of the\ndocumentation string can contain the details, for example when a value and when\n`nil` is returned.\n\nIf possible include examples, preferably in a form that works with doctests.\nThis makes it easy to test the examples so that they don't go stale and examples\nare often a great help in explaining what a function does.","ref":"contributing.html#contributing-documentation","title":"Contributing Documentation - Contributing to Scenic","type":"extras"},{"doc":"Good pull requests - patches, improvements, new features - are a fantastic help.\nThey should remain focused in scope and avoid containing unrelated commits.\n\n> **IMPORTANT**: By submitting a patch, you agree that your work will be licensed\nunder the license used by the project.\n\nIf you have any large pull request in mind (e.g. implementing features,\nrefactoring code, etc.), **please ask first** otherwise you risk spending a lot\nof time working on something that the project's developers might not want to\nmerge into the project.\n\nPlease adhere to the coding conventions in the project (indentation, accurate\ncomments, etc.) and don't forget to add your own tests and documentation. When\nworking with git, we recommend the following process in order to craft an\nexcellent pull request:\n\n1. [Fork](https://help.github.com/articles/fork-a-repo/) the project, clone your\n   fork, and configure the remotes:\n\n   ```bash\n   # Clone your fork of the repo into the current directory\n   git clone https://github.com/ /scenic\n   # Navigate to the newly cloned directory\n   cd scenic\n   # Assign the original repo to a remote called \"upstream\"\n   git remote add upstream https://github.com/ScenicFramework/scenic\n   ```\n\n2. If you cloned a while ago, get the latest changes from upstream, and update\n   your fork:\n\n   ```bash\n   git checkout main\n   git pull upstream main\n   git push\n   ```\n\n3. Create a new topic branch (off of `main`) to contain your feature, change,\n   or fix.\n\n   **IMPORTANT**: Making changes in `main` is discouraged. You should always\n   keep your local `main` in sync with upstream `main` and make your\n   changes in topic branches.\n\n   ```bash\n   git checkout -b  \n   ```\n\n4. Commit your changes in logical chunks. Keep your commit messages organized,\n   with a short description in the first line and more detailed information on\n   the following lines. Feel free to use Git's [interactive\n   rebase](https://help.github.com/articles/about-git-rebase/) feature to tidy\n   up your commits before making them public.\n\n5. Make sure all the tests are still passing.\n\n   ```bash\n   mix test\n   ```\n\n6. Push your topic branch up to your fork:\n\n   ```bash\n   git push origin  \n   ```\n\n7. [Open a Pull Request](https://help.github.com/articles/about-pull-requests/)\n    with a clear title and description.\n\n8. If you haven't updated your pull request for a while, you should consider\n   rebasing on main and resolving any conflicts.\n\n   **IMPORTANT**: _Never ever_ merge upstream `main` into your branches. You\n   should always `git rebase` on `main` to bring your changes up to date when\n   necessary.\n\n   ```bash\n   git checkout main\n   git pull upstream main\n   git checkout  \n   git rebase main\n   ```\n\nThank you for your contributions!","ref":"contributing.html#pull-requests","title":"Pull requests - Contributing to Scenic","type":"extras"},{"doc":"These Guides aim to be inclusive. We use \"we\" and \"our\" instead of \"you\" and\n\"your\" to foster this sense of inclusion.\n\nIdeally, there is something for everybody in each guide, from beginner to expert.\nThis is hard, maybe impossible. When we need to compromise, we do so on behalf\nof beginning users because expert users have more tools at their disposal to\nhelp themselves.\n\nThe general pattern we use for presenting information is to first introduce a\nsmall, discreet topic, then write a small amount of code to demonstrate the\nconcept, then verifies that the code worked.\n\nIn this way, we build from small, easily digestible concepts into more complex\nones. The shorter this cycle is, as long as the information is still clear and\ncomplete, the better.\n\nFor formatting the guides:\n\n* We use the \"elixir\" code fence for all module code.\n* We use the \"console\" code fence for iex and shell commands.\n* We use backticks for filenames and directory paths.\n* We use backticks for module names, function names, and variable names.\n\nThis contribution guide is adapted from the [Phoenix contribution\nguide](https://github.com/phoenixframework/phoenix/blob/main/CONTRIBUTING.md).","ref":"contributing.html#guides","title":"Guides - Contributing to Scenic","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}